/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CaConvFile_Oudia02To03.cpp: CaConvFile_Oudia02To03 NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <string>
using std::string ;

#include "str\strLf.h"
#include "str\CdConnectedString2.h"
#include "str\CConnectedStringCompress.h"

#include "CaConvFile_Oudia02To03.h"
#include "CDedRosenFileData.h"
#include "CconvCDedRosenFileData_01.h"
#include "CconvCDedRosenFileData_02.h"
#include "CDedRosenFileData.h"
#include "CconvCDedRosenFileData.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
static const char nameFileType[] = "FileType" ;
static const char nameFileTypeAppComment[] = "FileTypeAppComment" ;
static const char valueFileTypeAppComment[] = "ConvFileOudia02To03 Ver 0.03" ;

CaConvFile_Oudia02To03::CaConvFile_Oudia02To03()
{

}

CaConvFile_Oudia02To03::~CaConvFile_Oudia02To03()
{

}

	// ********************************
	//@name IfConvFile
	// ********************************
int CaConvFile_Oudia02To03::LeftToRight( 
		const IfByteBuffer* pLeftFormat , 
		IfByteBuffer* pRightFormat , 
		IfByteBuffer* pErrorInfoString ) 
{
	int iRv = 0 ;
	bool	bFormatFound = false ;
	string 	strErrorInfoString ;

	// --------------------------------
	//	ւ̕ϊ
	// --------------------------------
	string 	strSrcFileContent ;
	string strFileType ;
	string strFileTypeAppComment ;
	if ( iRv >= 0 )
	{
		strSrcFileContent.resize( pLeftFormat->size() )  ;
		for ( int idxBytes = 0 ; idxBytes < pLeftFormat->size() ; idxBytes ++ )
		{
			pLeftFormat->read( 
				&strSrcFileContent[idxBytes],
				idxBytes , 
				1 ) ;
		}
		
		//	sR[h '\r\n'  '\n' ɕϊ
		strSrcFileContent = OuLib::strLfOf( strSrcFileContent ) ;
	}
	if ( iRv >= 0 )
	{
		CdConnectedString2	aCdConnectedString2( '\n' , '=' )  ;
		aCdConnectedString2.decode( strSrcFileContent ) ;
		strFileType = aCdConnectedString2.getValue( nameFileType );
		strFileTypeAppComment = aCdConnectedString2.getValue( nameFileTypeAppComment );
	}
	// ================================
	//	񂩂Ht@Cf[^ւ̕ϊ
	// ================================
	CDedRosenFileData	aCDedRosenFileData ;
	// --------------------------------
	//	Ver.01  SrcFile Ht@Cf[^쐬
	// --------------------------------
	if ( iRv >= 0 && !bFormatFound )
	{
		CconvCDedRosenFileData_01	aCconvCDedRosenFileData_01 ;
		if ( aCconvCDedRosenFileData_01.isEncodeAbleFormat( strSrcFileContent ) )
		{
			bFormatFound = true ;
			int iResult = aCconvCDedRosenFileData_01.CDedRosenFileData_from_string( 
				&aCDedRosenFileData , strSrcFileContent ) ;
			if ( iResult < 0 )
			{
				iRv = -1 ;	//	ϊÕt@ĆÃR}hł̕ϊł܂B
			}
		}
	}

	// --------------------------------
	//	Ver.02  SrcFile Ht@Cf[^쐬
	// --------------------------------
	if ( iRv >= 0 && !bFormatFound )
	{

		CconvCDedRosenFileData_02	aCconvCDedRosenFileData_02 ;
		if ( aCconvCDedRosenFileData_02.getFileType() == strFileType )
		{
			bFormatFound = true ;
			CConnectedStringCompress	aCompress( '.' ) ;
			CdConnectedString2	aCdConnectedString2( '\n' , '=' )  ;
			aCompress.decode( strSrcFileContent , &aCdConnectedString2 ) ;

			int iResult = aCconvCDedRosenFileData_02.CDedRosenFileData_from_CdConnectedString( 
				&aCDedRosenFileData , aCdConnectedString2 ) ;
			if ( iResult < 0 )
			{
				iRv = -1 ;	//	ϊÕt@ĆÃR}hł̕ϊł܂B
			}
		}
	}
	// --------------------------------
	if ( iRv >= 0 && !bFormatFound )
	{
				iRv = -1 ;	//	ϊÕt@ĆÃR}hł̕ϊł܂B
	}
	// ================================
	//	Ht@Cf[^ Ver.3 ̃t@C쐬
	// ================================
	string strDstFile ;
	{
		CdConnectedString2	aCdConnectedString2( '\n' , '=' , false )  ;
		if ( iRv >= 0 )
		{
			CconvCDedRosenFileData	aCconvCDedRosenFileData ;

			//	CdConnectedString2 
			//	FileType  FileTypeAppComment t^
			aCdConnectedString2.setItem( nameFileType , CconvCDedRosenFileData().getFileType() );
			aCdConnectedString2.setItem( nameFileTypeAppComment , valueFileTypeAppComment );

			int iResult = aCconvCDedRosenFileData.CDedRosenFileData_to_CdConnectedString( 
				aCDedRosenFileData , &aCdConnectedString2 ) ;
			if ( iResult < 0 )
			{
				iRv = -3 ;	//	ϊ̃t@C̍쐬Ɏs܂B
			}
		}
		// --------------------------------
		//	CdConnectedString2 ̓e
		//	Ɋi[
		// --------------------------------
		if ( iRv >= 0 )
		{

			//	CConnectedStringCompress ɂ鈳k
			CConnectedStringCompress	aCompress( '.' ) ;
			strDstFile = aCompress.encode( aCdConnectedString2 ) ;
			
		}
	}
	//strDstFile=ϊ̕

	// ================================
	//	ďoɕԂB
	// ================================
	if ( iRv >= 0 )
	{
		//	sR[h '\n'  '\r\n' ɕϊ
		strDstFile = OuLib::strCrlfOf( strDstFile ) ;

		pRightFormat->size_reset( strDstFile.size() ) ;
		pRightFormat->write( strDstFile.c_str() , 0 , strDstFile.size() ) ;
	
	}
	if ( pErrorInfoString != NULL && strErrorInfoString.size() > 0 )
	{
		pErrorInfoString->size_reset( strErrorInfoString.size() ) ;
		pErrorInfoString->write( strErrorInfoString.c_str() , 0 , strErrorInfoString.size() ) ;
	}
	// --------------------------------
	return iRv ;
}

int CaConvFile_Oudia02To03::isLeftFormat( 
		const IfByteBuffer* pLeftFormat)  
{
	int iRv = 0 ;
	bool	bFormatFound = false ;

	// --------------------------------
	//	ւ̕ϊ
	// --------------------------------
	string 	strSrcFileContent ;
	string strFileType ;
	string strFileTypeAppComment ;
	if ( iRv >= 0 )
	{
		strSrcFileContent.resize( pLeftFormat->size() )  ;
		for ( int idxBytes = 0 ; idxBytes < pLeftFormat->size() ; idxBytes ++ )
		{
			pLeftFormat->read( 
				&strSrcFileContent[idxBytes],
				idxBytes , 
				1 ) ;
		}
		
		//	sR[h '\r\n'  '\n' ɕϊ
		strSrcFileContent = OuLib::strLfOf( strSrcFileContent ) ;
	}
	if ( iRv >= 0 )
	{
		CdConnectedString2	aCdConnectedString2( '\n' , '=' )  ;
		aCdConnectedString2.decode( strSrcFileContent ) ;
		strFileType = aCdConnectedString2.getValue( nameFileType );
		strFileTypeAppComment = aCdConnectedString2.getValue( nameFileTypeAppComment );
	}
	// ================================
	//	񂩂Ht@Cf[^ւ̕ϊ
	// ================================
	CDedRosenFileData	aCDedRosenFileData ;
	// --------------------------------
	//	Ver.01  SrcFile Ht@Cf[^쐬
	// --------------------------------
	if ( iRv >= 0 && !bFormatFound )
	{
		CconvCDedRosenFileData_01	aCconvCDedRosenFileData_01 ;
		if ( aCconvCDedRosenFileData_01.isEncodeAbleFormat( strSrcFileContent ) )
		{
			bFormatFound = true ;
		}
	}

	// --------------------------------
	//	Ver.02  SrcFile Ht@Cf[^쐬
	// --------------------------------
	if ( iRv >= 0 && !bFormatFound )
	{

		CconvCDedRosenFileData_02	aCconvCDedRosenFileData_02 ;
		if ( aCconvCDedRosenFileData_02.getFileType() == strFileType )
		{
			bFormatFound = true ;
		}

	}
	// --------------------------------
	if ( iRv >= 0 && !bFormatFound )
	{
				iRv = -1 ;	//	ϊÕt@ĆÃR}hł̕ϊł܂B
	}
	return ( iRv ) ;
}
bool CaConvFile_Oudia02To03::RightToLeftIsSupported() 
{
	return false ;	//	̃\bh̓T|[gĂ܂B
}
int CaConvFile_Oudia02To03::RightToLeft( 
		const IfByteBuffer* pRightFormat , 
		IfByteBuffer* pLeftFormat , 
		IfByteBuffer* pErrorInfoString ) 
{
	return -2 ;	//	̃\bh̓T|[gĂ܂B
}

int CaConvFile_Oudia02To03::isRightFormat( 
		const IfByteBuffer* pRightFormat ) 
{
	return -2 ;	//	̃\bh̓T|[gĂ܂B
}
