/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDia.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedDia_h
#define  CentDedDia_h

#include <deque>
using namespace std ;

#include "CentDed.h"
#include "CentDedRessya.h"
#include "CentDedRessyaCont.h"
class CentDedEkiCont ;

// ****************************************************************
//	CentDedDia
// ****************************************************************
/**
 *	@brief
 *	yTvz  DiagramEdit ́AHŐݒ肳Ăw_CxP
 *	\܂B
 *	
 *	̃NX̃CX^X́Aʏ́wHx ( CentDedRosen ) ɕ
 *	܂B
 *	
 *	ۂɂ́A
 *	
 *	- wHx (CentDedRosen) w_Cx ( CentDedDia ) 
 *	Oȏ㕡
 *	- ew_Cx ( CentDedDia ) wԁx (CentDedRessya ) 
 *	Oȏ㕡
 *	
 *	Ƃ֌WɂȂĂ܂B
 *	
 *	  ̃NX́Awԁx ( CentDedRessya ) AE̕ʂ
 *	ێ܂B
 *	  wԁx̒ǉE폜́ÃNX̃\bhɂȂĂ܂B
 *
 * 
 *	@̃NX́AƂāww̐xEwԎʐxێ܂B
 *	A͔hƂȂĂ܂B
 *
 * <h5>int EkiCount</h5>
 *	̃_Cɑ݂ww̐xłB
 *	̑́A m_CentDedRessyaCont[]->m_iEkiCount ƂɌ܂܂B
 * <h5>int RessyasyubetsuCount</h5>
 *	wԎʐxBԎʂ̎ނ̐łB
 *	̑́A m_CentDedRessyaCont[]->m_iRessyasyubetsuCount Ƃ
 *	܂܂B
 */
class CentDedDia
{
// ********************************
//	Ci[^Cv
// ********************************
 public:

// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	_Ĉ̖łB
	 *
	 *	ij "_C" Ȃ
	 *
	 * @see CentDedRosen
	 *	 CentDedRosen ́ȂqƂĈ܂B
	 *	CentDedRosen ɕ܂ CentDedDia ł́A
	 *	͈̑ӂłȂĂ͂Ȃ܂B
	 */
	string	m_strName ;
///@}
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	́w_Cxŉ^sĂԂ
	 *	wԁx ( CentDedRessya ) ێ܂B
	 *
	 *	̕ϐ́Avf 2 ̔złB\n
	 *	[0] 	 ( Ressyahoukou_Kudari ) 	\n
	 *	[1] 	 ( Ressyahoukou_Nobori ) 	\n
	 *	ێ܂B
	 *
	 *	̃Rei CentDedRessya IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *	Ԃł́Avf 0 ƂȂ܂B
	 */
	CentDedRessyaCont*	m_CentDedRessyaCont[2] ;
	
///@}


// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 *	̃RXgN^́A 
	 *	CentDedDia_From_CdConnectedString() 
	 *	t@C̓e擾ƂɁA
	 *	ǂݎƂĎw肷IuWFNg̐Ɏg܂B
	 * @param iEkiCount [in]
	 *	_CɊ܂܂w̐B\n
	 * @param iRessyasyubetsuCount [in]
	 *	Ԏʂ̐
	 */
	CentDedDia( int iEkiCount , int iRessyasyubetsuCount ) ;

	/**
	 * @param strName [in]
	 *	_Ĉ̖łB	\n
	 *	ij "_C" Ȃ
	 * @param iEkiCount [in]]
	 *	_CɊ܂܂w̐B\n
	 * @param iRessyasyubetsuCount [in]
	 *	Ԏʂ̐
	 */
	CentDedDia( 
		const string& strName  ,
		int iEkiCount , int iRessyasyubetsuCount ) ;

	CentDedDia( const CentDedDia& value );
	
	/**
	 *	̃NXւ̑s܂A
	 *	this ́wwx̐ ( m_iEkiCount ) ͕ύX܂B
	 *
	 *	this ܂wԁx( CentDedRessya )  ̃Rs[ɂ́A
	 *	CentDedRessya& operator=( const CentDedRessya& value ) 
	 *	g܂B
	 */
	CentDedDia& operator=( const CentDedDia& value );

	virtual ~CentDedDia();
		
// ********************************
//	CentDedDia
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	string	getName()const{	return m_strName ;};
	CentDedDia& setName( const string& value ){
		m_strName = value ; return *this ; } ;

	int getEkiCount()const
	{
		return m_CentDedRessyaCont[ Ressyahoukou_Kudari ]->
			getEkiCount() ;
	};
	int getRessyasyubetsuCount()const
	{
		return m_CentDedRessyaCont[ Ressyahoukou_Kudari ]->
			getRessyasyubetsuCount() ;
	};

	/**
	 * @param eRessyahoukou [in]
	 *	ԕw肵ĂB
	 *	-	 :	Ressyahoukou_Kudari 
	 *	-	 : 	Ressyahoukou_Nobori 
	 */
	CentDedRessyaCont* getpCentDedRessyaCont( 
			ERessyahoukou eRessyahoukou )const
	{
		return m_CentDedRessyaCont[ eRessyahoukou ] ;
	};
	
	/**
	 * @param eRessyahoukou [in]
	 *	ԕw肵ĂB
	 *	-	 :	Ressyahoukou_Kudari 
	 *	-	 : 	Ressyahoukou_Nobori 
	 */
	IfContGet< CentDedRessya* >* getCentDedRessyaContGet( 
			ERessyahoukou eRessyahoukou )const
	{
		return m_CentDedRessyaCont[ eRessyahoukou ]->getIfContGet() ;
	};
	
	
	///@}

	// ********************************
	///@name CentDedDia-wEԎʐ̕ύX
	// ********************************
	///@{
	/**
	 *	̃ReiɊ܂܂邷ׂĂ
	 *	w_Cx ( CentDedDia )ɑ΂A
	 *	wwxIuWFNg̑̕ύXʒm܂B
	 *	
	 *	̊֐́AwnwEIw̉w`ύXɔAȄCx
	 *	s킹܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwIndexxŎw肵ĂB
	 *	͈͂ 0 ȏ m_iEkiCount ȉłB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 */
	int onSetCentDedEki( const CentDedEkiCont* pCentDedEkiCont , int iEkiIndex ) ;

	/**
	 *	̃_CɊ܂܂邷ׂẮwԁx ( CentDedRessya )ɑ΂A
	 *	wwxIuWFNgAẅʒuɑ}܂B
	 * @param iEkiIndex [in]
	 *	IuWFNg}ʒuwwIndexxŎw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() ȉłB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int insertCentDedEkiJikoku(	int iEkiIndex = INT_MAX ) ;
	
	/**
	 *	̃_CɊ܂܂邷ׂẮwԁx ( CentDedRessya )ɑ΂A
	 *	wwxIuWFNgAẅʒu폜܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwIndexxŎw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int eraseCentDedEkiJikoku( int iEkiIndex = INT_MAX ) ;

	/**
	 *	wԎʁx̒ǉɔA
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ́wԎIndexxC܂B
	 *
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ̂A
	 *	 iRessyasyubetsuIndex ȏ wԎIndexx
	 *	wԁx ( CentDedRessya ) ́wԎIndexx 1 Z܂B
	 *
	 *	܂A this  m_iRessyasyubetsuCount  1 Z܂B
	 *
	 * @param iRessyasyubetsuIndex [in]
	 *	Ԏʂ̒ǉʒuw肵ĂB
	 *	͈͂ 0 ȏ m_iRessyasyubetsuCount ȉłB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int insertRessyasyubetsuIndex( int iRessyasyubetsuIndex = INT_MAX ) ;
	
	/**
	 *	wԎʁx̍폜ɔA
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ́wԎIndexxC܂B
	 *
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ̂A
	 *	 iRessyasyubetsuIndex 傫 wԎIndexx
	 *	wԁx ( CentDedRessya ) ́wԎIndexx 1 Z܂B
	 *
	 *	܂A this  m_iRessyasyubetsuCount  1 Z܂B
	 *
	 * @param iRessyasyubetsuIndex [in]
	 *	폜ԎIndexw肵ĂB
	 *	͈͂ 0 ȏ m_iRessyasyubetsuCount łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 *	-	-3 ;	//	wԎʁx iRessyasyubtsuIndex ̗Ԃ݂܂B
	 */
	int eraseRessyasyubetsuIndex( int iRessyasyubetsuIndex  = INT_MAX ) ;

	/**
	 *	̃ReiɁAw肳ꂽwԎʁx̗Ԃ邩ۂ𒲂ׂ܂B
	 * @param iRessyasyubetsuIndex [in]
	 *	wԎIndexxw肵ĂB
	 *	͈͂́A 0 ȏ Ԏʂ̐łB
	 *	INT_MAX ́A̗Ԏʂw肵̂Ƃ݂Ȃ܂B
	 * @param peRessyahoukou [out]
	 *	̊֐͂̕ϐɁAwԎʁx̗Ԃ
	 *	_C̗ԕ݂܂B
	 *	svȂ NULL ł܂܂B
	 * @param piRessyaIndex [out]
	 *	̊֐͂̕ϐɁAwԎʁx̗Ԃ
	 *	Index ݂܂B
	 *	svȂ NULL ł܂܂B
	 * @return 
	 *	-	1; //	w̗Ԏʂ̗Ԃ݂܂B
	 *	-	0; //	w̗Ԏʂ̗Ԃ݂͑܂B
	 *	-	-1 ;	//	CfNXs
	 */
	int isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		ERessyahoukou* peRessyahoukou ,
		int* piRessyaIndex ) ;

	///@}

};


#endif /*CentDedDia_h*/


