/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyaCont.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRessyaCont_h
#define  CentDedRessyaCont_h

#include "Cont/CaContFilter.h"

#include "CentDed.h"
#include "CentDedRessya.h"

// ****************************************************************
//	CentDedRessyaCont
// ****************************************************************
/**
 * @brief
 *	yTvz
 *	wԃReixNXB
 *	Hɑ铯́A0ȏ㕡́wԁx(CentDedRessya) 
 *	IuWFNgێReiłB
 *	
 *	̃NX̂́A IfCont< CentDedRessya > C^[tF[X
 *	T|[g܂B̃C^[tF[XɂA CentDedRessya IuWFNg
 *	ǉE폜邱Ƃł܂B
 *
 *	܂A getIfContGet() \bhɂA
 *	IfCont< CentDedRessya* > C^[tF[X擾邱Ƃł܂B
 *	̃C^[tF[XɂARei CentDedRessya IuWFNg
 *	ڃANZXi\bhďojsƂł܂B
 *
 * @attention
 *	this  get() \bh́ACentDedRessya IuWFNg̃Rs[Ԃ܂B
 *	get() \bhŕԂꂽIuWFNgɑ΂āA
 *	CentDedRessya IuWFNgXV郁\bhĂяoĂA
 *	Rei CentDedRessya IuWFNgXV邱Ƃ͂ł܂B\n
 *	Rei CentDedRessya IuWFNg̃\bhĂяoꍇ́A
 *	getIfContGet()  IfContGet<CentDedRessya*>* 擾ĂA
 *	̃C^[tF[XoR CentDedRessya* 擾Ã|C^
 *	\bhĂяoĂB
 *	
 *	̃Rei set() E insert() ́Aw肳ꂽ CentDedRessya IuWFNg
 *	Rs[RXgN^ŃRs[ŁAReiɕێ܂B
 *	set()E insert() Ŏw肵IuWFNǵA֐I͔jĂ
 *	܂܂B
 *
 *	̃IuWFNgێ CentDedRessya ́A
 *	wԕx (CentDedRessya::m_eRessyahoukou) E
 *	ww̐x ( CentDedRessya::m_CentDedEkiJikokuCont.size() )
 *	ׂēɂȂ܂B
 *	܂AwԎIndexx  (CentDedRessya::m_iRessyasyubetsuIndex ) ́A
 *	this ̑ wԎʐx ( m_iRessyasyubetsuCount )
 *	܂B
 *	set() , insert() ́Aw肳ꂽ CentDedRessya 
 *	wԕx (CentDedRessya::m_eRessyahoukou) E
 *	ww̐x ( CentDedRessya::m_CentDedEkiJikokuCont.size() ) E
 *	wԎIndexx  (CentDedRessya::m_iRessyasyubetsuIndex ) 
 *	CŁAReiɕۑ܂B
 */
class CentDedRessyaCont : public CaContFilter< CentDedRessya , CentDedRessya* >
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	typedef CaContFilter< CentDedRessya , CentDedRessya* > super ;
	
// ********************************
///@name 
// ********************************
///@{
	
	/**
	 *	̃ReiɊ܂܂Ԃ́wwx̐i_CɊ܂܂w̐jB
	 *
	 *	̒ĺAԂĂ CentDedRosen IuWFNg
	 *	 CentDedEki ̐ɓȂ܂B
	 *
	 *	̒ĺAReiɁwԁx ( CentDedRessya ) IuWFNgǉ
	 *	ꍇɕKvɂȂ܂B
	 */
	int m_iEkiCount ;
	
	/**
	 * @param eRessyahoukou [in]
	 *	̃ReiɊi[wԁx̗ԕB
	 *	-	 :	Ressyahoukou_Kudari 
	 *	-	 : 	Ressyahoukou_Nobori 
	 *	RXgN^Ō܂܂B
	 *
	 *	̒ĺAReiɁwԁx ( CentDedRessya ) IuWFNgǉ
	 *	ꍇɕKvɂȂ܂B
	 */
	ERessyahoukou m_eRessyahoukou ;
	
	/**
	 *	̃ReiɊ܂܂Ԃ́wԎʐxB
	 *
	 *	̒ĺAԂĂ CentDedRosen IuWFNg
	 *	CentDedRessyasyubetsu ̐ɓȂ܂B
	 *
	 *	̒ĺAReiɁwԁx ( CentDedRessya ) IuWFNgǉ
	 *	ꍇɕKvɂȂ܂B
	 */
	int m_iRessyasyubetsuCount ;
///@}
// --------------------------------
///@name CaContFilter-I[oCh\ȉz֐
// --------------------------------
///@{
 protected:
	/**
	 *	  this ́AΏۂ̃Rei m_pAdaptee ɑ΂ėvfǉ
	 *	ƂɁÅ֐ĂяoāA  ElementType1 ̒l value A
	 *	 ElementType2 ɕϊ܂B
	 *
	 *	onSet() ĂяoƁA onErase() Ăяo͑΂ɂȂĂ܂B
	 *	 onSet() łlԂꍇA̗vf m_pAdaptee 
	 *	菜ƂɁAK onSet() ŕԂlƂ
	 *	 onErase() Ăяo܂B
	 *	
	 *	@param value [in] (const ElementType1&)
	 *	  ϊׂlw肵ĂB
	 *	
	 *	@param piResult [out]
	 *	  ̊֐́Al value ̕ϊɐƂ͂̒l 0 ȏA
	 *	sƂ͕̐ɂ܂B
	 *	\n֐Iɂ̒l̐łꍇA this ͗vf
	 *	ReiɊi[܂B̏ꍇAset() E insert() 
	 *	sƂȂA *piResult  set() E insert() ̖߂lƂȂ܂B
	 *	
	 *	@return (ElementType2)
	 *	  value ϊʂԂ܂BAAϊɎsA
	 *	 *piResult ̐łꍇ́A̖߂lɂ͈Ӗ܂B
	 *
	 *	
	 *	<H4>
	 *	yI[oChz
	 *	</H4>
	 *	value ̃Rs[ new ŐāÃ|C^Ԃ܂B
	 *	AARs[̃CX^X́wwxwԕx́A
	 *	 this   m_iEkiCount , m_eRessyahoukou 
	 *	킹܂B
	 */
	virtual adaptee_value_type onSet( const value_type& value , int* piResult ) ;
	
	/**
	 *	  get() \bh́AΏۂ̃Rei m_pAdaptee 擾
	 *	̊֐ĂяoāA  ElementType2 ̒l value A
	 *	 ElementType1 ɕϊ܂B
	 *	
	 *	@param value [in] (const ElementType2&)
	 *	  ϊׂlw肵ĂB
	 *	
	 *	@return (ElementType1)
	 *	  value ϊʂԂ܂B
	 *	
	 *	<H4>
	 *	yI[oChz
	 *	</H4>
	 *	  vf̃Rs[IuWFNgԂ܂B
	 */
	virtual value_type onGet( const adaptee_value_type& value )const ;
	
	/**
	 *	  this ́AΏۂ̃Rei m_pAdaptee vf菜OɁA
	 *	̊֐Ăяo܂B
	 *
	 *
	 *	onSet() ĂяoƁA onErase() Ăяo͑΂ɂȂĂ܂B
	 *	 onSet() łlԂꍇA̗vf m_pAdaptee 
	 *	菜ƂɁAK onSet() ŕԂlƂ
	 *	 onErase() Ăяo܂B
	 *	
	 *	@param value [in] (const ElementType2&)
	 *	  Ώۂ̃Rei m_pAdaptee 菜vfw肵ĂB
	 *
	 *	<H4>
	 *	yI[oChz
	 *	</H4>
	 *	  vf delete ܂B
	 */
	virtual void onErase( const adaptee_value_type& value ) ;
///@}
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param iEkiCount [in]]
	 *	wԃReixɊ܂܂w̐B\n
	 * @param eRessyahoukou [in]
	 *	̃ReiɊi[wԁx̗ԕB
	 *	-	 :	Ressyahoukou_Kudari 
	 *	-	 : 	Ressyahoukou_Nobori 
	 * @param iRessyasyubetsuCount [in]
	 *	̃ReiɊ܂܂Ԃ́wԎʐxB
	 *
	 *	̒ĺAԂĂ CentDedRosen IuWFNg
	 *	CentDedRessyasyubetsu ̐ɓȂ܂B
	 *
	 *	̒ĺAReiɁwԁx ( CentDedRessya ) IuWFNgǉ
	 *	ꍇɕKvɂȂ܂B
	 */
	CentDedRessyaCont( 
		int iEkiCount ,
		ERessyahoukou m_eRessyahoukou ,
		int iRessyasyubetsuCount 
	) ;


	CentDedRessyaCont( const CentDedRessyaCont& value );
	
	/**
	 *	̃NXւ̑s܂A
	 *	this ́wwx̐ ( m_iEkiCount ) ͕ύX܂B
	 *
	 *	this ܂wԁx( CentDedRessya )  ̃Rs[ɂ́A
	 *	CentDedRessya& operator=( const CentDedRessya& value ) 
	 *	g܂B
	 */
	CentDedRessyaCont& operator=( const CentDedRessyaCont& value );

	virtual ~CentDedRessyaCont();

// ********************************
//	CentDedRessyaCont
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	ERessyahoukou getRessyahoukou()const{	return m_eRessyahoukou ;};
	int getEkiCount()const{	return m_iEkiCount ;};
	int getRessyasyubetsuCount()const{	return m_iRessyasyubetsuCount ;};

	///@}
	// ********************************
	///@name CentDedRessyaCont-
	// ********************************
	///@{
	/**
	 * @return 
	 *	Reĩ_CIuWFNg CentDedRessya ւ̃|C^
	 *	ANZX邽߂ IfContGet<CentDedRessya*>* Ԃ܂B
	 */
	IfContGet<CentDedRessya*>* getIfContGet(){	return getAdaptee() ;	};
	const IfContGet<CentDedRessya*>* getIfContGet()const{	return getAdaptee() ;	};

	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	̗Ԃǉ܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() ȉłB
	 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int insertBlank( int iIndex = INT_MAX ) ;
	
	/**
	 *	wwOrder(wIndex)xAwwIndexxɕϊ܂B
	 * @param iEkiOrder [in]
	 *	wwOrderxw肵ĂB
	 * @return 
	 *	0ȏ́wwIndexxԂ܂B
	 *	sȏꍇ́A -1 Ԃ܂B
	 */
	int EkiIndexOfEkiOrder( int iEkiOrder ) ;
	
	/**
	 *	wwIndexxwwOrder(wIndex)xɕϊ܂B
	 * @param iEkiIndex [in]
	 *	wwIndexxw肵ĂB
	 * @return 
	 *	0ȏ́wwOrderxԂ܂B
	 *	sȏꍇ́A -1 Ԃ܂B
	 */
	int EkiOrderOfEkiIndex( int iEkiIndex ) ;
	///@}

	// ********************************
	///@name CentDedRessyaCont-wEԎʐ̕ύX
	// ********************************
	///@{
	/**
	 *	̃ReiɊ܂܂邷ׂĂ
	 *	w_Cx ( CentDedDia )ɑ΂A
	 *	wwxIuWFNg̑̕ύXʒm܂B
	 *	
	 *	̊֐́AwnwEIw̉w`ύXɔAȄCx
	 *	s킹܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ m_iEkiCount ȉłB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 */
	int onSetCentDedEki( const IfContGet<CentDedEkiCont::CdDedEki>* pCentDedEkiCont , int iEkiOrder ) ;

	/**
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya )ɑ΂A
	 *	wwxIuWFNgAẅʒuɑ}܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ m_iEkiCount ȉłB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int insertCentDedEkiJikoku(	int iEkiOrder = INT_MAX ) ;
	
	/**
	 *	́wԃReixɊ܂܂邷ׂẮwԁx ( CentDedRessya )ɑ΂A
	 *	wwxIuWFNgAẅʒu폜܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ m_iEkiCount łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int eraseCentDedEkiJikoku( int iEkiOrder = INT_MAX ) ;

	/**
	 *	wԎʁx̒ǉɔA
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ́wԎIndexxC܂B
	 *
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ̂A
	 *	 iRessyasyubetsuIndex ȏ wԎIndexx
	 *	wԁx ( CentDedRessya ) ́wԎIndexx 1 Z܂B
	 *
	 *	܂A this  m_iRessyasyubetsuCount  1 Z܂B
	 *
	 * @param iRessyasyubetsuIndex [in]
	 *	Ԏʂ̒ǉʒuw肵ĂB
	 *	͈͂ 0 ȏ m_iRessyasyubetsuCount ȉłB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int insertRessyasyubetsuIndex( int iRessyasyubetsuIndex = INT_MAX ) ;
	
	/**
	 *	wԎʁx̍폜ɔA
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ́wԎIndexxC܂B
	 *
	 *	́wԃReixɊ܂܂邷ׂĂ
	 *	wԁx ( CentDedRessya ) ̂A
	 *	 iRessyasyubetsuIndex 傫 wԎIndexx
	 *	wԁx ( CentDedRessya ) ́wԎIndexx 1 Z܂B
	 *
	 *	܂A this  m_iRessyasyubetsuCount  1 Z܂B
	 *
	 * @param iRessyasyubetsuIndex [in]
	 *	폜ԎIndexw肵ĂB
	 *	͈͂ 0 ȏ m_iRessyasyubetsuCount łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 *	-	-3 ;	//	wԎʁx iRessyasyubtsuIndex ̗Ԃ݂܂B
	 */
	int eraseRessyasyubetsuIndex( int iRessyasyubetsuIndex  = INT_MAX ) ;

	/**
	 *	̃ReiɁAw肳ꂽwԎʁx̗Ԃ邩ۂ𒲂ׂ܂B
	 * @param iRessyasyubetsuIndex [in]
	 *	wԎIndexxw肵ĂB
	 *	͈͂́A 0 ȏ Ԏʂ̐łB
	 *	INT_MAX ́A̗Ԏʂw肵̂Ƃ݂Ȃ܂B
	 * @param piRessyaIndex [out]
	 *	̊֐͂̕ϐɁAwԎʁx̗Ԃ
	 *	Index ݂܂B
	 *	svȂ NULL ł܂܂B
	 * @return 
	 *	-	1; //	w̗Ԏʂ̗Ԃ݂܂B
	 *	-	0; //	w̗Ԏʂ̗Ԃ݂͑܂B
	 *	-	-1 ;	//	CfNXs
	 */
	int isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		int* piRessyaIndex ) ;
	///@}
};


#endif /*CentDedRessyaCont_h*/
