/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRosen.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRosen_h
#define  CentDedRosen_h

#include <deque>
using namespace std ;

#include "CentDed.h"
#include "CentDedEkiCont.h"
#include "CentDedRessyasyubetsuCont.h"
#include "CentDedDiaCont.h"
#include "Cont/CaCont_vector.h"

// ****************************************************************
//	CentDedRosen
// ****************************************************************
/**
 *	@brief
 *	yTvz  DiagramEdit ́AwHxP\܂B
 *	  ̃NX́A DiagramEdit ̃GeBeBNX CentDed... 
 *	[gƂȂNXłBȉ̃NX̃IuWFNg܂܂B
 *	
 *	- wwx ( CentDedEki ) F 0 ȏ㕡̃IuWFNg܂܂B
 *
 *	- wԎʁx ( CentDedRessyasyubetsu ) F 1 ȏ㕡̃IuWFNg
 *	܂܂B
 *
 *	- w_Cx ( CentDedDia ) F 0 ȏ㕡̃IuWFNg܂܂B
 *	w_Cx ( CentDedDia ) ́Awԁx ( CentDedRessya ) Oȏ㕡
 *	܂Ă܂BɁAwԁx́Awwx ( CentDedEkiJikoku ) 
 *	wwx̐܂Ă܂B
 *
 *	\n this ɕ܂ CentDedDia ́A CentDedDia::m_strName ӂłȂĂ
 *	Ȃ܂B CentDedDia  insertCentDedDia() œo^悤ƂƁA
 *	G[ƂȂ܂B
 *
 *  wwxIuWFNgǉE폜ꍇAthis ͕܂Ă
 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
 *	wwx ( CentDedEkiJikoku )IuWFNg̒ǉE폜s܂B
 *	
 *	  wԎʁxIuWFNg폜ꍇA this ͕܂Ă邷ׂĂ
 *	wԁxIuWFNĝA폜ꂽwԎIndexxwԁx
 *	ɑ΂āAwԎIndexx0(̗Ԏ)ɕύX܂B
 *
 *
 *	  wwIndexx́AH̉Ԃ̎nwiԂ̏Iwj 0 E 
 *	Ԃ̏IwiԂ̎nwj  ( w̐ - 1 ) ƂȂ܂B
 * @see CentDedRessya
 *	ywIndex  wOrderz QƂĂB
 */
class CentDedRosen
{
// ********************************
//	Ci[^Cv
// ********************************
public:

protected:
	// ----------------------------------------------------------------
	//	CentDedRosen::CXCentDedEkiCont
	// ----------------------------------------------------------------
	/**
	 *	@brief
	 *  wHxIuWFNgɕ܂A
	 *	wwx(CentDedEki) IuWFNg̃ReiłB
	 *
	 *  wwxIuWFNgǉE폜ꍇA
	 *	this ͊֘AwHx܂Ă
	 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
	 *	wwx ( CentDedEkiJikoku )IuWFNg̒ǉE폜s܂B
	 *	
	 */
	class CXCentDedEkiCont : public CentDedEkiCont
	{
	// ********************************
	//	Ci[^Cv
	// ********************************
	public:
		typedef CentDedEkiCont	super ;
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	 private:
		/**
		 *	wHxIuWFNgƂ̊֘AłB
		 *
		 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 */
		CentDedRosen*	m_pCentDedRosen ;
	///@}
	// ********************************
	//	RXgN^
	// ********************************
	 public:
		/**
		 * @param pCentDedRosen [in]
		 *	wHxIuWFNgƂ̊֘AłB
		 *	\ñIuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 *
		 * @attention
		 *	̃RXgN^́A
		 *	pCentDedRosen Ɋ܂܂SĂ̗Ԃ̉wA this ̉w
		 *	ɒ܂B
		 */
		CXCentDedEkiCont( CentDedRosen* pCentDedRosen ) ;

	 private:
		CXCentDedEkiCont( const CXCentDedEkiCont& value ){} ;
		CXCentDedEkiCont& operator=( const CXCentDedEkiCont& value ){} ;
	 public:
		virtual ~CXCentDedEkiCont() ;
		
	// ********************************
	//	IfCont
	// ********************************
	 public:
		/**
		 * 	ReíACfNXŎw肳ꂽꏊ
		 *	vfu܂B
		 * @param element [in]
		 * 	vfw肵ĂB
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() ȉłB
		 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedEki IuWFNgǉ̂ɉāA
		 *	m_pCentDedRosen ܂ĂSĂ̗Ԃ̂A
		 *	iIndex ̉wnEIƂԂ̉w
		 *	␳܂B
		 */
	 	virtual int  set (const CentDedEki& element, int iIndex) ;

		/**
		 * 	ReíACfNXŎw肳ꂽꏊɁA
		 * 	vfǉ܂B
		 * @param element [in]
		 * 	vfw肵ĂB
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() ȉłB
		 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedEki IuWFNgǉ̂ɉāA
		 *	m_pCentDedRosen ܂ĂSĂ̗Ԃɑ΂āA
		 *	w̒ǉs܂B
		 */
		virtual int insert( const CentDedEki& element , int iIndex = INT_MAX );
		/**
		 * 	ReíACfNXŎw肳ꂽꏊ
		 * 	vf폜܂B
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() łB
		 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @param iSize [in]
		 * 	폜vf̐w肵ĂB
		 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
		 * @attention
		 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedEki IuWFNg폜̂ɉāA
		 *	m_pCentDedRosen ܂ĂSĂ̗Ԃɑ΂āA
		 *	w̍폜s܂B
		 */
		virtual int erase( int iIndex  , int iSize = 1 ) ;
	};
	friend class CXCentDedEkiCont ;

	// ----------------------------------------------------------------
	//	CentDedRosen::CXCentDedRessyasyubetsuCont
	// ----------------------------------------------------------------
	/**
	 *	@brief
	 *  wHxIuWFNgɕ܂A
	 *	wԎʁx(CentDedRessyasyubetsu) IuWFNg̃ReiłB
	 *	
	 *	ʏ̗ԎʃReiɉāAȉ̂悤ȓ݂܂B
	 *	
	 *	
	 * PD  wԎʁxIuWFNgǉE폜ꍇA
	 *	this ͊֘AwHx܂Ă
	 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
	 *	wԎIndexx ( CentDedRessya::m_iRessyasyubetsuIndex )
	 *	̏Cs܂B
	 *
	 *	QD  ΉԂ m_pCentDedRosen ɑ݂ꍇA
	 *	̗Ԏʂ폜邱Ƃ͂ł܂B
	 *	  ʏAwԎʁx̃Reiuꍇ́A 
	 *	m_pCentDedRosen AׂĂ̗Ԃ폜ĂKv܂B
	 */
	class CXCentDedRessyasyubetsuCont : public CentDedRessyasyubetsuCont
	{
	// ********************************
	//	Ci[^Cv
	// ********************************
	public:
		typedef CentDedRessyasyubetsuCont	super ;
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	 private:
		/**
		 *	wHxIuWFNgƂ̊֘AłB
		 *
		 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 */
		CentDedRosen*	m_pCentDedRosen ;
	///@}
	// ********************************
	//	RXgN^
	// ********************************
	 public:
		/**
		 * @param pCentDedRosen [in]
		 *	wHxIuWFNgƂ̊֘AłB
		 *	\ñIuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 *
		 */
		CXCentDedRessyasyubetsuCont( CentDedRosen* pCentDedRosen ) ;

	 private:
		CXCentDedRessyasyubetsuCont( const CXCentDedRessyasyubetsuCont& value ){} ;
		CXCentDedRessyasyubetsuCont& operator=( const CXCentDedRessyasyubetsuCont& value ){} ;
	 public:
		virtual ~CXCentDedRessyasyubetsuCont() ;
		
	// ********************************
	//	IfCont
	// ********************************
	 public:
		/**
		 * 	ReíACfNXŎw肳ꂽꏊɁA
		 * 	vfǉ܂B
		 * @param element [in]
		 * 	vfw肵ĂB
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() ȉłB
		 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *	-	-1 ;	//	iIndex słB
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedRessyasyubetsu IuWFNgǉ̂ɉāA
		 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
		 *	wԎIndexx ( CentDedRessya::m_iRessyasyubetsuIndex )
		 *	̏Cs܂B
		 */
		virtual int insert( const CentDedRessyasyubetsu& element , int iIndex = INT_MAX );
		/**
		 * 	ReíACfNXŎw肳ꂽꏊ
		 * 	vf폜܂B
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() łB
		 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @param iSize [in]
		 * 	폜vf̐w肵ĂB
		 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
		 * @attention
		 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *	-	-1 ;	//	iIndex słB
		 *	-	-11 ;	//	폜Ώۂ̗Ԏʂ̗Ԃ݂܂B
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedRessyasyubetsu IuWFNg폜̂ɉāA
		 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
		 *	wԎIndexx ( CentDedRessya::m_iRessyasyubetsuIndex )
		 *	̏Cs܂B
		 */
		virtual int erase( int iIndex  , int iSize = 1 ) ;

	};
	friend class CXCentDedRessyasyubetsuCont ;



// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	Ĥ̖łB
	 *	ij "ߓS" Ȃ
	 */
	string	m_strName ;
	
	/**
	 *	_C̋N_łB
	 *	̎́A_CO̍[̎ƂȂ܂B
	 *
	 *	l 00:00:00 łB
	 * @attention
	 *	̒ĺA Null ԂɂȂłB
	 */
	CdDedJikoku	m_jikokuKitenJikoku ;
	
	/**
	 *	RgB
	 *	CDedCommentDoc,CDedCommentView ŕҏW܂B
	 */
	string	m_strComment ;
	
///@}
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	́wHxɂwwx ( CentDedEki ) ێ܂B
	 *
	 *	̃Rei CentDedEki IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *	Ԃł́Avf 0 ƂȂ܂B
	 */
	CXCentDedEkiCont*	m_pCentDedEkiCont ;
	
	/**
	 *	́wHxɂwԎʁx ( CentDedRessyasyubetsu ) ێ܂B
	 *
	 *	̃Rei CentDedRessyasyubetsu IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *	Ԃł́Avf 1 ƂȂ܂B
	 *	wԎʁx́AȂƂ݂͑ȂĂ͂Ȃ܂B
	 */
	CXCentDedRessyasyubetsuCont*	m_pCentDedRessyasyubetsuCont ;
	
	/**
	 *	́wHxɂw_Cx ( CentDedDia ) ێ܂B
	 *
	 *	̃Rei CentDedDia IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *
	 * @attention
	 *	this ́A CentDedDia::m_strName qƂĈ܂B
	 *	\n ̃Rei CentDedDia ́A CentDedDia::m_strName 
	 *	ӂłȂĂ͂Ȃ܂B
	 *
	 *	Ԃł́Avf 0 ƂȂ܂B
	 */
	CentDedDiaCont	m_CentDedDiaCont ;
	
///@}
	
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param strName [in]
	 *	Ĥ̖łB	\n
	 *	ij "ߓS" Ȃ
	 */
	CentDedRosen() ;
	
	CentDedRosen( const CentDedRosen& value );
	CentDedRosen& operator=( const CentDedRosen& value );

	virtual ~CentDedRosen() ;

	
// ********************************
//	CentDedRosen
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	string	getName()const{	return m_strName ;};
	CentDedRosen& setName( const string& value ){
		m_strName = value ; return *this ; } ;
	CdDedJikoku	getKitenJikoku()const{	return m_jikokuKitenJikoku ;};
	CentDedRosen& setKitenJikoku( const CdDedJikoku& value ){
		m_jikokuKitenJikoku = value ; return *this ; 
	} ;
	string	getComment()const{return m_strComment ;};
	CentDedRosen& setComment( const string& value ){
		m_strComment = value ;	return *this ; 
	} ;
	///@}
	
	// ********************************
	///@name -CentDedEki
	// ********************************
	///@{
	/**
	 * @return 
	 *	wwx ( CentDedEki ) IuWFNg̃Reiւ
	 *	C^[tF[XԂ܂B
	 *	̃C^[tF[X́A CentDedEki IuWFNgH
	 *	ǉE폜邽߂̃C^[tF[XłB
	 */
	CentDedEkiCont* getCentDedEkiCont(){	return m_pCentDedEkiCont ; } ;
	const CentDedEkiCont* getCentDedEkiCont()const{	return m_pCentDedEkiCont ; } ;
	
	/**
	 *	wwIndexx CfNXɂāAReỉwIuWFNg
	 *	ANZX邱Ƃ̂ł IfContGet<CentDedEki*> C^[tF[X
	 *	擾邱Ƃł܂B
	 * @return 
	 *	Rei̗vf̃IuWFNg
	 *	ANZX邽߂ IfContGet<CentDedEki*>* Ԃ܂B
	 *
	 *	̃C^[tF[X
	 */
	IfContGet<const CentDedEki*>* getCentDedEkiContGet()
	{
		return m_pCentDedEkiCont->getIfContGet() ;
	};
	const IfContGet<const CentDedEki*>* getCentDedEkiContGet()const
	{
		return m_pCentDedEkiCont->getIfContGet() ;
	};
	
	/**
	 *	wwOrderx CfNXɂāAReỉwIuWFNg̏񂪎擾ł
	 *	 IfContGet<CentDedEkiCont::CdDedEki> C^[tF[X
	 *	擾邱Ƃł܂B
	 * @param eRessyahoukou [in]
	 *	ԕw肵ĂB
	 * @return 
	 *	ReỉwIuWFNg CentDedEki ւ̃|C^
	 *	ANZX邽߂ IfContGet<CentDedEki*>* Ԃ܂B
	 */
	IfContGet<CentDedEkiCont::CdDedEki>* getCentDedEkiContGet( ERessyahoukou eRessyahoukou )
	{
		return m_pCentDedEkiCont->getIfContGet( eRessyahoukou ) ;
	};
	const IfContGet<CentDedEkiCont::CdDedEki>* getCentDedEkiContGet( ERessyahoukou eRessyahoukou )const
	{
		return m_pCentDedEkiCont->getIfContGet( eRessyahoukou ) ;
	};
	
	///@}
	
	// ********************************
	///@name -CentDedRessyasyubetsu
	// ********************************
	///@{
	/**
	 * @return 
	 *	wԎʁx ( CentDedRessyasyubetsu ) IuWFNg̃Reiւ
	 *	C^[tF[XԂ܂B
	 *	̃C^[tF[X́A CentDedRessyasyubetsu IuWFNgH
	 *	ǉE폜邽߂̃C^[tF[XłB
	 */
	CentDedRessyasyubetsuCont* getCentDedRessyasyubetsuCont()
	{
		return m_pCentDedRessyasyubetsuCont ; 
	} ;
	const CentDedRessyasyubetsuCont* getCentDedRessyasyubetsuCont()const
	{
		return m_pCentDedRessyasyubetsuCont ; 
	} ;
	
	/**
	 *	wԎIndexx CfNXɂāA
	 *	Rei̗ԎʃIuWFNg
	 *	ANZX邱Ƃ̂ł IfContGet<CentDedRessyasyubetsu*> 
	 *	C^[tF[X擾邱Ƃł܂B
	 * @return 
	 *	Rei̗vf̃IuWFNg
	 *	ANZX邽߂ IfContGet<CentDedRessyasyubetsu*>* Ԃ܂B
	 *
	 *	̃C^[tF[X
	 */
	IfContGet<CentDedRessyasyubetsu*>* getCentDedRessyasyubetsuContGet()
	{
		return m_pCentDedRessyasyubetsuCont->getIfContGet() ;
	};
	const IfContGet<CentDedRessyasyubetsu*>* 
		getCentDedRessyasyubetsuContGet()const
	{
		return m_pCentDedRessyasyubetsuCont->getIfContGet() ;
	};

	
	/**
	 *	Q́wԎʁxIndexւ܂B
	 *
	 *	w̗ԎIndexׂĂ̗ԂIndexA
	 *	ւ܂B
	 *	
	 * @param iRessyasyubetsuIndexA , iRessyasyubetsuIndexB [in]
	 *	wԎIndexxw肵ĂB
	 *	͈͂́A 0 ȏ Ԏʂ̐łB
	 *	INT_MAX ́A̗Ԏʂw肵̂Ƃ݂Ȃ܂B
	 *	iRessyasyubetsuIndexA  iRessyasyubetsuIndexB ́A
	 *	قȂlłȂĂ͂Ȃ܂B
	 * @return 
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-1 ;	//	ԎIndexsłB
	 */
	int swapRessyasyubetsu( int iRessyasyubetsuIndexA ,
		int iRessyasyubetsuIndexB ) ;
	
	///@}
	// ********************************
	///@name -CentDedDia
	// ********************************
	///@{
	/**
	 * @return 
	 *	w_Cx ( CentDedDia ) IuWFNg̃Reiւ
	 *	C^[tF[XԂ܂B
	 *	̃C^[tF[X́A CentDedDia IuWFNgH
	 *	ǉE폜邽߂̃C^[tF[XłB
	 */
	CentDedDiaCont* getCentDedDiaCont(){	return &m_CentDedDiaCont ;};
	const CentDedDiaCont* getCentDedDiaCont()const{	return &m_CentDedDiaCont ;};

	/**
	 * @return 
	 *	w_Cx ( CentDedDia ) IuWFNg̃Reiւ
	 *	C^[tF[XԂ܂B
	 *	̃C^[tF[X́A CentDedDia IuWFNgւ̃|C^
	 *	ANZX邽߂̃C^[tF[XłB
	 */
	IfContGet<CentDedDia*>* getCentDedDiaContGet()
	{
		return m_CentDedDiaCont.getIfContGet() ;
	};
	const IfContGet<CentDedDia*>* getCentDedDiaContGet()const
	{
		return m_CentDedDiaCont.getIfContGet() ;
	};
	///@}
	
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	 *	ׂĂ̑j܂B
	 */
	void clear() ;
	///@}
};





#endif /*CentDedRosen_h*/
