/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaCont_vector.h
// ****************************************************************
*/
/** @file */
#ifndef  CaCont_vector_h
#define  CaCont_vector_h
#include <stddef.h>
#include "./IfValueCont.h"

// ****************************************************************
//	CaCont_vector
// ****************************************************************
/**
 * @brief
 * yTvz
 *   IfValueCont C^[tF[XŁASTL̃_ANZXRei
 *	i_ANZXqT|[g
 * ReiBstd::vector  std::dequej𑀍삷AA_v^NXłB
 *	
 *   ̃NX̃IuWFNǵAΏۂƂȂ̃ReiƊ֘A
 *	܂B
 * 
 * 	  Rei̗vf̌^́AftHgRXgN^ = 
 *	p\łKv܂B
 * 
 * ygz
 * 
 * PD  ʏ́A炩ߑΏۃIuWFNgiAdapteej
 * i STL_ANZXReiistd::vector  std::deque jj
 *	 𐶐ĂB
 *
 *	QD  ̃NX̃ev[gɂ́AΏۃIuWFNǧ^
 *	w肵ĂB܂ARXgN^ł́AΏۃIuWFNg
 *	ւ̃|C^w肵ĂB
 * 
@code
	std::vector<int>	aVector ;
	CaCont_vector< std::vector<int>	>	aCont( &aVector )  ;
@endcode

 *   ̃NXɁAΏۃIuWFNg𐶐邱Ƃł܂B
 * ̏ꍇ́ARXgN^̈ NULL w肵ĂB
 * 
@code
	CaCont_vector< std::vector<int>	> aCont( NULL ) ;
@endcode
 * RD  Ȍ́A IfCont C^[tF[X̃\bh𗘗pāA
 * Rei𑀍삷邱Ƃł܂B
 *
 * <H4>
 *	yRei̗vf̃CX^Xɂāz
 * </H4>
 *	 ReĩTCYύX郁\bhĂяoꍇA
 *	ReĩCX^X̍Ċ蓖Ă܂B
 *  Ċ蓖ĂƁAgetp() Ŏ擾|C^͖ɂȂ܂B
 *
 *
 * @param ContType
 *	Ώۂ̃Reǐ^w肵ĂB
 *	̌^́Ai[vf̌^ev[gp[^Ɏw肵
 *	 std::vector  std::deque łȂĂ͂Ȃ܂B
 *	i[vf̌^ev[gp[^Ɏw肵
 */
template< class ContType >
class CaCont_vector : public IfValueCont< typename ContType::value_type >
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**
	 *	Ώۂ̃Reǐ^
	 */
	typedef ContType	cont_type ;

// ********************************
///@name ֘A
// ********************************
///@{
 private:	
	/**
	 *   Ώۂ́ASTL_ANZXReiłB
	 *
	 *	Ώۂw肹ɂ̃NX̃IuWFNg𐶐ꍇA
	 *	RXgN^́AΏۃRei𐶐܂B̏ꍇA
	 *  vf m_bIsDeleteObligatory  true ƂȂ܂B
	 *
	 *  ̃IuWFNg̔j̐Ӗ́Af[^ m_bIsDeleteObligatory 
	 *	 false ̏ꍇ̓NX[U[E true ̏ꍇ this ɂ܂B
	 *	
	 *	Ώۂ́Å֘ALȊԂ͐ȂĂ͂Ȃ܂B
	 */
	ContType*	m_pAdaptee ;
	
///@}
// --------------------------------
///@name f[^
// --------------------------------
///@{
 private:
	/**
	 * @see m_pAdaptee
	 */
	bool	m_bIsDeleteObligatory ;
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param pContType [in]
	 *   Ώۂ́ASTL_ANZXReiłB
	 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
	 *	Ώۂ́Å֘ALȊԂ͐ȂĂ͂Ȃ܂B\n
	 */
	CaCont_vector( ContType* pContType )
		: m_pAdaptee( pContType )
		, m_bIsDeleteObligatory( false ){};
	
	/**
	 *   ̃RXgN^́A
	 *	Ώۂ STL_ANZXRei m_pAdaptee 
	 *	ÃNXŐ܂B
	 */
	CaCont_vector()
		: m_pAdaptee( new ContType  )
		, m_bIsDeleteObligatory( true ){};
	
	/**
	 *  Rs[RXgN^́A
	 *	Ώۂ STL_ANZXRei m_pAdaptee 
	 *	ÃNXŐ܂B
	 */
	CaCont_vector( const CaCont_vector& element )
		: m_pAdaptee( new ContType )
		, m_bIsDeleteObligatory( true )
	{
		*m_pAdaptee = *element.m_pAdaptee ;
	};
	
	CaCont_vector& operator=( const CaCont_vector& element )
	{
		*m_pAdaptee = *element.m_pAdaptee ;
		return *this ; 
	};
	
	virtual ~CaCont_vector()
	{
		if ( m_bIsDeleteObligatory ){
			delete m_pAdaptee ;
			m_bIsDeleteObligatory = false ;
			m_pAdaptee = NULL ;
		}
	};
	
	
// ********************************
///@name	IfContGet
// ********************************
///@{
 public:
	/**
	 * @return
	 * 	ReiɊi[Ăvf̌Ԃ܂B
	 */
	virtual int	size()const
	{
		return m_pAdaptee->size() ; 
	} ;
	
	// --------------------------------

	/**
	 * 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 * 	vfԂ܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	CfNXŎw肳ꂽvfԂ܂B
	 *
	 *	CfNXsȏꍇ͖̓`łB
	 */
	virtual value_type get( int iIndex )const
	{
		if ( iIndex == INT_MAX ){
			iIndex = m_pAdaptee->size() - 1 ; 
		}
		if ( !( 0 <= iIndex && iIndex < (int)m_pAdaptee->size() ) ){
			return *( (value_type*)NULL ) ; 
		}
		return (*m_pAdaptee)[iIndex] ;
	} ;
	
	// --------------------------------
// ********************************
///@name	IfCont
// ********************************
///@{
 public:
	
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	vfZbgi㏑j܂B
	 * @param element [in]
	 * 	vfw肵ĂB
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	INT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 *	-	-1 ;	//	iIndexs
	 */
	virtual int set( const value_type& element , int iIndex ) 
	{
		if ( iIndex == INT_MAX ){
			iIndex = m_pAdaptee->size() - 1 ; 
		}
		if ( !( 0 <= iIndex && iIndex < (int)m_pAdaptee->size() ) ){
			return -1 ;	//	iIndexs
		}
		(*m_pAdaptee)[iIndex] = element ;
		return ( 0 ) ;
	};

	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	vfǉ܂B
	 * @param element [in]
	 * 	vfw肵ĂB
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() ȉłB
	 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
	 *	INT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 *	-	-1 ;	//	iIndexs
	 */
	virtual int insert( const value_type& element , int iIndex = INT_MAX ) 
	{
		if ( iIndex == INT_MAX ){
			iIndex = m_pAdaptee->size() ; 
		}
		if ( !( 0 <= iIndex && iIndex <= (int)m_pAdaptee->size() ) ){
			return -1 ;	//	iIndexs
		}
		m_pAdaptee->insert( m_pAdaptee->begin() + iIndex , element ) ;
		return ( 0 ) ;
	};
	
	/**
	 * 	ReíACfNXŎw肳ꂽꏊ
	 * 	vf폜܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @param iSize [in]
	 * 	폜vf̐w肵ĂB
	 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 * @attention
	 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 *	-	-1 ;	//	iIndex s
	 */
	virtual int erase( int iIndex , int iSize = 1 ) 
	{
		if ( iIndex == INT_MAX && iSize == INT_MAX ){
			return -1 ;	//	iIndexs
		}
		if ( iIndex == INT_MAX ){
			iIndex = m_pAdaptee->size() - iSize ; 
		}
		if ( iSize == INT_MAX ){
			iSize = m_pAdaptee->size() - iIndex ; 
		}
		if ( !( 0 <= iIndex && iIndex + iSize <= (int)m_pAdaptee->size() ) ){
			return -1 ;	//	iIndexs
		}
		// --------------------------------
		m_pAdaptee->erase( 
			m_pAdaptee->begin() + iIndex , 
			m_pAdaptee->begin() + iIndex + iSize ) ;
		return ( 0 ) ;
	};
///@}
// ********************************
///@name IfValueCont
// ********************************
///@{
 public:
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɊi[Ăvfւ
	 * 	 const ȃ|C^擾邱Ƃł܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() ȉłB
	 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
	 *	INT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	ReíACfNXŎw肳ꂽꏊɊi[Ăvfւ
	 * 	 const ȃ|C^Ԃ܂B
	 * 	iSize ͈͊Ȍꍇ́A NULL Ԃ܂B
	 */
	virtual value_type* getp( int iIndex ) 
	{
		if ( iIndex == INT_MAX ){
			iIndex = m_pAdaptee->size() - 1 ; 
		}
		if ( !( 0 <= iIndex && iIndex < (int)m_pAdaptee->size() ) ){
			return NULL ; 
		}
		return &(*m_pAdaptee)[iIndex] ;
	};
///@}
// ********************************
// CaCont_vector
// ********************************
 public:
	// ********************************
	///@name CaCont_vector-֘A
	// ********************************
	///@{
	ContType*	getAdaptee(){	return m_pAdaptee ;};
	const ContType*	getAdaptee()const{	return m_pAdaptee ;};
	CaCont_vector& setAdaptee( ContType*	pAdaptee )
	{
		if ( m_bIsDeleteObligatory && pAdaptee != NULL ){
			delete m_pAdaptee ;
			m_bIsDeleteObligatory = false ;
			m_pAdaptee = pAdaptee ;
		}	else if ( !m_bIsDeleteObligatory && pAdaptee == NULL ){
			m_bIsDeleteObligatory = true ;
			m_pAdaptee = new ContType ;
		}	else	{
			m_pAdaptee = pAdaptee ;
		}
		return *this ;
	};
	
	///@}
	// --------------------------------

};

#endif /*CaCont_vector_h*/
