/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvCDedRosenFileData.h
// ****************************************************************
*/
#ifndef  CconvCDedRosenFileData_h
#define  CconvCDedRosenFileData_h
/** @file */
#include "CconvCdDedDispProp.h"
#include "str\OuPropertiesText\CNodeContainer.h"
#include "str\OuPropertiesText\ErrorInfo\COuErrorInfoContainer.h"

// ****************************************************************
//	CconvCDedRosenFileData
// ****************************************************************
/**
	@brief
	  wHt@Cxf[^ ( CDedRosenFileData ) ̓eA
	f[^`ɕϊ֐^Ă܂B
	
	 wHt@Cxf[^  OuPropertiesText::CNodeContainer IuWFNgƂ̊Ԃ
	ϊT|[gĂ܂B 
	
	<H4>
	yHt@C (.ded) z
	</H4>
	  wHt@Cx́AHt@Cf[^NX
	 CDedRosenFileData_To_string() ŕɕϊA̕Ŝ
	ۑeLXgt@CłB
	
	   CDedRosenFileData_To_string() ֐́A
	   CDedRosenFileData IuWFNgێf[^
	ȉ̎菇ŕɕϊ܂B
	  ̕t@Cɕۑ邱ƂɂA
	 wHt@CxƂȂ܂B
*/
class CconvCDedRosenFileData
{
public:
	// ********************************
	///@name COuErrorInfo::m_strReason , m_Prop 
	// ********************************
	/**
		FileType słB
	@param FileType
		FileType
	*/
	static const char* ERRREASON_FileTypeIsInvalid(){	return "FileType Is Invalid." ;};
	static const char* ERRPROP_FileType(){	return "FileType" ;};
	/**
		Rosen Directory ܂B
	*/
	static const char* ERRREASON_RosenDirectoryIsNotFound(){	return "Rosen Directory is not found." ;};
	/**
		DispProp Directory ܂B
	*/
	static const char* ERRREASON_DispPropnDirectoryIsNotFound(){	return "DispProp Directory is not found." ;};
public:
	// ********************************
	//	CdDedDispProp
	// ********************************
	/**
	 @return
		PropertyTextACe "FileType" ̒lłB
	*/
	static string getFileType(){	return "OuDia.5" ; } ;
	
	
	
	// ********************************
	///@name	OuPropertiesText ւ̕ϊ
	// ********************************
	///@{
	/**
		  OuPropertiesText IuWFNgɁA
		  CDedRosenFileData ̑ǉ܂B
		@param aCDedRosenFileData [in]
		  CDedRosenFileData w肵ĂB
		  pCNodeContainer ɂ́A"FileType" PropertyString ܂݂܂B
		@param pCNodeContainer [out]
		  ̊֐́ÃIuWFNgɁA CDedRosenFileData ̓e𔽉f܂B
		  pCNodeContainer ܂ŕێĂIuWFNg͔j܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
				-	-11 ;	//	Ekimei w肳Ă܂B
				-	-22 ;	//	Ekijikokukeisiki ̒lsłB
				-	-32 ;	//	Ekikibo ̒lsłB
				-	-111 ;	//	Syubetsumei w肳Ă܂B
				-	-152 ;	//	DiagramSenStyle ̒lsłB
				-	-212 ;	//	DiagramEkiatsukai ̒lsłB
	*/
	int CDedRosenFileData_to_OuPropertiesText( 
			const CDedRosenFileData* pCDedRosenFileData , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CDedRosenFileData_to_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CDedRosenFileData IuWFNgɔf܂B
		
		@param pCDedRosenFileData [out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		  ̃IuWFNg܂ŕێĂf[^͔j܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-1 ;	//	FileType ܂B
			-	-2 ;	//	Rosen Directory܂B
			-	-11 ;	//	Ekimei w肳Ă܂B
			-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			-	-32 ;	//	Ekikibo ̒lsłB
			-	-101 ;	//	Eki fBNgł͂܂B
			-	-111 ;	//	Syubetsumei w肳Ă܂B
			-	-152 ;	//	DiagramSenStyle ̒lsłB
			-	-201 ;	//	Ressyasyubetsu fBNgł͂܂B
			-	-211 ;	//	DiaName w肳Ă܂B
			-	-212 ;	//	RessyaCont܂B
			-	-352 ;	//	N_̐ݒ肪sK؂łB
			-	-3 ;	//	DispProp Directory܂B
			-	-512 ;	//	JikokuhyouFont ̓esłB
			-	-522 ;	//	DiaEkimeiFont ̓esłB
			-	-532 ;	//	DiaJikokuFont ̓esłB
			-	-582 ;	//	DisplayRessyabangou słB
			-	-592 ;	//	DisplayRessyamei słB
			-	-602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
			-	-612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
	*/
	int CDedRosenFileData_from_OuPropertiesText( 
			CDedRosenFileData* pCDedRosenFileData ,
			const OuPropertiesText::CNodeContainer* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	/**
		  OuPropertiesText IuWFNg
		̃NXŉ߉\ȃtH[}bgۂ𔻒肵܂B
	@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
	@return
		-	0 ;	//	߉\łB
		-	-1 ;	//	FileType ܂B
		
	@note
		FileType ̒l𔻒肵܂B
	*/
	int isEncodeAbleFormat( 
			const OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	
	///@}
	// ********************************
	///@name Ht@C`ւ̕ϊ
	// ********************************
	///@{
	/**
		  CDedRosenFileData ̕ێf[^A
		wHt@Cx(.ded) `̕쐬܂B
	
		@param aCDedRosenFileData [in]
		  CDedRosenFileData w肵ĂB
		@param pString [out]
		  ̊֐́A̕IuWFNgɁA
		wHt@Cx(.ded) `̕ݒ肵܂B
		  ̃IuWFNg܂ŕێĂ͔j܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	Ekimei w肳Ă܂B
		-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		-	-32 ;	//	Ekikibo ̒lsłB
		-	-111 ;	//	Syubetsumei w肳Ă܂B
		-	-152 ;	//	DiagramSenStyle ̒lsłB
		-	-212 ;	//	DiagramEkiatsukai ̒lsłB
	*/
	int CDedRosenFileData_to_string( 
			const CDedRosenFileData& aCDedRosenFileData , 
			string* pString  ) ;
	
	/**
		  CDedRosenFileData_to_string() Ő
		wHt@Cx(.ded) `̕߂A
		 CDedRosenFileData IuWFNgɔf܂B
		
		@param pCDedRosenFileData [out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		  ̃IuWFNg܂ŕێĂf[^͔j܂B
		@param aString [in]
		  CDedRosenFileData_to_string() Ő
		wHt@Cx(.oud) `̕w肵ĂB
		@param pCOuErrorInfoContainer [in]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-1 ;	//	fBNgrŕĂ܂B	
			-	-1001 ;	//	FileType ܂B
			-	-1002 ;	//	Rosen Directory܂B
			-	-1011 ;	//	Ekimei w肳Ă܂B
			-	-1022 ;	//	Ekijikokukeisiki ̒lsłB
			-	-1032 ;	//	Ekikibo ̒lsłB
			-	-1101 ;	//	Eki fBNgł͂܂B
			-	-1111 ;	//	Syubetsumei w肳Ă܂B
			-	-1152 ;	//	DiagramSenStyle ̒lsłB
			-	-1201 ;	//	Ressyasyubetsu fBNgł͂܂B
			-	-1211 ;	//	DiaName w肳Ă܂B
			-	-1212 ;	//	RessyaCont܂B
			-	-1352 ;	//	N_̐ݒ肪sK؂łB
			-	-1003 ;	//	DispProp Directory܂B
			-	-1512 ;	//	JikokuhyouFont ̓esłB
			-	-1522 ;	//	DiaEkimeiFont ̓esłB
			-	-1532 ;	//	DiaJikokuFont ̓esłB
			-	-1582 ;	//	DisplayRessyabangou słB
			-	-1592 ;	//	DisplayRessyamei słB
			-	-1602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
			-	-1612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
	*/
	int CDedRosenFileData_from_string( 
			CDedRosenFileData* pCDedRosenFileData ,
			const string& aString ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;

	/**
		t@C̓ei[
		̃NXŉ߉\ȃtH[}bgۂ𔻒肵܂B
	@param aString [in]
		  CDedRosenFileData_to_string() Ő
		wHt@Cx(.oud) `̕w肵ĂB
	@return
		-	0 ;	//	߉\łB
		-	-1 ;	//	FileType ܂B
		-	-1001 ;	//	FileType ܂B
	@note
		FileType ̒l𔻒肵܂B
	*/
	int isEncodeAbleFormat( 
			const string& aString  ) ;
	///@}	
};
#endif /*CconvCDedRosenFileData_h*/
