/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdDedDispProp.h
// ****************************************************************
*/
/** @file */
#ifndef  CdDedDispProp_h
#define  CdDedDispProp_h

#include "DcDraw/CdFontProp.h"
#include "DcDraw/CdColorProp.h"

#include "CentDed.h"
// ****************************************************************
//	CdDedDispProp
// ****************************************************************
/**
 * @brief
 *	yTvz  DiagramEdit ̕\Ɋ֌WvpeBێ
 *	Pf[^NXłB
 */
class CdDedDispProp
{
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	 \ʃtHgB
	 *	KĺA	CdFontProp( 9 ,"lr SVbN"  ) B
	 */
	CdFontProp	m_fontpropJikokuhyouFont ;

	/**
	 *	 _CʉwtHgB
	 *	KĺA	CdFontProp( 9 ,"lr SVbN"  ) B
	 */
	CdFontProp	m_fontpropDiaEkimeiFont ;

	/**
	 *	 _CʎtHgB
	 *	KĺA	CdFontProp( 9 ,"lr SVbN"  ) B
	 */
	CdFontProp	m_fontpropDiaJikokuFont ;

	/**
	 *	 _CʗԃtHgB
	 *	KĺA	CdFontProp( 9 ,"lr SVbN"  ) B
	 */
	CdFontProp	m_fontpropDiaRessyaFont ;

	/**
	 *	 Rgr[tHgB
	 *	KĺA	CdFontProp( 9 ,"lr SVbN"  ) B
	 */
	CdFontProp	m_fontpropViewComment ;

	/**
	 *	 _CʕFB
	 *	KĺAB
	 */
	CdColorProp	m_colorDiaMojiColor ;
	/**
	 *	 _CʔwiFB
	 *	KĺAB
	 */
	CdColorProp	m_colorDiaHaikeiColor ;
	/**
	 *	 _CʗԐFB
	 *	KĺAB
	 */
	CdColorProp	m_colorDiaRessyaColor ;
	/**
	 *	 _CʏcFB
	 *	KĺAB
	 */
	CdColorProp	m_colorDiaJikuColor ;

	/**
	 *	w̕ێ܂B
	 *	Pʂ́ASpł̕łB
	 *	܂Aẃ̕A
	 *
	 *		̍ ~ m_iEkimeiLength 
	 *	
	 *	ƂȂ܂B
	 *	ftHgl 6 Ƃ܂Bŏl 1 łB
	 */
	int m_iEkimeiLength ;

	/**
		\r[́Aԗ̕ێ܂B
		Pʂ́Apł̕łB

		ԗ́̕A ̍~m_iJikokuhyouRessyaWidth / 2 ƂȂ܂B

		Kl 5 Ƃ܂Bŏl 4,ől8łB
	*/
	int m_iJikokuhyouRessyaWidth ;

	/**
	 *	 _Cʗԏ\ʒu:wwOrderx
	 *	( Ressyahoukou_Kudari )́A
	 *	ԏ\ʒuAwwOrderxŎw肵܂B
	 *
	 *	AA̒lwwx ( CentDedEki ) ̐ȏ̏ꍇ́A
	 *	( wwx̐  - 1 ) w肳Ă̂Ƃ݂Ȃ܂B
	 *	
	 *	Kl 0 łB
	 *	
	 * @attention
	 *	wwOrderxɂẮA CentDedRessya QƂĂB
	 */
	int m_iDiaRessyajouhouHyoujiEkiOrderKudari ;
	/**
	 *	( Ressyahoukou_Nobori )́A
	 *	ԏ\ʒuAwwOrderxŎw肵܂B
	 * @see m_iDiaRessyajouhouHyoujiEkiOrderKudari 
	 */
	int m_iDiaRessyajouhouHyoujiEkiOrderNobori ;

///@}

// ********************************
//	RXgN^
// ********************************
 public:
	CdDedDispProp() :
		m_fontpropJikokuhyouFont( 9 ,"lr SVbN"  ) ,
		m_fontpropDiaEkimeiFont( 9 ,"lr SVbN"  ) ,
		m_fontpropDiaJikokuFont( 9 ,"lr SVbN"  ) ,
		m_fontpropDiaRessyaFont( 9 ,"lr SVbN"  ) ,
		m_fontpropViewComment( 9 ,"lr SVbN"  ) ,
		m_colorDiaMojiColor( CdColorProp( 0 , 0 , 0 ) ) ,
		m_colorDiaHaikeiColor( CdColorProp( 255 , 255 , 255 ) ) ,
		m_colorDiaRessyaColor( CdColorProp( 0 , 0 , 0 ) ) ,
		m_colorDiaJikuColor( CdColorProp(192 , 192 , 192 ) ) ,
		m_iEkimeiLength( 6 ) ,
		m_iJikokuhyouRessyaWidth( 5 ) ,
		m_iDiaRessyajouhouHyoujiEkiOrderKudari( 0 ) ,
		m_iDiaRessyajouhouHyoujiEkiOrderNobori( 0 ) {};
	
	
// ********************************
//	CdDedDispProp
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	CdFontProp	getJikokuhyouFont()const{
		return 	m_fontpropJikokuhyouFont ;};
	CdDedDispProp& setJikokuhyouFont( const CdFontProp& value ){
		m_fontpropJikokuhyouFont = value ; return *this ;};
	CdFontProp	getDiaEkimeiFont()const{
		return 	m_fontpropDiaEkimeiFont ;};
	CdDedDispProp& setDiaEkimeiFont( const CdFontProp& value ){
		m_fontpropDiaEkimeiFont = value ; return *this ;};
	CdFontProp	getDiaJikokuFont()const{
		return 	m_fontpropDiaJikokuFont ;};
	CdDedDispProp& setDiaJikokuFont( const CdFontProp& value ){
		m_fontpropDiaJikokuFont = value ; return *this ;};
	CdFontProp	getDiaRessyaFont()const{
		return 	m_fontpropDiaRessyaFont ;};
	CdDedDispProp& setDiaRessyaFont( const CdFontProp& value ){
		m_fontpropDiaRessyaFont = value ; return *this ;
	};
	CdFontProp	getViewCommentFont()const{	return m_fontpropViewComment ;};
	CdDedDispProp& setViewCommentFont( const CdFontProp& value ){
		m_fontpropViewComment = value ; return *this ; 
	};


		
	CdColorProp	getDiaMojiColor()const{
		return m_colorDiaMojiColor ;};
	CdDedDispProp& setDiaMojiColor( const CdColorProp& value ){
		m_colorDiaMojiColor = value ; return *this ;};
	CdColorProp	getDiaHaikeiColor()const{
		return m_colorDiaHaikeiColor ;};
	CdDedDispProp& setDiaHaikeiColor( const CdColorProp& value ){
		m_colorDiaHaikeiColor = value ; return *this ;};
	CdColorProp	getDiaRessyaColor()const{
		return m_colorDiaRessyaColor ;};
	CdDedDispProp& setDiaRessyaColor( const CdColorProp& value ){
		m_colorDiaRessyaColor = value ; return *this ;};
	CdColorProp	getDiaJikuColor()const{
		return m_colorDiaJikuColor ;};
	CdDedDispProp& setDiaJikuColor( const CdColorProp& value ){
		m_colorDiaJikuColor = value ; return *this ;};

	int getEkimeiLength()const{ return m_iEkimeiLength ;};
	CdDedDispProp& setEkimeiLength( int value )
	{
		m_iEkimeiLength = value ;
		if ( m_iEkimeiLength < 1 ){
			m_iEkimeiLength = 1 ;
		}
		if ( m_iEkimeiLength > 20 ){
			m_iEkimeiLength = 20 ;
		}
		return *this ;
	};

	int getJikokuhyouRessyaWidth()const
	{	return m_iJikokuhyouRessyaWidth ; };
	CdDedDispProp& setJikokuhyouRessyaWidth( int value )
	{	
		m_iJikokuhyouRessyaWidth = value ;	
		if ( m_iJikokuhyouRessyaWidth < 4 )
		{
			m_iJikokuhyouRessyaWidth = 4 ;
		}
		if ( m_iJikokuhyouRessyaWidth > 8 )
		{
			m_iJikokuhyouRessyaWidth = 8 ;
		}
		return *this ;
	};

	/**
	 * @return
	 *	w̕擾邽߂̕쐬܂B
	 *	̊֐́ASp m_iEkimeiLength ׂ
	 *	ie͎gȂjԂ܂B
	 */
	string createEkimeiExtentString()const 
	{
		string	strRv ;
		for ( int idx = 0 ; idx < m_iEkimeiLength ; idx ++ ){
			strRv += "" ;
		}
		return strRv ;
	};
	

	
	int getDiaRessyajouhouHyoujiEkiOrder( ERessyahoukou eRessyahoukou )const{
		if ( eRessyahoukou == Ressyahoukou_Kudari ){
			return m_iDiaRessyajouhouHyoujiEkiOrderKudari ;
		}
		return m_iDiaRessyajouhouHyoujiEkiOrderNobori ;
	};
	CdDedDispProp& setDiaRessyajouhouHyoujiEkiOrder( 
		 ERessyahoukou eRessyahoukou , int value ){
		if ( eRessyahoukou == Ressyahoukou_Kudari ){
			m_iDiaRessyajouhouHyoujiEkiOrderKudari = value ;
		}	else	{
			m_iDiaRessyajouhouHyoujiEkiOrderNobori = value ;
		}
		return *this ;
	};

	/**
	 *	ׂĂ̑A
	 *	ԁiftHgRXgN^Őԁj
	 *	ɂ܂B
	 */
	void clear(){	*this = CdDedDispProp() ; } ;
	///@}
};
#endif /*CdDedDispProp_h*/


