/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDia.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CentDedDia.h"

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif



// ****************************************************************
//	CentDedDia
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
CentDedDia::CentDedDia( 
		int iEkiCount , int iRessyasyubetsuCount ) 
{
	m_CentDedRessyaCont[0] = new CentDedRessyaCont( 
		iEkiCount , Ressyahoukou_Kudari , iRessyasyubetsuCount ) ;
	m_CentDedRessyaCont[1] = new CentDedRessyaCont( 
		iEkiCount , Ressyahoukou_Nobori , iRessyasyubetsuCount) ;
}

CentDedDia::CentDedDia( 
		const string& strName ,
		int iEkiCount , int iRessyasyubetsuCount ) :
	m_strName( strName ) 
{
	m_CentDedRessyaCont[0] = new CentDedRessyaCont( 
		iEkiCount , Ressyahoukou_Kudari , iRessyasyubetsuCount ) ;
	m_CentDedRessyaCont[1] = new CentDedRessyaCont( 
		iEkiCount , Ressyahoukou_Nobori , iRessyasyubetsuCount ) ;
}

CentDedDia::CentDedDia( const CentDedDia& value ) :
	m_strName( value.m_strName ) 
{
	m_CentDedRessyaCont[0] = new CentDedRessyaCont( *value.m_CentDedRessyaCont[0] ) ;
	m_CentDedRessyaCont[1] = new CentDedRessyaCont( *value.m_CentDedRessyaCont[1] ) ;
}

CentDedDia& CentDedDia::operator=( const CentDedDia& value )
{
	m_strName = value.m_strName ;
	*m_CentDedRessyaCont[0] = *value.m_CentDedRessyaCont[0] ;	
	*m_CentDedRessyaCont[1] = *value.m_CentDedRessyaCont[1] ;	

	return *this ;
}
		
CentDedDia::~CentDedDia()
{
	delete m_CentDedRessyaCont[0] ;
	delete m_CentDedRessyaCont[1] ;

}

// ********************************
//	CentDedDia
// ********************************
	// ********************************
	//@name 
	// ********************************


	// ********************************
	//@name 
	// ********************************
	// ********************************
	//@name CentDedDia-wEԎʐ̕ύX
	// ********************************
int CentDedDia::onSetCentDedEki( const CentDedEkiCont* pCentDedEkiCont , int iEkiIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		int iRessyahoukou = 0 ; 
		for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; 
				iRessyahoukou ++ ){
			m_CentDedRessyaCont[iRessyahoukou]->onSetCentDedEki( 
					pCentDedEkiCont->getIfContGet( (ERessyahoukou)iRessyahoukou ) , 
					m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( iEkiIndex ) ) ;
		}
	}
	return ( iRv ) ;

}
int CentDedDia::insertCentDedEkiJikoku(	int iEkiIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		int iRessyahoukou = 0 ; 
		for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; 
				iRessyahoukou ++ ){
			if ( iRessyahoukou == Ressyahoukou_Kudari ){ 
				m_CentDedRessyaCont[iRessyahoukou]->insertCentDedEkiJikoku( 
					m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( iEkiIndex )  ) ;
			}	else if ( iRessyahoukou == Ressyahoukou_Nobori ){ 
				m_CentDedRessyaCont[iRessyahoukou]->insertCentDedEkiJikoku( 
					m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( iEkiIndex ) + 1 ) ;
				//	 +1 ̈ӖEEE
				//	Sw̘HɁAnwłwIndex0ǉꍇA
				//	̃ReỉwOrder 4()  ɒǉȂĂ͂Ȃ܂B 
			}
		}
	}
	return ( iRv ) ;
}
int CentDedDia::eraseCentDedEkiJikoku( int iEkiIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		int iRessyahoukou = 0 ; 
		for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; 
				iRessyahoukou ++ ){
			m_CentDedRessyaCont[iRessyahoukou]->eraseCentDedEkiJikoku( 
				m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( iEkiIndex ) ) ;
		}
	}
	return ( iRv ) ;
}

int CentDedDia::insertRessyasyubetsuIndex( int iRessyasyubetsuIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndex == INT_MAX ){
			iRessyasyubetsuIndex = getRessyasyubetsuCount() ;
		}
		if ( !( 0 <= iRessyasyubetsuIndex && 
				iRessyasyubetsuIndex <= getRessyasyubetsuCount() ) ){
			iRv = -1 ;	//	CfNXs
		}
	}
	// --------------------------------
	if ( iRv >= 0 ){
			int iRessyahoukou = 0 ;
			for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				
				iRv = m_CentDedRessyaCont[iRessyahoukou]->
					insertRessyasyubetsuIndex( iRessyasyubetsuIndex ) ;
			}

	}
	return ( iRv ) ;
}
	
int CentDedDia::eraseRessyasyubetsuIndex( int iRessyasyubetsuIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndex == INT_MAX ){
			iRessyasyubetsuIndex = getRessyasyubetsuCount() - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndex && 
				iRessyasyubetsuIndex < getRessyasyubetsuCount() ) ){
			iRv = -1 ;	//	CfNXs
		}
	}
	if ( iRv >= 0 ){
		if ( isExistRessyaOfRessyasyubetsu( 
			iRessyasyubetsuIndex , NULL , NULL ) > 0 ){
			iRv = -3 ;	//	wԎʁx iRessyasyubtsuIndex ̗Ԃ݂܂B
		}
	}
	// --------------------------------
	if ( iRv >= 0 ){
			int iRessyahoukou = 0 ;
			for ( iRessyahoukou = Ressyahoukou_Kudari ; 
				iRessyahoukou <= Ressyahoukou_Nobori ; iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				
				
				iRv = m_CentDedRessyaCont[iRessyahoukou]->
					eraseRessyasyubetsuIndex( iRessyasyubetsuIndex ) ;
			}
	}
	return ( iRv ) ;
}

int CentDedDia::isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		ERessyahoukou* peRessyahoukou ,
		int* piRessyaIndex ) 
{
	int iRv = 0 ;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari ;
	int iRessyaIndexFound = -1 ;
	// --------------------------------
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndex == INT_MAX ){
			iRessyasyubetsuIndex = getRessyasyubetsuCount() - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndex && 
				iRessyasyubetsuIndex < getRessyasyubetsuCount() ) ){
			iRv = -1 ;	//	CfNXs

		}
	}
	if ( iRv >= 0 ){
			int iRessyahoukou = 0 ;
			for ( iRessyahoukou = Ressyahoukou_Kudari ; 
					iRv == 0 && iRessyahoukou <= Ressyahoukou_Nobori ; 
					iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				
				iRv = m_CentDedRessyaCont[iRessyahoukou]->
					isExistRessyaOfRessyasyubetsu( 
						iRessyasyubetsuIndex , &iRessyaIndexFound ) ;
				if ( iRv == 1 ){
					eRessyahoukouFound = eRessyahoukou ;
				}
			}
	}
	// --------------------------------
	if ( peRessyahoukou != NULL ){
		*peRessyahoukou = eRessyahoukouFound ;
	}
	if ( piRessyaIndex != NULL ){
		*piRessyaIndex = iRessyaIndexFound ;
	}

	return ( iRv ) ;
}
