/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
//****************************************************************
//	CdDrawTextProp.h
//****************************************************************
*/
/** @file */
#ifndef  CdDrawTextProp_h
#define  CdDrawTextProp_h
#include "CdColorProp.h"
#include "CdFontProp.h"
#include "CdDrawTextFormat.h"

//****************************************************************
//	CdDrawTextProp
//****************************************************************
/**
 * @brief
 * yTvz
 * 	eLXg`悷ۂ̑ێAPf[^NXłB
 * 
 */
class CdDrawTextProp
{
// ********************************
/// @name	
// ********************************
///@{
 private:
	/** 
	 *	tHg 
	 *	ftHgł́AlƂȂ܂BݒK{̑łB
	 */
	CdFontProp	m_CdFontProp ;

	/**	
	 *	eLXg`悷ꍇ̕FłB
	 *	ftHg͍łB
	 */
	CdColorProp	m_colorrefText ;
	
	/**
	 * 	eLXg̔wih邩ۂ܂
	 * 	^Ȃwih܂B
	 *
	 *	ftHg͋UłB
	 */
	bool		m_bIsOpaque ;

	/**
	 * 	eLXg`悷ꍇ́AwiFłB
	 * 	m_bIsOpaque ^̏ꍇɂALłB
	 */
	CdColorProp	m_colorrefBack ;
	
	/**
	 *	eLXg`掞̑\tO
	 */
	CdDrawTextFormat	m_CdDrawTextFormat ;
///@}
	
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * 	eLXg̔wiFŁAݒ肷RXgN^łB
	 * @param aCdFontProp [in]
	 * tHg 
	 * @param colorrefText [in]
	 *	eLXg`悷ꍇ̕FłB
	 * @param colorrefBack [in]
	 * 	eLXg`悷ꍇ́AwiFłB
	 * @param aCdDrawTextFormat [in]
	 *	eLXg`掞̑\tO
	 */
	CdDrawTextProp( 
			const CdFontProp& aCdFontProp ,
			CdColorProp	colorrefText ,
			CdColorProp	colorrefBack ,
			CdDrawTextFormat	aCdDrawTextFormat = CdDrawTextFormat() ) :
		m_CdFontProp( aCdFontProp ) ,
		m_colorrefText( colorrefText ) ,
		m_bIsOpaque( true ) ,
		m_colorrefBack( m_colorrefBack ) ,
		m_CdDrawTextFormat( aCdDrawTextFormat ) {};

	/**
	 * 	eLXg̔wiFȂij́Aݒ肷RXgN^łB
	 * @param aCdFontProp [in]
	 * tHg 
	 * @param colorrefText [in]
	 *	eLXg`悷ꍇ̕FłB
	 * @param aCdDrawTextFormat [in]
	 *	eLXg`掞̑\tO
	 */
	CdDrawTextProp( 
			const CdFontProp& aCdFontProp ,
			CdColorProp	colorrefText = CdColorProp( 0 , 0 , 0 ) ,
			CdDrawTextFormat	aCdDrawTextFormat = CdDrawTextFormat() ) :
		m_CdFontProp( aCdFontProp ) ,
		m_colorrefText( colorrefText ) ,
		m_bIsOpaque( false ) ,
		m_colorrefBack( CdColorProp( 255 , 255 , 255 ) ) ,
		m_CdDrawTextFormat( aCdDrawTextFormat ) {};

	/**
	 *	ftHgRXgN^łB
	 * 	eLXg̔wiFȂijłB
	 */
	CdDrawTextProp() :
		m_colorrefText( CdColorProp( 0 , 0 , 0 ) ) ,
		m_bIsOpaque( false ) ,
		m_colorrefBack( CdColorProp( 255 , 255 , 255 ) ) {};


// ********************************
//	CdDrawTextProp
// ********************************
 public:
	// ********************************
	/// @name	
	// ********************************
	///@{
	CdFontProp	getCdFontProp()const{
		return 	m_CdFontProp ;	};
	CdDrawTextProp& setCdFontProp( const CdFontProp& ev ){
		m_CdFontProp = ev ;	return *this ; };

	CdColorProp	getTextColor()const{	
		return m_colorrefText ;	};
	CdDrawTextProp& setTextColor( CdColorProp ev ){
		m_colorrefText = ev	; return *this ; } ;
	
	bool		getIsOpaque()const{
		return 	m_bIsOpaque ;	};
	CdDrawTextProp& setIsOpaque( bool ev ){
		m_bIsOpaque = ev ;	return *this ; } ;

	CdColorProp	getBackColor()const{
		return m_colorrefBack ;	};
	CdDrawTextProp& setBackColor( CdColorProp	ev ){
		m_colorrefBack = ev ;	
		m_bIsOpaque = false ;
		return *this ; } ;
	
	CdDrawTextFormat	getCdDrawTextFormat()const{
		return m_CdDrawTextFormat ;	};
	CdDrawTextProp& setCdDrawTextFormat( const CdDrawTextFormat& ev ){
		m_CdDrawTextFormat = ev ;	return *this ; } ;
	///@}
};


#endif /*CdDrawTextProp_h*/
