/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaCont.h
// ****************************************************************
*/
/** @file */
#ifndef  CaCont_h
#define  CaCont_h
#include "./IfCont.h"
// ****************************************************************
//	CaCont
// ****************************************************************
/**
 * @brief
 * yTvz
 * A_v^NXłB
 * IfCont C^[tF[XT|[gĂReiɑ΂A
 * ǉ܂B
 * 
 * ̃NX̃CX^X́A IfCont C^[tF[XT|[gĂ
 * Rei𑀍ΏۃIuWFNgƂAƂ̊֘A܂B
 * 
 * ̃NXŒǉ鑀́Aȉ̂̂łB
 * 
 * - insert()	//	̃Rei̓eAΏۃReiɃRs[
 */
template < class ElementType > class CaCont
{
// ********************************
///@name ֘A
// ********************************
///@{
 private:
	/**
	 *	ΏۃIuWFNgƂȂAReiłB
	 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
	 *	̃IuWFNǵAthisƂ̊֘AۂĂԂ́A
	 *	ȂĂ͂Ȃ܂B
	 */
	IfCont<ElementType>*	m_pAdaptee ;
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	CaCont( IfCont<ElementType>* pAdaptee ) : 
		m_pAdaptee( pAdaptee ){};
	
// ********************************
//	CaCont
// ********************************
 public:
	// ********************************
	///@name CaCont-֘A
	// ********************************
	///@{
	IfCont<ElementType>*	getAdaptee(){	return 	m_pAdaptee ;};
	const IfCont<ElementType>*	getAdaptee()const{	return 	m_pAdaptee ;};
	CaCont& setAdaptee( IfCont<ElementType>* value ){
		m_pAdaptee = value ;	return *this ;};
	///@}
	// ********************************
	///@name CaCont-
	// ********************************
	///@{
	/**
	 *	ΏۃIuWFNg m_pAdaptee ̃ReiɁA
	 *	̃Rei̗vf}܂B
	 * @param pIfContGet [in]
	 *	Rs[vfێĂReiw肵ĂB
	 * @param iSrcIndex [in]
	 *	Rs[vf́A pIfContGet ł̐擪CfNXB
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ pIfContGet->size() łB
	 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @param iSize [in]
	 *	Rs[vf̐B
	 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 * @param iIndex [in]
	 *	m_pAdaptee ł́AvfRs[ʒuB
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ m_pAdaptee->size() ȉłB
	 * 	ÓA擪Em_pAdaptee->size() size()Ȃ疖ւ̒ǉɂȂ܂B
	 *	INT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @attention
	 *	iSrcIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	iIndexs
	 *	-	-2 ;	//	iSrcIndexs
	 */
	virtual int insert( 
			const IfContGet<ElementType>* pIfContGet , 
			int iSrcIndex = 0 , int iSize = INT_MAX , int iIndex = INT_MAX )
	{
		int iRv = 0 ;
		if ( iRv >= 0 ){
			if ( iSrcIndex == INT_MAX && iSize == INT_MAX ){
				iRv = -2 ;	//	iSrcIndex s
			}
		}
		if ( iRv >= 0 ){
			if ( iSrcIndex == INT_MAX ){
				iSrcIndex = pIfContGet->size() - iSize ; 
			}
			if ( iSize == INT_MAX ){
				iSize = pIfContGet->size() - iSrcIndex ; 
			}
			if ( !( 0 <= iSrcIndex && iSrcIndex + iSize<= 
					(int)pIfContGet->size()  ) ){
				iRv = -2 ;	//	iSrcIndexs
			}
		}
		if ( iRv >= 0 ){
			if ( iIndex == INT_MAX ){
				iIndex = m_pAdaptee->size() ; 
			}
			if ( !( 0 <= iIndex && iIndex <= (int)m_pAdaptee->size() ) ){
				iRv = -1 ;	//	iIndexs
			}
		}
		// --------------------------------

		if ( iRv >= 0 ){
			for ( int cnt = 0 ; iRv >= 0 && cnt < iSize ; cnt ++ ){
				iRv = m_pAdaptee->insert( pIfContGet->get( iSrcIndex + cnt ) , 
					iIndex + cnt ) ;
			}
		}
		return ( iRv ) ;
	};
	///@}

};

#endif /*CaCont_h*/

