/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	IfCont.h
// ****************************************************************
*/
/** @file */
#ifndef  IfCont_h
#define  IfCont_h

#include <limits.h>
#include "./IfContGet.h"

//****************************************************************
//	IfCont
//****************************************************************
/**
 * @brief
 * yTvz
 * 	  ev[g ElementType Ŏw肵^̗vf𕡐ێ
 *	Reiւ́Avf̒ǉE폜s߂̃C^[tF[XłB
 *
 *	  Rei̗vf̎擾́A{NX IfContGet ̃\bhgƂɂ
 *	ł܂B
 */
template < class ElementType > class IfCont : 
	public IfContGet< ElementType >
{
 public:
	/**
	 *	̃ReiɊi[Ăvf̌^B
	 */
	typedef ElementType value_type ;
// ********************************
///@name	IfContGet
// ********************************
///@{
 public:
	
	/**
	 * @return
	 * 	ReiɊi[Ăvf̌Ԃ܂B
	 */
	virtual int	size()const = 0 ;
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 * 	vfԂ܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	CfNXŎw肳ꂽvfԂ܂B
	 */
	virtual ElementType get( int iIndex )const = 0 ;
	
///@}
// ********************************
///@name	IfCont
// ********************************
///@{
 public:
	
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	vf㏑܂B
	 * @param element [in]
	 * 	vfw肵ĂB
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int set( const ElementType& element , int iIndex ) = 0;

	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	vfǉ܂B
	 * @param element [in]
	 * 	vfw肵ĂB
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() ȉłB
	 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int insert( const ElementType& element , int iIndex = INT_MAX ) =0;
	
	/**
	 * 	ReíACfNXŎw肳ꂽꏊ
	 * 	vf폜܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @param iSize [in]
	 * 	폜vf̐w肵ĂB
	 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 * @attention
	 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int erase( int iIndex  , int iSize = 1 ) = 0 ;
	
///@}
};
#endif /*IfCont_h*/
