/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdConnectedString.h
// ****************************************************************
*/
/** @file */
#ifndef  CdConnectedString_h
#define  CdConnectedString_h

#include <string>
#include <deque>

// ****************************************************************
//	CdConnectedString
// ****************************************************************
/**
* @brief
* yTvz
* 	PoCg̋؂蕶iftHg';'jŋ؂ꂽ
* 	<ږ>=<l>̌`́wAxێPf[^NXłB
* 	
* 		ij"PROTOCOL=TCP;REMOTEIPADDR=192.168.0.1;REMOTEPORT=8001"
* 	
* 	̃NXł́AL`̕S
* 		ij"PROTOCOL=TCP;REMOTEIPADDR=192.168.0.1;REMOTEPORT=8001"
* 	AwAxB
* 	؂蕶ŋ؂ꂽP
* 		ij"PROTOCOL=TCP"
* 			"REMOTEIPADDR=192.168.0.1"
* 			"REMOTEPORT=8001"
* 	wACex
* 	ACe=̍
* 		ij"PROTOCOL"
* 			"REMOTEIPADDR"
* 			"REMOTEPORT"
* 	wږx
* 	ACe=̉E
* 		ij"TCP"
* 			"192.168.0.1"
* 			"8001"
* 	wlxƌĂł܂B
* 	
* 	̃NX́AÃACeҏW@\A
* 	ACe̍ږElҏW@\Ă܂B
* 	
*/
class CdConnectedString 
{
// ********************************
//	Ci[`
// ********************************
 public:
	
	/**
	* @brief
	*	ACeP̓e\\̂łB
	*/
	struct ITEM
	{
		ITEM( const std::string& strName = "" , 
			const std::string& strValue = "" )
			: m_strName( strName ) , m_strValue( strValue )	{};
		
		/**
		* 	ACéAږB
		*	lȂꍇ́AACeŜږɂȂ܂B
		*/
		std::string	m_strName ;

		/**
		*	ACéAlB
		*	lȂꍇ́A󕶎ɂȂ܂B
		*/
		std::string	m_strValue ;
	};

// ********************************
//	
// ********************************
 private:
	///	ACeԂ̋؂蕶łBftHg';'ł
	char		m_chSplit ;

	
	///	ڂƒl̊Ԃ̋؂蕶łBftHg'='ł
	char		m_chEqualChar ;

// --------------------------------
//	f[^
// --------------------------------
 private:
	///	ACeێReǐ^\܂B
	typedef std::deque<ITEM>	ITEMCont ;
	
	///	ACeێReiłB
	ITEMCont	m_contItem ;



// ********************************
//	RXgN^
// ********************************
 public:
	/**
	* @param chSplit [in]
	* 	ACeԂ̋؂蕶w肵ĂB
	* @param chEqualChar [in]
	* 	ڂƒl̊Ԃ̋؂蕶w肵ĂB
	*/
	CdConnectedString( char chSplit = ';' , char chEqualChar = '=' ) 
		: m_chSplit( chSplit ) , m_chEqualChar( chEqualChar ){};
	
	/**
	* @param ev [in]
	* 	Aw肵ĂB
	* @param chSplit [in]
	* 	؂蕶w肵ĂB
	* @param chEqualChar [in]
	* 	ڂƒl̊Ԃ̋؂蕶w肵ĂB
	*/
	CdConnectedString( const std::string& ev ,  char chSplit = ';' , 
										char chEqualChar = '=' ) 
		: m_chSplit( chSplit ) , m_chEqualChar( chEqualChar )
	{
		decode( ev ) ;
	};
	
	virtual ~CdConnectedString(){} ;

// ********************************
//	Rei
// ********************************
 public:
	/**
	* @return
	* 	ACe̐Ԃ܂B
	*/
	int size()const{	return ( m_contItem.size() ) ; } ;
	
	/**
	* 	ẅʒuɂACeQƂ܂B
	* @param idx [in]
	* 	Oȏsize()̃CfNXw肵ĂB
	* @return
	* 	ACeԂ܂B
	*/
	ITEM at( int idx )const{	return ( m_contItem[ idx ] ) ; } ;
	
	
	/**
	* 	ẅʒuɐVACe}܂B
	* @param idx [in]
	* 	Oȏsize()ȉ̃CfNXw肵ĂB
	* 	-1ȂAɒǉ܂B
	* @param ev [in]
	* 	}ACew肵ĂB
	* @return
	* 	0ȏAs畉̐ł
	*/
	int insert( int idx , const ITEM& ev ){
		if ( idx < 0 ){
			idx = size() ;
		}
		if ( !( 0 <= idx && idx <= size() ) ){
			return -1 ;
		}
		m_contItem.insert( m_contItem.begin() + idx , ev ) ;
		return ( 0 ) ; 
	} ;

	/**
	* 	ẅʒuACe܂B
	* @param idx [in]
	* 	Oȏsize()̃CfNXw肵ĂB
	* @return
	* 	0ȏAs畉̐ł
	*/
	int erase( int idx ){
		if ( !( 0 <= idx && idx < size() ) ){
			return -1 ;
		}
		m_contItem.erase( m_contItem.begin() + idx ) ;
		return ( 0 ) ; 
	};
	
	/**
	* 	w̍ږACëʒu𒲂ׂ܂
	* @param strName [in]
	* 	ږw肵ĂB
	* @return
	* 	0ȏ̃CfNXAȂ-1ł
	*/
	int find( std::string strName )const{
		int idx ;
		for ( idx = 0 ; idx < size() && at( idx ).m_strName != strName 
								; idx ++ ){}
		if ( idx == size() ){
			idx = -1 ;
		}
		return ( idx ) ;
	};

	/**
	* 	w̍ږACe폜܂
	* @param strName [in]
	* 	ږw肵ĂB
	* @return
	* 	A폜ACěXʒũCfNXA
	* 	Ȃ-1ł
	*/
	int remove( std::string strName ){
		int idx = find( strName )  ;
		if ( idx >= 0 ){
			erase( idx ) ;
		}
		return ( idx ) ;
	};
	
	/**
	*	ׂẴACej܂B
	*/
	void clear(){
		m_contItem.clear() ;
	};
	
	/**
	* 	w̍ږACe̒lԂ܂B
	* @param strName [in]
	* 	ږw肵ĂB
	* @return
	* 	AlԂ܂B
	* 	ڂ݂Ȃꍇ́A󕶎Ԃ܂B
	*/
	std::string getValue( std::string strName )const{
		int idx = find( strName ) ;
		if ( idx < 0 ){
			return ( "" ) ;
		}
		return ( at( idx ).m_strValue )  ;
	}; 
	
	
	/**
	* 	w̍ږACe̒lύX܂B
	* 	̂ƂAw̍ږACe݂Ȃ΁A
	* 	VACeǉŁAږElZbg܂B
	* @param strName [in]
	* 	ږw肵ĂB
	* @param strValue [in]
	* 	lw肵ĂB
	* @return
	* 	0ȏAs畉̐ł
	*/
	int setItem( const std::string& strName , const std::string& strValue ){
		int idx = remove( strName ) ;
		return ( insert( idx , ITEM( strName ,strValue ) ) ) ;
	}; 

// ********************************
//	CdConnectedStringL
// ********************************
 public:
	// ********************************
	//	
	// ********************************
	char getSplit()const {	return ( m_chSplit ) ; } ;
	CdConnectedString& setSplit( char chSplit ){
		m_chSplit = chSplit ; return ( *this ) ;} ;

	char getEqualChar()const{	return ( m_chEqualChar ) ; } ;
	CdConnectedString& setEqualChar( char ev ){	
		m_chEqualChar = ev ; return ( *this ) ;} ;

	/**
	* @return
	* 	̃IuWFNgێĂACeƋ؂蕶ƂɁA
	* 	A쐬AԂ܂B
	*/
	std::string encode()const{
		std::string	strRv ;
		int	idx ;
		for ( idx = 0 ; idx < size() ; idx ++ ){
			if ( idx != 0 ){
				strRv += getSplit() ;
			}
			strRv += at( idx ).m_strName ;
			if ( !at( idx ).m_strValue.empty() ){
				strRv += getEqualChar() ;
				strRv += at( idx ).m_strValue ;
			}
		};
		return ( strRv ) ;
	};

	/**
	* 	w̘AÃIuWFNgɊi[܂B
	* @param strEv [in]
	* 	Aw肵ĂB
	* @return
	* 	0ȏAs畉̐ł
	*/
	int decode( const std::string&	strEv ){
		int iRv = 0 ;
		clear() ;
		std::string	strLeft = strEv ;
		
		while ( !strLeft.empty() ){
			// --------------------------------
			//	ITEM؂o܂B
			// --------------------------------
			std::string	strItem ;
			{

				int	idx ;
				for ( idx = 0 ; 
					idx < strLeft.size() && strLeft[idx] != getSplit() ; 
					idx++ ){}
				
				//idx = ̏I[AACe؂蕶wĂ܂B

				if ( idx == strLeft.size() ){
					strItem = strLeft ; 
					strLeft = "" ;
				}	else	{
					strItem = strLeft.substr( 0 , idx ) ;
					strLeft.erase( 0 , idx + 1 ) ;
				}
				
				//strItem = ǂ̃ACe
				//strLeft = ǂ̃ACeiƁA̒̋؂蕶j
				//	폜܂B
			}
			if ( strItem.empty() ){
				continue ;
			}
			// --------------------------------
			//	NAMEVALUEɕ܂B
			// --------------------------------
			{
				ITEM	aItem ;
			
				int	idx ;
				for ( idx = 0 ; 
					idx < strItem.size() && strItem[idx] != getEqualChar() ; 
					idx++ ){}
				
				//idx = strItem ̏̕I[A'='wĂ܂B

				if ( idx == strItem.size() ){
					aItem.m_strName = strItem ;
				}	else	{
					aItem.m_strName = strItem.substr( 0 , idx ) ;
					aItem.m_strValue = strItem.substr( idx + 1 )  ;
				};
				
				insert( -1 , aItem ) ;
			}
		}
		return ( iRv ) ;
	};
// ********************************
//	Zq
// ********************************
 public:
	/** encode() Ɠł */
	operator std::string()const {	return encode() ;	};
};




#endif /*CdConnectedString_h*/

