/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CConvFile_Oudia101To102.cpp 174 2014-05-05 13:26:26Z okm $
// ****************************************************************

#include "stdafx.h"
#include "CConvFile_Oudia101To102.h"

#include <string>
#include <vector>

#include "Str\strToVector.h"
#include "Str\strLf.h"
#include "Str\strToWstr.h"
#include "ou\dynamic_castOu.h"
#include "ou\OuNew.h"
#include "DcdCd\DcDrawProp\CconvDcDrawProp.h"
#include "DcDraw\CConverter_WinGdi.h"
#include "DedRosenFileData\CconvCDedRosenFileData.h"


namespace ConvFile_Oudia101To102{


static const char nameFileType[] = "FileType" ;
static const char valueFileTypeLeftFormat[] = "OuDia.1.01" ;
static const char valueFileTypeRightFormat[] = "OuDia.1.02" ;
static const char nameFileTypeAppComment[] = "FileTypeAppComment" ;
static const char valueFileTypeAppComment[] = "ConvFileOudia101To102 Ver 0.01" ;


// ****************************************************************
//	CConvFile_Oudia101To102
// ****************************************************************
	// --------------------------------
	//@name ֐
	// --------------------------------
CdFontProp CConvFile_Oudia101To102::createVFontPropFromHFont( 
		const CdFontProp& aCdFontProp ) 
{
	int iRv = 0 ;

	CdFontProp	aCdFontPropV = aCdFontProp ;
	aCdFontPropV.setFacename( string( "@" ) + aCdFontPropV.getFacename() ) ;
	CConverter_WinGdi	aConv ;
	Ou<CGdiHFontHolder>	aHFontHolder = aConv.createGdiHFontHolder( aCdFontPropV ) ;
	if ( aHFontHolder != NULL )
	{
		LOGFONT	aLOGFONT ;
		int iResult = GetObject( aHFontHolder->getHFont() , sizeof(aLOGFONT) , &aLOGFONT ) ;
		if ( iResult == 0 ){
			iRv = -2 ;	//	GetObjectɎs
		}
		else
		{
			aCdFontPropV.setFacename( OuLib::stringOf( aLOGFONT.lfFaceName ) ) ;
		}
	}
	return aCdFontPropV ;
}


	// ********************************
	//	RXgN^
	// ********************************

CConvFile_Oudia101To102::CConvFile_Oudia101To102()
{
}
CConvFile_Oudia101To102::~CConvFile_Oudia101To102()
{
}
	// ********************************
	//@name IfConvFile
	// ********************************
int CConvFile_Oudia101To102::LeftToRight( 
		const IfByteBuffer* pLeftFormat , 
		IfByteBuffer* pRightFormat , 
		IfByteBuffer* pErrorInfoString ) 
{
	int iRv = 0 ;
	string strErrorInfoString ;
	// --------------------------------
	//	t@CtH[}bg̊mF
	// --------------------------------
	if ( iRv >= 0 )
	{
		int iResult = isLeftFormat( pLeftFormat ) ;
		//	-	-1 ;	//	FileType ܂B
		//	-	-11 ;	//	t@CtH[}bgł͂܂B
		if ( iResult < 0 )
		{
			switch( iResult )
			{
			case -1 :	//	FileType ܂B
				strErrorInfoString = "FileType Mismatch." ;
				break ;
			case -11 :	//	JgTuACeR}hƑޏR}hΉ܂B	
				strErrorInfoString = "File Format Error." ;
				break ;
			}
			iRv = iResult ;
		}
		//iRv = 
		//	-	-1 ;	//	FileType ܂B
		//	-	-11 ;	//	t@CtH[}bgł͂܂B
	}
	// --------------------------------
	//	oCg 
	//	OuPropertiesText::CNodeContainer ɓǂݍ
	// --------------------------------
	string strLeftFormat ;
	if ( iRv >= 0 )
	{
		vector<char> binLeftFormat ;
		binLeftFormat.resize( pLeftFormat->size() ) ;
		if ( binLeftFormat.size() > 0 )
		{
			pLeftFormat->read( 
				&binLeftFormat[0] , 
				0 , 
				binLeftFormat.size() ) ;
		}
		strLeftFormat = OuLib::stringOf( binLeftFormat ) ;
		strLeftFormat = OuLib::strLfOf( strLeftFormat ) ;
	}
	//strLeftFormat = LeftFile ̓e

	CNodeContainer	nodecontRoot ;
	if ( iRv >= 0 )
	{
		OuPropertiesText::CConvNodeContainer	aConv ;
		int iResult = aConv.decode( 
			strLeftFormat , 
			&nodecontRoot ,
			&strErrorInfoString ) ;
		if ( iResult < 0 )
		{
			iRv = -11 ;	//	t@CtH[}bgł͂܂B
		}
	}
	//nodecontRoot = LeftFile̓eێĂ܂B

	// --------------------------------
	//FileType
	//	  "OuDia.1.01""OuDia.1.02" ɕϊ܂B
	// --------------------------------
	if ( iRv >= 0 )
	{
		nodecontRoot.setValue( 
			nameFileType , 
			valueFileTypeRightFormat ) ;
	}
	// --------------------------------
	//	CDedRosenFile𐶐
	// --------------------------------
	CDedRosenFileData	aCDedRosenFileData ;
	if ( iRv >= 0 )
	{
		CconvCDedRosenFileData	aConv ;
		ErrorInfo::COuErrorInfoContainer	aErrorInfoConteiner ;

		int iResult = aConv.CDedRosenFileData_from_OuPropertiesText( 
			&aCDedRosenFileData ,
			&nodecontRoot ,
			&aErrorInfoConteiner ) ;
		if ( iResult < 0 )
		{
			iRv = -21 ;	//	CDedRosenFileData ւ̕ϊɎs܂B
			strErrorInfoString = aErrorInfoConteiner.toOuErrorInfoText() ;
		}
	}
	

	// --------------------------------
	//Rosen.Eki[0].Ekijikokukeisiki
	//	@"Jikokukeisiki_Hatsu""Jikokukeisiki_NoboriChaku" ɕύX
	// --------------------------------
	CentDedRosen* pCentDedRosen = NULL ;
	if ( iRv >= 0 )
	{
		pCentDedRosen = aCDedRosenFileData.getCentDedRosen() ;
		if ( pCentDedRosen->getCentDedEkiCont()->size() > 0 ) 
		{
			CentDedEki aCentDedEki = pCentDedRosen->getCentDedEkiCont()->get( 0 ) ;
			if ( aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsu )
			{
				aCentDedEki.setEkijikokukeisiki( CentDedEki::Jikokukeisiki_NoboriChaku ) ;
			}
			pCentDedRosen->getCentDedEkiCont()->set( aCentDedEki ,0 );
			pCentDedRosen->adjustByEkijikokukeisiki( 0 ) ;
		}
	}
	// --------------------------------
	//Rosen.Eki[].Ekijikokukeisiki
	//	@"Jikokukeisiki_Hatsu""Jikokukeisiki_KudariChaku" ɕύX
	// --------------------------------
	if ( iRv >= 0 )
	{
		pCentDedRosen = aCDedRosenFileData.getCentDedRosen() ;
		if ( pCentDedRosen->getCentDedEkiCont()->size() > 0 ) 
		{
			CentDedEki aCentDedEki = pCentDedRosen->getCentDedEkiCont()->get( INT_MAX ) ;
			if ( aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsu )
			{
				aCentDedEki.setEkijikokukeisiki( CentDedEki::Jikokukeisiki_KudariChaku ) ;
			}
			pCentDedRosen->getCentDedEkiCont()->set( aCentDedEki ,INT_MAX );
			pCentDedRosen->adjustByEkijikokukeisiki( INT_MAX ) ;
		}
	}
	// --------------------------------
	//DispProp.JikokuhyouVFont
	//	@DispProp.JikokuhyouFont[0] ̃tFCX̐擪 "@" t^ 
	//	CreateFont() s܂B
	//	@ꂽtHg̑A̒lɃZbg܂B
	// --------------------------------
	if ( iRv >= 0 )
	{
		CdDedDispProp aCdDedDispProp = aCDedRosenFileData.getCdDedDispProp() ;
		CdFontProp	aCdFontProp = aCdDedDispProp.getJikokuhyouFont( 0 ) ;
		aCdFontProp = createVFontPropFromHFont( aCdFontProp ) ;
		aCdDedDispProp.setJikokuhyouVFont( aCdFontProp ) ;
		aCDedRosenFileData.setCdDedDispProp( aCdDedDispProp ) ;
	}
	// --------------------------------
	//	CDedRosenFile [gm[hɔf
	// --------------------------------
	if ( iRv >= 0 )
	{
		//	[gm[h͈UɂB
		nodecontRoot.erase( 0 , INT_MAX ) ;

		CconvCDedRosenFileData	aConv ;

		int iResult = aConv.CDedRosenFileData_to_OuPropertiesText( 
			&aCDedRosenFileData ,
			&nodecontRoot ) ;
		if ( iResult < 0 )
		{
			iRv = -22 ;	//	CDedRosenFileData ւ̕ϊɎs܂B
		}
	}

	// --------------------------------
	//FileTypeAppComment
	//	"ConvFileOudia101To102 Ver 0.01"
	// --------------------------------
	if ( iRv >= 0 )
	{
		nodecontRoot.setValue( 
			nameFileTypeAppComment , 
			valueFileTypeAppComment ) ;
	}

	
	// --------------------------------
	//	CConvNodeContainer 
	//	oCgɕϊ
	// --------------------------------
	string strRightFormat ;
	if ( iRv >= 0 )
	{
		OuPropertiesText::CConvNodeContainer	aConv ;
		strRightFormat = aConv.encode( 
			&nodecontRoot ) ;
	}


	//strRightFormat = RightFile ̓e
	vector<char> binRightFormat ;
	if ( iRv >= 0 )
	{
		strRightFormat = OuLib::strCrlfOf( strRightFormat ) ;
		binRightFormat = OuLib::vectorCharOf( strRightFormat ) ;
	}
	// --------------------------------
	if ( pRightFormat != NULL )
	{
		pRightFormat->size_reset( binRightFormat.size() ) ;
		if ( binRightFormat.size() > 0 )
		{
			pRightFormat->write( &binRightFormat[0] , 0 , binRightFormat.size() ) ;
		}
	}
	if ( pErrorInfoString != NULL )
	{
		pErrorInfoString->size_reset( strErrorInfoString.size() ) ;
		if ( strErrorInfoString.size() > 0 )
		{
			pErrorInfoString->write( strErrorInfoString.c_str() , 0 , strErrorInfoString.size() ) ;
		}
	}
	return iRv ;
}

int CConvFile_Oudia101To102::isLeftFormat( 
		const IfByteBuffer* pLeftFormat)  
{
	int iRv = 0 ;
	string strErrorInfoString ;

	string strLeftFormat ;
	if ( iRv >= 0 )
	{
		vector<char> binLeftFormat ;
		binLeftFormat.resize( pLeftFormat->size() ) ;
		if ( binLeftFormat.size() > 0 )
		{
			pLeftFormat->read( 
				&binLeftFormat[0] , 
				0 , 
				binLeftFormat.size() ) ;
		}
		strLeftFormat = OuLib::stringOf( binLeftFormat ) ;
		strLeftFormat = OuLib::strLfOf( strLeftFormat ) ;
	}
	//strLeftFormat = pLeftFormat i[łB
	OuPropertiesText::CNodeContainer	nodecontRoot ;
	if ( iRv >= 0 )
	{
		OuPropertiesText::CConvNodeContainer	aConv ;
		int iResult = aConv.decode( 
			strLeftFormat , 
			&nodecontRoot ,
			&strErrorInfoString ) ;
		if ( iResult < 0 )
		{
			iRv = -11 ;	//	t@CtH[}bgł͂܂B
		}
	}
	if ( iRv >= 0 )
	{
		string strValue = nodecontRoot.getValue(
			nameFileType ) ;
		if ( strValue != valueFileTypeLeftFormat )
		{
			iRv = -1 ;	//	FileType ܂B
		}
	}
	return iRv ;
}

bool CConvFile_Oudia101To102::RightToLeftIsSupported()
{
	return false ;
}

int CConvFile_Oudia101To102::RightToLeft( 
		const IfByteBuffer* pRightFormat , 
		IfByteBuffer* pLeftFormat , 
		IfByteBuffer* pErrorInfoString ) 
{
	return -2 ;	//	̃\bh̓T|[gĂ܂B
}
int CConvFile_Oudia101To102::isRightFormat( 
		const IfByteBuffer* pRightFormat ) 
{
	return -2 ;	//	̃\bh̓T|[gĂ܂B
};


} //namespace ConvFile_Oudia101To102
