/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	CdDedJikokuOrder
// ****************************************************************
/** @file */


#ifndef CdDedJikokuOrder_h
#define CdDedJikokuOrder_h


// ****************************************************************
//	CdDedJikokuOrder
// ****************************************************************

/**
    CdDedJikokuOrder ́Aw̗vf肷lłB

	́A\̊eɕ\ׂe̎ނlł܂B
	ȉ̑Ȃ܂B

	- wOrder
	- \e{E}

   ̃NX́ANULLԂƂł܂B
*/
class CdDedJikokuOrder
{
public:
	/** w̗vf\񋓂łB */
	enum EEkiJikokuItem
	{
		EkiJikokuItem_Chaku = 0 ,	///<
		EkiJikokuItem_Hatsu = 1 ,	///<
	};
private:
	/**
		OrderB
		̒l̐̏ꍇ́ANULLԂƂȂ܂B
	*/
	int m_iEkiOrder ;
	/**
		w̗vf
	*/
	EEkiJikokuItem m_eEkiJikokuItem  ;
public:
	/**
		NULL Ԃŏ܂B
	*/
	CdDedJikokuOrder() 
		: m_iEkiOrder( -1 )
		, m_eEkiJikokuItem( EkiJikokuItem_Chaku ){};
	/**
	@param value [in]
		Orderw肵ĂB
	explicit CdDedJikokuOrder( int value ) : m_iJikokuOrder( value ) {};
	*/

	/** 
	@param iEkiOrder [in]
		wOrder 
	@param eEkiJikokuItem [in]
		w̗vf
	*/
	CdDedJikokuOrder( int iEkiOrder , EEkiJikokuItem eEkiJikokuItem ) 
		: m_iEkiOrder( iEkiOrder ) 
		, m_eEkiJikokuItem( eEkiJikokuItem ) 
	{};


	bool getIsNull()const{	return m_iEkiOrder < 0 ;};
	void setIsNull()
	{	
		m_iEkiOrder = -1 ; 
		m_eEkiJikokuItem = EkiJikokuItem_Chaku ;
	};

	int getEkiOrder()const{	return m_iEkiOrder ;};
	EEkiJikokuItem getEkiJikokuItem()const{	return m_eEkiJikokuItem ;};

	/** 
	@param iEkiOrder [in]
		wOrder 
	@param eEkiJikokuItem [in]
		w̗vf\
	*/
	void setEkiOrder( int iEkiOrder , EEkiJikokuItem eEkiJikokuItem )
	{
		m_iEkiOrder = iEkiOrder ;
		m_eEkiJikokuItem = eEkiJikokuItem ;
	};

	/**
		EEkiJikokuItem ̒E𔽓]܂B
	@param eEkiJikokuItem [in]
		] EEJikokuItem w肵ĂB
	@return
		- eEkiJikokuItem  EkiJikokuItem_Chaku ȂAEkiJikokuItem_HatsuB
		- eEkiJikokuItem  EkiJikokuItem_Hatsu ȂAEkiJikokuItem_ChakuB
		- ȊȌꍇ́AeEkiJikokuItem ̂܂ܕԂ܂B
	*/
	static EEkiJikokuItem EkiJikokuItemInvert( 
		EEkiJikokuItem eEkiJikokuItem )
	{
		EEkiJikokuItem	eRv = eEkiJikokuItem ;
		if ( eRv == EkiJikokuItem_Chaku )
		{
			eRv = EkiJikokuItem_Hatsu ;
		}
		else if ( eRv == EkiJikokuItem_Hatsu )
		{
			eRv = EkiJikokuItem_Chaku ;
		}
		return eRv ;
	}

	/**
		EEkiJikokuItem ̒E𔽓]܂B
	@param eEkiJikokuItem [in]
		] EEJikokuItem w肵ĂB
	@return
		- eEkiJikokuItem  EkiJikokuItem_Chaku ȂAEkiJikokuItem_HatsuB
		- eEkiJikokuItem  EkiJikokuItem_Hatsu ȂAEkiJikokuItem_ChakuB
		- ȊȌꍇ́AeEkiJikokuItem ̂܂ܕԂ܂B
	*/
	void EkiJikokuItemInvert( void )
	{
		m_eEkiJikokuItem = EkiJikokuItemInvert( m_eEkiJikokuItem ) ;
	}

	bool isEqualTo( const CdDedJikokuOrder& value )const
	{
		return ( m_iEkiOrder == value.m_iEkiOrder && 
				m_eEkiJikokuItem == value.m_eEkiJikokuItem ) 
			|| ( getIsNull() && value.getIsNull() );
	};

	bool operator==(  const CdDedJikokuOrder& value )const
	{	return isEqualTo( value ) ;	}
	bool operator!=(  const CdDedJikokuOrder& value )const
	{	return !isEqualTo( value ) ;	}
};
#endif /*CdDedJikokuOrder_h*/
