/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessya.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRessya_h
#define  CentDedRessya_h


#include <deque>


#include "Mu/CMup_deque.h"
#include "Mu/CaMuPtref.h"

#include "CentDed.h"
#include "CentDedEkiJikoku.h"
#include "CdDedJikan.h"
#include "CentDedEkiCont.h"
#include "CdDedJikokuOrder.h"

// ****************************************************************
//	CentDedRessya
// ****************************************************************
/**
 @brief
	 DiagramEdit ́AHŉ^swԁxP{\܂B
	
	̃NX̃CX^X́Aʏ́wHxi CentDedRosen j
	܂܂B
	
	ۂɂ́A
	
	- wHx (CentDedRosen) w_Cx ( CentDedDia ) 
	Oȏ㕡
	- ew_Cx ( CentDedDia ) wԁx (CentDedRessya ) 
	Oȏ㕡
	
	Ƃ֌WɂȂĂ܂B
	
	̃NX́AwHxi CentDedRosen jɑ݂
	wwx ( CentDedEki )̐Awwx(CentDedEkiJikokuj
	IuWFNgێ܂BwHx ( CentDedRosen )ɕ܂
	ׂẮwԁx( CentDedRessya )܂
	wwx ( CentDedEkiJikoku ) IuWFNg̐́A
	wHx ( CentDedRosen )́wwx ( CentDedEki ) ̐ƓłȂĂ
	Ȃ܂B
	  ̓Ƃ邽߁Awԁx ( CentDedRessya ) ɑ΂
	wwx ( CentDedEkiJikoku ) IuWFNg̒ǉE폜̑͐
	Ă܂B
	wwx̒ǉE폜̑́AwHxw_Cx
	wԃReix ( CentDedRessyaCont ) 
	ɑ΂Ă̂݋̂Ƃ܂B
	̃NX CentDedRessyaCont  friend NXɎw肵Ă̂͂̂߂łB
	
	܂ÃNXێAwԎIndexx́A
	wHx( CentDedRosen )ێwԎʁx ( CentDedRessyasyubetsu )
	IuWFNgɑΉ܂B
	
	̃IuWFNǵALȗԃf[^ȂwNullԁx
	Ƃ邱Ƃł܂B
	wNullԁx̗Ԃ́Aw\r[xł͋sƂĕ\܂B
	
	<H4>
	ywIndex  wOrder , Orderz
	</H4>
	  wHx ( CentDedRosen ) IuWFNg̓
	wwx ( CentDedEki )IuWFNgw肷@Ay
	wԁx ( CentDedRessya )IuWFNg̓
	wwx ( CentDedEkiJikoku ) IuWFNgw肷@ɂ́A
	wwIndexxEwwOrderx̂Q܂BǂA
	0 ȏ ( w̐)  ̐ŁAwwxw肵܂B
	
	  wwIndexx́AH̉Ԃ̎nwiԂ̏Iwj 0 E 
	Ԃ̏IwiԂ̎nwj  ( w̐ - 1 ) ƂȂ܂B
	
	  wwOederx́AԂ̕ʂ̃CfNXłBԁE
	ƂɎnw 0 E Iw ( w̐ - 1 ) 
	Ȃ܂B

	  ]āAwwIndexx 0 ̉ẃAԂɂƂẮwwOederx 
	 0 łAԂɂƂẮwwOrderx  iw̐ - 1 jƂȂ܂B 
	
	  wHx ( CentDedRosen ) NXł́AƂ
	wwx( CentDedEki ) IuWFNgw肷̂ɁwwIndexxg܂B
	wwxێRei CentDedRosen::m_CentDedEkiCont ̓Y
	wwIndexxɂȂĂ܂B\n  
	Ƃ͑ΏƓIɁAwԁx(NXł́AƂ
	wwx ( CentDedEkiJikoku ) IuWFNgw肷̂ɂ
	wwOrderxg܂Bwwx ( CentDedEkiJikoku ) ێRei
	  CentDedRessya::m_CentDedEkiJikokuCont ̓YAwwOrderx 
	ƂȂ܂B
	  ǂ̃NXɂĂAwwIndexxƁwwOrderx̑ݕϊs
	\bh EkiIndexOfEkiOrder() , EkiOrderOfEkiIndex() 񋟂Ă܂B
	
	wOrderx́AwԁxIuWFNgŁA̎
	iw̒Êꂩjw肷鏇łB
	wOrderx́Aȉ̖@܂B
	l͈̔͂́A0 ȏ w̐*2 łB
	
	- wwOrderx*2 + 0 EEEwwOrderx̉w̒(Ƃȍ~)
	ύX܂B
	- wwOrderx*2 + 1 EEEwwOrderx̉w̔(Ƃȍ~)
	ύX܂B
*/
class CentDedRessya
{
 public:
	// ********************************
	//	Ci[^Cv
	// ********************************
	typedef std::deque< CentDedEkiJikoku* > CentDedEkiJikokuCont ;


private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		̗ԂwNullԁxȂ^A
		LȗԑێĂ̂ȂUłB
		
		̑^̏ꍇA 
		-	m_iRessyasyubetsuIndex,
		-	m_strRessyabangou ;
		-	m_strRessyamei ;
		-	m_strGousuu ;
		-	m_strBikou ;
	
		сA
			m_CentDedEkiJikokuCont Ɋi[Ă 
		CentDedEkiJikoku ́AӖ܂B
		
		Kl true łB
		set...() \bhŁAm_eRessyahoukou ȊO
		ꂩ̑ݒ肵Ƃɂ́A
		IɋUɕς܂B
		clear() ŁA^ƂȂ܂B
	 */
	bool m_bIsNull ;

	/**
		̗Ԃ̗ԕ܂B
		
		Kl Ressyahoukou_Kudari łB
	
		RXgN^Ō܂܂B
	 */
	ERessyahoukou	m_eRessyahoukou ;

	/**
		̗Ԃ́wԎʁxA
		wԎIndexxŕێ܂B
		
		Kl 0 łB
	*/
	int	m_iRessyasyubetsuIndex ;
	
	/**
		̗Ԃ́wԔԍxB
		
		Kl͋󕶎łB
	 */
	std::string m_strRessyabangou ;
	
	/**
		̗Ԃ́wԖxB
		
		Kl͋󕶎łB
	 */
	std::string m_strRessyamei ;
	
	/**
		̗Ԃ́wxB
		
		Kl͋󕶎łB
	 */
	std::string m_strGousuu ;
	
	/**
		̗Ԃ́wlxB
		
		Kl͋󕶎łB
	 */
	std::string m_strBikou ;
	
	///@}
 private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		̗Ԃ̊ew̎B
		vf́Awwx( CentDedEki ) ̐ɓȂ܂B
		ÝwwOrderxłB
	
		̃ReĩIuWFNg̐Ej̐Ӗthisɂ܂B
	
		Ԃł́Avf 0 ƂȂ܂B
	
		ׂẮwwx
		w^sȂx(Ekiatsukai_None ),
		̏ꍇA̗Ԃ́wNullԁxƂȂ܂B
	 */
	CentDedEkiJikokuCont	m_CentDedEkiJikokuCont ;

	///@}

protected:
	// --------------------------------
	///@name CentDedRosenCentDedRessyaContCentDedRessya po֐
	// --------------------------------
	///@{

	/**
	CentDedRosenCentDedRessyaContCentDedRessya po֐̂߁A
	friend classƂ܂B
	*/
	friend class CentDedRessyaCont ;

	/**
		wwxIuWFNg̑̕ύXʒm܂B
		
		ẮA
		w[w`]ύX́AԂ̉wύXx
		sĂ܂A݂͉Ă܂B

		([w̃vpeB]_CAO
		[ww`ɐK]w肷邱ƂɂA
		̏ł悤ɂȂ߂łB

	 @param iEkiOrder [in]
		IuWFNg}ʒuwwOrderxŎw肵ĂB
		͈͂ 0 ȏ m_iEkiCount ȉłB
	 @return
		 0 ȏAG[Ȃ畉̐łB
	@deprecated
		݁Å֐ł̏͂܂B
	 */
	int onSetCentDedEki( const Mu<CentDedEkiCont::CdDedEki>* pCentDedEkiCont , int iEkiOrder ) ;

	/**
		wwxIuWFNgAẅʒuɑ}܂B
	 @param aCentEkiJikoku [in]
		}wwxIuWFNgw肵ĂB
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵÅ֐I͔jł܂B
	 @param iEkiOrder [in]
		IuWFNg}ʒuwwOrderxŎw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() ȉłB
		INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 @return
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	CfNXsłB
	 */
	int insertCentDedEkiJikoku( const CentDedEkiJikoku& aCentEkiJikoku , 
		int iEkiOrder = INT_MAX ) ;
	
	/**
		wwxIuWFNgAẅʒu폜܂B
	 @param iEkiOrder [in]
		IuWFNg}ʒuwwOrderxŎw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() łB
		INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 @return
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	CfNXsłB
	 */
	int eraseCentDedEkiJikoku( int iEkiOrder = INT_MAX ) ;

	///@}

	

// ********************************
//	RXgN^
// ********************************
 public:
	/**
		̗ԂNULLԂɏ܂B
	 @param iEkiJikokuCount [in]
		̗ԂsH́wwx̐w肵ĂB
		̃RXgN^ł́A m_CentDedEkiJikokuCont ̗vfA
		̈ŏ܂B
		i[ CentDedEkiJikoku ́A 
		CentDedEkiJikoku::m_eEkiatsukai	 Ekiatsukai_None ƂȂ܂B
	 @param eRessyahoukou [in]
		̗Ԃ̗ԕ܂B
	 */
	CentDedRessya( 
		int iEkiJikokuCount , 
		ERessyahoukou	eRessyahoukou ) ;

	/**
			Rs[RXgN^B
	 */
	CentDedRessya( const CentDedRessya& value );

	/**
		̃NXւ̑s܂A
		this ́wԕx ( m_eRessyahoukou ) E
		wwx (CentDedEkiJikoku ) ͕̐ύX܂B
	
		this  m_CentDedEkiJikokuCont ̐ value  m_CentDedEkiJikokuCount
		菭Ȃꍇ́As this  m_CentDedEkiJikokuCount vf
		w^sȂxƂȂ܂B
	
		this  m_CentDedEkiJikokuCont ̐ value  m_CentDedEkiJikokuCount
		葽ꍇ́Aߏ蕪 value  m_CentDedEkiJikokuCount vf
		̂Ă܂B
	 */
	CentDedRessya& operator=( const CentDedRessya& value );
 public:
	virtual ~CentDedRessya() ;
		
// ********************************
//	CentDedRessya
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	ERessyahoukou	getRessyahoukou()const ;
	int	getRessyasyubetsuIndex()const ;
	CentDedRessya& setRessyasyubetsuIndex( int value ) ;
	std::string getRessyabangou()const{
		return m_strRessyabangou ;};
	CentDedRessya& setRessyabangou( const std::string& value ){
		m_bIsNull = false ;
		m_strRessyabangou = value ; return *this ; } ;
	std::string getRessyamei()const{
		return m_strRessyamei ;};
	CentDedRessya& setRessyamei( const std::string& value ){
		m_bIsNull = false ;
		 m_strRessyamei = value ; return *this ; } ;
	std::string getGousuu()const{
		return m_strGousuu ;};
	CentDedRessya& setGousuu( const std::string& value ){
		m_bIsNull = false ;
		 m_strGousuu = value ; return *this ; } ;
	std::string getBikou()const{
		return m_strBikou ;};
	CentDedRessya& setBikou( const std::string& value ){
		m_bIsNull = false ;
		 m_strBikou = value ; return *this ; } ;
	///@}
	
	// ********************************
	///@name -CentDedEkiJikoku
	// ********************************
	///@{
	
	/**
	 @return
		wwx ̐Ԃ܂B
	 */
	int getCentDedEkiJikokuCount()const ;
	
	/**
		wwOrderxɑΉAwwxIuWFNg擾
		Ƃł܂B
	 @param iEkiOrder [in]
		wwOrderxw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() łB
		INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 @return 
		ΉwwxIuWFNg
	 */
	CentDedEkiJikoku getCentDedEkiJikoku( int iEkiOrder )const ;

	/**
		wwOrderxɑΉAwwxIuWFNgݒ肷
		Ƃł܂B
		  this NULLԂ̏ꍇÃ\bhĂяo
		NULLԑ͉܂B
	 @param iEkiOrder [in]
		wwOrderxw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() łB
		INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 @param value [in]
		wwxw肵ĂB
	 @return 
		ΉwwxIuWFNg
	 */
	CentDedRessya& setCentDedEkiJikoku( 
		int iEkiOrder , 
		const CentDedEkiJikoku& value ) ;
	///@}
	// ********************************
	///@name wwOrderxPʂ̑
	// ********************************
	///@{
	/**
		wwOrder(wIndex)xAwwIndexxɕϊ܂B
	 @param iEkiOrder [in]
		wwOrderxw肵ĂB
	 @return 
		0ȏ́wwIndexxԂ܂B
		sȏꍇ́A -1 Ԃ܂B
	 */
	int EkiIndexOfEkiOrder( int iEkiOrder )const  ;
	
	/**
		wwIndexxwwOrder(wIndex)xɕϊ܂B
	 @param iEkiIndex [in]
		wwIndexxw肵ĂB
	 @return 
		0ȏ́wwOrderxԂ܂B
		sȏꍇ́A -1 Ԃ܂B
	 */
	int EkiOrderOfEkiIndex( int iEkiIndex )const  ;
	
	/**
		wwOrderxɑΉAwwxIuWFNgAύX
		Ƃł܂B
	
		̂ƂAwxEwxύXꂽA
		Ȍ̉wׂČJ艺܂B
	
		  this NULLԂ̏ꍇÃ\bhĂяo
		NULLԑ͉܂B

		ij
	
		  ܂ł(this)wx 10:00 ŁA
		V(value )wx 10:03 ̏ꍇ́A
		́wwOrderx́wxƁA
		肠Ƃ́wwOrderx́wxwxׂāA
		RJ艺܂B
		
		  ܂ł(this)wx IsNull ŁA
		V(value )wx 10:03 ̏ꍇ́A
		́wwOrderx́wx 10:03 ɍXV܂B
		́wwOrderx́wxƁA
		肠Ƃ́wwOrderx́wxEwxɂ͉e
		^܂B
	
		  ܂ł(this)wx 10:00 ŁA
		V(value )wx IsNull ̏ꍇ́A
		́wwOrderx́wx IsNull ɍXV܂B
		́wwOrderx́wxƁA
		肠Ƃ́wwOrderx́wxEwxɂ͉e
		^܂B
	
		  wxɊւĂAύXꂽꍇ́A̍ɏ]
		肠Ƃ́wwOrderx́wxEwx̌Jグ/J艺
		s܂B
	
	@param pCentDedEkiCont [in]
		wReiw肵ĂB
	 @param iEkiOrder [in]
		wwOrderxw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() łB
		INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 @param value [in]
		wwxw肵ĂB
	 @return 
		ΉwwxIuWFNg
	 */
	CentDedRessya& modifyCentDedEkiJikoku( 
		int iEkiOrder , 
		const CentDedEkiJikoku& value ) ;
	
	/**
	 @return
		̗Ԃ̎nẃwwOrderxԂ܂B
		ׂẮwwxw^sȂx̏ꍇ́A-1 Ԃ܂B
		̏ꍇA̗Ԏ̂w^sȂxƂȂ܂B
	 */
	int getSihatsuEki()const ;

	/**
		̗Ԃ̎nwݒ肵܂B
		wwOrderxnwŵׂẮwwx
		 Ekiatsukai_None ɕς܂B
	 @param iEkiOrder [in]
		nwwwOrderxŎw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 @return
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	wwOrderxsłB
	 */
	int setSihatsuEki( int iEkiOrder ) ;
	
	/**
	 @return
		̗Ԃ̏IẃwwOrderxԂ܂B
		ׂẮwwxw^sȂx̏ꍇ́A-1 Ԃ܂B
		̏ꍇA̗Ԏ̂w^sȂxƂȂ܂B
	 */
	int getSyuuchakuEki()const ;

	/**
		̗Ԃ̏Iwݒ肵܂B
		wwOrderxIw傫ŵׂẮwwx
		 Ekiatsukai_None ɕς܂B
	 @param iEkiOrder [in]
		IwwwOrderxŎw肵ĂB
		͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 @return
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	wwOrderxsłB
	 */
	int setSyuuchakuEki( int iEkiOrder ) ;

	/**
		Ԃw wwOrderxƁÁwwOrderx̊Ԃ
		^sĂ邩ۂ𒲂ׂ܂B

		uw wwOrderxƁÁwwOrderx̊Ԃ
		^sĂv́A
		w wwOrderxƁÁwwOrderx̗
		wԁx܂́wʉ߁x̏ꍇAɊY܂B
		_COr[ł́A̗Ԃ̂̉wԂɂ͗Ԑ
		`悳܂B

	@param iEkiOrder [in]
		ΏۂƂȂwԂ̋N_́wwOrderxw肵ĂB
		͈͂́A0ȏA(w̐-1)łB
	@return
		Ԃ iEkiOrder Ǝ̉ẘԂ^sĂȂ true łB
		łȂꍇ́A false łB
		͈͊ȌꍇAfalse łB
	@attention
		ǂ炩̉wE܂͗̉wwoRȂx̏ꍇ́A
		uẘԂ^sĂvƂ݂͂Ȃ܂B
		̏ꍇÃ\bh̖߂l͋UƂȂ܂B
	*/
	bool isRunBetweenNextEki( int iEkiOrder )const ;

	/**
	@return
		̗ԂHŉ^sĂԂ́Aŏ́wwOrderxԂ܂B
		ׂĂ̋Ԃ^sĂȂꍇ́A-1 Ԃ܂B
		u^sĂԁvɂẮAisRunBetweenNextEki() 
		QƂĂB

		getSihatsuEki() ƎړI̊֐łB
		AnwwoRȂx̏ꍇ́Å֐͂̉w
		w^sĂxƂ݂͂Ȃ܂B
	 */
	int getRunFirstEkiOrder()const ;
	
	/**
	@return
		̗ԂHŉ^sĂAṒwwOrderxԂ܂B
		ׂĂ̋Ԃ^sĂȂꍇ́A-1 Ԃ܂B
		u^sĂԁvɂẮAisRunBetweenNextEki() 
		QƂĂB

		getSyuuchakuEki() ƎړI̊֐łB
		AIwwoRȂx̏ꍇ́Å֐͂̉w
		w^sĂxƂ݂͂Ȃ܂B
	 */
	int getRunLastEkiOrder()const ;
	
	/**
		w̉w Order ̉wA
		w`EnEIɍ킹ĕύX܂B

		ύXéA CentDedEkiJikoku::adjustByEkijikokukeisiki 
		̐QƂĂB

		this NULLԂ̏ꍇÃ\bh͉܂B

	@see CentDedEkiJikoku::adjustByEkijikokukeisiki 

	@param iEkiOrder [in]
		wOrderw肵ĂB
	@param bChakujikokuHyouji [in]
		w`B
		\B
	@param bHatsujikokuHyouji [in]
		w`B
		\B
	*/
	void adjustByEkijikokukeisiki(
		int iEkiOrder ,
		bool bChakujikokuHyouji , bool bHatsujikokuHyouji ) ;
	

	///@}
	// ********************************
	///@name wOrderxPʂ̑
	//*******************************
	///@{
	/**
	    CdDedJikokuOrder Ảwɐi߂܂B
	@param aJikokuOrder [in]
		i߂Ώۂ́A	CdDedJikokuOrder w肵ĂB
	@return 
		- aJikokuOrder ̏ꍇ́AwOrder̔
		- aJikokuOrder ̏ꍇ́ẢwOrder̒
		- aJikokuOrder  EkiOrder>=this.size() (Ō̉wOrder̎) ȂA@n
			aJikokuOrder ̂܂ܕԂ܂B
		- aJikokuOrder NULL ȂAaJikokuOrder ̂܂ܕԂ܂B
	@attention
		̊֐́Aw`(E\邩ۂ)̑󂯂܂
	*/
	CdDedJikokuOrder incJikokuOrder( 
		const CdDedJikokuOrder& aJikokuOrder )const ;

	/**
	    CdDedJikokuOrder AỎwɈړ܂B
	@param aJikokuOrder [in]
		ړΏۂ́A	CdDedJikokuOrder w肵ĂB
	@return 
		- aJikokuOrder ̏ꍇ́AwOrder̒
		- aJikokuOrder ̏ꍇ́ẢwOrder̔
		- aJikokuOrder  EkiOrder>=this.size() (Ō̉wOrder̎) ȂA@n
			Ō̉wOrder̔
		- aJikokuOrder  EkiOrder=0 ȂANULL
		- aJikokuOrder NULL ȂAaJikokuOrder ̂܂ܕԂ܂B
	@attention
		̊֐́Aw`(E\邩ۂ)̑󂯂܂
	*/
	CdDedJikokuOrder decJikokuOrder( 
		const CdDedJikokuOrder& aJikokuOrder )const ;

	
	/**
		̗Ԃ́AwOrderxɑΉ鎞擾܂B
		
	 @param aJikokuOrder [in]
		擾鎞́wOrderxw肵ĂB
	 @return
		Ή鎞Ԃ܂B
		p[^sȏꍇ́A NullԂ̎Ԃ܂B

	*/
	CdDedJikoku getEkiJikoku( CdDedJikokuOrder aJikokuOrder )const  ;
	
	/**
		̗Ԃ́AwOrderxɑΉ鎞ύX܂B
	 @attention
		̊֐́Aw̉wȍ~̉w
		Jグ^J艺͍s܂B
	 @param aCdDedJikoku [in]
		w肵ĂB
	 @param aJikokuOrder [in]
		ύX鎞́wOrderxw肵ĂB
	 @return
		 0 ȏAG[Ȃ畉̐łB
		- 	-1 ;	//	p[^s
	 */
	int setEkiJikoku( const CdDedJikoku& aCdDcdJikoku , CdDedJikokuOrder aJikokuOrder ) ;
	
	/**
		̗Ԃ́Aw̎ȍ~̎ύX܂B
		w肵wȍ~́AwNullxԂׂ̂Ẳw̎A
		Jグ^J艺܂B
		
	@param pCentDedEkiCont [in]
		wReiw肵ĂB
	@param aCdDedJikan [in]
		JグEJ艺sԂw肵ĂB
	@param iJikokuOrder [in]
		ύX鎞́wOrderxw肵ĂB
	@return
		 0 ȏAG[Ȃ畉̐łB
		- 	-1 ;	//	p[^s
	*/
	int modifyRessyaJikoku(  
		const CdDedJikan& aCdDedJikan , 
		const CdDedJikokuOrder& aJikokuOrder) ;
	
	/**
		̗Ԃ́AẃwOrderxȑOŁA
		wNullxԂ̎A
		ɌāiwOrderx0̕Ɍāj܂B
		
	@param pCentDedEkiCont [in]
		wReiw肵ĂB
	 @param aJikokuOrder [in]
		̋N_ƂȂύX鎞wOrderxŎw肵ĂB
	 @return
		NullԂ̎ꍇ́A0 ȏ́wOrderx擾܂B
		ȂꍇAp[^sȏꍇ́A
		NULLԂ̃IuWFNgԂ܂B
	 */
	CdDedJikokuOrder findrevJikoku( 
		const CdDedJikokuOrder& aJikokuOrder )const ;

	///@}
	
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	 @return
		̗ԂwNullԁxȂ^łB
	
		ׂẮwwx
		w^sȂx(Ekiatsukai_None ),
		̏ꍇA̗Ԃ́wNullԁxƂȂ܂B
	 */
	bool isNull()const ;
	/**
		̗ԂwNullԁxƂ܂B
	 */
	void clear() ;

	/**
		̗Ԃ̉wA̗Ԃ̉wɏ㏑܂B
	@param aCentDedRessyaSrc [in]
		̊֐́A̗Ԃ̉wAthis̉wɏ㏑܂B
		aCentDedRessyaSrc ̉ww^sȂx̉w̎́A
		this ̉wɂ͏㏑܂B
		܂AENULL̏ꍇ́A
		̉w this ɏ㏑܂B
	*/
	void pasteEkiJikoku( const CentDedRessya& aCentDedRessyaSrc ) ;

	/**
		̗ԂƑ̗Ԃ𒼒ʉ܂B
	@param aRessyaSihatsu [in]
		nԂ̃CfNXw肵ĂB
	@return
		0ȏAG[Ȃ畉̐łB
		-	-1 ;	//	̗Ԃɂ͉ww肳Ă܂B
		-	-2 ;	//	nԂɂ͉ww肳Ă܂B
		-	-3 ;	//	aRessyaSihatsu Ƃ̒ʉ͂ł܂B\n
			//aRessyaSihatsu ̎nẃA	this ̏IwƓAȍ~łȂĂ͂Ȃ܂B
	@attention
		aRessyaSihatsu ̎nẃA
		this ̏IwƓAȍ~łȂĂ
		Ȃ܂B
		this̏Iw<aRessyaSihatsu ̎nwȂA
		̊Ԃ̉w̉w[oRȂ]Ƃ܂B

		nw̎(ʉ)́Aȉ̂悤ɂȂ܂B

		- wFς܂B
		- F
		  - thisԂɒw肳ĂꍇF̒
		  - thisԂɒȂAw肳ĂꍇFrw~܂Ԃ̔
		  - thisԂɒw肳ĂȂꍇF͂Ȃ
		- 
		  - nԂɔw肳ĂꍇF̔𒼒ʉԂ̔Ƃ܂B
		  - nԂɔȂAw肳ĂꍇFrwnԂ̒AVԂ̔Ƃ܂B
		  - nԂɒw肳ĂȂꍇF͂Ȃ


	*/
	virtual int direct( 
		const CentDedRessya& aRessyaSihatsu ) ;

	/**
		̗ԂAw̉wŕf܂B

	@param iEkiOrder[in]
		w̉wOrderw肵ĂB
	@param pCentDedRessyaSyuuchaku [out]
		̊֐̗͂ԃIuWFNgɁAw~܂Ԃ̗Ԃ̏
		㏑܂B
		̃IuWFNg ԕEẃA炩
		this ƓɂKv܂B
	@param 	pCentDedRessyaSihatsu [out]
		̊֐̗͂ԃIuWFNgɁAwn̗Ԃ̏
		㏑܂B
		̃IuWFNg ԕEẃA炩
		this ƓɂKv܂B
	@return
		0ȏAG[Ȃ畉̐łB
		-	-1 ;	//	w̉wOrderł́Af͂ł܂

	*/
	virtual int undirect(
		int iEkiOrder , 
		CentDedRessya* pCentDedRessyaSyuuchaku ,
		CentDedRessya* pCentDedRessyaSihatsu )const ;
	///@}
};
#endif /*CentDedRessya_h*/
