/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyaCont.cpp
// ****************************************************************
*/
/** @file*/

#include "stdafx.h"
#include <algorithm>
#include "Mu\CMup_deque.h"
#include "Mu\CaMui.h"
#include "str\strtoint.h"
#include "logmsg\LogMsg.h"
#include "CentDedRessyaCont.h"
using namespace std ;

//#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//#endif


// ****************************************************************
//	CentDedRessyaCont
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
CentDedRessyaCont::CentDedRessyaCont( 
		int iEkiCount ,
		ERessyahoukou eRessyahoukou , 
		int iRessyasyubetsuCount )
	:
	 m_iEkiCount( iEkiCount ) 
	, m_eRessyahoukou( eRessyahoukou )
	, m_iRessyasyubetsuCount( iRessyasyubetsuCount ) 
{
}


CentDedRessyaCont::CentDedRessyaCont( const CentDedRessyaCont& value )
	: super( value )
	, m_iEkiCount( value.m_iEkiCount ) 
	, m_eRessyahoukou( value.m_eRessyahoukou ) 
	, m_iRessyasyubetsuCount( value.m_iRessyasyubetsuCount ) 
{
}
	
CentDedRessyaCont& CentDedRessyaCont::operator=( const CentDedRessyaCont& value )
{
	//	ێĂԂAׂĔj܂B
	erase( 0 , INT_MAX ) ;

	//	value ̗ԂAthisɃRs[Ă܂B
	CaMui< CentDedRessya >	aCaCont_this( this ) ;
	aCaCont_this.insert( &value ) ;

	return *this ;
}

CentDedRessyaCont::~CentDedRessyaCont()
{
	//	ReiێĂ|C^̗vf
	//	erase()->onErase() ɂA
	//	delete ō폜ȂĂ͂Ȃ܂B
	erase( 0 , INT_MAX ) ;
}

// ********************************
//	CentDedRessyaCont
// ********************************
int CentDedRessyaCont::insertBlank( int iIndex )
{
	return ( super::insert( CentDedRessya( m_iEkiCount , m_eRessyahoukou ) , iIndex ) ) ;
}
	

int CentDedRessyaCont::EkiIndexOfEkiOrder( int iEkiOrder )const 
{
	int iRv = iEkiOrder ;
	if ( m_eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = m_iEkiCount - 1 - iEkiOrder ;
	}
	return ( iRv ) ;
}

int CentDedRessyaCont::EkiOrderOfEkiIndex( int iEkiIndex )const 
{
	int iRv = iEkiIndex ;
	if ( m_eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = m_iEkiCount - 1 - iEkiIndex ;
	}
	return ( iRv ) ;
}

int CentDedRessyaCont::findEkikanSaisyouSec( 
		int iEkiOrder , 
		int* pidxRessya )const 
{
	// --------------------------------
			int iSaisyouSyouSecTeisya = -1 ;
			//iSaisyouSyouSecTeisya = 
			//	iEkiiIndex E iEkiIndex + 1 ̗wɒԂԂ̂́A
			//	ŏwԏvb 
			int iSaisyouSyouSec = -1 ;
			//iSaisyouSyouSec = 
			//	iEkiiIndex E iEkiIndex + 1 ̍ŏwԏvb
			//	ЕE܂͗wʉ߉w̗Ԃ܂݂܂B

			int iSaisyouSyouSecTeisyaRessyaIdx = -1 ;
			//iSaisyouSyouSecTeisyaRessyaIdx = 
			//	iSaisyouSyouSecTeisya ɑΉIndex 
			int iSaisyouSyouSecRessyaIdx = -1 ;
			//iSaisyouSyouSecRessyaIdx = 
			//	iSaisyouSyouSec ɑΉIndex 
			
			const Mu<const CentDedRessya*>* pCentDedRessyaContGet =
				this->getMuPtr() ;
			if ( 0 <= iEkiOrder && iEkiOrder < this->getEkiCount() - 1 ){
				int iRessyaIndex = 0 ;
				for ( iRessyaIndex = 0 ; 
						iRessyaIndex < this->size() ; 
						iRessyaIndex ++ ){
					const CentDedRessya* pCentDedRessya = 
						pCentDedRessyaContGet->get( iRessyaIndex ) ;
					CentDedEkiJikoku aEkiJikokuCurr = 
						pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;
					CentDedEkiJikoku aEkiJikokuNext = 
						pCentDedRessya->getCentDedEkiJikoku( iEkiOrder + 1 ) ;

					CdDedJikoku	jikokuHatsu = 
						aEkiJikokuCurr.getHatsujikoku( true ) ;
					CdDedJikoku	jikokuChaku = 
						aEkiJikokuNext.getChakujikoku( true ) ;
					if ( !jikokuHatsu.isNull() && !jikokuChaku.isNull() ){
						int iSyoyouSec = jikokuChaku.subJikoku( jikokuHatsu ) ;
						if ( iSaisyouSyouSec == -1 || 
								iSaisyouSyouSec > iSyoyouSec ){
							iSaisyouSyouSec = iSyoyouSec ;
							iSaisyouSyouSecRessyaIdx = iRessyaIndex ;
						}
						
						if ( aEkiJikokuCurr.getEkiatsukai() == 
								CentDedEkiJikoku::Ekiatsukai_Teisya && 
							aEkiJikokuNext.getEkiatsukai() == 
								CentDedEkiJikoku::Ekiatsukai_Teisya ){
							if ( iSaisyouSyouSecTeisya == -1 || 
									iSaisyouSyouSecTeisya > iSyoyouSec ){
								iSaisyouSyouSecTeisya = iSyoyouSec ;
								iSaisyouSyouSecTeisyaRessyaIdx = iRessyaIndex ;
							}
						} 
					}
					
				}
			}
			LogMsg( "CentDedRessyaCont::findEkikanSaisyouSec( iEkiOrder=%d )"
				" iSaisyouSyoyouSecTeisya=%d RessyaIdx=%d "
				" iSaisyouSyoyouSec=%d RessyaIdx=%d" , 
				iEkiOrder , 
				iSaisyouSyouSecTeisya ,
				iSaisyouSyouSecTeisyaRessyaIdx , 
				iSaisyouSyouSec ,
				iSaisyouSyouSecRessyaIdx ) ; 

			if ( iSaisyouSyouSecTeisya >= 0 ){
				iSaisyouSyouSec = iSaisyouSyouSecTeisya ;
				iSaisyouSyouSecRessyaIdx = iSaisyouSyouSecTeisyaRessyaIdx ;
			}
			if ( iSaisyouSyouSec < 0 ){
					iSaisyouSyouSec = 0 ;
			}
			// --------------------------------
			if ( pidxRessya != NULL ){
				*pidxRessya = iSaisyouSyouSecRessyaIdx ;
			}
			return ( iSaisyouSyouSec ) ;

}



/**
	CentDedRessyaCont::sort() Ɏgp
	ׂpwIuWFNgB
*/
class CdRessyaForSort_Ekijikoku
{
public:
	/**
		CdRessyaForSort_Ekijikoku ̔rs֐IuWFNgłB
	*/
	class CCompareFunction
	{
		/**
		_CON_w肵ĂB
		̊֐́A\[gɁA̒lł
		݂Ȃ܂B
		(F̎5:00w肳ꂽꍇ́A5:00<23:59<0:00<4:59 ƂĔrs܂)
		*/
		CdDedJikoku m_jikokuKitenJikoku ;
	public:
		CCompareFunction( 
			const CdDedJikoku& jikokuKitenJikoku ) 
			: m_jikokuKitenJikoku( jikokuKitenJikoku )
		{
		};
		/**
		@return
			left < right Ȃ^łB

		@note
		  r́A
			- wNULLłȂ̂NULL̂̂Ƃł́ANULLłȂ̂B
			- EkijikokȕقB
			- EkijikokuȂAB
			- Ekijikoku/ȂRessyaIdx̏قB
		*/
		bool operator()( 
			const CdRessyaForSort_Ekijikoku& left , 
			const CdRessyaForSort_Ekijikoku& right )
		{
			// --------------------------------
			//	ЕNULL̏ꍇ̔r
			// --------------------------------
			if ( !left.getJikoku().isNull() && right.getJikoku().isNull() )
			{
				//	leftNULLŁAright͔NULL
				return true ;
			}
			else if ( left.getJikoku().isNull() && !right.getJikoku().isNull() )
			{
				//	left͔NULLŁArightNULL
				return false ;
			}
			// --------------------------------
			//	m_Jikoku ͂ǂNULLł͂ȂE͂ǂNULL
			//	m_Jikoku ͓
			// --------------------------------
			int iResult = left.getJikoku().compare( right.getJikoku() , m_jikokuKitenJikoku ) ;
			if ( iResult == -1 )
			{
				return true ;
			}
			else if ( iResult == 1 )
			{
				return false ;
			}

			// --------------------------------
			//	m_Jikoku ͓
			//	EkijikokuȂAB
			// --------------------------------
			if ( !left.getIsHatsuJikoku() &&
				right.getIsHatsuJikoku() )
			{
				return true ;
			}
			else if ( left.getIsHatsuJikoku() != right.getIsHatsuJikoku() )
			{
				return false ;
			}
			
			// --------------------------------
			// m_Jikoku , m_bIsHatsuJikoku ͓
			//	- Ekijikoku/ȂRessyaIdx̏قB
			// --------------------------------
			if ( left.getRessyaIdx() < right.getRessyaIdx() )
			{
				return true ;
			}
			return false ;
		}

	};

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/** ԃCfNX */
	int m_iRessyaIdx ;

	/** w */
	CdDedJikoku m_Jikoku ;
	/** 
	-	false : m_Jikoku ́A
	-	true  : m_Jikoku ́A
	*/
	bool	m_bIsHatsuJikoku ;
	///@}

public:
	CdRessyaForSort_Ekijikoku( 
		int iRessyaIdx , 
		const CdDedJikoku& aJikoku , 
		bool bIsHatsuJikoku ) 
		: m_iRessyaIdx( iRessyaIdx ) 
		, m_Jikoku( aJikoku ) 
		, m_bIsHatsuJikoku( bIsHatsuJikoku ){} ;
	CdRessyaForSort_Ekijikoku()
		: m_iRessyaIdx( 0 ) 
		, m_Jikoku() 
		, m_bIsHatsuJikoku( false ){} ;


	// ********************************
	///@name 
	// ********************************
	///@{
	int getRessyaIdx()const{	return m_iRessyaIdx ;};
	void setRessyaIdx( int value ){	m_iRessyaIdx = value ;};
	CdDedJikoku getJikoku()const{	return m_Jikoku ;};
	bool getIsHatsuJikoku()const{	return m_bIsHatsuJikoku ;};
	///@}

};
/**
	CentDedRessyaCont::sort() Ɏgp
	ׂpԃIuWFNg
*/
class CdRessyaForSort_Ressya
{
public:
	/**
		CdRessyaForSort ̔rs֐IuWFNgłB
	*/
	class CCompareFunction
	{
	public:
		CCompareFunction( ) 
		{
		};
		/**
		@return
			left < right Ȃ^łB

		@note
		  r́A
			- NULLłȂ̂NULL̂̂Ƃł́ANULLłȂ̂B
			- ԎIndex̏قB
			- ԖőB
			- 𐮐ꍇɑB
			- őB
		*/
		bool operator()( 
			const CdRessyaForSort_Ressya& left , 
			const CdRessyaForSort_Ressya& right )
		{
			// --------------------------------
			//	ЕNULL̏ꍇ̔r
			//	- NULLłȂ̂NULL̂̂Ƃł́ANULLłȂ̂B
			// --------------------------------
			if ( !left.getIsNull() && right.getIsNull() )
			{
				//	leftNULLŁAright͔NULL
				return true ;
			}
			else if ( left.getIsNull() && !right.getIsNull() )
			{
				//	left͔NULLŁArightNULL
				return false ;
			}
			// --------------------------------
			//	- ԎIndex̏قB
			// --------------------------------
			if ( left.getRessyasyubetsuIndex() < right.getRessyasyubetsuIndex() )
			{
				return true ;
			}
			else if ( left.getRessyasyubetsuIndex() > right.getRessyasyubetsuIndex() )
			{
				return false ;
			}

			// --------------------------------
			//	- ԖőB
			// --------------------------------
			if ( left.getRessyamei() < right.getRessyamei() )
			{
				return true ;
			}
			else if ( left.getRessyamei() > right.getRessyamei() )
			{
				return false ;
			}

			// --------------------------------
			//	- 𐮐ꍇɑB
			// --------------------------------
			{
				int iLeftGousuu = OuLib::intOf( left.getGousuu() ) ;
				int iRightGousuu = OuLib::intOf( right.getGousuu() ) ;
				if ( iLeftGousuu < iRightGousuu )
				{
					return true ;
				}
				else if ( iLeftGousuu > iRightGousuu )
				{
					return false ;
				}
			}
			// --------------------------------
			//	- őB
			// --------------------------------
			if ( left.getGousuu()  < right.getGousuu() )
			{
				return true ;
			}
			return false ;
		}

	};

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/** ԃCfNX */
	int m_iRessyaIdx ;
	/**
		̗ԂwNullԁxȂ^A
		LȗԑێĂ̂ȂUłB
		
		̑^̏ꍇA 
		-	m_iRessyasyubetsuIndex,
		-	m_strRessyabangou ;
		-	m_strRessyamei ;
		-	m_strGousuu ;
		-	m_strBikou ;
	
		сA
			m_CentDedEkiJikokuCont Ɋi[Ă 
		CentDedEkiJikoku ́AӖ܂B
		
		Kl true łB
		set...() \bhŁAm_eRessyahoukou ȊO
		ꂩ̑ݒ肵Ƃɂ́A
		IɋUɕς܂B
		clear() ŁA^ƂȂ܂B
	 */
	bool m_bIsNull ;

	/**
		̗Ԃ́wԎʁxA
		wԎIndexxŕێ܂B
		
		Kl 0 łB
	*/
	int	m_iRessyasyubetsuIndex ;
	
	/**
		̗Ԃ́wԖxB
		
		Kl͋󕶎łB
	 */
	string m_strRessyamei ;
	
	/**
		̗Ԃ́wxB
		
		Kl͋󕶎łB
	 */
	string m_strGousuu ;
	///@}
public:
	CdRessyaForSort_Ressya( 
		int iRessyaIdx , 
		bool bIsNull ,
		int	iRessyasyubetsuIndex ,
		const string& strRessyamei ,
		const string& strGousuu )
		: m_iRessyaIdx( iRessyaIdx ) 
		, m_bIsNull( bIsNull )
		, m_iRessyasyubetsuIndex( iRessyasyubetsuIndex )
		, m_strRessyamei( strRessyamei )
		, m_strGousuu( strGousuu ){} ;
	CdRessyaForSort_Ressya()
		: m_iRessyaIdx( 0 ) 
		, m_bIsNull( true )
		, m_iRessyasyubetsuIndex( 0 )
		, m_strRessyamei()
		, m_strGousuu(){} ;
	// ********************************
	///@name 
	// ********************************
	///@{
	int getRessyaIdx()const{	return m_iRessyaIdx ;};
	void setRessyaIdx( int value ){	m_iRessyaIdx = value ;};
	bool getIsNull()const{	return m_bIsNull ;};
	int	getRessyasyubetsuIndex()const{	return m_iRessyasyubetsuIndex ;};
	string getRessyamei()const{	return m_strRessyamei ;};
	string getGousuu()const{	return m_strGousuu ;};
	///@}
};	


int CentDedRessyaCont::findTrainToDirect(
		int idxRessya , 
		int iEkiOrder  )const 
{
	const CentDedRessya* pCentDedRessyaSyuuchaku = getMuPtr()->get( idxRessya ) ;
	CdDedJikoku jikokuSyuuchaku ;
	{
		int iEkiOrderSyuuchaku = pCentDedRessyaSyuuchaku->getRunLastEkiOrder() ;
		jikokuSyuuchaku = pCentDedRessyaSyuuchaku->getCentDedEkiJikoku( iEkiOrderSyuuchaku ).getChakujikoku( true ) ;
	}
	//jikokuSyuuchaku = thisԂ̏Iw̒iNULL̏ꍇ܂j

	int iRv = -1 ;
	for ( idxRessya ++ ; iRv == -1 && idxRessya  < getMuPtr()->size() ; idxRessya ++ )
	{
		const CentDedRessya* pCentDedRessyaSihatsu = getMuPtr()->get( idxRessya ) ;
		//	  - EtH[JX̂(rw~܂̗)ƓԎ
		if ( pCentDedRessyaSyuuchaku->getRessyasyubetsuIndex() == 
			pCentDedRessyaSihatsu->getRessyasyubetsuIndex() )
		{
			//	  - EtH[JX̂wnwƂ
			if ( iEkiOrder == pCentDedRessyaSihatsu->getRunFirstEkiOrder() )
			{
				//	  - EIԂ̒nw̔w肳Ăꍇ́A
				//	  - Enw̔AIԂ̒12Ԉȓ
				//	  - EIԂ̒Enw̔̂ǂ炩Ăꍇ́A
				//		ɒʉ̑ΏۂƂȂ܂B
				CdDedJikoku jikokuSihatsu = pCentDedRessyaSihatsu->getCentDedEkiJikoku( iEkiOrder ).getHatsujikoku( true ) ;
				if ( !jikokuSyuuchaku.isNull() && !jikokuSihatsu.isNull() )
				{
					CdDedJikan aJikan = jikokuSihatsu.subJikoku( jikokuSyuuchaku ) ;
					if ( CdDedJikan() <= aJikan )
					{
						iRv = idxRessya ;
					} 
				}
				else
				{
					//	  - Enw̔AIԂ̒12Ԉȓ
					iRv = idxRessya ;
				}
			}
		}
	}
	return iRv ;
}

void CentDedRessyaCont::adjustByEkijikokukeisiki(
		int iEkiOrder ,
		bool bChakujikokuHyouji , bool bHatsujikokuHyouji ) 
{
	for ( int idxRessya = 0 ; idxRessya < size() ; idxRessya ++ )
	{
		CentDedRessya* pRessya = getMuPtr()->get( idxRessya ) ;
		pRessya->adjustByEkijikokukeisiki( 
			iEkiOrder ,
			bChakujikokuHyouji , bHatsujikokuHyouji ) ;
	}
}


// --------------------------------
//@name CentDedRessya  
//	CentDedEkiJikoku 𑝌
// --------------------------------
int CentDedRessyaCont::onSetCentDedEki( const Mu<CentDedEkiCont::CdDedEki>* pCentDedEkiCont , int iEkiOrder ) 
{
	int iRv = 0 ;

	Mu<CentDedRessya*>*	pIfContGet = getMuPtr() ;
	if ( iRv >= 0 ){
		int idxRessya = 0 ;
		for ( idxRessya = 0 ; 
				idxRessya < pIfContGet->size() ;
				idxRessya ++ ){
			CentDedRessya*	pCentDedRessya = pIfContGet->get( idxRessya ) ;

			iRv = pCentDedRessya->onSetCentDedEki( 
					pCentDedEkiCont , 
					iEkiOrder ) ;
				//-1 ; // CfNXsłB 
		}
	}
	return ( iRv ) ;
}

int CentDedRessyaCont::insertCentDedEkiJikoku(	int iEkiOrder ) 
{
	int iRv = 0 ;

	Mu<CentDedRessya*>*	pIfContGet = getMuPtr() ;
	if ( iRv >= 0 ){
		m_iEkiCount ++ ;
		int idxRessya = 0 ;
		for ( idxRessya = 0 ; 
				idxRessya < pIfContGet->size() ;
				idxRessya ++ ){
			CentDedRessya*	pCentDedRessya = pIfContGet->get( idxRessya ) ;

			iRv = pCentDedRessya->insertCentDedEkiJikoku( 
					CentDedEkiJikoku() , 
					iEkiOrder ) ;
				//-1 ; // CfNXsłB 
		}
	}
	return ( iRv ) ;
}
	
int CentDedRessyaCont::eraseCentDedEkiJikoku( int iEkiOrder ) 
{
	int iRv = 0 ;
	Mu<CentDedRessya*>*	pIfContGet = getMuPtr() ;
	if ( iRv >= 0 ){
		m_iEkiCount -- ;

		int idxRessya = 0 ;
		for ( idxRessya = 0 ; 
				idxRessya < pIfContGet->size() ;
				idxRessya ++ ){
			CentDedRessya*	pCentDedRessya = pIfContGet->get( idxRessya ) ;
			iRv = pCentDedRessya->eraseCentDedEkiJikoku( iEkiOrder ) ;
			//-1 ; // CfNXsłB 
		}
	}
	return ( iRv ) ;
}
int CentDedRessyaCont::insertRessyasyubetsuIndex( int iRessyasyubetsuIndex ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndex == INT_MAX ){
			iRessyasyubetsuIndex = m_iRessyasyubetsuCount ;
		}
		if ( !( 0 <= iRessyasyubetsuIndex && 
				iRessyasyubetsuIndex <= m_iRessyasyubetsuCount ) ){
			iRv = -1 ;	//	CfNXs
		}
	}
	// --------------------------------
	if ( iRv >= 0 ){
				Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr() ;
	
				int iRessyaCount = pCentDedRessyaContGet->size() ;
				int iRessyaIndex ;
				for ( iRessyaIndex = 0 ; iRessyaIndex < iRessyaCount ; iRessyaIndex ++ ){
					CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIndex ) ;
					
					int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex() ;
					if ( iRessyasyubetsuIndexCurr >= iRessyasyubetsuIndex ){
						iRessyasyubetsuIndexCurr ++ ;
						pCentDedRessya->setRessyasyubetsuIndex( iRessyasyubetsuIndexCurr ) ;
					} 
				}
				m_iRessyasyubetsuCount ++ ;
	}
	return ( iRv ) ;
	
	
}
	
int CentDedRessyaCont::eraseRessyasyubetsuIndex( int iRessyasyubetsuIndex ) 
{
	int iRv = 0 ;

	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndex == INT_MAX ){
			iRessyasyubetsuIndex = m_iRessyasyubetsuCount - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndex && 
				iRessyasyubetsuIndex < m_iRessyasyubetsuCount ) ){
			iRv = -1 ;	//	CfNXs
		}
	}
	if ( iRv >= 0 ){
		if ( isExistRessyaOfRessyasyubetsu( 
			iRessyasyubetsuIndex , NULL ) > 0 ){
			iRv = -3 ;	//	wԎʁx iRessyasyubtsuIndex ̗Ԃ݂܂B
		}
	}
	// --------------------------------
	if ( iRv >= 0 ){
				Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr() ;
				int iRessyaCount = pCentDedRessyaContGet->size() ;

				int iRessyaIndex ;
				for ( iRessyaIndex = 0 ; iRessyaIndex < iRessyaCount ; iRessyaIndex ++ ){
					CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIndex ) ;
					
					int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex() ;
					if ( iRessyasyubetsuIndexCurr > iRessyasyubetsuIndex ){
						iRessyasyubetsuIndexCurr -- ;
						pCentDedRessya->setRessyasyubetsuIndex( iRessyasyubetsuIndexCurr ) ;
					}	else if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndex ){
						iRessyasyubetsuIndexCurr = 0 ;
						pCentDedRessya->setRessyasyubetsuIndex( iRessyasyubetsuIndexCurr ) ;
					} 
				}
				
				m_iRessyasyubetsuCount -- ;
	}
	return ( iRv ) ;
	
}

int CentDedRessyaCont::isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		int* piRessyaIndex ) 
{
	int iRv = 0 ;
	Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr() ;

	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndex == INT_MAX ){
			iRessyasyubetsuIndex = m_iRessyasyubetsuCount - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndex && 
				iRessyasyubetsuIndex < m_iRessyasyubetsuCount ) ){
			iRv = -1 ;	//	CfNXs
		}
	}
	
	int iRessyaIndexFound = -1 ;
	if ( iRv >= 0 ){
	
				Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr() ;
				int iRessyaCount = pCentDedRessyaContGet->size() ;

				int iRessyaIndex ;
				for ( iRessyaIndex = 0 ; 
						iRv == 0 && iRessyaIndex < iRessyaCount ; 
						iRessyaIndex ++ ){
					CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIndex ) ;
					
					int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex() ;
					// --------------------------------
					if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndex ){
						iRessyaIndexFound = iRessyaIndex ;
						iRv = 1 ;	//	w̗Ԏʂ̗Ԃ݂܂B
					}
				}
	}
	// --------------------------------
	if ( iRv == 1 ){
		if ( piRessyaIndex != NULL ){
			*piRessyaIndex = iRessyaIndexFound ;
		}
	}
	
	return ( iRv ) ;
}

