/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	CentDedRessya_EkijikokuModifyOperation2.h
// ****************************************************************
#ifndef  CentDedRessya_EkijikokuModifyOperation2_h
#define  CentDedRessya_EkijikokuModifyOperation2_h
/** @file */

#include "CentDedRessya.h"

// ****************************************************************
//	CentDedRessya_EkijikokuModifyOperation2
// ****************************************************************
/**
 * @brief
 *	Ԃɑ΂ww̕ύXx̓ełB
 *
 *	̃NX̃IuWFNgɁww̕ύXx̓eݒ肵
 *	CentDedRessya_EkijikokuModifyOperation2::execute() s邱ƂɂA
 *	w̕ύXs邱Ƃł܂B
 */
class CentDedRessya_EkijikokuModifyOperation2
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**
	 *	wɑ΂鑀̓e\񋓂łB
	 */
	enum EOperation 
	{
		/**
		*	wύX܂B
		*/
		OperationNop ,
		
		/**
		*	w̌JグEJB
		*
		*	ύXΏۂ̉wA
		*	 m_iSecondsChaku J܂i̐Ȃ
		*	JグƂȂ܂j
		*/
		OperationModify ,
		/**
		*	w̃Rs[B
		*
		*	ύXΏۂ̉wɁA
		*	wOrderxm_iJikokuOrderCopySrc ̎
		*	Rs[܂B
		*	̂ƂAύXΏۂ̉wȍ~̎͌JグEJ
		*	Ȃ܂B
		*
		*	modifyRessyaJikoku() 
		*/
		OperationCopy ,
		/**
		*
		*	ύXΏۂ̉wA
		*	wȂɕύX܂B
		*/
		OperationToNull ,
	};
// ********************************
///@name	
// ********************************
///@{
 private:
	/**
	 *	wύX܂B
	 *	̕ϐ true ̏ꍇAw̒ĺA m_eEkiatsukai Ŏw肵܂B
	 */
	bool m_bSetEkiatsukai ;
	/**
	 * @see m_bSetEkiatsukai QƂĂB
	 *
	 *	m_bSetEkiatsukai Ȕꍇ́A̕ϐ͈Ӗ܂B
	 */
	CentDedEkiJikoku::EEkiatsukai m_eEkiatsukai ;


	/**
	*	ύX̕@
	*/
	EOperation m_eOperation ;

	/**
	* @see m_eOperation
	*/
	int	m_iSeconds ;

	/**
	* @see m_eOperation
	*/
	CdDedJikokuOrder m_iJikokuOrderCopySrc ;

///@}
// ********************************
//	RXgN^
// ********************************
 public:
	CentDedRessya_EkijikokuModifyOperation2() : 
		m_bSetEkiatsukai( false ) ,
		m_eEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ,
		m_eOperation( OperationNop ) , 
		m_iSeconds( 0 ) ,
		m_iJikokuOrderCopySrc( 0 , CdDedJikokuOrder::EkiJikokuItem_Chaku ){} ;
		
// ********************************
//	CentDedRessya_EkijikokuModifyOperation2
// ********************************
 public:
	// ********************************
	///@name	
	// ********************************
	///@{
	bool getSetEkiatsukai()const{ return m_bSetEkiatsukai ;};
	CentDedRessya_EkijikokuModifyOperation2& setSetEkiatsukai( bool value ){
		m_bSetEkiatsukai = value ; return *this ; } ;
	CentDedEkiJikoku::EEkiatsukai getEkiatsukai()const{
		return m_eEkiatsukai ; } ;
	CentDedRessya_EkijikokuModifyOperation2& setEkiatsukai( 
			CentDedEkiJikoku::EEkiatsukai value ){
		m_eEkiatsukai = value ; return *this ; } ;

	EOperation getOperation()const{ return m_eOperation ;};
	CentDedRessya_EkijikokuModifyOperation2& setOperation( 
			EOperation value ){
		m_eOperation = value ; return *this ; } ;
	int getSeconds()const{ return m_iSeconds ;};
	CentDedRessya_EkijikokuModifyOperation2& setSeconds( int value ){
		m_iSeconds = value ; return *this ; } ;
	CdDedJikokuOrder getJikokuOrderCopySrc()const{ return m_iJikokuOrderCopySrc ;};
	CentDedRessya_EkijikokuModifyOperation2& setJikokuOrderCopySrc( 
		const CdDedJikokuOrder& value )
	{
		m_iJikokuOrderCopySrc = value ; return *this ; 
	} ;

	/**
	@return
		- true:	this NULLԂłB
		
		NULLԂ́A m_bSetEkiatsukai == false & m_eOperation == OperationNop
		ł邱Ƃ܂B
	*/
	bool isNull()const{	return !m_bSetEkiatsukai && m_eOperation == OperationNop ;};

	/**
		this  NULL Ԃɂ܂B
	*/
	void setNull(){	m_bSetEkiatsukai = false ;	m_eOperation = OperationNop ;};

	///@}
	// ********************************
	///@name	
	// ********************************
	///@{
	/**
	*	ẃwԁxɑ΂āȂێĂww̕ύXx
	*	s܂B
	*
	*	̂ƂAwxEwxύXꂽA
	*	Ȍ̉wׂČJ艺܂B
	*
	*
	* @param pCentDedRessya [in,out]
	*	́wԁxɑ΂āȂێĂww̕ύXx
	*	s܂B
	* @param aJikokuOrder [in]
	*	wOrderxw肵ĂB
	*	͈͂ 0 ȏ getCentEkiJikokuCount() * 2 łB
	* @return 
	*	 0 ȏAG[Ȃ畉̐łB
	*	-	-1 ;	//	aJikokuOrder ͈͊OłB
	*	-	-15 ;	//	EƂɐݒ肳ĂȂw
	*			//	ԂɕύX邱Ƃ͂ł܂B
	*/
	virtual int execute( CentDedRessya* pCentDedRessya , CdDedJikokuOrder aJikokuOrder ) ;
	///@}
};
#endif /*CentDedRessya_EkijikokuModifyOperation2_h*/
