/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRosen.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRosen_h
#define  CentDedRosen_h

#include <deque>

#include "CentDed.h"
#include "CentDedEkiCont.h"
#include "CentDedRessyasyubetsuCont.h"
#include "CentDedDiaCont.h"
#include "Mu/CaMup_vector.h"

// ****************************************************************
//	CentDedRosen
// ****************************************************************
/**
 *	@brief
 *	yTvz  DiagramEdit ́AwHxP\܂B
 *	  ̃NX́A DiagramEdit ̃GeBeBNX CentDed... 
 *	[gƂȂNXłBȉ̃NX̃IuWFNg܂܂B
 *	
 *	- wwx ( CentDedEki ) F 0 ȏ㕡̃IuWFNg܂܂B
 *
 *	- wԎʁx ( CentDedRessyasyubetsu ) F 1 ȏ㕡̃IuWFNg
 *	܂܂B
 *
 *	- w_Cx ( CentDedDia ) F 0 ȏ㕡̃IuWFNg܂܂B
 *	w_Cx ( CentDedDia ) ́Awԁx ( CentDedRessya ) Oȏ㕡
 *	܂Ă܂BɁAwԁx́Awwx ( CentDedEkiJikoku ) 
 *	wwx̐܂Ă܂B
 *
 *	\n this ɕ܂ CentDedDia ́A CentDedDia::m_strName ӂłȂĂ
 *	Ȃ܂B CentDedDia  insertCentDedDia() œo^悤ƂƁA
 *	G[ƂȂ܂B
 *
 *  wwxIuWFNgǉE폜ꍇAthis ͕܂Ă
 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
 *	wwx ( CentDedEkiJikoku )IuWFNg̒ǉE폜s܂B
 *	
 *	  wԎʁxIuWFNg폜ꍇA this ͕܂Ă邷ׂĂ
 *	wԁxIuWFNĝA폜ꂽwԎIndexxwԁx
 *	ɑ΂āAwԎIndexx0(̗Ԏ)ɕύX܂B
 *
 *
 *	  wwIndexx́AH̉Ԃ̎nwiԂ̏Iwj 0 E 
 *	Ԃ̏IwiԂ̎nwj  ( w̐ - 1 ) ƂȂ܂B
 * @see CentDedRessya
 *	ywIndex  wOrderz QƂĂB
 */
class CentDedRosen
{

protected:
	// ********************************
	//	Ci[^Cv
	// ********************************
	// ----------------------------------------------------------------
	//	CentDedRosen::CXCentDedEkiCont
	// ----------------------------------------------------------------
	/**
	 *	@brief
	 *  wHxIuWFNgɕ܂A
	 *	wwx(CentDedEki) IuWFNg̃ReiłB
	 *
	 *  wwxIuWFNgǉE폜ꍇA
	 *	this ͊֘AwHx܂Ă
	 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
	 *	wwx ( CentDedEkiJikoku )IuWFNg̒ǉE폜s܂B
	 *	
	 */
	class CXCentDedEkiCont : public CentDedEkiCont
	{
	public:
		// ********************************
		//	Ci[^Cv
		// ********************************
		typedef CentDedEkiCont	super ;
	private:
		// ********************************
		///@name ֘A
		// ********************************
		///@{
		/**
		 *	wHxIuWFNgƂ̊֘AłB
		 *
		 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 */
		CentDedRosen*	m_pCentDedRosen ;
		///@}
	public:
		// ********************************
		//	RXgN^
		// ********************************
		/**
		 * @param pCentDedRosen [in]
		 *	wHxIuWFNgƂ̊֘AłB
		 *	\ñIuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 *
		 * @attention
		 *	̃RXgN^́A
		 *	pCentDedRosen Ɋ܂܂SĂ̗Ԃ̉wA this ̉w
		 *	ɒ܂B
		 */
		CXCentDedEkiCont( CentDedRosen* pCentDedRosen ) ;

	private:
		CXCentDedEkiCont( const CXCentDedEkiCont& value ){} ;
		CXCentDedEkiCont& operator=( const CXCentDedEkiCont& value ){} ;
	public:
		virtual ~CXCentDedEkiCont() ;
		
	public:
		// ********************************
		//	Mui
		// ********************************
		/**
		 * 	ReíACfNXŎw肳ꂽꏊ
		 *	vfu܂B
		 * @param element [in]
		 * 	vfw肵ĂB
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() ȉłB
		 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedEki IuWFNgǉ̂ɉāA
		 *	m_pCentDedRosen ܂ĂSĂ̗Ԃ̂A
		 *	iIndex ̉wnEIƂԂ̉w
		 *	␳܂B
		 */
	 	virtual int  set (const CentDedEki& element, int iIndex) ;

		/**
		 * 	ReíACfNXŎw肳ꂽꏊɁA
		 * 	vfǉ܂B
		 * @param element [in]
		 * 	vfw肵ĂB
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() ȉłB
		 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedEki IuWFNgǉ̂ɉāA
		 *	m_pCentDedRosen ܂ĂSĂ̗Ԃɑ΂āA
		 *	w̒ǉs܂B
		 */
		virtual int insert( const CentDedEki& element , int iIndex = INT_MAX );
		/**
		 * 	ReíACfNXŎw肳ꂽꏊ
		 * 	vf폜܂B
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() łB
		 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @param iSize [in]
		 * 	폜vf̐w肵ĂB
		 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
		 * @attention
		 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedEki IuWFNg폜̂ɉāA
		 *	m_pCentDedRosen ܂ĂSĂ̗Ԃɑ΂āA
		 *	w̍폜s܂B
		 */
		virtual int erase( int iIndex  , int iSize = 1 ) ;
	};
	friend class CXCentDedEkiCont ;

	// ----------------------------------------------------------------
	//	CentDedRosen::CXCentDedRessyasyubetsuCont
	// ----------------------------------------------------------------
	/**
	 *	@brief
	 *  wHxIuWFNgɕ܂A
	 *	wԎʁx(CentDedRessyasyubetsu) IuWFNg̃ReiłB
	 *	
	 *	ʏ̗ԎʃReiɉāAȉ̂悤ȓ݂܂B
	 *	
	 *	
	 * PD  wԎʁxIuWFNgǉE폜ꍇA
	 *	this ͊֘AwHx܂Ă
	 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
	 *	wԎIndexx ( CentDedRessya::m_iRessyasyubetsuIndex )
	 *	̏Cs܂B
	 *
	 *	QD  ΉԂ m_pCentDedRosen ɑ݂ꍇA
	 *	̗Ԏʂ폜邱Ƃ͂ł܂B
	 *	  ʏAwԎʁx̃Reiuꍇ́A 
	 *	m_pCentDedRosen AׂĂ̗Ԃ폜ĂKv܂B
	 */
	class CXCentDedRessyasyubetsuCont : public CentDedRessyasyubetsuCont
	{
	public:
		// ********************************
		//	Ci[^Cv
		// ********************************
		typedef CentDedRessyasyubetsuCont	super ;
	private:
		// ********************************
		///@name ֘A
		// ********************************
		///@{
		/**
		 *	wHxIuWFNgƂ̊֘AłB
		 *
		 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 */
		CentDedRosen*	m_pCentDedRosen ;
		///@}
	public:
		// ********************************
		//	RXgN^
		// ********************************
		/**
		 * @param pCentDedRosen [in]
		 *	wHxIuWFNgƂ̊֘AłB
		 *	\ñIuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		 *	̃IuWFNǵAthis̔j܂ŐȂĂ͂Ȃ܂B
		 *
		 */
		CXCentDedRessyasyubetsuCont( CentDedRosen* pCentDedRosen ) ;

	 private:
		CXCentDedRessyasyubetsuCont( const CXCentDedRessyasyubetsuCont& value ){} ;
		CXCentDedRessyasyubetsuCont& operator=( const CXCentDedRessyasyubetsuCont& value ){} ;
	 public:
		virtual ~CXCentDedRessyasyubetsuCont() ;
		
	public:
		// ********************************
		//	Mui
		// ********************************
		/**
		 * 	ReíACfNXŎw肳ꂽꏊɁA
		 * 	vfǉ܂B
		 * @param element [in]
		 * 	vfw肵ĂB
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() ȉłB
		 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *	-	-1 ;	//	iIndex słB
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedRessyasyubetsu IuWFNgǉ̂ɉāA
		 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
		 *	wԎIndexx ( CentDedRessya::m_iRessyasyubetsuIndex )
		 *	̏Cs܂B
		 */
		virtual int insert( const CentDedRessyasyubetsu& element , int iIndex = INT_MAX );
		/**
		 * 	ReíACfNXŎw肳ꂽꏊ
		 * 	vf폜܂B
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() łB
		 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @param iSize [in]
		 * 	폜vf̐w肵ĂB
		 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
		 * @attention
		 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
		 * @return
		 * 	0ȏ͐A̐̓G[ł
		 *	-	-1 ;	//	iIndex słB
		 *	-	-11 ;	//	폜Ώۂ̗Ԏʂ̗Ԃ݂܂B
		 *
		 *	<H4>
		 *	yI[oChz
		 *	</H4>
		 *	CentDedRessyasyubetsu IuWFNg폜̂ɉāA
		 *	ׂẮwԁx ( CentDedRessya ) ɑ΂āA
		 *	wԎIndexx ( CentDedRessya::m_iRessyasyubetsuIndex )
		 *	̏Cs܂B
		 */
		virtual int erase( int iIndex  , int iSize = 1 ) ;

	};
	friend class CXCentDedRessyasyubetsuCont ;

	///@}


private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	 *	Ĥ̖łB
	 *	ij "ߓS" Ȃ
	 */
	std::string	m_strName ;
	
	/**
	 *	_C̋N_łB
	 *	̎́A_CO̍[̎ƂȂ܂B
	 *
	 *	l 00:00:00 łB
	 * @attention
	 *	̒ĺA Null ԂɂȂłB
	 */
	CdDedJikoku	m_jikokuKitenJikoku ;
	
	/**
		_CO̊̉wԕB

		Ԑݒ̂ȂwԂ́A_COr[ł
		c̕w_COGeBeBYWxP(b)Ŏw肵܂B
	
		l 60 łB
	*/
	int	m_iDiagramDgrYZahyouKyoriDefault ;
	
	/**
	 *	RgB
	 *	CDedCommentDoc,CDedCommentView ŕҏW܂B
	 */
	std::string	m_strComment ;
	
	///@}
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	 *	́wHxɂwwx ( CentDedEki ) ێ܂B
	 *
	 *	̃Rei CentDedEki IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *	Ԃł́Avf 0 ƂȂ܂B
	 */
	CXCentDedEkiCont*	m_pCentDedEkiCont ;
	
	/**
	 *	́wHxɂwԎʁx ( CentDedRessyasyubetsu ) ێ܂B
	 *
	 *	̃Rei CentDedRessyasyubetsu IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *	Ԃł́Avf 1 ƂȂ܂B
	 *	wԎʁx́AȂƂ݂͑ȂĂ͂Ȃ܂B
	 */
	CXCentDedRessyasyubetsuCont*	m_pCentDedRessyasyubetsuCont ;
	
	/**
	 *	́wHxɂw_Cx ( CentDedDia ) ێ܂B
	 *
	 *	̃Rei CentDedDia IuWFNg
	 *	Ej̐Ӗthisɂ܂B
	 *
	 *
	 * @attention
	 *	this ́A CentDedDia::m_strName qƂĈ܂B
	 *	\n ̃Rei CentDedDia ́A CentDedDia::m_strName 
	 *	ӂłȂĂ͂Ȃ܂B
	 *
	 *	Ԃł́Avf 0 ƂȂ܂B
	 */
	CentDedDiaCont	m_CentDedDiaCont ;
	///@}
	
 public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	 *	Ԃł́AԎʂ̗vf 1 ƂȂ܂B
	 *	wԎʁx́AȂƂ݂͑ȂĂ͂Ȃ܂B
	 */
	CentDedRosen() ;
	
	CentDedRosen( const CentDedRosen& value );
	CentDedRosen& operator=( const CentDedRosen& value );

	virtual ~CentDedRosen() ;

	
// ********************************
//	CentDedRosen
// ********************************
 public:
	// ********************************
	///@name CentDedRosen-
	// ********************************
	///@{
	std::string	getName()const{	return m_strName ;};
	CentDedRosen& setName( const std::string& value )
	{	m_strName = value ; return *this ; } ;
	CdDedJikoku	getKitenJikoku()const{	return m_jikokuKitenJikoku ;};
	CentDedRosen& setKitenJikoku( const CdDedJikoku& value )
	{	m_jikokuKitenJikoku = value ; return *this ; } ;
	int	getDiagramDgrYZahyouKyoriDefault()const
	{	return m_iDiagramDgrYZahyouKyoriDefault ;};
	CentDedRosen& setDiagramDgrYZahyouKyoriDefault( int value )
	{	m_iDiagramDgrYZahyouKyoriDefault = value ; return *this ;};
	std::string	getComment()const{return m_strComment ;};
	CentDedRosen& setComment( const std::string& value )
	{	m_strComment = value ;	return *this ; 	} ;
	///@}
	
	// ********************************
	///@name CentDedRosen-
	// ********************************
	///@{
	/**
	 @return 
		wwx ( CentDedEki ) IuWFNg̃Reiւ
		C^[tF[XԂ܂B
		̃C^[tF[X́A CentDedEki IuWFNgH
		ǉE폜邽߂̃C^[tF[XłB
	 @attention
		̃Reiɑ΂āAZqgpĂ͂܂B
		KAReĩ\bhgėvf̒ǉE폜sĂB
		 CentDedEkiCont ̓eCentDedRosen ɃRs[ꍇ́A
		CaMui::insert() gp邱Ƃł܂B
	@code
		CaMui<CentDedEki>	aCaCont( aCentDedRosen().getCentDedEkiCont() ) ; 
		aCaCont.insert( &aCentDedEkiCont ) ;
	@endcode
	*/
	CentDedEkiCont* getCentDedEkiCont(){	return m_pCentDedEkiCont ; } ;
	const CentDedEkiCont* getCentDedEkiCont()const{	return m_pCentDedEkiCont ; } ;

	/**
	 @return 
		wԎʁx ( CentDedRessyasyubetsu ) IuWFNg̃Reiւ
		C^[tF[XԂ܂B
		̃C^[tF[X́A CentDedRessyasyubetsu IuWFNgH
		ǉE폜邽߂̃C^[tF[XłB
	@attention
		̃Reiɑ΂āAZqgpĂ͂܂B
		KAReĩ\bhgėvf̒ǉE폜sĂB
		 CentDedRessyasyubetsuCont ̓eCentDedRosen ɃRs[ꍇ́A
		CaMui::insert() gp邱Ƃł܂B
	@code
			CaMui<CentDedRessyasyubetsu>	aCaCont( pCentDedRosen->getCentDedRessyasyubetsuCont() ) ; 
			aCaCont.insert( &aCentDedRessyasyubetsuCont ) ;
	@endcode
	 */
	CentDedRessyasyubetsuCont* getCentDedRessyasyubetsuCont()
	{
		return m_pCentDedRessyasyubetsuCont ; 
	} ;
	const CentDedRessyasyubetsuCont* getCentDedRessyasyubetsuCont()const
	{
		return m_pCentDedRessyasyubetsuCont ; 
	} ;
	
	/**
		Q́wԎʁxIndexւ܂B
	
		w̗ԎIndexׂĂ̗ԂIndexA
		ւ܂B
		
	 @param iRessyasyubetsuIndexA , iRessyasyubetsuIndexB [in]
		wԎIndexxw肵ĂB
		͈͂́A 0 ȏ Ԏʂ̐łB
		INT_MAX ́A̗Ԏʂw肵̂Ƃ݂Ȃ܂B
		iRessyasyubetsuIndexA  iRessyasyubetsuIndexB ́A
		قȂlłȂĂ͂Ȃ܂B
	 @return 
		 0 ȏAG[Ȃ畉̐łB
		-1 ;	//	ԎIndexsłB
	 */
	int swapRessyasyubetsu( int iRessyasyubetsuIndexA ,
		int iRessyasyubetsuIndexB ) ;
	
	/**
	 @return 
		w_Cx ( CentDedDia ) IuWFNg̃Reiւ
		C^[tF[XԂ܂B
		̃C^[tF[X́A CentDedDia IuWFNgH
		ǉE폜邽߂̃C^[tF[XłB
	@attention
		̃Reiɑ΂āAZqgpĂ͂܂B
		KAReĩ\bhgėvf̒ǉE폜sĂB
		 CentDedRessyasyubetsuCont ̓eCentDedRosen ɃRs[ꍇ́A
		CaMui::insert() gp邱Ƃł܂B
	@code
			CaMui<CentDedDia>	aCaCont( pCentDedRosen->getCentDedDiaCont() ) ; 
			aCaCont.insert( &aCentDedDia ) ;
	@endcode
	 */
	CentDedDiaCont* getCentDedDiaCont(){	return &m_CentDedDiaCont ;};
	const CentDedDiaCont* getCentDedDiaCont()const{	return &m_CentDedDiaCont ;};

	///@}
	
	// ********************************
	///@name CentDedRosen-
	// ********************************
	///@{
	/**
		̘Ht@CɁA̘Ht@Cg܂B
	@param rosenToAdd [in]
		ǉHw肵ĂB
	@param iEkiIndexToInsert [in]
		Ht@CgwIndexw肵ĂB

	(1)@OuDiáAwǉHt@Cxׂ̂ẲwA
	wݕҏWĂHt@Cx́wgxɒǉ܂B

	(1.1)@wݕҏWĂHt@Cx̑gw
	wǉHt@Cx̋N_EwłꍇA
	OuDia͂2w𓯈wƂ݂Ȃ܂B
@	  wǉHt@Cx̏I_ɂĂAlłB

	(2)@OuDiáAwǉHt@Cxׂ̂Ă̗Ԏʂ
	wݕҏWĂHt@Cxɒǉ܂B
@	  AA̗ԎʂwݕҏWĂHt@Cx
	  łɑ݂Ăꍇ́AOuDia̗͂Ԏʂǉ܂B

	(3)@OuDiáAwǉHt@Cxׂ̂Ẵ_C
	wݕҏWĂHt@Cxɒǉ܂B
@	  AÃ_CwݕҏWĂHt@Cx
	  łɑ݂Ăꍇ́AOuDia͂̃_Cǉ܂B

	(4)@OuDiáAwǉHt@Cxׂ̂Ă
	_ĈׂĂ̗ԂAwݕҏWĂHt@Cx́A
	̃_Cɒǉ܂B
	@
	(5)@OuDiáAwǉHt@Cx̃RgA
	wݕҏWĂHt@Cx̃Rg̖ɒǉ܂B
	*/
	void insert( const CentDedRosen& rosenToAdd , int iEkiIndexToInsert ) ;

	/**
		̘ḦꕔwԂ̘H쐬܂B
	@param iEkiIndex [in]
		쐬H̋N_wƂwIndexw肵ĂB
	@param iEkiCount [in]
		쐬H̉ww肵ĂB
	@return
		ꂽHԂ܂B

	(1)@VHt@ĆA
	wݕҏWĂHt@CxA
	w肳ꂽ͈͈ȊỎw폜̂ɂȂ܂B

	(2)@VH^]ԂɊ܂܂ȂԂ́A폜܂B
	*/
	CentDedRosen createSubRosen( 
		int iEkiIndex , int iEkiCount )const ;

	/**
		S_CESԂ́Aw̉wIndex̉wA
		w`EnEIɍ킹ĕύX܂B

		ύXéA CentDedEkiJikoku::adjustByEkijikokukeisiki()
		QƂĂB

	@see CentDedEkiJikoku::adjustByEkijikokukeisiki 

	@param iEkiIndex [in]
		wIndexw肵ĂB
	*/
	void adjustByEkijikokukeisiki( int iEkiIndex ) ;

	/**
	Ht@C𔽓]܂B

	(1)@Ht@C̉w̏̕яtɂ܂B

	(2)@w̃vpeB́Aȉ̕ϊs܂B

	(2.1)w͂̂܂

	(2.2)w`
		- 蒅蒅
		- 蒅蒅

	(2.3)E
		- w̏ύXAN_(wIndex̏)1wVtgB
		- V葤I_(wIndex̍ł傫w)̋E͖ɂB

	(2.4)_COԏ
@	  ̓eƏ̓eւ܂B

	(3)Ht@CɊ܂܂邷ׂĂ̗Ԃ̉w̕яtɂ܂B
	*/
	void invert();


	/**
	 *	ׂĂ̑j܂B
	 */
	void clear() ;
	///@}
};





#endif /*CentDedRosen_h*/
