/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvContentPosToDcdTarget.h
// ****************************************************************
*/
/** @file */
#ifndef  DcDrawa_DcdCd_Pos_CconvContentPosToDcdTarget_h
#define  DcDrawa_DcdCd_Pos_CconvContentPosToDcdTarget_h
#include "DcdCd\Pos\CconvContentPosToTargetXy.h"
#include "DcDraw\CaContentPosToDcdTarget_Dim.h"
#include "DcDraw\IfDcdTarget.h"

// ****************************************************************
//	CconvContentPosToDcdTarget
// ****************************************************************
/**
@brief
  X,Y Wn̊ԂŁAContentPos(RegW)
`Ώۂ IfDcdTarget ̍Wɕϊ@񋟂NXłB
 */
class CconvContentPosToDcdTarget
{
public:
	// ********************************
	//	 NX
	// ********************************
	// ****************************************************************
	//	CaConvX
	// ****************************************************************
	class CaConvX : public CaContentPosToDcdTarget_Dim
	{
	protected:
		// --------------------------------
		///@name I[oCh
		// --------------------------------
		///@{
		/**
		@return 
			IfDcdTarget ̕`̈Ԃ܂B
		*/
		virtual CdDcdZone calcCdDcdZone( IfDcdTarget* pIfDcdTarget ) ;
		///@}

	public:
		// ********************************
		//	RXgN^
		// ********************************
		CaConvX(
			DcdSize sizeDcdMargin );
		// ********************************
		///@name CconvContentPosToTargetDim-֘A
		// ********************************
		///@{
		virtual CconvContentPosToTarget* getCconvContentPosToTarget() ;
		virtual const CconvContentPosToTarget* getCconvContentPosToTarget()const  ;
		///@}
	};
	friend class CaConvX ;
	// ****************************************************************
	//	CaConvY
	// ****************************************************************
	class CaConvY : public CaContentPosToDcdTarget_Dim
	{
	protected:
		// --------------------------------
		///@name I[oCh
		// --------------------------------
		///@{
		/**
		@return 
			IfDcdTarget ̕`̈Ԃ܂B
		*/
		virtual CdDcdZone calcCdDcdZone( IfDcdTarget* pIfDcdTarget ) ;
		///@}

	public:
		// ********************************
		//	RXgN^
		// ********************************
		CaConvY(
			DcdSize sizeDcdMargin );
		// ********************************
		///@name CconvContentPosToTargetDim-֘A
		// ********************************
		///@{
		virtual CconvContentPosToTarget* getCconvContentPosToTarget() ;
		virtual const CconvContentPosToTarget* getCconvContentPosToTarget()const  ;
		///@}
	};
	friend class CaConvY ;
private:
	// ********************************
	///@name W
	// ********************************
	///@{
	/**
		Wϊ CconvContentPosToTarget IuWFNgłB
	 */
	CconvContentPosToTargetXy	m_CconvContentPosToTargetXy ;
	
	/**
		XWϊ CconvContentPosToTarget IuWFNgłB
		̃IuWFNǵAۂɂ 
		m_CconvContentPosToTargetXy.m_convX ւ̃A_v^łB
	*/
	CaConvX	m_convX ;

	/**
		XWϊ CconvContentPosToTarget IuWFNgłB
		̃IuWFNǵAۂɂ 
		m_CconvContentPosToTargetXy.m_convY ւ̃A_v^łB
	*/
	CaConvY	m_convY ;
	///@}
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	///@}
protected:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{
	/**
		m_sizeDcdMarginXRight , m_sizeDcdMarginYBottom 
		Kpꂽ̈Zo܂B
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
		NULL ͎wł܂B
	@return
		Zö̗łB
	*/
	virtual CdDcdZoneXy calcMarginAppliedZone( IfDcdTarget* pIfDcdTarget ) ;
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	/** m_convX,m_convY ̗ɁA[hݒ肵܂ */
	CconvContentPosToDcdTarget( 
		CconvContentPosToTarget::EMode	eMode ,
		DcdSize	sizeDcdMarginXRight = 0 ,
		DcdSize	sizeDcdMarginYBottom = 0 );

	/** m_convX,m_convY  EModePosAndRate Ƃď܂B*/
	CconvContentPosToDcdTarget( 
		DcdPos	iContentPosX ,
		double dTargetPosPerContentX ,
		DcdPos	iContentPosY ,
		double dTargetPosPerContentY ,
		DcdSize	sizeDcdMarginXRight = 0 ,
		DcdSize	sizeDcdMarginYBottom = 0 ) ;

	/**
		m_convX,m_convY  EModeZone Ƃď܂B
	@param zoneContent[in]
		TargetZoneɕ\Reg̎n_Ƒ傫B
	*/
	CconvContentPosToDcdTarget( 
		const CdDcdZoneXy&	zonexyContent ,
		DcdSize	sizeDcdMarginXRight = 0 ,
		DcdSize	sizeDcdMarginYBottom = 0 ) ;

	CconvContentPosToDcdTarget() ;

	virtual ~CconvContentPosToDcdTarget() ;

public:
	// ********************************
	///@name CconvContentPosToDcdTarget-W
	// ********************************
	///@{
	CaConvX* getX()
	{
		return &m_convX ;
	};
	const CaConvX* getX()const
	{
		return &m_convX ;
	};
	CaConvY* getY() 
	{
		return &m_convY ;
	};
	const CaConvY* getY()const 
	{
		return &m_convY ;
	};
	///@}
	
	// ********************************
	///@name CconvContentPosToDcdTarget-
	// ********************************
	///@{
	DcdSize	getDcdMarginXRight()const ;
	void setDcdMarginXRight( DcdSize value ) ;
	DcdSize	getDcdMarginYBottom()const ;
	void setDcdMarginYBottom( DcdSize value ) ;
	///@}
	// ********************************
	///@name CconvContentPosToDcdTarget-
	// ********************************
	///@{
	/**
	@return
		m_convX,m_convY ́A TargetPosւ̕ϊ[hB
	@attention
		m_convX,m_convY ŕϊ[hقȂꍇ́Å֐̖߂l
		`łB
	*/
	virtual CconvContentPosToTarget::EMode	getMode()const ;

	/**
	@param value [in]
		m_convX,m_convY ́A TargetPosւ̕ϊ[hw肵ĂB
	*/
	virtual void setMode( CconvContentPosToTarget::EMode	value ) ;

	/**
	@return 
		TargetPos̍ɕ`悳Content́AContentPosWB
	*/
	virtual CdDcdPosXy getContentPos()const ;

	/**
	@param value [in]
		TargetPos̍ɕ`悳Content́AContentPosWݒB
	*/
	virtual void setContentPos( const CdDcdPosXy& value ) ;

	/**
		TargetZoneɕ\Reg̎n_Ɗg嗦ݒ肷邱Ƃł܂B
	@param posContentPos [in]
		TargetPos̍ɕ`悳Content́AContentPosWB
	@param dTargetPosPerContentX [in]
		X̊g嗦BRegWṔATargetPos ̐B
	@param dTargetPosPerContentY [in]
		Y̊g嗦BRegWṔATargetPos ̐B
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	@note
		l擾Ƃ́A 
		getX() , getY() gpāA
		m_convX,m_convY ̃|C^擾ÃIuWFNg
		l擾ĂB
	*/
	virtual void setContentPosAndRate( 
		const CdDcdPosXy& posContentPos , 
		double dTargetPosPerContentX , 
		double dTargetPosPerContentY , 
		IfDcdTarget* pIfDcdTarget ) ;


	/** 
		TargetZoneɕ\Reg̎n_Ƒ傫擾邱Ƃł܂B
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	@return
		TargetZoneɕ\Reg̈ʒuƑ傫B
	*/
	CdDcdZoneXy getContentZone( IfDcdTarget* pIfDcdTarget ) ;

	/**
		TargetZoneɕ\Reg̎n_Ƒ傫ݒ肷邱Ƃł܂B
	@param zoneContent[in]
		TargetZoneɕ\Reg̎n_Ƒ傫B
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	*/
	virtual void setContentZone( const CdDcdZoneXy& zoneContent , 
		IfDcdTarget* pIfDcdTarget ) ;
	///@}
	// ********************************
	///@name CconvContentPosToDcdTarget-Wϊ
	// ********************************
	///@{
	/**
		ContentPos ̍W
		A
		TargetZone ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	@return
  		ϊ̒lԂ܂B
	 */
	virtual CdDcdPosXy ContentPosToTarget( 
		const CdDcdPosXy& value ,
		IfDcdTarget* pIfDcdTarget ) ;
	
	/**
		TargetZone ̍W
		A
		ContentPos ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	 */
	virtual CdDcdPosXy ContentPosFromTarget( 
		const CdDcdPosXy& value ,
		IfDcdTarget* pIfDcdTarget ) ;

	/**
		ContentPos ̍W
		A
		TargetZone ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	 */
	virtual CdDcdZoneXy ContentZoneToTarget( 
		const CdDcdZoneXy& value ,
		IfDcdTarget* pIfDcdTarget ) ;
	
	/**
		TargetZone ̍W
		A
		ContentPos ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param pIfDcdTarget [in]
		`Ώۂ IfDcdTarget w肵ĂB
	 */
	virtual CdDcdZoneXy ContentZoneFromTarget( 
		const CdDcdZoneXy& value ,
		IfDcdTarget* pIfDcdTarget ) ;
	///@}
};

#endif /*DcDrawa_DcdCd_Pos_CconvContentPosToDcdTarget_h*/
