/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvDcdPosOnZone_DcdZone.h
// ****************************************************************
*/
/** @file */
#ifndef  CconvDcdPosOnZone_DcdZone_h
#define  CconvDcdPosOnZone_DcdZone_h
#include "DcdCd\Pos\CdDcdZone.h"
#include "DcdCd\Pos\CconvDcdPosOnZone.h"
// ****************************************************************
//	CconvDcdPosOnZone_DcdZone
// ****************************************************************
/**
 @brief
	yTvz
	  Q̈ꎟWn̊ԂŁAWϊ܂B
	
	  ̃NX́AWn Zone1 ̍WlA Zone2 ̍Wl
	ϊ邱Ƃł܂B
	
	  Wn Zone1  Zone2 ́A CdDcdZone ^̑ m_Zone1,m_Zone2 Ƃ
	\܂B
	  m_Zone1,m_Zone2 ́Aw͈́x 
	Wn Zone1 E Wn Zone2 ŕ\WlłB
	
	  ij
	
	  WnA
	
	-	m_Zone1 = { Pos=0 , Size=10 }
	-	m_Zone2 = { Pos=0 , Size=20 }
	
	łꍇÁA
	  uWn Zone1 ł͈̔ { Pos=0 , Size=10 } ́A
	Wn Zone2 ł { Pos=0 , Size=20 } ƂȂvƂӖ܂B
	
	  ̏ԂŁA
	
	  Zone1̈ʒu 5  Zone2 ɕϊƁA 10 ƂȂ܂B
	
	  ܂AZone1 ͈̔(CdDcdZone){ Pos= 3 , Size=5 } A
	Zone2 ɕϊƁA{ Pos=6 , Size=10 } ƂȂ܂B
	
 */
class CconvDcdPosOnZone_DcdZone : public CconvDcdPosOnZone
{
 private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		Wn Zone1 ł́Aw͈́x̍WlB
	 */
	CdDcdZone	m_Zone1 ;
	
	/**
		Wn Zone2 ł́Aw͈́x̍WlB
	 */
	CdDcdZone	m_Zone2 ;
	
	///@}
 public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	 @param aZone1 [in]
		Wn Zone1 ł́Aw͈́x̍WlB\n
		Size ɂ́A 0 w肵Ȃłi[ZɂȂ܂jB
	 @param aZone2 [in]
		Wn Zone2 ł́Aw͈́x̍WlB\n
		Size ɂ́A 0 w肵Ȃłi[ZɂȂ܂jB
	 */
	CconvDcdPosOnZone_DcdZone( 
		const CdDcdZone& aZone1 ,
		const CdDcdZone& aZone2 ) ;

	/**
	 ̃RXgN^́A m_Zone1 , m_Zone2 ƂA
		Pos=0 , Size=1 ɏ܂B
	 */
	CconvDcdPosOnZone_DcdZone() ;

	virtual ~CconvDcdPosOnZone_DcdZone() ;

 public:
	// ********************************
	///@name CconvDcdPosOnZone_DcdZone-
	// ********************************
	///@{
	CdDcdZone	getZone1()const ;
	CconvDcdPosOnZone_DcdZone& setZone1( const CdDcdZone& value ) ;
	CdDcdZone	getZone2()const ;
	CconvDcdPosOnZone_DcdZone& setZone2( const CdDcdZone& value ) ;
	///@}
	
	// ********************************
	///@name CconvDcdPosOnZone-
	// ********************************
	///@{
	/**
		Zone1 ̍Wn
		ł̈ʒuA
		Zone2 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_Zone1.getSize()=0̏ꍇ́Am_posZone2Org ɂȂ܂B
	 */
	virtual DcdPos Zone1PosToZone2( DcdPos value )const ;
	
	/**
		Zone2 ̍Wn
		ł̈ʒuA
		Zone1 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_Zone2.getSize()=0̏ꍇ́Am_posZone1Org ɂȂ܂B
	 */
	virtual DcdPos Zone1PosFromZone2( DcdPos value )const ;

	/**
		Zone1 ̍Wn
		ł͈̔͂A
		Zone2 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_Zone1.getSize()=0̏ꍇ́ACdDcdZone(m_posZone1Org,0) ɂȂ܂B
	 */
	virtual CdDcdZone Zone1ToZone2( const CdDcdZone& value )const ;
	
	/**
		Zone2 ̍Wn
		ł͈̔͂A
		Zone1 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_Zone2.getSize()=0̏ꍇ́ACdDcdZone(m_posZone2Org,0) ɂȂ܂B
	 */
	virtual CdDcdZone Zone1FromZone2( const CdDcdZone& value )const ;
	///@}
	
	
};





#endif /*CconvDcdPosOnZone_DcdZone_h*/
