/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CMup_vector.h
// ****************************************************************
*/
/** @file */
#ifndef  Mu_CMup_vector_h
#define  Mu_CMup_vector_h

#include "./CaMup_vector.h"
#include <vector>

// ****************************************************************
//	CMup_vector
// ****************************************************************
/**
 @brief
   STL std::vector Rei܂ReiNXłB
   Mup C^[tF[X񋟂܂B
 
	Rei̗vf̑́A Mup C^[tF[X\bh
	gƂɂł܂B
	܂A ܂Ă std::vector 𒼐ڑ삷邱Ƃł܂B
	igetAdaptee() \bhg܂jB
 
 @see o֐̐́A CaMup_vector B
 <H4>
	yRei̗vf̃CX^Xɂāz
 </H4>
	 ReĩTCYύX郁\bhĂяoꍇA
	ReĩCX^X̍Ċ蓖Ă܂B
  Ċ蓖ĂƁAgetp() Ŏ擾|C^͖ɂȂ܂B


 @param ElementType
	i[f[^̌^w肵ĂB
@param ContType
	i[f[^^ ElementType ێ std::vector 
	std::deque w肵ĂB
*/
template< class ElementType , class ContType = std::vector<ElementType> >
class CMup_vector : public Mup< ElementType >
{
public:

private:	
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	/**
		Ώۂ́ASTL_ANZXReiłB
	
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		Ώۂ́Å֘ALȊԂ͐ȂĂ͂Ȃ܂B
	*/
	ContType	m_Adaptee ;
	
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	
public:
	// ********************************
	///@name	Mu
	// ********************************
	///@{
	/**
	 @return
	 	ReiɊi[Ăvf̌Ԃ܂B
	*/
	virtual int	size()const
	{
		return (int)m_Adaptee.size() ; 
	} ;
	
	/**
	 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 	vfԂ܂B
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	CfNXŎw肳ꂽvfԂ܂B
	
		CfNXsȏꍇ͖̓`łB
	*/
	virtual value_type get( int iIndex )const
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Adaptee.size() - 1 ; 
		}
		if ( !( 0 <= iIndex && iIndex < (int)m_Adaptee.size() ) )
		{
			return *( (value_type*)NULL ) ; 
		}
		return m_Adaptee[iIndex] ;
	} ;
	///@}
	
public:
	// ********************************
	///@name Mui
	// ********************************
	///@{
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vfǉ܂B
	 @param element [in]
	 	vfw肵ĂB
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() ȉłB
	 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	0ȏ͐A̐̓G[ł
		-	-1 ;	//	iIndexs
	*/
	virtual int insert( const value_type& element , int iIndex = INT_MAX ) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Adaptee.size() ; 
		}
		if ( !( 0 <= iIndex && iIndex <= (int)m_Adaptee.size() ) )
		{
			return -1 ;	//	iIndexs
		}
		m_Adaptee.insert( m_Adaptee.begin() + iIndex , element ) ;
		return ( 0 ) ;
	};
	
	/**
	 	ReíACfNXŎw肳ꂽꏊ
	 	vf폜܂B
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @param iSize [in]
	 	폜vf̐w肵ĂB
	 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 @attention
		iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 @return
	 	0ȏ͐A̐̓G[ł
		-	-1 ;	//	iIndexs
	*/
	virtual int erase( int iIndex  , int iSize = 1 ) 
	{
		if ( iIndex == INT_MAX && iSize == INT_MAX )
		{
			return -1 ;	//	iIndexs
		}
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Adaptee.size() - iSize ; 
		}
		if ( iSize == INT_MAX )
		{
			iSize = (int)m_Adaptee.size() - iIndex ; 
		}
		if ( !( 0 <= iIndex && iIndex + iSize <= (int)m_Adaptee.size() ) )
		{
			return -1 ;	//	iIndexs
		}
		// --------------------------------
		m_Adaptee.erase( 
			m_Adaptee.begin() + iIndex , 
			m_Adaptee.begin() + iIndex + iSize ) ;
		return ( 0 ) ;
	}
	
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vf㏑܂B
	 @param element [in]
	 	vfw肵ĂB
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	0ȏ͐A̐̓G[ł
		-	-1 ;	//	iIndexs
	*/
	virtual int set( const value_type& element , int iIndex ) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Adaptee.size() - 1 ; 
		}
		if ( !( 0 <= iIndex && iIndex < (int)m_Adaptee.size() ) )
		{
			return -1 ;	//	iIndexs
		}
		m_Adaptee[iIndex] = element ;
		return ( 0 ) ;
	}
	///@}
public:
	// ********************************
	///@name	Mup
	// ********************************
	///@{
	/**
	 	ReíACfNXŎw肳ꂽꏊɊi[Ăvfւ
	 	 const ȃ|C^擾邱Ƃł܂B
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() ȉłB
	 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		INT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	ReíACfNXŎw肳ꂽꏊɊi[Ăvfւ
	 	 const ȃ|C^Ԃ܂B
	 	iSize ͈͊Ȍꍇ́A NULL Ԃ܂B
	*/
	virtual value_type* getp( int iIndex ) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Adaptee.size() - 1 ; 
		}
		if ( !( 0 <= iIndex && iIndex < (int)m_Adaptee.size() ) )
		{
			return NULL ; 
		}
		return &m_Adaptee[iIndex] ;
	}
	///@}

public:
	// ********************************
	///@name CaMup_vector-֘A
	// ********************************
	///@{
	ContType*	getAdaptee(){	return &m_Adaptee ;};
	const ContType*	getAdaptee()const{	return &m_Adaptee ;};
	
	///@}

};




#endif /*Mu_CMup_vector_h*/
