/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CJikokuhyouView.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "NsOu/OuNew.h"
#include "str/strToInt.h"
#include "DcDraw/CDcdLine.h"
#include "DcDraw/CDcdTargetPrinter.h"
#include "DcDraw/CDcDeviceUnitSizeX.h"
#include "DcDraw/CDcDeviceUnitSizeY.h"
#include "DcDraw/CDcdText.h"
#include "DcDraw/CaDcdTargetItemPosition.h"
#include "DcDraw/CConverter_WinGdi.h"
#include "DcDraw/print/CaDcdTargetZoomDisplay.h"
#include "DcDrawMfc/CDcdTargetMfcPrintInfo.h"
#include "DcdGrid\WndDcdGrid3\WndDcdGrid3.h"
#include "DcdGrid\CaDcdGrid_PageSelector.h"
#include "LogMsg\LogMsg.h"

#include "..\DiagramEdit.h"
#include "..\Print\CconvCdPrintPageProp.h"
#include "CJikokuhyouView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewJikokuhyou{

using namespace std ;
using namespace DcDrawLib::DcDrawMfc;
using namespace DcDrawLib::DcDraw::Print;

/////////////////////////////////////////////////////////////////////////////
// CJikokuhyouView
// --------------------------------
//@name ֐
// --------------------------------
// ********************************
//@name 
// ********************************
int CJikokuhyouView::setFocusToRessyaIndex( int iRessyaIdx  , int iEkiOrder ) 
{
	int iRv = 0 ;

	CdXColSpecCont aXColSpecCont = m_pCWndDcdGrid->createXColSpecCont() ;


	int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec( 
		CdXColSpec( 
			CdXColSpec::ColumnType_Ressya , iRessyaIdx ) ) ;
	if ( iRv >= 0 )
	{
		if ( iXColumnNumber < 0  )
		{
			iRv = -1 ;
		}
	}
	if ( iRv >= 0 )
	{
		CdYColSpecCont aYColSpecCont = m_pCWndDcdGrid->createYColSpecCont() ;

		int iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec(
			CdYColSpec( 
				CdYColSpec::ColumnType_Ekijikoku_Hatsu , 
				iEkiOrder ) , false ) ;
		if ( iYColumnNumber < 0 )
		{
			iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec(
				CdYColSpec( 
					CdYColSpec::ColumnType_Ekijikoku_Chaku , 
					iEkiOrder ) , false ) ;
		}
		if ( iYColumnNumber < 0 )
		{
			iYColumnNumber = m_pCWndDcdGrid->getCXDcdGrid()->getYColumnNumberOfCell( 
				m_pCWndDcdGrid->getCFocus()->getFocusCell() )  ;
		}

		CDcdGridCell* pCell = m_pCWndDcdGrid->getCXDcdGrid()->getCell( 
			iXColumnNumber , iYColumnNumber ) ;
		if ( pCell != NULL )
		{
			m_pCWndDcdGrid->getCFocus()->setFocusCell( pCell )  ;
		}
	}
	return ( iRv ) ;
}

// ----------------------------------------------------------------

IMPLEMENT_DYNCREATE(CJikokuhyouView, CView)

CJikokuhyouView::CJikokuhyouView()
	: m_pCWndDcdGrid( NULL ) 
{
}

CJikokuhyouView::~CJikokuhyouView()
{
}


BEGIN_MESSAGE_MAP(CJikokuhyouView, CView)
	//{{AFX_MSG_MAP(CJikokuhyouView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJikokuhyouView `

void CJikokuhyouView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CJikokuhyouView ff

#ifdef _DEBUG
void CJikokuhyouView::AssertValid() const
{
	CView::AssertValid();
}

void CJikokuhyouView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJikokuhyouView bZ[W nh

int CJikokuhyouView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_pCWndDcdGrid = new CWndJikokuhyou() ;
	m_pCWndDcdGrid->Create( this ) ;
	m_pCWndDcdGrid->ShowWindow( SW_SHOW ) ;
	
	return 0;
}

void CJikokuhyouView::OnDestroy() 
{
	//	_COr[̑ .ini t@Cɏ݁B
	getCDiagramEditApp()->writeCWndJikokuhyouViewProp( m_pCWndDcdGrid ) ;
	if ( m_pCWndDcdGrid != NULL )
	{
		m_pCWndDcdGrid->DestroyWindow() ;
		delete m_pCWndDcdGrid ;
		m_pCWndDcdGrid = NULL ;	
	}
	CView::OnDestroy();
}

void CJikokuhyouView::OnSize(UINT nType, int cx, int cy) 
{
	if ( nType == SIZE_MAXIMIZED   //EBhE͍ő\܂B
		|| nType == SIZE_RESTORED  // EBhE̓TCYύX܂ASIZE_MINIMIZED  SIZE_MAXIMIZED ͓Kp܂B
	){
		m_pCWndDcdGrid->MoveWindow( 0 , 0 , cx , cy , TRUE ) ;
		return ;
	}
	
	CView::OnSize(nType, cx, cy);
	
}

void CJikokuhyouView::OnSetFocus(CWnd* pOldWnd) 
{
	//CView::OnSetFocus(pOldWnd);
	CWnd*	pControl = GetNextDlgTabItem( (CWnd*)NULL , FALSE ) ;
	pControl->SetFocus() ;
	
}

void CJikokuhyouView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if ( lHint == LHINT_SUBVIEW_TO_ROOTDOC ){
		return ;
	}
	// --------------------------------
	m_pCWndDcdGrid->OnUpdate( pSender, lHint, pHint) ;
}


BOOL CJikokuhyouView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	//	R}hnh́A\Ȃ CWndDcdGrid ɈϏ܂B
	if ( m_pCWndDcdGrid != NULL && 
		m_pCWndDcdGrid->OnCmdMsg( nID, nCode, pExtra, pHandlerInfo) )
	{
		return ( TRUE ) ;
	} 

	
	return CView::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CJikokuhyouView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
}

BOOL CJikokuhyouView::OnPreparePrinting(CPrintInfo* pInfo) 
{
	// ftHg̈
	return DoPreparePrinting( pInfo ) ;
	//return CView::OnPreparePrinting(pInfo);
}

void CJikokuhyouView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	//	̎_ł́A 
	//	pInfo->m_rectDraw
	//	̒l͌肵Ă܂B

	//	ԂAԕҏW[hɕύX
	m_pCWndDcdGrid->getStateMachine()->setCurrentStateIdx( 
		m_pCWndDcdGrid->StateIdx_Ressyahensyu ) ;


	//	̃r[ANeBuɂāAXV
	getCDiagramEditApp()->getCMainFrame()->MDIActivate( GetParent() ) ;
	m_pCWndDcdGrid->OnUpdate( NULL , 0 , NULL ) ;
	

	CView::OnBeginPrinting(pDC, pInfo);
}

void CJikokuhyouView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	//	̎_ł́A 
	//	pInfo->m_rectDraw
	//	̒l͌肵Ă܂B

	if ( pInfo != NULL ){
		//	Ɋւ鏈
		LogMsg( "CJikokuhyouView::OnPrepareDC() " ) ;
		LogMsg( CDcdTargetMfcPrintInfo::stringOf( pInfo ).c_str() ) ;

		//	y[Ẅsꍇ́A
		//CView::OnPrepareDC(pDC, pInfo);
		//	ĂяoĂ͂܂B
	}	else	{
		CView::OnPrepareDC(pDC, pInfo);
	}
}

/**
@return
	\r[̈́ALvV
	(㕔̃^CgẼy[Wԍ)̂߂
	tHgԂ܂B
*/
static CdDrawTextProp	getCdDrawTextPropStandard()
{ 
	const CDedRosenFileData* pCDedRosenFileData = 
		getCDiagramEditDoc()->getCDedRosenFileData() ;
	CdDedDispProp aCdDedDispProp = pCDedRosenFileData->getCdDedDispProp() ;

	return CdDrawTextProp( 
		aCdDedDispProp.getJikokuhyouFont(0) ,
		CdColorProp( 0 , 0 , 0 ) ) ;
}

void CJikokuhyouView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	LogMsg( "CJikokuhyouView::OnPrint() " ) ;
	LogMsg( CDcdTargetMfcPrintInfo::stringOf( pInfo ).c_str() ) ;

	// --------------------------------
	//	`ʂ쐬
	// --------------------------------
	CDcdTargetMfcPrintInfo	aCDcdTargetMfcPrintInfo( pDC, pInfo ) ;

	LogMsg( "CJikokuhyouView::OnPrint()1" ) ;
	// --------------------------------
	//	]̈쐬
	// --------------------------------
	CaDcdTargetItemPosition	aTargetInnerMargin( &aCDcdTargetMfcPrintInfo , 
		CdDcdZoneXy() ) ;
	{
		LogMsg( DeviceCapsToString( 
			aCDcdTargetMfcPrintInfo.getPrinterHdc() ).c_str() ) ;
	
		CconvCdPrintPageProp aCconvCdPrintPageProp ;
		CdDcdZoneXy	zonexyInneraMargin = 
			aCconvCdPrintPageProp.calcZoneInnerMargin( 
				getCDiagramEditApp()->getCdPrintPageProp() , 
				aCDcdTargetMfcPrintInfo.getPrinterHdc() ) ;
		if ( zonexyInneraMargin.getX().getSize() <= 0 ){
			zonexyInneraMargin.setX( 
				aCDcdTargetMfcPrintInfo.getZone().getX() ) ;
		}
		if ( zonexyInneraMargin.getY().getSize() <= 0 ){
			zonexyInneraMargin.setY( 
				aCDcdTargetMfcPrintInfo.getZone().getY() ) ;
		}

		aTargetInnerMargin.setZone( zonexyInneraMargin ) ;

	}

	//aTargetInnerMargin = ]`̈B
	//	Pʂ̓v^̃sNZłB

	LogMsg( "CJikokuhyouView::OnPrint()2" ) ;
	// --------------------------------
	//	_Wݒ
	// --------------------------------
	CaDcdTargetZoomDisplay	aCaDcdTargetZoomDisplay( 
		&aTargetInnerMargin , 
		aCDcdTargetMfcPrintInfo.getPrinterHdc() ) ;
	//aCaDcdTargetZoomDisplay = ]`̈B
	//	Pʂ́Aʏ̂PsNZɂȂ܂B

	LogMsg( "CJikokuhyouView::OnPrint()3" ) ;
	// --------------------------------
	//	LvVƃy[Wԍ̕i쐬
	// --------------------------------
	Ou<CDcdText>	pdcdCaption ;
	Ou<CDcdText>	pdcdPage ;
	{
		const CentDedRosen* pCentDedRosen = 
			getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
		CJikokuhyouDoc* pCJikokuhyouDoc = (CJikokuhyouDoc*)GetDocument() ;

		string	strText ;
		//	H
		if ( !pCentDedRosen->getName().empty() ){
			strText += pCentDedRosen->getName() ;
			strText += " " ;
		}
		//	_C
		if ( !pCJikokuhyouDoc->getDiaName().empty() ){
			strText += pCJikokuhyouDoc->getDiaName() ;
			strText += " " ;
		}
		//	
		{
			CString	strHoukou ;
			if ( pCJikokuhyouDoc->getRessyahoukou() == Ressyahoukou_Kudari ){
				strHoukou.LoadString( IDS_WORD_Kudari ) ;
			}	else	{
				strHoukou.LoadString( IDS_WORD_Nobori ) ;
			}
			strText += (LPCTSTR)strHoukou ;
			strText += " " ;
		}

		pdcdCaption = OuNew<CDcdText>( new CDcdText( 
			strText , getCdDrawTextPropStandard() ) ) ;
	}
	// --------------------------------
	{
		CdDrawTextProp	aProp = getCdDrawTextPropStandard() ;
		CdDrawTextFormat	aFormat = aProp.getCdDrawTextFormat() ;
		aFormat.setHorizontal( aFormat.H_CENTER ) ;
		aProp.setCdDrawTextFormat( aFormat ) ;
		pdcdPage = OuNew<CDcdText>( new CDcdText( "" ,aProp , "99" ) ) ;
	}

	LogMsg( "CJikokuhyouView::OnPrint()4" ) ;
	// --------------------------------
	//	LvVƃy[Wԍ̕iE
	//	Obh̃CAEg߂	
	// --------------------------------
	Ou<IfDcdTarget>	pTargetCaption ;
	Ou<IfDcdTarget>	pTargetGrid ;
	Ou<IfDcdTarget>	pTargetPage ;
	{
		CdDcdZoneXy	zoneGrid = aCaDcdTargetZoomDisplay.getZone() ;
		CdDcdSizeXy	aSize ;

		pdcdCaption->getItemSize( &aCaDcdTargetZoomDisplay , &aSize ) ;
		CdDcdZoneXy zoneCaption( zoneGrid.getX() , 
			CdDcdZone( zoneGrid.getY().getPos() , aSize.getY() ) ) ;
		zoneGrid.setY( CdDcdZone().setBeginEndPos( 
			zoneCaption.getY().getEndPos() , zoneGrid.getY().getEndPos() ) ) ;
		//zoneCaption = S̈̏㕔ALvVpɊ蓖ĂĂ܂B
		//zoneGrid = S̈悩A㕔̃LvV̈̈łB

		pdcdPage->getItemSize( &aCaDcdTargetZoomDisplay , &aSize ) ;
		CdDcdZoneXy zonePage( zoneGrid.getX() , 
			CdDcdZone( zoneGrid.getY().getEndPos() - aSize.getY() , aSize.getY() ) ) ;
		zoneGrid.setY( CdDcdZone().setBeginEndPos( 
			zoneCaption.getY().getEndPos() , zonePage.getY().getPos() ) ) ;
		//zonePage = S̈̉Ay[WpɊ蓖ĂĂ܂B
		//zoneGrid = 㕔̃LvVɑāÃy[Ẅ̈łB


		pTargetCaption = OuNew<CaDcdTargetItemPosition>( 
			new CaDcdTargetItemPosition( &aCaDcdTargetZoomDisplay , zoneCaption ) ) ;
		pTargetGrid = OuNew<CaDcdTargetItemPosition>( 
			new CaDcdTargetItemPosition( &aCaDcdTargetZoomDisplay , zoneGrid ) ) ;
		pTargetPage = OuNew<CaDcdTargetItemPosition>(
			new CaDcdTargetItemPosition( &aCaDcdTargetZoomDisplay , zonePage ) ) ;
	}


	LogMsg( "CJikokuhyouView::OnPrint()5" ) ;
	// --------------------------------
	//	Obh`
	// --------------------------------
	int iPage = 0 ;
	int iXPage = 0 ;
	{
		//	ɂ́AXN[o[삵Ȃ悤ɂ܂B
		//	XN[ƍĕ`}~܂B
		CPropStack	aPropStack( m_pCWndDcdGrid ) ;
		aPropStack.CDcdGrid_setUpdateCWndDcdGrid( false )
			.CFocus_setFixafterColumnNumberChange( false );
			

		CDcdGrid*	pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;
		CaDcdGrid_PageSelector	aCaDcdGrid_PageSelector( pCDcdGrid , pTargetGrid ) ;

		if ( (int)pInfo->m_nCurPage > aCaDcdGrid_PageSelector.getPageCount() ){
			//	y[Wԍ傫܂B
			//	̏ꍇ́A͒f܂B	
			pInfo->m_bContinuePrinting = false ;
			return ;
		}
			
		aCaDcdGrid_PageSelector.setPage( pInfo->m_nCurPage - 1 ) ;
		aCaDcdGrid_PageSelector.DcDraw() ;


		//OnPrint()  
		//pInfo->SetMaxPage( aCaDcdGrid_PageSelector.getPageCount() ) ;
		//	Ăʂ͂܂B
		//	([v́AOnBeginPrinting() I_
		//	lƂɍs邩ł)
		pInfo->SetMinPage( 1 ) ;
		pInfo->SetMaxPage( aCaDcdGrid_PageSelector.getPageCount() ) ;

		if ( (int)pInfo->m_nCurPage >= aCaDcdGrid_PageSelector.getPageCount() ){
			//ŏIy[WA[vI܂B
			//OnPrint()  
			//pInfo->SetMaxPage( aCaDcdGrid_PageSelector.getPageCount() ) ;
			//	Ăʂ͂܂B

			pInfo->m_bContinuePrinting = false ;
		}	else	{
			pInfo->m_bContinuePrinting = true ;
		}


		iPage = aCaDcdGrid_PageSelector.getPage() ;
		iXPage = aCaDcdGrid_PageSelector.getXPage() ;
	}

	LogMsg( "CJikokuhyouView::OnPrint()6" ) ;
	// --------------------------------
	//	LvVƃy[Wԍ̃eLXg쐬
	// --------------------------------
	{
		//LvVɃy[Wǉ
		{
			string	strCaption = pdcdCaption->getText() ;
			CString	strSono ;
			strSono.Format( IDS_WORD_Sono , iXPage + 1 ) ;
			strCaption += (LPCTSTR)strSono ;
			strCaption += " " ;
			pdcdCaption->setText( strCaption ) ;
		}
		//y[Wԍ
		{
			string	strPage = stringOf( iPage + 1) ;
			pdcdPage->setText( strPage ) ;
		}
	}

	LogMsg( "CJikokuhyouView::OnPrint()7" ) ;
	// --------------------------------
	//	LvVƃy[Wԍ`
	// --------------------------------
	{
			pdcdCaption->DcDraw( pTargetCaption ) ;
			pdcdPage->DcDraw( pTargetPage ) ;
	}
	// --------------------------------
	//CView::OnPrint(pDC, pInfo);
}

void CJikokuhyouView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	//	Iɉʕ\B
	//
	//	̃NX́A̓Obh̃XN[ʒu
	//	ꎞIɕύX܂B
	//	̂Ƃ m_pCWndDcdGrid ɍĕ`悪ƁA
	//	ʂɂ͈ꎞIɈʒu̕ύXꂽObh
	//	`悳邽߁Aʂ܂B
	m_pCWndDcdGrid->InvalidateGrid() ;

	// --------------------------------
	CView::OnEndPrinting(pDC, pInfo);
}


void CJikokuhyouView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	if ( m_pCWndDcdGrid != NULL )
	{
		m_pCWndDcdGrid->OnActivateView( bActivate, pActivateView, pDeactiveView ) ;
	}
	//CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}
} //namespace ViewJikokuhyou
