/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CWjkStateMachine.h
// ****************************************************************
*/
/** @file */
#ifndef  ViewJikokuhyou_CWjkStateMachine_h
#define  ViewJikokuhyou_CWjkStateMachine_h

#include "NsOu\Ou.h"
#include "NsMu\CMup_vector.h"
#include "NsMu\CaMuCast.h"

#include "ViewJikokuhyou\WndJikokuhyou\CWjkState.h"

namespace ViewJikokuhyou{ namespace WndJikokuhyou{

// ****************************************************************
//	CWjkStateMachine
// ****************************************************************
/**
@brief
  CWndJikokuhyou ̏ԋ@B\NXłB

@̃NX́AԂ\ CWjkState IuWFNg
 ReiƂē܂B

  ܂ÃNX̓JgԂێ܂BԑJڎ
Eޏꓮ̌Ăяos܂B

  
ygz

(1)  add() ŁACWndJikokuhyou IuWFNgǉĂB

(2)  setCurrentStateIdx() ŁÃJgԂw肵ĂB

(3)  getCurrentState() ŁAJgԂ CWjkState IuWFNgւ̃|C^擾邱Ƃł܂B
  ̃|C^ɑ΂ă\bhĂяoƂɂAԑJڂɉs킹邱Ƃł܂B

(4)  setCurrentStateIdx() ŁAԑJڐw肷邱ƂɂAJgԂJڂ邱Ƃł܂B

*/
class CWjkStateMachine 
{
private:
	// ********************************
	///@name	
	// ********************************
	///@{
	/**
		wJgԁx\܂B
	
		wJgԁx́A m_CStateCont ReĩCfNXŎ܂B
		-1 ́Aǂ̏ԂɂĂȂԂłB
	 */
	int m_iCurrentStateIdx ;
	///@}
	// ********************************
	///@name	W
	// ********************************
	///@{
	/**
		wԁxIuWFNgւ̃|C^ێReiłB
	
		add() ŃIuWFNgǉ邱Ƃł܂B
	 */
	CMup_vector< Ou< CWjkState > >	m_CStateCont ;

	/**
		m_CStateCont ̃A_v^łB
	
		Mu C^[tF[X񋟂܂B
	 */
	CaMuCast< CWjkState* , Ou< CWjkState > >
		m_CStateContGet ;
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	CWjkStateMachine() ;

	// ********************************
	///@name	CWjkStateMachine-
	// ********************************
	///@{
	int getCurrentStateIdx() ;

	/**
		wJgԁxύX܂B
	
		̊֐́Aȉ̏ŏs܂B
	
		-# VwJgԁx CWjkState IuWF
		Ngɑ΂āA CWjkState::canEnter() 
		ĂяoāA\ۂ𒲂ׂB
			s\ȂA㑱͍̏sȂB
		-# ܂ł́wJgԁx CWjkState 
		IuWFNgɑ΂āA CWjkState::onExit() 
		ĂяoāAޏꓮs킹B
		-# JgԂ m_iCurrentStateIdx XVB
		-# VwJgԁx CWjkState 
		IuWFNgɑ΂āACWjkState::onEnter() 
		ĂяoāAꓮs킹B
	
		 value  m_iCurrentStateIdx ꍇłA
		CWjkState::onExit() , 
		CWjkState::onEnter() ̌Ăяo͍s܂B
		
	@param value [in]
		́wJgԁxw肵ĂB
		wJgԁx́A m_CStateCont ReĩCfNXŎ܂B
	@return
		ԑJڂ 0 ȏAJڂłȂΕ̐łB
		Jڐ̏Ԃ canEnter() ̐Ԃꍇ́A
		̐ԂāAԑJڂ͎s܂B
	*/
	int setCurrentStateIdx( int value ) ;
	///@}

	// ********************************
	///@name	CWjkStateMachine-W 
	// ********************************
	///@{
	Mu< CWjkState* >*	getCStateContGet()
	{	return &m_CStateContGet ;};
	///@}

	// ********************************
	///@name	CWjkStateMachine- 
	// ********************************
	///@{
	/**
		Ԃǉ܂B
	*/
	void add( Ou< CWjkState > pState ) ;
	
	/**
	@return 
		JgԂ̃IuWFNgԂ܂B
		 m_iCurrentStateIdx == -1 ̏ꍇ NULL Ԃ܂B

		̊֐̖߂ĺA getCStateContGet( getCurrentStateIdx() ) 
		ƓłB
	*/
	CWjkState* getCurrentState() ;


	///@}
};

} } // namespace WndJikokuhyou namespace ViewJikokuhyou

#endif //ViewJikokuhyou_CWjkStateMachine_h
