/*
	OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CWndJikokuhyou.cpp
//	$Id: CWndJikokuhyou.cpp 295 2016-06-11 05:14:13Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"

#include "NsOu\OuNew.h"
#include "NsOu\dynamic_castOu.h"
#include "str\CsvDocument\CConvCsvDocument.h"
#include "str\vectorToFile.h"
#include "logmsg\LogMsg.h"

#include "DcDraw\CDcdTargetGetDC.h"
#include "DcDraw\CDcdLine.h"
#include "DcDraw\CDcdFillrectRop.h"
#include "DcDraw\CDcdTextbox.h"
#include "DcDraw\CConverter_WinGdi.h"

#include "MfcUtil\MfcUtil.h"

#include "..\JikokuhyouColSpec\JikokuhyouColSpec.h"
#include "..\..\DedRosenFileData\EditCmd\CRfEditCmd_Rosen.h"
#include "..\..\resource.h"
#include "..\..\entDed\CentDedRosen.h"
#include "..\..\DiagramEdit.h"
#include "..\..\ViewJikokuhyou\CDlgJikokuhyouViewProp.h"
#include "..\..\ViewDiagram\CDedDiagramView.h"
#include "..\CDlgOuJikokuhyouCsvExport.h"
#include "CCellBuilder.h"
#include "CWndJikokuhyou.h"
#include "CWjkState_Ressyahensyu.h"
#include "CWjkState_Renzoku.h"
#include "CWndJikokuhyou.h"

#include <algorithm>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewJikokuhyou{ namespace WndJikokuhyou{
using namespace std ;
using namespace OuMfc::MfcUtil ;
using namespace OuLib::Str;
// ****************************************************************
//	CWndJikokuhyou
// ****************************************************************
// --------------------------------
//@name ֐
// --------------------------------
CJikokuhyouDoc*	CWndJikokuhyou::GetDocument() 
{
	CView* pCView = (CView*)GetParent() ;
	return (CJikokuhyouDoc*)pCView->GetDocument() ;
};

ERessyahoukou CWndJikokuhyou::getRessyahoukou() 
{
	return GetDocument()->getRessyahoukou() ;
};


const CentDedDia*	CWndJikokuhyou::getCentDedDia()
{
	const CentDedRosen*	pCentDedRosen = 
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
	int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName( 
			GetDocument()->getDiaName() ) ;
	if ( iDiaIndex < 0 ){
		return ( NULL ) ;
	}
	const CentDedDia* pCentDedDia = pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( iDiaIndex ) ;
	return ( pCentDedDia ) ;
};

const CentDedRessyaCont*	CWndJikokuhyou::getCentDedRessyaCont()
{
	const CentDedDia* pCentDedDia = getCentDedDia() ;
	if ( pCentDedDia == NULL ){
		return ( NULL ) ;
	}
	return ( pCentDedDia->getCentDedRessyaCont( getRessyahoukou() ) ) ;
};	


	// --------------------------------
	//@name updateUI...() EZ̍XV
	// --------------------------------

void  CWndJikokuhyou::updateUIAll() 
{
	//	̕ϐ true ̂Ƃ́A
	//	ur[ANeBuȏԂł updateUIAll() v
	//	܂ŁAXV͍s܂B
	if ( m_bUpdate_All_Requested )
	{
		return ;
	}
	// --------------------------------

	//	SXV
	CView *pView = getCDiagramEditApp()->getCMainFrame()->
		getMDIChildActiveView() ;
	if ( pView != GetParent() )
	{
		//	SXVKvƂꍇŁA
		//	̃r[ANeBułȂꍇ
		//	SXVۗ܂B
		LogMsg( "CWndJikokuhyou::OnUpdate_All() " 
			"m_bUpdate_All_Requested=true" ) ;
		m_bUpdate_All_Requested = true ;
	}
	else
	{
		//	SXVKvƂꍇŁA
		//	̃r[ANeBȕꍇ́A
		//	SXVs܂B
		CWaitCursor	aCWaitCursor ;


		// --------------------------------
		//	ZXV
		// --------------------------------
		//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
		//	ZI@\ꎞIɒ~܂B
		{
			clearSelect() ;
			CPropStack aPropStack( this ) ;
			aPropStack
				.CBoxSelect_setIsEnable( false )
				.CRandomSelect_setIsEnable( false )  ;
		}


		//	ZXV
		ViewJikokuhyou::WndJikokuhyou::CCellBuilder	aCellBuilder(
			getCDiagramEditDoc()->getCDedRosenFileData() ,
			getCentDedRessyaCont() , 
			m_bDisplayTsuukaEkiJikoku ,
			m_bDisplayAllEkiJikoku ,
			m_bDisplaySecondEkiJikoku ,
			m_bStandardOperationTimeFunction );
		aCellBuilder.update( 
			this ) ;

		InvalidateGrid() ;

		m_bUpdate_All_Requested = false ;
	}
}
void CWndJikokuhyou::updateUISetAllRessya() 
{
	//	̕ϐ true ̂Ƃ́A
	//	ur[ANeBuȏԂł OnUpdate_All() v
	//	܂ŁAXV͍s܂B
	if ( m_bUpdate_All_Requested )
	{
		return ;
	}
	// --------------------------------
	//	ZXV
	// --------------------------------
	{
		//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
		//	ZIAZI@\ꎞIɒ~܂B
		{
			clearSelect() ;
			CPropStack aPropStack( this ) ;
			aPropStack
				.CBoxSelect_setIsEnable( false )
				.CRandomSelect_setIsEnable( false )  ;
		}

		//	ZXV
		ViewJikokuhyou::WndJikokuhyou::CCellBuilder	aCellBuilder(
			getCDiagramEditDoc()->getCDedRosenFileData() ,
			getCentDedRessyaCont() , 
			m_bDisplayTsuukaEkiJikoku ,
			m_bDisplayAllEkiJikoku ,
			m_bDisplaySecondEkiJikoku ,
			m_bStandardOperationTimeFunction );
		aCellBuilder.updateAllRessya(
			this ) ;
	}
}

void CWndJikokuhyou::updateUI_ReplaceRessya( 
		int iDstRessyaIndex , 
		int iDstDelCount , 
		int iInsertCount ) 

{
	//	̕ϐ true ̂Ƃ́A
	//	ur[ANeBuȏԂł OnUpdate_All() v
	//	܂ŁAXV͍s܂B
	if ( m_bUpdate_All_Requested )
	{
		return ;
	}
	// --------------------------------
	//	ZXV
	// --------------------------------
	{
		//	̑𔺂R}hsꍇ́A
		//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
		//	ZIAZI@\ꎞIɒ~܂B
		if ( iDstDelCount != iInsertCount )
		{
			clearSelect() ;
			CPropStack aPropStack( this ) ;
			aPropStack
				.CBoxSelect_setIsEnable( false )
				.CRandomSelect_setIsEnable( false )  ;
		}

		//	ZXV
		ViewJikokuhyou::WndJikokuhyou::CCellBuilder	aCellBuilder(
			getCDiagramEditDoc()->getCDedRosenFileData() ,
			getCentDedRessyaCont() , 
			m_bDisplayTsuukaEkiJikoku ,
			m_bDisplayAllEkiJikoku ,
			m_bDisplaySecondEkiJikoku ,
			m_bStandardOperationTimeFunction );
		aCellBuilder.replaceRessya(
			iDstRessyaIndex , 
			iDstDelCount , 
			iInsertCount , 
			this ) ;
	}
}



	// --------------------------------
	//@name CWndJikokuhyou-MFCR}hnh֐
	// --------------------------------
int CWndJikokuhyou::OnFileExportJikokuhyoucsv_Process( 
	BOOL bQueryEnable )  
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************

	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		CJikokuhyouDoc* pCJikokuhyouDoc = (CJikokuhyouDoc*)GetDocument() ;

		const CDedRosenFileData* pCDedRosenFileData = 
			getCDiagramEditDoc()->getCDedRosenFileData() ;

		CDlgOuJikokuhyouCsvExport	aDlg( 
			pCDedRosenFileData->getCentDedRosen() , 
			pCJikokuhyouDoc->getDiaIndex() , 
			pCJikokuhyouDoc->getRessyahoukou() , 
			this ) ;
		aDlg.DoModal() ;
	
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

int CWndJikokuhyou::OnFileImportJikokuhyoucsv_Process( BOOL bQueryEnable ) 
{
	int iRv = 0 ;
	CString	strError ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	const Mu<const CentDedRessya*>* pCentDedRessyaCont 
		= getCentDedRessyaCont()->getMuPtr() ;
	CDcdGridCell*	pCDcdGridCell = NULL ;
	if ( iRv >= 0 ){
		 pCDcdGridCell = getCFocus()->getFocusCell() ;
		if ( pCDcdGridCell == NULL ){
			iRv = -1  ;	//	Z̏ꏊs
		}
	}
	//pCDcdGridCell = ҏW̃Z
	int iRessyaIdx = -1 ;
	if ( iRv >= 0 ){
		iRessyaIdx = getXColSpecOfFocus().getRessyaIndex() ;
		if ( !( 0 <= iRessyaIdx && iRessyaIdx < pCentDedRessyaCont->size() ) ){
			//	Z̈ʒuA̗Ԃ̓̎̏ꏊł͂Ȃ
			//	G[ɂ͂܂B
			iRessyaIdx = pCentDedRessyaCont->size() ;
		}
	}
	//iRessyaIdx = Index
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		CentDedRosen aCentDedRosen = *getCDiagramEditDoc()
			->getCDedRosenFileData()->getCentDedRosen() ;

		// --------------------------------
		//	̓t@C͒l̎擾
		// --------------------------------
		CString strCsvFilename ;
		if ( iRv >= 0 )
		{
			CFileDialog aDlg( 
				TRUE , 
				_T( "csv" ) , 
				NULL , 
				OFN_HIDEREADONLY , 
				getCDiagramEditApp()->getCFileDialogFilterCsv(), 
				this );
			if ( aDlg.DoModal() != IDOK )
			{
				iRv = -2 ;	//	Cancel܂B
			}
			else
			{
				strCsvFilename = aDlg.GetPathName() ;
			}
		}
		//strCsvFilename = w肳ꂽCSVt@C
		// --------------------------------
		//	CSVt@C̓ǂݏo
		// --------------------------------
		CWaitCursor aCursor ;
		CdCsvDocument aCdCsvDocument ;
		if ( iRv >= 0 )
		{
			string strCsvDocument ;
			int iResult = stringFromFile( 
				&strCsvDocument , 
				(LPCSTR)strCsvFilename ) ; 
			if ( iResult < 0 )
			{
				strError.Format( IDS_ERR_FILENOTFOUND , 
					(LPCTSTR)strCsvFilename ) ;
				iRv = -11 ;	//	t@C܂B
			}
			else
			{
				CConvCsvDocument	aConv ;
				int iResult = aConv.decode( &aCdCsvDocument , strCsvDocument ) ;
				if ( iResult < 0 )
				{
					strError.Format( IDS_ERR_FILEFORMAT , 
						(LPCTSTR)strCsvFilename ) ;
					iRv = -12 ;	//	CSV̉߂Ɏs܂B
				}
			}

		}

		if ( iRv >= 0 )
		{
			int iDiaIndex = GetDocument()->getDiaIndex() ;
			ERessyahoukou eRessyahoukou = GetDocument()->getRessyahoukou() ;
			string strErrorInfoString ;		
			CconvJikokuhyouCsv	aConv( 
				getCDiagramEditApp()->createCconvJikokuhyouCsv() ) ;
			int iResult = aConv.decode(
				&aCentDedRosen ,
				iDiaIndex , 
				eRessyahoukou , 
				iRessyaIdx , 
				aCdCsvDocument , 
				&strErrorInfoString ) ;
			//iResult = 
			//	-1 ; // sȂ܂B
			//	-2 ; // 񂪏Ȃ܂B
			//	-3 ; // t@C`Fł܂
			//	-4 ; // t@C`Fł܂
			//	-11 ; // w܂B
			//	-21 ; // iDiaIndex słB
			//	-22 ; // iRessyaIndex słB 
			if ( iResult < 0 )
			{
				strError.Format( IDS_ERR_FILEFORMAT , 
					(LPCTSTR)strCsvFilename , iResult ) ;
				strError += _T( "\n" ) ;
				strError += _T( "(" ) ;
				strError += strErrorInfoString.c_str()  ;
				strError += _T( ")" ) ;
				iRv = iResult - 100 ;
				//	-101 ; // sȂ܂B
				//	-102 ; // 񂪏Ȃ܂B
				//	-103 ; // t@C`Fł܂
				//	-104 ; // t@C`Fł܂
				//	-111 ; // w܂B
				//	-121 ; // iDiaIndex słB
				//	-122 ; // iRessyaIndex słB 
			}
		}
		//	ҏWR}hs
		if ( iRv >= 0 )
		{
			Ou<CRfEditCmd> pCmd 
				= OuNew<CRfEditCmd_Rosen>( 
					new CRfEditCmd_Rosen( aCentDedRosen ) );
			getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
		}	
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************
		if ( iRv < 0 )
		{
			if ( !strError.IsEmpty() )
			{
				MessageBox( strError , NULL , MB_ICONSTOP ) ;
			}
		}
		// ****************************************************************
	}
	return iRv ;
}

int CWndJikokuhyou::OnJikokuhyouViewProp_Process( BOOL bQueryEnable ) 
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************

	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		CDlgJikokuhyouViewProp aDlg( 
			m_jikanPasteIdouryou , 
			m_eEkijikokuSort ,
			this ) ;
		if ( aDlg.DoModal() == IDOK )
		{
			m_jikanPasteIdouryou = aDlg.getPasteIdouryou() ;
			m_jikanPasteIdouryouPrevValue = 0 ;
			m_eEkijikokuSort = aDlg.getEkijikokuSort() ;

			//	EkijikokuSort ̐ݒA
			//	.ini t@Cɕۑ
			getCDiagramEditApp()->writeCWndJikokuhyouViewProp( this ) ;

			iRv = 1 ;	//	_CAO{bNXł̓͂Kp܂B
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

int CWndJikokuhyou::OnJikokuhyouDiagramHeIdou_Process( BOOL bQueryEnable ) 
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	const Mu<const CentDedRessya*>* pCentDedRessyaCont = getCentDedRessyaCont()->getMuPtr() ;

	CDcdGridCell*	pCDcdGridCell = NULL ;
	if ( iRv >= 0 ){
		 pCDcdGridCell = getCFocus()->getFocusCell() ;
		if ( pCDcdGridCell == NULL ){
			iRv = -11  ;	//	Z̏ꏊs
		}
	}
	//pCDcdGridCell = ҏW̃Z
	
	int iRessyaIdx = -1 ;
	const CentDedRessya* pCentDedRessya = NULL ;
	if ( iRv >= 0 ){
		iRessyaIdx = getXColSpecOfFocus().getRessyaIndex() ;

		if ( !( 0 <= iRessyaIdx && iRessyaIdx < pCentDedRessyaCont->size() ) ){
			//	Z̈ʒuA̗Ԃ̓̎̏ꏊł͂Ȃ
			//	G[ɂ͂܂B
		}	else	{
			pCentDedRessya = pCentDedRessyaCont->get( iRessyaIdx ) ;
		}
	}
	//iRessyaIdx = Index
	//pCentDedRessya = w̃ZɑΉwԁx
	//	ΉԂȂꍇNULL
	
	CdDedJikokuOrder aJikokuOrder;
	if ( iRv >= 0 )
	{
		aJikokuOrder = CdDedJikokuOrderOf( getYColSpecOfFocus() ) ;
	}
	//aJikokuOrder = w̃ZɑΉwOrderx
	//	ȂȂNULL

	CdDedJikoku	jikokuFocus ;
	if ( iRv >= 0 ){
		if ( pCentDedRessya != NULL ){
			jikokuFocus = pCentDedRessya->getEkiJikoku( aJikokuOrder ) ;
		}
	}
	//jikokuFocus = tH[JX̂Z̎BȂȂNULL

	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		// --------------------------------
		//	_COr[J
		// --------------------------------
		CDedDiagramView* pCDedDiagramView = NULL ;
		if ( iRv >= 0 ){
			
			const CDedDiagramDoc* pCDedDiagramDoc = NULL ;
			if ( iRv >= 0 ){
				pCDedDiagramDoc = 
					getCDiagramEditApp()->openCDedDiagramDoc( 
						getCentDedDia()  ) ; 
				if ( pCDedDiagramDoc == NULL ){
					iRv = -2 ;	//	_COr[̃I[vɎs܂
				}
			}
			//pCJikokuhyouDoc = _COhLg
			//	r[ANeBuɂȂĂ܂B
			
			if ( iRv >= 0 ){
				POSITION aPOSITION = pCDedDiagramDoc->GetFirstViewPosition() ;
				if ( aPOSITION != NULL ){
					pCDedDiagramView = (CDedDiagramView*)pCDedDiagramDoc->GetNextView( aPOSITION ) ;
				}
				if ( pCDedDiagramView == NULL ){
					iRv = -3 ;	//	_COr[̃I[vɎs܂
				}
			}
		}
		//pCDedDiagramView = _COr[
		if ( iRv >= 0 ){
			pCDedDiagramView->setZone_Dgr( jikokuFocus , 
				getCentDedRessyaCont()->EkiIndexOfEkiOrder( aJikokuOrder.getEkiOrder() ) , 
				getRessyahoukou() == Ressyahoukou_Nobori ) ;
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

//17.4.20edit_by_d_mania
int CWndJikokuhyou::OnVIEWDisplayTsuukaEkiJikoku_Process( 
	BOOL bQueryEnable )  
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( getDisplayTsuukaEkiJikoku() )
	{
		iRv = 1 ;	//(bQueryEnable==TRUȄꍇ)[S\]LłB
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		//ʉߎ\Ɗ@\̗ON̎ɁAʉߎOFFɂꍇ́AOFFɂB
		if( getDisplayTsuukaEkiJikoku() &&
			getStandardOperationTimeFunction() )
		{
			setStandardOperationTimeFunction( false ) ;
		}
		setDisplayTsuukaEkiJikoku( !getDisplayTsuukaEkiJikoku() ) ;
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

int CWndJikokuhyou::OnViewDisplayallekijikoku_Process( 
	BOOL bQueryEnable ) 
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( getDisplayAllEkiJikoku() )
	{
		iRv = 1 ;	//	(bQueryEnable==TRUȄꍇ)[S\]LłB
	}

	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		const CentDedRosen*	pCentDedRosen = 
			getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
		// --------------------------------
		//	Grid̔zuύXÓA
		//	tH[JXZ̕\e擾
		// --------------------------------
		CDcdGridCell*	pCDcdGridCell = getCFocus()->getFocusCell() ;
		int iYColumnNumber = getCXDcdGrid()->getYColumnNumberOfCell(
			pCDcdGridCell) ;
		int iXColumnNumber = getCXDcdGrid()->getXColumnNumberOfCell(
			pCDcdGridCell) ;

		CdYColSpecCont aYColumnSpecCont 
			= createYColSpecCont() ;

		CdYColSpec aYColumnSpec = 
			aYColumnSpecCont.ColumnNumberToSpec( iYColumnNumber ) ;
		//aYColumnSpec = tH[JXZ̕\eB

		// --------------------------------
		//	S\[h̕ύX
		// --------------------------------
		setDisplayAllEkiJikoku( !getDisplayAllEkiJikoku() ) ;
		// --------------------------------
		//	tH[JXZAGridzuύXOƓ\ëʒuɈړ
		// --------------------------------
		//	Gridzuς߁Awԍ-\ex̑Ή\č쐬܂B
		aYColumnSpecCont = createYColSpecCont() ;

		//	GridzuÕtH[JXZ̕\eɑΉ
		//	Yԍ擾
		iYColumnNumber = aYColumnSpecCont.ColumnNumberFromSpec(
			aYColumnSpec , true ) ;

		pCDcdGridCell = getCXDcdGrid()->getCell( 
			iXColumnNumber , iYColumnNumber ) ;
		getCFocus()->setFocusCell( pCDcdGridCell ) ;
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

//add_by_d_mania
int CWndJikokuhyou::OnViewDisplaySecondEkijikoku_Process( 
	BOOL bQueryEnable )  
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( getDisplaySecondEkiJikoku() )
	{
		iRv = 1 ;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplaySecondEkiJikoku( !getDisplaySecondEkiJikoku() ) ;
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

//17.4.20edit_by_d_mania
//add_by_d_mania
int CWndJikokuhyou::OnViewStandardOperationTimeFunction_Process( 
	BOOL bQueryEnable )  
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( getStandardOperationTimeFunction() )
	{
		iRv = 1 ;	//(bQueryEnable==TRUȄꍇ)[^]@\Lɂ]LłB
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		//ʉߎ\Ɗ@\̗OFF̎ɁA@\ONɂꍇ́Aʉߎ\ONɂB
		if( !getDisplayTsuukaEkiJikoku() &&
			!getStandardOperationTimeFunction() )
		{
			setDisplayTsuukaEkiJikoku( true ) ;
		}
		setStandardOperationTimeFunction( !getStandardOperationTimeFunction() ) ;
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;
}

CString CWndJikokuhyou::OnUpdateINDICATOR_PasteZoubun_Process() 
{
	CString	strLs ;
	if ( m_StateMachine.getCurrentStateIdx() == StateIdx_Renzoku  )
	{
		//	A̓[h
		strLs.LoadString( IDS_INDICATOR_Renzoku ) ;
	}
	else
	{
		//	̑
		//bo͂ǉA[̏ꍇ̂݁Ab͕o edit_by_d_mania
		if( m_jikanPasteIdouryou.getTotalSeconds() / 60 == 0 )
		{
		strLs.Format( ID_INDICATOR_PasteZoubun , 
			m_jikanPasteIdouryou.getTotalSeconds() / 60 , 
			m_jikanPasteIdouryou.getTotalSeconds() % 60 , 
			( m_jikanPasteIdouryouPrevValue.getTotalSeconds() + 
				m_jikanPasteIdouryou.getTotalSeconds() ) / 60  ,
			( m_jikanPasteIdouryouPrevValue.getTotalSeconds() + 
				m_jikanPasteIdouryou.getTotalSeconds() ) % 60 )	;
		}
		else
		{
		strLs.Format( ID_INDICATOR_PasteZoubun , 
			m_jikanPasteIdouryou.getTotalSeconds() / 60 , 
			abs( m_jikanPasteIdouryou.getTotalSeconds() % 60 ) , 
			( m_jikanPasteIdouryouPrevValue.getTotalSeconds() + 
				m_jikanPasteIdouryou.getTotalSeconds() ) / 60  ,
			abs( ( m_jikanPasteIdouryouPrevValue.getTotalSeconds() + 
				m_jikanPasteIdouryou.getTotalSeconds() ) % 60 ) )	;
		}
	}
	return strLs ;
}



// --------------------------------
//@name ֐
// --------------------------------


// ********************************
//@name	CDcdGrid
// ********************************

	// --------------------------------
	//@name sEEZ̏
	// --------------------------------
void CWndJikokuhyou::OnCreateXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) 
{
	pCDcdGridXColumn->getCDcdGridXBorder()->setAutoColumnBorderSize( false ) ;
	pCDcdGridXColumn->setAutoColumnSize( false ) ;

	super::OnCreateXColumn( iXColumnNumber , 
		pCDcdGridXColumn ) ;
}

	
void CWndJikokuhyou::OnCreateYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) 
{
	pCDcdGridYColumn->getCDcdGridYBorder()->setAutoColumnBorderSize( false ) ;
	pCDcdGridYColumn->setAutoColumnSize( false ) ;

	super::OnCreateYColumn( iYColumnNumber , 
			pCDcdGridYColumn ) ;
}

	
// ********************************
//@name	CWndDcdGrid
// ********************************
	// --------------------------------
	//@name	Cxĝ߂̉z֐
	// --------------------------------
void CWndJikokuhyou::OnSetFocusCell( CDcdGridCell* pCDcdGridCell ) 
{
	m_StateMachine.getCurrentState()->
		OnSetFocusCell( pCDcdGridCell ) ;

	//	super::OnSetFocusCell( pCDcdGridCell ) ;
}

void CWndJikokuhyou::OnSetXFixafterColumnNumber( int iFixafterColumnNumber ) 
{
	m_StateMachine.getCurrentState()->
		OnSetXFixafterColumnNumber( iFixafterColumnNumber ) ;
	//	super::OnSetXFixafterColumnNumber( iFixafterColumnNumber ) ;
}

void CWndJikokuhyou::OnSetYFixafterColumnNumber( int iFixafterColumnNumber ) 
{
	m_StateMachine.getCurrentState()->
		OnSetYFixafterColumnNumber( iFixafterColumnNumber ) ;
	//	super::OnSetYFixafterColumnNumber( iFixafterColumnNumber ) ;
}

void CWndJikokuhyou::OnChangeSelectCell( 
		int iXColumnNumber , int iYColumnNumber , bool bIsSelected ) 
{
	m_StateMachine.getCurrentState()->
		OnChangeSelectCell( iXColumnNumber , iYColumnNumber , bIsSelected ) ;
}


// ********************************
//	RXgN^
// ********************************
CWndJikokuhyou::CWndJikokuhyou()
	: m_jikanPasteIdouryou( 0 )
	, m_bDisplayTsuukaEkiJikoku( true )
	, m_bDisplayAllEkiJikoku( false ) 
	, m_eEkijikokuSort( EEkijikokuSort_Ekiatsukai )	// wł̃\[g
	, m_bModifyEkijikoku( true )
	, m_jikanPasteIdouryouPrevValue( 0 )
	, m_bUpdate_All_Requested( true )
	, m_bReadCWndJikokuhyouDefault( false ) 
	, m_bDisplaySecondEkiJikoku( false ) 
	, m_bStandardOperationTimeFunction( false ) 
{
	//	IeLXgJ[ݒ
	{
		Ou<CDcdFillrectRop>	pIfDcDraw = dynamic_castOu<CDcdFillrectRop>(
			getCSelect()->getIfDcDrawSelect() ) ;

		//	IeLXgJ[=
		pIfDcDraw->setCdBrushProp( CdColorProp( 0 , 0 , 0 ) ) ;
	}
}
CWndJikokuhyou::~CWndJikokuhyou()
{
}


// ********************************
//@name	CWndJikokuhyou
// ********************************
	// ********************************
	//@name CWndJikokuhyou-
	// ********************************
bool CWndJikokuhyou::getDisplayTsuukaEkiJikoku()const 
{
	return m_bDisplayTsuukaEkiJikoku ;
}
int CWndJikokuhyou::setDisplayTsuukaEkiJikoku( bool value ) 
{
	int iRv = 0 ;
	if ( m_bDisplayTsuukaEkiJikoku != value )
	{
		m_bDisplayTsuukaEkiJikoku = value ;

		//	ʉߗԂ̕\̗Lωꍇ́A
		//	r[̉wXV܂B
		updateUISetAllRessya() ;
		InvalidateGrid() ;

		//	ʉߗԂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndJikokuhyouViewProp( this ) ;
	}
	return ( iRv ) ;
}

bool CWndJikokuhyou::getDisplayAllEkiJikoku()const
{	return m_bDisplayAllEkiJikoku ;};

int CWndJikokuhyou::setDisplayAllEkiJikoku( bool value )
{
	int iRv = 0 ;
	if ( m_bDisplayAllEkiJikoku != value )
	{
		m_bDisplayAllEkiJikoku = value ;

		//	Obh̗񐔂ς܂̂ŁA
		//	r[̑SXVKvłB
		//	Ãr[XV Kv͂܂B
		updateUIAll() ;

		//	\ݒ .ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndJikokuhyouViewProp( this ) ;
	}
	return ( iRv ) ;
}


void CWndJikokuhyou::setModifyEkijikoku( bool value )
{
	if ( m_bModifyEkijikoku != value )
	{
		m_bModifyEkijikoku = value ;
	
		//	\ݒ .ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndJikokuhyouViewProp( this ) ;
	}
};

//add_by_d_mania
bool CWndJikokuhyou::getDisplaySecondEkiJikoku()const 
{
	return m_bDisplaySecondEkiJikoku ;
}
int CWndJikokuhyou::setDisplaySecondEkiJikoku( bool value ) 
{
	int iRv = 0 ;
	if ( m_bDisplaySecondEkiJikoku != value )
	{
		m_bDisplaySecondEkiJikoku = value ;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[̉wXV܂B
		updateUISetAllRessya() ;
		InvalidateGrid() ;

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndJikokuhyouViewProp( this ) ;
	}
	return ( iRv ) ;
}

//add_by_d_mania
bool CWndJikokuhyou::getStandardOperationTimeFunction()const 
{
	return m_bStandardOperationTimeFunction ;
}
int CWndJikokuhyou::setStandardOperationTimeFunction( bool value ) 
{
	int iRv = 0 ;
	if ( m_bStandardOperationTimeFunction != value )
	{
		m_bStandardOperationTimeFunction = value ;

		//	^]@\̗Lωꍇ́A
		//	r[̉wXV܂B
		updateUISetAllRessya() ;
		InvalidateGrid() ;

		//	^]@\̗L
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndJikokuhyouViewProp( this ) ;
	}
	return ( iRv ) ;
}

	// ********************************
	//@name CDiagramView ̈Ϗ
	// ********************************
void CWndJikokuhyou::OnUpdate(
	CView* pSender, LPARAM lHint, CObject* pHint)
{
	if ( !m_bReadCWndJikokuhyouDefault )
	{
		// --------------------------------
		//	.ini t@CAԂǂݍ
		// --------------------------------
		getCDiagramEditApp()->readCWndJikokuhyouViewProp( this ) ;
		
		m_bReadCWndJikokuhyouDefault = true ;
	}

	//	XV́ACWjkState IuWFNgōs܂B
	{
		m_StateMachine.getCurrentState()->
			OnUpdate( pSender, lHint, pHint) ;
		//memo:
		//	uSXVv AND ̃r[ANeBur[v̏ꍇłA
		//	XVsKv܂B
		//	SXVv̏ꍇ́AԑI[hEA̓[h
		//	ޏꂷKv邽߂łB
	}


}

void CWndJikokuhyou::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	LogMsg( "CWndJikokuhyou::OnActivateView(%d,,)" , bActivate ) ;
	
	if ( bActivate && m_bUpdate_All_Requested ){
		//	updateUI... ֐ĂяoOɁA̕ϐ false 
		//	ȂĂ͂Ȃ܂B
		//	̕ϐ true ƁAOnUpdate ̉֐͉
		//	return ܂B
		m_bUpdate_All_Requested = false ;

		updateUIAll() ;
	}
}

	// ********************************
	//@name static CWndJikokuhyou-
	// ********************************
CdDedJikokuOrder 
CWndJikokuhyou::CdDedJikokuOrderOf( 
		const CdYColSpec& aYColSpec ) 
{
	CdDedJikokuOrder	aJikokuOrder ;
	if ( aYColSpec.getColumnType() 
		== CdYColSpec::ColumnType_Ekijikoku_Chaku )
	{
		aJikokuOrder.setEkiOrder( aYColSpec.getEkiOrder() , 
			CdDedJikokuOrder::EkiJikokuItem_Chaku ) ;
	}
	else if ( aYColSpec.getColumnType() 
		== CdYColSpec::ColumnType_Ekijikoku_Hatsu )
	{
		aJikokuOrder.setEkiOrder( aYColSpec.getEkiOrder() , 
			CdDedJikokuOrder::EkiJikokuItem_Hatsu ) ;
	}
	return aJikokuOrder ;
}
CdYColSpec 
CWndJikokuhyou::CdYColSpecOf( 
		const CdDedJikokuOrder& aJikokuOrder ) 
{
	CdYColSpec aYColSpec ;
	if ( aJikokuOrder.getEkiJikokuItem() 
		== CdDedJikokuOrder::EkiJikokuItem_Chaku )
	{
		aYColSpec.set( CdYColSpec::ColumnType_Ekijikoku_Chaku ,
			aJikokuOrder.getEkiOrder() ) ;
	}
	else if ( aJikokuOrder.getEkiJikokuItem() 
		== CdDedJikokuOrder::EkiJikokuItem_Hatsu )
	{
		aYColSpec.set( CdYColSpec::ColumnType_Ekijikoku_Hatsu ,
			aJikokuOrder.getEkiOrder() ) ;
	}
	return aYColSpec ;
}


	// ********************************
	//@name CWndJikokuhyou-
	// ********************************

CdXColSpecCont 
CWndJikokuhyou::createXColSpecCont() 
{
	CdXColSpecCont aXColumnSpecCont ;
	const CentDedRessyaCont* pCentDedRessyaCont = getCentDedRessyaCont() ;
	if ( pCentDedRessyaCont != NULL )
	{
		aXColumnSpecCont.scan( pCentDedRessyaCont ) ;
	}
	return aXColumnSpecCont ;
}

CdYColSpecCont 
CWndJikokuhyou::createYColSpecCont() 
{
	const CentDedRosen*	pCentDedRosen = 
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;

	CdYColSpecCont aYColumnSpecCont ;

	aYColumnSpecCont.scan(
		pCentDedRosen->getCentDedEkiCont() ,
		getRessyahoukou() ,
		m_bDisplayAllEkiJikoku ) ;
	return aYColumnSpecCont ;
}

CdXColSpec 
CWndJikokuhyou::getXColSpecOfFocus() 
{
	CdXColSpec aXColSpec ;

	CdXColSpecCont aXColSpecCont 
				= createXColSpecCont() ;
	CdDcdPosXy	posFocusCell = getCFocus()->getFocusCellColumnNumber() ;
	aXColSpec = aXColSpecCont.ColumnNumberToSpec( posFocusCell.getX() ) ;

	return aXColSpec ;
}
CdYColSpec 
CWndJikokuhyou::getYColSpecOfFocus() 
{
	CdYColSpec aYColSpec ;

	CdYColSpecCont aYColSpecCont 
				= createYColSpecCont() ;
	CdDcdPosXy	posFocusCell = getCFocus()->getFocusCellColumnNumber() ;
	aYColSpec = aYColSpecCont.ColumnNumberToSpec( posFocusCell.getY() ) ;

	return aYColSpec ;
}


int CWndJikokuhyou::
	moveFocusCellToNext( bool bJikokuhyouFocusToRight , bool bNextEkiOrder ) 
{
	int iRv = 0 ;
	CDcdGridCell*	pCDcdGridCell = getCFocus()->getFocusCell() ;

	CdXColSpecCont	aXColSpecCont
		= createXColSpecCont() ;

	//	tH[JX㉺Ɉړ
	if ( !bJikokuhyouFocusToRight )
	{
		//	ZړɁAԑIϓȂ悤ɂ܂B
		CPropStack aPropStack( this ) ;
		aPropStack.CBoxSelect_setIsEnable( false ).CRandomSelect_setIsEnable( false ) ;

		//	ړ̃Zʒu߂
		CdYColSpecCont aYColSpecCont = createYColSpecCont() ;

		int iYColumnNumber = getCXDcdGrid()->getYColumnNumberOfCell(pCDcdGridCell) ;
		int iXColumnNumber = getCXDcdGrid()->getXColumnNumberOfCell(pCDcdGridCell) ;
		if ( 0 <= iYColumnNumber && 
				iYColumnNumber < 
				aYColSpecCont.getColumnNumber_Ekijikoku_begin() )
		{
			//iYColumnNumber = Ԕԍ`܂ł̊ԁiw̏j
			//	ɂ܂B
			//	̏ꍇ́Aԏ̉wɈړ܂B
			iYColumnNumber = 
				aYColSpecCont.getColumnNumber_Ekijikoku_begin() ;
		}
		else if ( 
			aYColSpecCont.getColumnNumber_Ekijikoku_begin() <= 
				iYColumnNumber && 
			iYColumnNumber < 
				aYColSpecCont.getColumnNumber_Ekijikoku_end() )
		{
			//iYColumnNumber = ẅʒuɂ܂B
			if ( bNextEkiOrder && 
				aXColSpecCont.getColumnNumber_Ressya_begin() <= iXColumnNumber	)
			{
				//	bNextEkiOrder ^ŁAtH[JXԏɂꍇ	
				CdDedJikokuOrder	aJikokuOrder = CdDedJikokuOrderOf( 
					aYColSpecCont.ColumnNumberToSpec( iYColumnNumber ) ) ;
				if ( !aJikokuOrder.getIsNull() )
				{
					//iYColumnNumber = ẅʒuɂ܂B
					//	̉w̗̒ԍ
					iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec( 
						CdYColSpec(
							CdYColSpec::ColumnType_Ekijikoku_Chaku ,
							aJikokuOrder.getEkiOrder() + 1  ) , false ) ;
					//iYColumnNumber=̉w̗̒ԍ
					if ( iYColumnNumber < 0 )
					{
						iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec( 
						CdYColSpec(
							CdYColSpec::ColumnType_Ekijikoku_Hatsu ,
							aJikokuOrder.getEkiOrder() + 1  ) , false ) ;
					}
					if ( iYColumnNumber < 0 )
					{
						//	ԉ̉ẅړłB
						//	w̎Ɉړ܂B
						iYColumnNumber = aYColSpecCont.getColumnNumber_Ekijikoku_end() ;
					}

				}
			}
			else
			{
				//	bNextEkiOrder ȔꍇA
				//	tH[JXԏɂꍇ	

				//tH[JXZֈړ
				CDcdGridCell*	pCell = 
					getCXDcdGrid()->calcMovedCell( 
						pCDcdGridCell , 
						0 , 
						1 ) ;
				if ( pCell != NULL )
				{
					iYColumnNumber = getCXDcdGrid()->getYColumnNumberOfCell( pCell ) ;
				}
			}
		}
		else if ( aYColSpecCont.getColumnNumber_Ekijikoku_end() <= 
					iYColumnNumber )
		{
			//iYColumnNumber = w̌(l)ɂ܂B
			//	̏ꍇ́A̗(̗)̍ŏsɈړ܂B	
			iYColumnNumber = 0 ;
			if ( 0 <= iXColumnNumber && 
				iXColumnNumber < aXColSpecCont.getColumnNumber_Ressya_begin() )
			{
				iXColumnNumber = aXColSpecCont.getColumnNumber_Ressya_begin() ;
			}
			else
			{
				iXColumnNumber ++ ;
			}

		}

		//iYColumnNumber = ̉w̗ԍ
		//	(-1̏ꍇ܂B(H̏Iw̉w͂I))
		if ( iYColumnNumber >= 0 )
		{
			CDcdGridCell*	pCell = 
				getCXDcdGrid()->getCell( 
					iXColumnNumber , 
					iYColumnNumber ) ;
			if ( pCell )
			{
				getCFocus()->setFocusCell( pCell ) ;
			}
		}
	}
	//	tH[JXړ[h
	else
	{
		CDcdGridCell*	pCell = 
			getCXDcdGrid()->calcMovedCell( 
				getCFocus()->getFocusCell() , 
				+1 , 
				0 ) ;
		if ( pCell ){
			getCFocus()->setFocusCell( pCell ) ;
		}

		//	tH[JXړ[hł́AI܂B
		clearSelect() ;

	}


	return ( iRv ) ;
}

int CWndJikokuhyou::
	moveFocusCellToPrev( bool bJikokuhyouFocusToRight , bool bNextEkiOrder ) 
{
	int iRv = 0 ;
	CDcdGridCell*	pCDcdGridCell = getCFocus()->getFocusCell() ;

	CdXColSpecCont	aXColSpecCont
		= createXColSpecCont() ;
	CdYColSpecCont	aYColSpecCont
		= createYColSpecCont() ;

	//	tH[JX㉺Ɉړ
	if ( !bJikokuhyouFocusToRight )
	{
		//	ZړɁAԑIϓȂ悤ɂ܂B
		CPropStack aPropStack( this ) ;
		aPropStack.CBoxSelect_setIsEnable( false ).CRandomSelect_setIsEnable( false ) ;


		//	ړ̃Zʒu߂
		int iYColumnNumber = getCXDcdGrid()->getYColumnNumberOfCell(pCDcdGridCell) ;
		int iXColumnNumber = getCXDcdGrid()->getXColumnNumberOfCell(pCDcdGridCell) ;
		if ( 0 <= iYColumnNumber && 
			iYColumnNumber < 
			aYColSpecCont.getColumnNumber_Ekijikoku_begin() )
		{
			//iYColumnNumber = Ԕԍ`܂ł̊ԁiw̏j
			//	ɂ܂B
			//	̏ꍇ́AO̗()́Al Ɉړ܂B
			iYColumnNumber = aYColSpecCont.getColumnNumber_Ekijikoku_end()  ;

			iXColumnNumber -- ;

		}
		else if ( 
			aYColSpecCont.getColumnNumber_Ekijikoku_begin() <= 
				iYColumnNumber && 
			iYColumnNumber < 
				aYColSpecCont.getColumnNumber_Ekijikoku_end() )
		{
			//iYColumnNumber = ẅʒuɂ܂B
			if ( bNextEkiOrder &&
				aXColSpecCont.getColumnNumber_Ressya_begin() <= iXColumnNumber	)
			{
				//	bNextEkiOrder ^ŁAtH[JXԏɂꍇ	

				CdDedJikokuOrder aJikokuOrder = CdDedJikokuOrderOf(
					aYColSpecCont.ColumnNumberToSpec( iYColumnNumber ) )  ;

				if ( !aJikokuOrder.getIsNull() )
				{
					//iYColumnNumber = ẅʒuɂ܂B
					iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec( 
						CdYColSpec( 
							CdYColSpec::ColumnType_Ekijikoku_Chaku ,
							aJikokuOrder.getEkiOrder() - 1  ) , false ) ;
					//iYColumnNumber = Ỏw̒w
					if ( iYColumnNumber < 0 )
					{
						iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec( 
							CdYColSpec( 
								CdYColSpec::ColumnType_Ekijikoku_Hatsu ,
								aJikokuOrder.getEkiOrder() - 1  ) , false ) ;
					}
					if ( iYColumnNumber < 0 )
					{
						//	tH[JXnw̉wOɂȂ܂B
						//	̏ꍇ́AԔԍ̈ʒuɈړ܂B
						iYColumnNumber = aYColSpecCont.ColumnNumberFromSpec( 
							CdYColSpec(
							CdYColSpec::ColumnType_Ressyabangou )
							, false ) ;
					}
				}
			}
			else
			{
				CDcdGridCell*	pCell = 
					getCXDcdGrid()->calcMovedCell( 
						pCDcdGridCell , 
						0 , 
						-1 ) ;
				if ( pCell != NULL )
				{
					iYColumnNumber = getCXDcdGrid()->getYColumnNumberOfCell( pCell ) ;
				}
			}
		}
		else if ( aYColSpecCont.getColumnNumber_Ekijikoku_end() <= iYColumnNumber )
		{
			//iYColumnNumber = ẅʒu肠Ƃɂ܂B
			//	Iw̍Ō̉wɈړ܂B
			iYColumnNumber = aYColSpecCont.getColumnNumber_Ekijikoku_end() - 1 ;
		}

		//iYColumnNumber = ̉w̗ԍ
		//	(-1̏ꍇ܂B(H̏Iw̉w͂I))
		if ( iYColumnNumber >= 0 )
		{
			CDcdGridCell*	pCell = 
				getCXDcdGrid()->getCell( 
					iXColumnNumber , 
					iYColumnNumber ) ;
			if ( pCell )
			{
				getCFocus()->setFocusCell( pCell ) ;
			}
		}
	}
	//	tH[JXړ[h
	else
	{
		CDcdGridCell*	pCell = 
			getCXDcdGrid()->calcMovedCell( 
				getCFocus()->getFocusCell() , 
				-1 , 
				0 ) ;
		if ( pCell )
		{
			getCFocus()->setFocusCell( pCell ) ;
		}

		//	tH[JXړ[hł́AI܂B
		clearSelect() ;

	}


	return ( iRv ) ;
}


int CWndJikokuhyou::execCdModifyEkijikokuCmd(
		Ou<EditCmd::CRfEditCmd_Ressya> pCmd , 
		CdDedJikokuOrder aCdJikokuOrder ) 
{
	int iRv = 0 ;
	CString	strError ;
	// --------------------------------
	int idxError = -1 ;

	// --------------------------------
	//	R}hIuWFNg̗ԂҏW
	// --------------------------------
	if ( iRv >= 0 )
	{
		for ( int idxRessya = 0 ; 
			iRv >= 0 && idxRessya < pCmd->getCaMuiSelect()->size() ; 
			idxRessya ++ )
		{
			CentDedRessya*	pCentDedRessya = pCmd->getCaMuiSelect()->getMuPtr()->get( idxRessya ) ; 
			//pCentDedRessya = pCmd ̗ԃIuWFNgw܂B

			int iResult = m_EkijikokuModifyOperation2.execute( 
				pCentDedRessya , 
				aCdJikokuOrder ) ;
			//	-	-1 ;	//	iJikokuOrder ͈͊OłB
			if ( iResult < 0 )
			{
				switch ( iResult ){
				case -1 :	
					iRv = -1 ;	//	XԍsłB
					break ;
				default :	
					iRv = iResult ;
					break ;
				}
				idxError = idxRessya ;
			}
		}
	}
	//idxError = G[ꍇ́A
	//	G[̔Ԃ aCentDedRessyaCont łIndexłB

	// --------------------------------
	//	R}hIuWFNgs
	// --------------------------------
	if ( iRv >= 0 )
	{
		getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
	}
	// --------------------------------
	//	G[\
	// --------------------------------
	if ( iRv < 0 )
	{
		//	tH[JXZG[̔Ԃֈڂ܂B
		{
			CdDcdPosXy	posFocusCell = getCFocus()->getFocusCellColumnNumber() ;

			CdXColSpecCont aXColSpecCont 
				= createXColSpecCont() ;
			posFocusCell.setX( aXColSpecCont.ColumnNumberFromSpec( 
				CdXColSpec( 
					CdXColSpec::ColumnType_Ressya ,
					pCmd->getIndexDst() + pCmd->getCaMuiSelect()->indexFromAdapteeIndex( idxError ) )
			) );
			
			getCFocus()->setFocusCellColumnNumber( posFocusCell ) ;
		}

		// --------------------------------
		if ( strError.IsEmpty() )
		{
			strError.Format( IDS_ERR_ERRORCODE , iRv ) ;
		}
		MessageBox( strError , NULL , MB_ICONEXCLAMATION | MB_OK ) ; 
	}
	return ( iRv ) ;

}



bool CWndJikokuhyou::createCmd( ECreateCmd eCreateCmd , Ou<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>* ppCmd )
{
	bool bRv = false ;
	Ou<DedRosenFileData::EditCmd::CRfEditCmd_Ressya> pCmd ;

	CdXColSpecCont aCdXColSpecCont = createXColSpecCont() ;
	CdXColSpec  aCdXColSpecOfFocus = getXColSpecOfFocus() ;

	// ********************************
	//	ECreateCmd_NewTrain
	//@VKԂΏۂƂR}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_NewItem )
	{
		//	\r[ŕIOFF
		if ( getCSelect()->getSelectedCellCount() == 0 )
		{
			//	VKɒǉԂ́AIuWFNg
			CentDedRessya aNewRessya = getCentDedRessyaCont()->createNullRessya() ;
			aNewRessya.setRessyasyubetsuIndex( 0 ) ;

			//@\r[ŕIOFFEtH[JXZԏɂꍇ: 
			// - m_iIndexDst = tH[JXZ̗IndexAm_iIndexSize = 0
			// - m_CentDedRessyaCont = (NULLł͂Ȃ)
			// - CaMuSelect,CaMuiSelect = YԂIB
			if ( aCdXColSpecOfFocus.getColumnType() == CdXColSpec::ColumnType_Ressya )
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
						new CRfEditCmd_Ressya( 
							*getCDiagramEditDoc()->getCDedRosenFileData() , 
							GetDocument()->getDiaIndex() , 
							GetDocument()->getRessyahoukou() ,
							aCdXColSpecOfFocus.getRessyaIndex() , 
							0 ) ) ;
					pCmd->getCaMuiSelect()->insert( aNewRessya , INT_MAX ) ;
					pCmd->getCaMuiSelect()->setSelectAll( true ) ;
				}
			}
			// @\r[ŕIOFFEtH[JXZVKԈʒuɂꍇ:
			// - m_iIndexDst = Index+1Am_iIndexSize = 0
			// - m_CentDedRessyaCont = (NULLł͂Ȃ)
			// - CaMuSelect,CaMuiSelect = YԂIB
			else if ( aCdXColSpecOfFocus.getColumnType() == CdXColSpec::ColumnType_NewRessya )
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
						new CRfEditCmd_Ressya( 
							*getCDiagramEditDoc()->getCDedRosenFileData() , 
							GetDocument()->getDiaIndex() , 
							GetDocument()->getRessyahoukou() ,
							aCdXColSpecOfFocus.getRessyaIndex() , 
							0 ) ) ;
					pCmd->getCaMuiSelect()->insert( aNewRessya , INT_MAX ) ;
					pCmd->getCaMuiSelect()->setSelectAll( true ) ;
				}
			}
		}
		// @\r[ŕION:
		// NULLԂ܂([14/05/18]:IOFF̏ꍇƓ)
	}
	// ********************************
	//	ECreateCmd_Focus
	//@tH[JXZ1ԂΏۂƂR}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_Focus )
	{
		//	\r[ŕIOFF
		if ( getCSelect()->getSelectedCellCount() == 0 )
		{
			//@\r[ŕIOFFEtH[JXZԏɂꍇ: 
			// - m_iIndexDst = tH[JXZ̗IndexAm_iIndexSize = 1
			// - m_CentDedRessyaCont = tH[JXZ̗1̃Rs[
			// - m_CaMuiSelect = tH[JXZ̗ԂIB
			if ( aCdXColSpecOfFocus.getColumnType() == CdXColSpec::ColumnType_Ressya )
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
						new CRfEditCmd_Ressya( 
							*getCDiagramEditDoc()->getCDedRosenFileData() , 
							GetDocument()->getDiaIndex() , 
							GetDocument()->getRessyahoukou() ,
							aCdXColSpecOfFocus.getRessyaIndex() , 
							1 ) ) ;
					pCmd->getCaMuiSelect()->setSelectAll( true ) ;
				}
			}

			//@\r[ŕIOFFEtH[JXZVKԈʒuɂꍇ: 
			// - NULLԂ܂B
		}
		//@\r[ŕION
		// NULLԂ܂([14/05/18]:IOFF̏ꍇƓ)
	}
	// ********************************
	//	ECreateCmd_Select
	//@̒P܂͕IĂԂΏۂƂ
	//	R}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_Select )
	{
		//@\r[ŕIOFFEtH[JXZԏɂꍇ: 
		//
		// - m_iIndexDst = tH[JXZ̗IndexAm_iIndexSize = 1
		// - m_CentDedRessyaCont = tH[JXẐ1̃Rs[
		// - CaMuiSelect = YԂIB
		if ( getCSelect()->getSelectedCellCount() == 0 
			&& aCdXColSpecOfFocus.getColumnType() == CdXColSpec::ColumnType_Ressya )
		{
			bRv = true ;
			if ( ppCmd != NULL )
			{
				pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
					new CRfEditCmd_Ressya( 
						*getCDiagramEditDoc()->getCDedRosenFileData() , 
						GetDocument()->getDiaIndex() , 
						GetDocument()->getRessyahoukou() ,
						aCdXColSpecOfFocus.getRessyaIndex() , 
						1 ) ) ;
				pCmd->getCaMuiSelect()->setSelectAll( true ) ;
			}
		}

		//@\r[ŕIOFFEtH[JXZVKԈʒuɂꍇ: 
		// - NULLԂ܂B

		//@\r[ŕION
		// - m_iIndexDst = IĂԂ̐擪index
		// - m_iIndexSize = IĂԂ̖index-擪index+1
		// - m_CentDedRessyaCont = IĂԂ̐擪index
		//  index܂ł̗Ԃ̃Rs[
		// - CaMuiSelect ́AtH[JXZɍ킹ėԂIB
		
		//(A)̈ʒuŏ܂B
	}


	// ********************************
	//		ECreateCmd_All ,
	//@SԂΏۂƂR}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_All )
	{

		//  \r[ŕIOFFEtH[JXZԏɂꍇ: 
		//
		// - m_iIndexDst = 0Am_iIndexSize = Ԃ̐
		// - m_CentDedRessyaCont = SԂ̃Rs[
		// - m_CaMuiSelect2 ́ASԂIB
		//  \r[ŕIOFFEtH[JXZVKԈʒuɂꍇ: 
		// 
		// - m_iIndexDst = 0Am_iIndexSize = Ԃ̐
		// - m_CentDedRessyaCont = SԂ̃Rs[
		// - CaMuiSelect2 ́ASԂIB
		if ( getCSelect()->getSelectedCellCount() == 0 
			&& ( aCdXColSpecOfFocus.getColumnType() == CdXColSpec::ColumnType_Ressya 
			|| aCdXColSpecOfFocus.getColumnType() == CdXColSpec::ColumnType_NewRessya ) )
		{
			bRv = true ;
			if ( ppCmd != NULL )
			{
				pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
					new CRfEditCmd_Ressya( 
						*getCDiagramEditDoc()->getCDedRosenFileData() , 
						GetDocument()->getDiaIndex() , 
						GetDocument()->getRessyahoukou() ,
						0 , 
						getCentDedRessyaCont()->size() ) ) ;
				pCmd->getCaMuiSelect()->setSelectAll( true ) ;
			}
		}

		//\r[ŕION
		//
		// - m_iIndexDst = IĂԂ̐擪index
		// - m_iIndexSize = IĂԂ̖index-擪index+1
		// - m_CentDedRessyaCont = IĂԂ̐擪index
		//	index܂ł̗Ԃ̃Rs[
		// - m_CaMuiSelect2 ́AZ̑Iɍ킹ėԂIB

		//(A)̈ʒuŏ܂B
	}

	// ********************************
	//	(A)ECreateCmd_SelectEECreateCmd_All 
	//@IĂԂΏۂƂ
	//	R}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_Select 
		|| eCreateCmd == ECreateCmd_All )
	{
		if ( getCSelect()->getSelectedCellCount() > 0 )
		{
			//	IĂԂ̗Index擾
			deque<int> contiRessyaIndex ;
			for ( int iColumnNumber = 0 ; iColumnNumber < getCXDcdGrid()->getXColumnCount() ;iColumnNumber ++ )
			{
				if ( getCSelect()->getXColumnNumberSelected( iColumnNumber ) )
				{
					CdXColSpec aCdXColSpec = aCdXColSpecCont.ColumnNumberToSpec( iColumnNumber ) ;
					if ( aCdXColSpec.getColumnType() == CdXColSpec::ColumnType_Ressya )
					{
						contiRessyaIndex.push_back( aCdXColSpec.getRessyaIndex() ) ;
					}
				}
			}
			//contiRessyaIndex = ̕I{Ăꍇ́A
			//	IĂIndexi[܂B
			//	łȂꍇ́AłB

			if ( contiRessyaIndex.size() > 1 )
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					//	R}hIuWFNgɁAIĂԂ̐擪疖܂ł
					//	Ԃi[܂(擪EȊOɂ́AIĂȂԂ
					//	܂܂Ăꍇ܂)
					pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
						new CRfEditCmd_Ressya( 
							*getCDiagramEditDoc()->getCDedRosenFileData() ,
							GetDocument()->getDiaIndex() , 
							GetDocument()->getRessyahoukou() ,
							contiRessyaIndex.front() , 
							contiRessyaIndex.back() - contiRessyaIndex.front() + 1 ) ) ;

					//	R}hIuWFNg
					//	m_CentDedRessyaContSrc  ̗ԂI܂B
					pCmd->getCaMuiSelect()->setSelectAll( false ) ;
					for ( int i = 0 ; i < (int)contiRessyaIndex.size() ; i ++ )
					{
						pCmd->getCaMuiSelect()->setSelect( contiRessyaIndex[i] - contiRessyaIndex.front()  , true ) ;
					}
				}
			}
		}
	}
	// ================================
	if ( ppCmd != NULL && pCmd != NULL )
	{
		*ppCmd = pCmd ;
	}
	return bRv ;
}

bool CWndJikokuhyou::createCmd( int iRessyaIndex , int iRessyaCount , 
		Ou<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>* ppCmd) 
{
	bool bRv = false ;
	Ou<DedRosenFileData::EditCmd::CRfEditCmd_Ressya> pCmd ;
	int iRv = 0 ;

	//  --------------------------------
	//	R}hIuWFNg𐶐
	//  --------------------------------
	if ( iRv >= 0 )
	{
		//	R}hIuWFNgɁAw肳ꂽ͈͂
		//	Ԃi[܂
		//	Ԃ͑SIƂȂ܂B
		bRv = true ;
		if ( ppCmd != NULL )
		{
			pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_Ressya>( 
				new CRfEditCmd_Ressya( 
					*getCDiagramEditDoc()->getCDedRosenFileData() , 
					GetDocument()->getDiaIndex() , 
					GetDocument()->getRessyahoukou() ,
					iRessyaIndex , 
					iRessyaCount ) ) ;
		}
	}
	// ================================
	if ( ppCmd != NULL && pCmd != NULL )
	{
		*ppCmd = pCmd ;
	}
	return bRv ;
}

// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CWndJikokuhyou,CWndJikokuhyou::super)
	//{{AFX_MSG_MAP(CWndJikokuhyou)
	ON_WM_CREATE()
	ON_WM_KEYUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_Jikokuhyou_RessyaProp, OnJikokuhyouRessyaProp)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_RessyaProp, OnUpdateJikokuhyouRessyaProp)
	ON_COMMAND(ID_Jikokuhyou_RessyaInsert, OnJikokuhyouRessyaInsert)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_RessyaInsert, OnUpdateJikokuhyouRessyaInsert)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_Edit_PasteEkiJikoku, OnEditPasteEkiJikoku)
	ON_UPDATE_COMMAND_UI(ID_Edit_PasteEkiJikoku, OnUpdateEditPasteEkiJikoku)
	ON_COMMAND(ID_Jikokuhyou_Tsuuka, OnJikokuhyouTsuuka)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Tsuuka, OnUpdateJikokuhyouTsuuka)
	ON_COMMAND(ID_Jikokuhyou_Keiyunasi, OnJikokuhyouKeiyunasi)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Keiyunasi, OnUpdateJikokuhyouKeiyunasi)
	ON_COMMAND(ID_Jikokuhyou_Sihatsu, OnJikokuhyouSihatsu)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Sihatsu, OnUpdateJikokuhyouSihatsu)
	ON_COMMAND(ID_Jikokuhyou_Syuuchaku, OnJikokuhyouSyuuchaku)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Syuuchaku, OnUpdateJikokuhyouSyuuchaku)
	ON_COMMAND(ID_Jikokuhyou_Renzoku, OnJikokuhyouRenzoku)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Renzoku, OnUpdateJikokuhyouRenzoku)
	ON_COMMAND(ID_Jikokuhyou_ViewProp, OnJikokuhyouViewProp)
	ON_COMMAND(ID_Jikokuhyou_FocusMoveDown, OnJikokuhyouFocusMoveDown)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_FocusMoveDown, OnUpdateJikokuhyouFocusMoveDown)
	ON_COMMAND(ID_Jikokuhyou_FocusMoveRight, OnJikokuhyouFocusMoveRight)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_FocusMoveRight, OnUpdateJikokuhyouFocusMoveRight)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuProp, OnJikokuhyouEkijikokuProp)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuProp, OnUpdateJikokuhyouEkijikokuProp)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuInsert, OnJikokuhyouEkijikokuInsert)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuInsert, OnUpdateJikokuhyouEkijikokuInsert)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuErase, OnJikokuhyouEkijikokuErase)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuErase, OnUpdateJikokuhyouEkijikokuErase)
	ON_WM_CHAR()
	ON_COMMAND(ID_Jikokuhyou_ModifyEkijikokuCmd, OnJikokuhyouModifyEkijikokuCmd)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_ModifyEkijikokuCmd, OnUpdateJikokuhyouModifyEkijikokuCmd)
	ON_COMMAND(ID_Jikokuhyou_ModifyEkijikokuCmdRepeat, OnJikokuhyouModifyEkijikokuCmdRepeat)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_ModifyEkijikokuCmdRepeat, OnUpdateJikokuhyouModifyEkijikokuCmdRepeat)
	ON_COMMAND(ID_Jikokuhyou_JikokuSakujo, OnJikokuhyouJikokuSakujo)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_JikokuSakujo, OnUpdateJikokuhyouJikokuSakujo)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuDec, OnJikokuhyouEkijikokuDec)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuDec, OnUpdateJikokuhyouEkijikokuDec)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuNext, OnJikokuhyouEkijikokuNext)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuNext, OnUpdateJikokuhyouEkijikokuNext)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuInc, OnJikokuhyouEkijikokuInc)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuInc, OnUpdateJikokuhyouEkijikokuInc)
	ON_COMMAND(ID_Jikokuhyou_EKikanSaisyouSec, OnJikokuhyouEKikanSaisyouSec)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EKikanSaisyouSec, OnUpdateJikokuhyouEKikanSaisyouSec)
	ON_COMMAND(ID_Jikokuhyou_DiagramHeIdou, OnJikokuhyouDiagramHeIdou)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_DiagramHeIdou, OnUpdateJikokuhyouDiagramHeIdou)
	ON_COMMAND(ID_VIEW_DisplayTsuukaEkiJikoku, OnVIEWDisplayTsuukaEkiJikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayTsuukaEkiJikoku, OnUpdateVIEWDisplayTsuukaEkiJikoku)
	ON_COMMAND(ID_FILE_EXPORT_JIKOKUHYOUCSV, OnFileExportJikokuhyoucsv)
	ON_COMMAND(ID_FILE_IMPORT_JIKOKUHYOUCSV, OnFileImportJikokuhyoucsv)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_PasteZoubun, OnUpdateINDICATOR_PasteZoubun)

	ON_COMMAND(ID_Jikokuhyou_EkijikokuDecNoMove, &CWndJikokuhyou::OnJikokuhyouEkijikokudecnomove)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuDecNoMove, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokudecnomove)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuIncNoMove, &CWndJikokuhyou::OnJikokuhyouEkijikokuincnomove)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuIncNoMove, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuincnomove)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuPrev, &CWndJikokuhyou::OnJikokuhyouEkijikokuPrev)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuPrev, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuPrev)
	ON_COMMAND(ID_EDIT_SELECT_ALL, &CWndJikokuhyou::OnEditSelectAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL, &CWndJikokuhyou::OnUpdateEditSelectAll)
	ON_COMMAND(ID_Jikokuhyou_SORT, &CWndJikokuhyou::OnJikokuhyouSort)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_SORT, &CWndJikokuhyou::OnUpdateJikokuhyouSort)
	ON_COMMAND(ID_Jikokuhyou_TsuukaTeisya, &CWndJikokuhyou::OnJikokuhyouTsuukateisya)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_TsuukaTeisya, &CWndJikokuhyou::OnUpdateJikokuhyouTsuukateisya)
	ON_COMMAND(ID_Jikokuhyou_Direct, &CWndJikokuhyou::OnJikokuhyouDirect)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Direct, &CWndJikokuhyou::OnUpdateJikokuhyouDirect)
	ON_COMMAND(ID_Jikokuhyou_Undirect, &CWndJikokuhyou::OnJikokuhyouUndirect)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Undirect, &CWndJikokuhyou::OnUpdateJikokuhyouUndirect)
	ON_COMMAND(ID_VIEW_DisplayAllEkiJikoku, &CWndJikokuhyou::OnViewDisplayallekijikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayAllEkiJikoku, &CWndJikokuhyou::OnUpdateViewDisplayallekijikoku)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_Jikokuhyou_Unify, &CWndJikokuhyou::OnJikokuhyouUnify)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_Unify, &CWndJikokuhyou::OnUpdateJikokuhyouUnify)
//change_by_d_mania
	ON_COMMAND(ID_Jikokuhyou_EkijikokuDecAnySecNoMove, &CWndJikokuhyou::OnJikokuhyouEkijikokudecAnysecnomove)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuDecAnySecNoMove, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokudecAnysecnomove)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuIncAnySecNoMove, &CWndJikokuhyou::OnJikokuhyouEkijikokuincAnysecnomove)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuIncAnySecNoMove, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuincAnysecnomove)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuDecAny2SecNoMove, &CWndJikokuhyou::OnJikokuhyouEkijikokudecAny2secnomove)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuDecAny2SecNoMove, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokudecAny2secnomove)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuIncAny2SecNoMove, &CWndJikokuhyou::OnJikokuhyouEkijikokuincAny2secnomove)
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuIncAny2SecNoMove, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuincAny2secnomove)
	ON_COMMAND(ID_VIEW_DisplaySecondEkiJikoku, &CWndJikokuhyou::OnViewDisplaySecondEkijikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplaySecondEkiJikoku, &CWndJikokuhyou::OnUpdateViewDisplaySecondEkijikoku)
	ON_COMMAND(ID_VIEW_StandardOperationTimeFunction, &CWndJikokuhyou::OnViewStandardOperationTimeFunction)
	ON_UPDATE_COMMAND_UI(ID_VIEW_StandardOperationTimeFunction, &CWndJikokuhyou::OnUpdateViewStandardOperationTimeFunction)
	ON_COMMAND(ID_Jikokuhyou_EkijikokuAdjustStdOpeTime, &CWndJikokuhyou::OnJikokuhyouEkijikokuAdjustStdOpeTime) // 17.4.19
	ON_UPDATE_COMMAND_UI(ID_Jikokuhyou_EkijikokuAdjustStdOpeTime, &CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuAdjustStdOpeTime) // 17.4.19
	

//܂change_by_d_mania
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


int CWndJikokuhyou::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (super::OnCreate(lpCreateStruct) == -1)
		return -1;


	// --------------------------------
	//	Ԃ̏lݒ
	// --------------------------------
	m_StateMachine.add( OuNew< CWjkState >( new CWjkState_Ressyahensyu( this ) ) ) ;
	m_StateMachine.add( OuNew< CWjkState >( new CWjkState_Renzoku( this ) ) ) ;
	m_StateMachine.setCurrentStateIdx( StateIdx_Ressyahensyu ) ;


	// --------------------------------
	//	̐w
	// --------------------------------
	//	w
	//	
	//	(1...*)
	getCXDcdGrid()->setXColumnCount( 3 ) ;
	getCXDcdGrid()->setXFixColumnCount( 2 ) ;
	//	Ԕԍ
	//	
	//	Ԗ
	//	
	//	
	//	w(0...*)
	//	l
	getCXDcdGrid()->setYColumnCount( 6 ) ;
	getCXDcdGrid()->setYFixColumnCount( 5 ) ;

	// --------------------------------
	//	tH[JXZ̏ʒuݒ
	// --------------------------------
	getCFocus()->setFocusCell( getCXDcdGrid()->getCell( 1 , 1 ) ) ;	
	
	return 0;
}

void CWndJikokuhyou::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_StateMachine.getCurrentState()->
		OnKeyDown(nChar, nRepCnt, nFlags);
	//	super::OnKeyDown(nChar, nRepCnt, nFlags);
}
void CWndJikokuhyou::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_StateMachine.getCurrentState()->
		OnKeyUp(nChar, nRepCnt, nFlags);
	//super::OnKeyUp(nChar, nRepCnt, nFlags);
}



void CWndJikokuhyou::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_StateMachine.getCurrentState()->
		OnChar( nChar, nRepCnt, nFlags)  ;
	
	
}

void CWndJikokuhyou::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	m_StateMachine.getCurrentState()->
		OnLButtonDblClk(nFlags, point);
	//super::OnLButtonDblClk(nFlags, point);

}

//TODO:t@N^O
//	GridOnContextMenu() ́AdĂ܂B
//	́ACWndDcdGrid2(́ACWndDcdGrid3)ɒuׂłB
void CWndJikokuhyou::OnContextMenu(CWnd* pWnd, CPoint point)
{
	int iMenuIndex = -1 ;
	//	tH[JXZԂɂ邩Awɂ邩𔻒肵܂
	//	ɂA\ReLXgj[ς܂B
	{
		const Mu<const CentDedRessya*>* pCentDedRessyaCont = getCentDedRessyaCont()->getMuPtr() ;
		CdXColSpec aXColSpec = getXColSpecOfFocus() ;
		CdYColSpec aYColSpec = getYColSpecOfFocus() ;
		
		//	tH[JXZwE(V ܂)ɂꍇ́A
		//	ReLXgj[\܂B
		if ( aXColSpec.getColumnType() 
				== CdXColSpec::ColumnType_Ekimei || 
			aXColSpec.getColumnType() 
				== CdXColSpec::ColumnType_Chakuhatsu || 
			aXColSpec.getColumnType() 
				== CdXColSpec::ColumnType_Ressya || 
			aXColSpec.getColumnType() 
				== CdXColSpec::ColumnType_NewRessya )
		{
			if ( aYColSpec.isEkiJikoku() )
			{
				//	Ԃ̉wɃZꍇ́Awp̃j[
				iMenuIndex = 1 ;
			}
			else
			{
				//	Ԃ́AwȊO̗ԏɃZꍇ́A
				//	ԗp̃j[
				iMenuIndex = 0 ;
			}
		}
	}
	//iMenuIndex = 
	//	0: Ԃ̃ReLXgj[
	//	1: ԁEw̃ReLXgj[
	//	-1: YReLXgj[܂B

	{
		//	ReLXgj[}EXȊOŌĂяoꂽꍇ́A
		//	ReLXgj[̕\ʒúAtH[JXZ̒̈ʒuƂ܂B
		if ( point.x ==-1 || point.y == -1 )
		{
			//	ReLXgj[}EXȊOŌĂяo܂
			CdDcdPosXy posxyFocusCellColumnNumber = getCFocus()->getFocusCellColumnNumber() ;
			if ( posxyFocusCellColumnNumber !=  
					CFocus::ColumnNumberPosXy_NULL() )
			{
				CdDcdZoneXy	zonexyFocusCell = getCellZone( 
					posxyFocusCellColumnNumber.getX() , 
					posxyFocusCellColumnNumber.getY() ) ;
				point.x = zonexyFocusCell.getX().getPos() + zonexyFocusCell.getX().getSize() / 2 ;
				point.y = zonexyFocusCell.getY().getPos() + zonexyFocusCell.getY().getSize() / 2 ;
				ClientToScreen( &point ) ;
			}
		}
	}
	//point = ReLXgj[̕\ʒuB
	//	-1̏ꍇ́AReLXgj[͕\ł܂B

	if ( iMenuIndex >= 0 && point.x >= 0 &&  point.y >= 0 )
	{
		CMenu	aMenu ;
		aMenu.LoadMenu( IDR_MENU_JIKOKUHYOUVIEW_CONTEXT ) ;
		CMenu* pContextMenu = aMenu.GetSubMenu( iMenuIndex ) ;
	
		pContextMenu->TrackPopupMenu( 
			TPM_LEFTALIGN | TPM_RIGHTBUTTON ,
			point.x , point.y , 
			AfxGetMainWnd() ) ;	//	this w肷ƁAAppDocView 
								//R}h`F[삵܂B
	}
	else
	{
		super::OnContextMenu(pWnd, point);
	}
}

void CWndJikokuhyou::OnEditCut() 
{
	m_StateMachine.getCurrentState()->
		OnEditCut_Process( FALSE )  ;

}

void CWndJikokuhyou::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnEditCut_Process( TRUE ) >= 0 );
}

void CWndJikokuhyou::OnEditCopy() 
{
	m_StateMachine.getCurrentState()->
		OnEditCopy_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnEditCopy_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnEditPaste() 
{
	m_StateMachine.getCurrentState()->
		OnEditPaste_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnEditPaste_Process( TRUE ) >= 0 ) ;
}
void CWndJikokuhyou::OnEditClear() 
{
	m_StateMachine.getCurrentState()->
		OnEditClear_Process( FALSE ) ;

}

void CWndJikokuhyou::OnUpdateEditClear(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnEditClear_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnEditPasteEkiJikoku() 
{
	m_StateMachine.getCurrentState()->
		OnEditPasteEkiJikoku_Process( FALSE ) ;

	
}

void CWndJikokuhyou::OnUpdateEditPasteEkiJikoku(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnEditPasteEkiJikoku_Process( TRUE ) >= 0 ) ;
	
}

void CWndJikokuhyou::OnEditSelectAll()
{
	m_StateMachine.getCurrentState()->
		OnEditSelectAll_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateEditSelectAll(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnEditSelectAll_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouRessyaProp() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouRessyaProp_Process( FALSE ) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouRessyaProp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouRessyaProp_Process( TRUE )  >= 0 ) ;
	
}

void CWndJikokuhyou::OnJikokuhyouRessyaInsert() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouRessyaInsert_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouRessyaInsert(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouRessyaInsert_Process( TRUE )  >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouTsuuka() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouTsuuka_Process(FALSE) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouTsuuka(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouTsuuka_Process( TRUE )  >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouKeiyunasi() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouKeiyunasi_Process(FALSE) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouKeiyunasi(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouKeiyunasi_Process( TRUE )  >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouSihatsu() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouSihatsu_Process(FALSE) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouSihatsu(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouSihatsu_Process( TRUE )  >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouSyuuchaku() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouSyuuchaku_Process(FALSE) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouSyuuchaku(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouSyuuchaku_Process( TRUE )  >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouRenzoku() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouRenzoku_Process( FALSE ) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouRenzoku(CCmdUI* pCmdUI) 
{
	int iResult = m_StateMachine.getCurrentState()->
		OnJikokuhyouRenzoku_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ) ; 
	pCmdUI->SetCheck( iResult > 0 ) ; 
}

void CWndJikokuhyou::OnJikokuhyouViewProp() 
{
	OnJikokuhyouViewProp_Process( FALSE ) ;
}



void CWndJikokuhyou::OnUpdateINDICATOR_PasteZoubun(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(); 
	pCmdUI->SetText( OnUpdateINDICATOR_PasteZoubun_Process() ) ;
}



void CWndJikokuhyou::OnJikokuhyouFocusMoveDown() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouFocusMoveDown_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouFocusMoveDown(CCmdUI* pCmdUI) 
{
	int iResult = m_StateMachine.getCurrentState()
		->OnJikokuhyouFocusMoveDown_Process( TRUE ) ;
	//iResult = 
	//	-	1 ;	//	(bQueryEnable=TRUȄꍇ)̍ڂ͂łɑIĂ܂
	//	-	0 ;	//	(bQueryEnable=TRUȄꍇ)̍ڂ͑IĂ܂
	//	-  -1 ;	//	̃R}h͑Ił܂(j[)
	pCmdUI->Enable( iResult >= 0 );
	pCmdUI->SetCheck( iResult > 0 );
}

void CWndJikokuhyou::OnJikokuhyouFocusMoveRight() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouFocusMoveRight_Process( FALSE ) ;

}

void CWndJikokuhyou::OnUpdateJikokuhyouFocusMoveRight(CCmdUI* pCmdUI) 
{
	int iResult = m_StateMachine.getCurrentState()
		->OnJikokuhyouFocusMoveRight_Process( TRUE ) ;
	//iResult = 
	//	-	1 ;	//	(bQueryEnable=TRUȄꍇ)̍ڂ͂łɑIĂ܂
	//	-	0 ;	//	(bQueryEnable=TRUȄꍇ)̍ڂ͑IĂ܂
	//	-  -1 ;	//	̃R}h͑Ił܂(j[)
	pCmdUI->Enable( iResult >= 0 );
	pCmdUI->SetCheck( iResult > 0 );
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuProp() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuProp_Process( FALSE ) ;

}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuProp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuProp_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouJikokuSakujo() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouJikokuSakujo_Process( FALSE ) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouJikokuSakujo(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouJikokuSakujo_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuInsert() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuInsert_Process( FALSE ) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuInsert(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuInsert_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuErase() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuErase_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuErase(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuErase_Process( TRUE ) >= 0 ) ;
}


void CWndJikokuhyou::OnJikokuhyouModifyEkijikokuCmd() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouModifyEkijikokuCmd_Process( FALSE ) ;
	
}

void CWndJikokuhyou::OnUpdateJikokuhyouModifyEkijikokuCmd(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouModifyEkijikokuCmd_Process( TRUE ) >= 0 ) ;
	
}

void CWndJikokuhyou::OnJikokuhyouModifyEkijikokuCmdRepeat() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouModifyEkijikokuCmdRepeat_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouModifyEkijikokuCmdRepeat(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouModifyEkijikokuCmdRepeat_Process( TRUE ) >= 0 ) ;
}


void CWndJikokuhyou::OnJikokuhyouEkijikokuDec() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDec_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuDec(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDec_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuNext() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuNext_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuNext(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuNext_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuInc() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuInc_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuInc(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuInc_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokudecnomove()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDecNoMove_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokudecnomove(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDecNoMove_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuincnomove()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuIncNoMove_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuincnomove(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuIncNoMove_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEkijikokuPrev()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuPrev_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuPrev(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuPrev_Process( TRUE ) >= 0 ) ;
}


//add_by_d_mania
void CWndJikokuhyou::OnJikokuhyouEkijikokuincAnysecnomove()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuIncAnySecNoMove_Process( FALSE ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuincAnysecnomove(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuIncAnySecNoMove_Process( TRUE ) >= 0 ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnJikokuhyouEkijikokudecAnysecnomove()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDecAnySecNoMove_Process( FALSE ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokudecAnysecnomove(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDecAnySecNoMove_Process( TRUE ) >= 0 ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnJikokuhyouEkijikokuincAny2secnomove()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuIncAny2SecNoMove_Process( FALSE ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuincAny2secnomove(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuIncAny2SecNoMove_Process( TRUE ) >= 0 ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnJikokuhyouEkijikokudecAny2secnomove()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDecAny2SecNoMove_Process( FALSE ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokudecAny2secnomove(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuDecAny2SecNoMove_Process( TRUE ) >= 0 ) ;
}

//add_by_d_mania 17.4.19
void CWndJikokuhyou::OnJikokuhyouEkijikokuAdjustStdOpeTime()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuAdjustStdOpeTime_Process( FALSE ) ;
}

//add_by_d_mania 17.4.19
void CWndJikokuhyou::OnUpdateJikokuhyouEkijikokuAdjustStdOpeTime(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEkijikokuAdjustStdOpeTime_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouEKikanSaisyouSec() 
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouEKikanSaisyouSec_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouEKikanSaisyouSec(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouEKikanSaisyouSec_Process( TRUE ) >= 0 );
}

void CWndJikokuhyou::OnJikokuhyouSort()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouSort_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouSort(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouSort_Process( TRUE ) >= 0 );
}

void CWndJikokuhyou::OnJikokuhyouDiagramHeIdou() 
{
	OnJikokuhyouDiagramHeIdou_Process( FALSE ) ;
}
void CWndJikokuhyou::OnUpdateJikokuhyouDiagramHeIdou(CCmdUI* pCmdUI) 
{
	int iResult = OnJikokuhyouDiagramHeIdou_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ? TRUE : FALSE ) ;
}

void CWndJikokuhyou::OnVIEWDisplayTsuukaEkiJikoku() 
{
	OnVIEWDisplayTsuukaEkiJikoku_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateVIEWDisplayTsuukaEkiJikoku(CCmdUI* pCmdUI) 
{
	int iResult = OnVIEWDisplayTsuukaEkiJikoku_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ? TRUE : FALSE ) ;
	pCmdUI->SetCheck( iResult >= 1 ? TRUE : FALSE ) ;
	
}

//TODO:OnUpdate... nhǉ
void CWndJikokuhyou::OnFileExportJikokuhyoucsv() 
{
	OnFileExportJikokuhyoucsv_Process( FALSE ) ;
}

//TODO:OnUpdate... nhǉ
void CWndJikokuhyou::OnFileImportJikokuhyoucsv() 
{
	OnFileImportJikokuhyoucsv_Process( FALSE ) ;
}


void CWndJikokuhyou::OnJikokuhyouTsuukateisya()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouTsuukateisya_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouTsuukateisya(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouTsuukateisya_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouDirect()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouDirect_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouDirect(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouDirect_Process( TRUE ) >= 0 ) ;
}

void CWndJikokuhyou::OnJikokuhyouUndirect()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouUndirect_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouUndirect(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( m_StateMachine.getCurrentState()->
		OnJikokuhyouUndirect_Process( TRUE ) >= 0 ) ;
}



void CWndJikokuhyou::OnViewDisplayallekijikoku()
{
	OnViewDisplayallekijikoku_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateViewDisplayallekijikoku(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplayallekijikoku_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ) ;
	pCmdUI->SetCheck( iResult >= 1 ) ;
}

void CWndJikokuhyou::OnJikokuhyouUnify()
{
	m_StateMachine.getCurrentState()->
		OnJikokuhyouUnify_Process( FALSE ) ;
}

void CWndJikokuhyou::OnUpdateJikokuhyouUnify(CCmdUI *pCmdUI)
{
	int iResult = m_StateMachine.getCurrentState()->
		OnJikokuhyouUnify_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnViewDisplaySecondEkijikoku()
{
	OnViewDisplaySecondEkijikoku_Process( FALSE ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnUpdateViewDisplaySecondEkijikoku(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplaySecondEkijikoku_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ) ;
	pCmdUI->SetCheck( iResult >= 1 ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnViewStandardOperationTimeFunction()
{
	OnViewStandardOperationTimeFunction_Process( FALSE ) ;
}

//add_by_d_mania
void CWndJikokuhyou::OnUpdateViewStandardOperationTimeFunction(CCmdUI *pCmdUI)
{
	int iResult = OnViewStandardOperationTimeFunction_Process( TRUE ) ;
	pCmdUI->Enable( iResult >= 0 ) ;
	pCmdUI->SetCheck( iResult >= 1 ) ;
}
} } // namespace WndJikokuhyou namespace ViewJikokuhyou

