/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgRosenFileProp_Diagram.cpp : Cve[V t@C
//

#include "stdafx.h"


#include "str/CStrCharSizeMb.h"

#include "..\DiagramEdit.h"
#include "CDlgRosenFileProp.h"
#include "CDlgRosenFileProp_Diagram.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewRosen{

/** ̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	false ,		//	NoColon 
	CdDedJikoku::CConv::EHour_Zero ,	//  00  09 ̏ꍇA10̈ʂ "0" Ƃ܂
	CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B 
	) ;

/////////////////////////////////////////////////////////////////////////////
// CDlgRosenFileProp_Diagram _CAO
// --------------------------------
//	֐
// --------------------------------
CDlgRosenFileProp* CDlgRosenFileProp_Diagram::GetParent() 
{
	return static_cast<CDlgRosenFileProp*>( CWnd::GetParent() ) ;
}

void CDlgRosenFileProp_Diagram::updateUIState() 
{
}
	
// ********************************
//	CDlgRosenFileProp_Diagram
// ********************************
void CDlgRosenFileProp_Diagram::updateUI()
{
	CDlgRosenFileProp::CPropEditorData* pPropEditorData = GetParent()->getPropEditorData() ;

	m_strEDIT_DoagramKitenJikoku = 
		g_CdDedJikokuConv.encode( pPropEditorData->getUIKitenJikoku() ).c_str() ;
	m_iEDIT_DiagramDgrYZahyouKyoriDefault = 
		pPropEditorData->getUIDiagramDgrYZahyouKyoriDefault() / 60  ;

	UpdateData( FALSE ) ;
}
int CDlgRosenFileProp_Diagram::updatePropEditorData()
{
	CDlgRosenFileProp::CPropEditorData* pPropEditorData = GetParent()->getPropEditorData() ;
	int	iRv = 0 ;
	if ( iRv >= 0 )
	{
		if ( !UpdateData() )
		{
			iRv = -1 ;
		}
	}
	CdDedJikoku	jikokuKitenJikoku ;
	if ( iRv >= 0 )
	{
		if ( jikokuKitenJikoku.decode( 
				CStrCharSizeMb::strToSingleByte( (LPCTSTR)m_strEDIT_DoagramKitenJikoku ) ) < 0 )
		{
			iRv = -11 ;	//	_CON_sł
		}
	}
	//jikokuKitenJikoku = _CON_
	if ( iRv >= 0 )
	{
		pPropEditorData->setUIKitenJikoku( jikokuKitenJikoku ) ; 
		pPropEditorData->setUIDiagramDgrYZahyouKyoriDefault( 
			m_iEDIT_DiagramDgrYZahyouKyoriDefault * 60 );
	}
	// --------------------------------
	if ( iRv < 0 )
	{
		CString	strError ;
		switch( iRv )
		{
		 case -11 :	
			GetDlgItem( IDC_STATIC_ERROR_KitenJikoku )->GetWindowText( strError ) ;
			break ;
		}
		if ( !strError.IsEmpty() )
		{
			MessageBox( strError , NULL ,  MB_OK | MB_ICONEXCLAMATION ) ;
		}
	}


	return iRv ;	
}


// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------

CDlgRosenFileProp_Diagram::CDlgRosenFileProp_Diagram(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRosenFileProp_Diagram::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgRosenFileProp_Diagram)
	m_strEDIT_DoagramKitenJikoku = _T("");
	m_iEDIT_DiagramDgrYZahyouKyoriDefault = 0;
	//}}AFX_DATA_INIT
}


void CDlgRosenFileProp_Diagram::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRosenFileProp_Diagram)
	DDX_Text(pDX, IDC_EDIT_DiagramKitenJikoku, m_strEDIT_DoagramKitenJikoku);
	DDX_Text(pDX, IDC_EDIT_DiagramDgrYZahyouKyoriDefault, m_iEDIT_DiagramDgrYZahyouKyoriDefault);
	DDV_MinMaxInt(pDX, m_iEDIT_DiagramDgrYZahyouKyoriDefault, 1, 30);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgRosenFileProp_Diagram, CDialog)
	//{{AFX_MSG_MAP(CDlgRosenFileProp_Diagram)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgRosenFileProp_Diagram bZ[W nh

BOOL CDlgRosenFileProp_Diagram::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// --------------------------------
	updateUIState() ;
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgRosenFileProp_Diagram::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
}
} //namespace ViewRosen
