/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDia.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedDia_h
#define  CentDedDia_h

#include <deque>

#include "CentDed.h"
#include "CentDedRessya.h"
#include "CentDedRessyaCont.h"

namespace entDed{

class CentDedEkiCont ;

// ****************************************************************
//	CentDedDia
// ****************************************************************
/**
@brief
 DiagramEdit ́AHŐݒ肳Ăw_CxP\܂B

̃NX̃CX^X́Aʏ́wHx ( CentDedRosen ) ɕ
܂B

ۂɂ́A

- wHx (CentDedRosen) w_Cx ( CentDedDia ) 
Oȏ㕡
- ew_Cx ( CentDedDia ) wԁx (CentDedRessya ) 
Oȏ㕡

Ƃ֌WɂȂĂ܂B

  ̃NX́Awԁx ( CentDedRessya ) AE̕ʂ
ێ܂B

@̃NX́AƂāww̐xEwԎʐxێ܂B
A͔hƂȂĂ܂B

<h5>int EkiCount</h5>
̃_Cɑ݂ww̐xłB
̑́A m_CentDedRessyaCont[]->m_iEkiCount ƂɌ܂܂B

<h5>int RessyasyubetsuCount</h5>
wԎʐxBԎʂ̎ނ̐łB
̑́A m_CentDedRessyaCont[]->m_iRessyasyubetsuCount Ƃ
܂܂B


 -------------------------------- 

̃G[EC
 -------------------------------- 


㏑(operator=): ̃IuWFNgeIuWFNg CentDedDiaCont ̎qłꍇŁÃ_C󕶎łꍇA͓Õ_C CentDedDiaCont ɂꍇ͗OX[B
@(ACentDedDiaCont::set()ɓnƃG[ɂȂ悤ȃIuWFNgłꍇ́A͗OX[Ƃ܂)

setName:̃IuWFNgeIuWFNg CentDedDiaCont ̎qłꍇŁÃ_C󕶎łꍇA͓Õ_C CentDedDiaCont ɂꍇ͗OX[Ƃ܂B
@(ύX̃IuWFNgACentDedDiaCont::set()ɓnƃG[ɂȂ悤ȃIuWFNgłꍇ́AG[Ƃ܂)

setParent:adjusts

 ɍ悤ɑC(adjust)
 -------------------------------- 

ԃRei(CentDedRessyaCont)adjust()Ϗ܂B


*/
class CentDedDia : public CChildBase
{
	typedef CChildBase	super ;
public:
	// ****************************************************************
	//	Ci[^Cv
	// ****************************************************************
	/**
	@CentDedDia ɕ܂ĂwԁxReiłB
	*/
	class CXRessyaCont : public CentDedRessyaCont
	{
		typedef CentDedRessyaCont super ;
	 public:
		// ********************************
		///@name ֘A
		// ********************************
		///@{
		/**
			eIuWFNgւ̃|C^łBRXgN^Ō܂܂B
		*/
		CentDedDia* m_pDia ;
	public:
		// ********************************
		//	RXgN^
		// ********************************
		CXRessyaCont( 
			CentDedDia* pCentDedDia , 
			ERessyahoukou m_eRessyahoukou ) 
			: 
			super( 0 ,
				m_eRessyahoukou ) ,
		  	m_pDia( pCentDedDia )
		{}
		CXRessyaCont( 
			CentDedDia* pCentDedDia , 
			int iEkiCount ,
			ERessyahoukou m_eRessyahoukou ) 
			: 
			super( iEkiCount ,
				m_eRessyahoukou ) ,
		  	m_pDia( pCentDedDia )
		{}


		CXRessyaCont( 
			CentDedDia* pCentDedDia , 
			const CentDedRessyaCont& value )
			: 
			super( value ) ,
		  	m_pDia( pCentDedDia )
		{}

	 public:
		// ********************************
		///@name CentDedRessyaCont-֘A
		// ********************************
		///@{
		/**
		@return
			̃Rei CentDedDia ɕ܂Ăꍇ́A
			CentDedDia ̃AhXB
			łȂȂNULLB
		*/
		virtual CentDedDia* getDia(){ return m_pDia ;}
		/**
		@return
			̃Rei CentDedRessya ɕ܂Ăꍇ́A
			CentDedRessya ̃AhXB
			łȂȂNULLB
		*/
		virtual const CentDedDia* getDia()const{ return m_pDia ;}
	};
	/**
		ZqAset...() ŃX[OłB
	*/
	class LException
	{
	};


	// ****************************************************************
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	  	_Ĉ̖łB
	  
	  	ij "_C" Ȃ
	  
	   @see CentDedRosen
	  	 CentDedRosen ́ȂqƂĈ܂B
	  	CentDedRosen ɕ܂ CentDedDia ł́A
	  	͈̑ӂłȂĂ͂Ȃ܂B
	 */
	std::string	m_strName ;
	///@}
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		́w_Cxŉ^sĂԂ
		wԁx ( CentDedRessya ) ێ܂B
	
		̕ϐ́Avf 2 ̔złB

		- [0] 	 ( Ressyahoukou_Kudari ) 	
		- [1] 	 ( Ressyahoukou_Nobori ) 	
	
		̃Rei CentDedRessya IuWFNg
		Ej̐Ӗthisɂ܂B
	
		Ԃł́Avf 0 ƂȂ܂B
	*/
	CXRessyaCont*	m_CentDedRessyaCont[2] ;
	
	///@}


public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	   @param strName [in]
	  	_Ĉ̖łB	\n
	  	ij "_C" Ȃ
	*/
	CentDedDia( const string& strName = "" ) ;

	/**
	  	̃RXgN^́A 
	  	CentDedDia_From_CdConnectedString() 
	  	t@C̓e擾ƂɁA
	  	ǂݎƂĎw肷IuWFNg̐Ɏg܂B
	   @param iEkiCount [in]
	  	_CɊ܂܂w̐B
	 */
	CentDedDia( int iEkiCount ) ;

	/**
	   @param strName [in]
	  	_Ĉ̖łB	\n
	  	ij "_C" Ȃ
	   @param iEkiCount [in]]
	  	_CɊ܂܂w̐B
	 */
	CentDedDia( 
		const std::string& strName  ,
		int iEkiCount ) ;


	CentDedDia( const CentDedDia& value );
	
	/**
	  	̃NXւ̑s܂A
	  	this ́wwx̐ ( m_iEkiCount ) ͕ύX܂B
	  
		㏑(operator=): ̃IuWFNgeIuWFNg CentDedDiaCont 
		̎qłꍇŁÃ_C󕶎łꍇA
		͓Õ_C CentDedDiaCont ɂꍇ͗OX[B
		@(ACentDedDiaCont::set()ɓnƃG[ɂȂ悤
		@IuWFNgłꍇ́A͗OX[Ƃ܂)

	 */
	CentDedDia& operator=( const CentDedDia& value );

	virtual ~CentDedDia();

public:
	// ********************************
	///@name CChildBase-
	// ********************************
	///@{
	/**
	@setParent:adjusts
	*/
	virtual void setParent( CParentBase* pParent );
	///@}
public:
	// ********************************
	///@name CentDedDia-
	// ********************************
	///@{
	std::string	getName()const{	return m_strName ;};
	
	/**
	setName:̃IuWFNgeIuWFNg CentDedDiaCont ̎qł
	ꍇŁÃ_C󕶎łꍇA͓Õ_C
	 CentDedDiaCont ɂꍇ͗OX[Ƃ܂B
	@(ύX̃IuWFNgACentDedDiaCont::set()ɓnƃG[
	@Ȃ悤ȃIuWFNgłꍇ́AG[Ƃ܂)
	*/
	void setName( const std::string& value );

	int getEkiCount()const
	{
		return m_CentDedRessyaCont[ Ressyahoukou_Kudari ]->
			getEkiCount() ;
	};
	///@}
	// ********************************
	///@name CentDedDia-
	// ********************************
	///@{
	/**
	   @param eRessyahoukou [in]
	  	ԕw肵ĂB
	  	-	 :	Ressyahoukou_Kudari 
	  	-	 : 	Ressyahoukou_Nobori 
	 */
	CentDedRessyaCont* getCentDedRessyaCont( 
			ERessyahoukou eRessyahoukou )
	{
		return m_CentDedRessyaCont[ eRessyahoukou ] ;
	};
	/**
	   @param eRessyahoukou [in]
	  	ԕw肵ĂB
	  	-	 :	Ressyahoukou_Kudari 
	  	-	 : 	Ressyahoukou_Nobori 
	 */
	const CentDedRessyaCont* getCentDedRessyaCont( 
			ERessyahoukou eRessyahoukou )const
	{
		return m_CentDedRessyaCont[ eRessyahoukou ] ;
	};
	///@}
	// ********************************
	///@name CentDedDia-
	// ********************************
	///@{

	/**
		w̉w Order ̉wA
		w`EnEIɍ킹ĕύX܂B

		ύXéA CentDedEkiJikoku::adjustByEkijikokukeisiki 
		̐QƂĂB

	@see CentDedEkiJikoku::adjustByEkijikokukeisiki 

	@param pCentDedEkiCont [in]
		wReiw肵ĂB
	@param iEkiIndex [in]
		wIndexw肵ĂB
		INT_MAX ́Aw肵ƂɂȂ܂B
	*/
	void adjustByEkijikokukeisiki(
		const CentDedEkiCont* pCentDedEkiCont ,
		int iEkiIndex );
	///@}

	/**
		this ̑ɔĂꍇAɍ悤ɁA
		C܂B

		ԃRei(CentDedRessyaCont)adjust()Ϗ܂B

	*/
	void adjust() ;

public:
	// ********************************
	///@name CentDedDia-wEԎʐ̕ύX
	// ********************************
	///@{

	/**
	  	̃ReiɁAw肳ꂽwԎʁx̗Ԃ邩ۂ𒲂ׂ܂B
	   @param iRessyasyubetsuIndex [in]
	  	wԎIndexxw肵ĂB
	  	͈͂́A 0 ȏ Ԏʂ̐łB
	  	INT_MAX ́A̗Ԏʂw肵̂Ƃ݂Ȃ܂B
	   @param peRessyahoukou [out]
	  	̊֐͂̕ϐɁAwԎʁx̗Ԃ
	  	_C̗ԕ݂܂B
	  	svȂ NULL ł܂܂B
	   @param piRessyaIndex [out]
	  	̊֐͂̕ϐɁAwԎʁx̗Ԃ
	  	Index ݂܂B
	  	svȂ NULL ł܂܂B
	   @return 
	  	-	1; //	w̗Ԏʂ̗Ԃ݂܂B
	  	-	0; //	w̗Ԏʂ̗Ԃ݂͑܂B
	  	-	-1 ;	//	CfNXs
	 */
	int isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		ERessyahoukou* peRessyahoukou ,
		int* piRessyaIndex ) const ;

	///@}
public:
	// ********************************
	///@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
	///@{
	/**
		m_CentDedEkiCont  CentDedEki ǉꂽA
		m_CentDedEkiCont Ăяo܂B
	@param iEkiIndex
		ǉꂽ CentDedEki ̃CfNXB
	*/
	virtual void onEkiInsert( int iEkiIndex );

	/**
		m_CentDedEkiCont  CentDedEki 폜ꂽA
		m_CentDedEkiCont Ăяo܂B
	@param iEkiIndex
		폜ꂽ CentDedEki ̃CfNXB
	*/
	virtual void onEkiErase( int iEkiIndex  );

	/**
		CentDedEkiTrackCont  CentDedEkiTrack ǉꂽA
		CentDedEkiTrackCont Ăяo܂B
	@param iEkiIndex
		CentDedEkiTrackCont ǉꂽ CentDedEki ̉wIndexB
	@param iEkiTrackIndex
		ǉꂽ CentDedEkiTrack ̃CfNXB
	*/
	virtual void onEkiTrackInsert( int iEkiIndex , int iEkiTrackIndex );

	/**
		CentDedEkiTrackCont  CentDedEkiTrack 폜ꂽA
		CentDedEkiTrackCont Ăяo܂B
	@param iEkiIndex
		CentDedEkiTrackCont 폜ꂽ CentDedEki ̉wIndexB
	@param iEkiTrackIndex
		폜ꂽ CentDedEkiTrack ̐擪̃CfNXB
	*/
	virtual void onEkiTrackErase( int iEkiIndex , int iEkiTrackIndex );

	/**
		CentDedRessyasyubetsuCont  CentDedRessyasyubetsu ǉꂽA
		CentDedRessyasyubetsuCont Ăяo܂B
	@param iRessyasyubetsuIndex
		ǉꂽ CentDedRessyasyubetsu  ̃CfNXB
	*/
	virtual void onRessyasyubetsuInsert( int iRessyasyubetsuIndex );

	/**
		CentDedRessyasyubetsuCont  CentDedRessyasyubetsu 폜ꂽA
		CentDedRessyasyubetsuCont Ăяo܂B
	@param iRessyasyubetsuIndex
		폜ꂽ CentDedRessyasyubetsu  ̃CfNXB
	*/
	virtual void onRessyasyubetsuErase( int iRessyasyubetsuIndex );



	///@}
};

} //namespace entDed

#endif /*CentDedDia_h*/


