/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyasyubetsuCont.cpp
// ****************************************************************
*/
#include "stdafx.h"
#include "CentDedRessyasyubetsuCont.h"
#include "CentDedRosen.h"

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

namespace entDed{

// ****************************************************************
//	CentDedRessyasyubetsuCont
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CentDedRessyasyubetsuCont::CentDedRessyasyubetsuCont() 
{
}
CentDedRessyasyubetsuCont& 
CentDedRessyasyubetsuCont::operator=( const CentDedRessyasyubetsuCont& value ) 
{
	//	Reȋ(operator=):ReiḦꕔłꍇŁAEӂ̗vf0̏ꍇ́A
	//	CfNX0Ԃ̗ԎʂǉāAԎʂ̐0ɂȂȂ悤ɂ
	if ( value.size() == 0 && getRosen() != NULL )
	{
		insert( CentDedRessyasyubetsu( "00" , "" ) ) ;
		erase( 1 , INT_MAX ) ; 
	}
	else
	{
		super::operator=( value ) ; 
	}
	return *this ;
}

	// ********************************
	///@name Mui
	// ********************************
int CentDedRessyasyubetsuCont::insert( const CentDedRessyasyubetsu& element , int iIndex )
{
	int iRv = 0 ; 
	if ( iIndex == INT_MAX )
	{
		iIndex = size() ;
	}

	//rinji
	//	Ԏʂ̒ǉ(insert):̃ReiḦꕔłꍇAO̗Ԏʂ̒ǉ̓G[
	if ( getRosen() != NULL && element.getSyubetsumei().length() == 0 )
	{
		iRv = -11 ;	//	name CentDedRessyasyubetsu㏑ƃG[B
	}
	if ( iRv >= 0 )
	{
		iRv = super::insert( element , iIndex ) ; 
	}
	//	  ̃Rei CentDedRosen ɕ܂ĂꍇA insert() 
	//	\bh́ACentDedRosen::onRessyasyubetsuInsert( iEkiIndex ) 
	//	ɏϏ܂B
	if ( iRv >= 0 )
	{
		CentDedRosen* pRosen = getRosen() ;
		if ( pRosen != NULL )
		{
			pRosen->onRessyasyubetsuInsert( iIndex ) ; 
		}
	}

	return iRv ;
}

int CentDedRessyasyubetsuCont::erase( int iIndex  , int iSize ) 
{
	int iRv = 0 ; 

	if ( iIndex == INT_MAX && iSize != INT_MAX )
	{
		iIndex = size() - iSize ;
	}
	else if ( iIndex != INT_MAX && iSize == INT_MAX )
	{
		iSize = size() - iIndex ;
	}
	// --------------------------------	
	if ( !( 0 <= iIndex && iIndex + iSize <= size() ) )
	{
		iRv = -1 ;	//	CfNX͈͊OłB
	}
	if ( iRv >= 0 )
	{
		if ( size() <= iSize && getRosen() != NULL )
		{
			iRv = -11 ;	//	Ԏʂ̍폜(erase):@Ԏʂ0ɂȂ悤ȍ폜̓G[

		}
	}
	if ( iRv >= 0 )
	{
		iRv = super::erase( iIndex , iSize ) ;
	}
	//	  ̃Rei  CentDedRosen ɕ܂ĂꍇA erase() 
	//	\bh́ACentDedRosen::onEkiErase( iEkiIndex )
	//	ɏϏ܂B
	if ( iRv >= 0 )
	{
		CentDedRosen* pRosen = getRosen() ;
		if ( pRosen != NULL )
		{
			for ( int idx = iIndex + iSize - 1 ; idx >= iIndex ; idx-- )
			{
				pRosen->onRessyasyubetsuErase( idx ) ; 
			}
		}
	}

	return iRv ;
}
int CentDedRessyasyubetsuCont::set( const CentDedRessyasyubetsu& element , int iIndex ) 
{
	int iRv = setable( element , iIndex ) ;
	if ( iRv < 0 )
	{
		return iRv ;
	}
	return super::set( element , iIndex ) ;
}

	// ********************************
	//@name CentDedRessyasyubetsuCont-
	// ********************************
int CentDedRessyasyubetsuCont::setable(  const CentDedRessyasyubetsu& element , int iIndex )const 
{
	int iRv = 0 ;
	if ( iIndex == INT_MAX )
	{
		iIndex = size() - 1 ;
	}

	if ( element.getSyubetsumei().length() == 0 )
	{
		//Ԑ̏㏑(set): name CentDedRessyasyubetsu㏑ƃG[B
		iRv = -11 ;	//	
	}

	return iRv ;
}

int CentDedRessyasyubetsuCont::getIndex( const CentDedRessyasyubetsu* element )const 
{
	const Mu<const CentDedRessyasyubetsu*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		if ( pMu->get( idx ) == element ){	return idx ;}
	}
	return -1 ;
}

int CentDedRessyasyubetsuCont::isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		int* piDiaIndex ,
		ERessyahoukou* peRessyahoukou ,
		int* piRessyaIndex ) const 
{
	const CentDedRosen* pRosen = getRosen() ;
	if ( pRosen  != NULL )
	{
		return pRosen->getCentDedDiaCont()->isExistRessyaOfRessyasyubetsu(
			iRessyasyubetsuIndex , 
			piDiaIndex , 
			peRessyahoukou , 
			piRessyaIndex ) ;
	}
	return 0 ;
}



} //namespace entDed

