/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdBrushProp.h
// ****************************************************************
*/
/** @file */
#ifndef  CdBrushProp_h
#define  CdBrushProp_h
#include "CdColorProp.h"

namespace DcDrawLib{
namespace DcdCd{
namespace DcDrawProp{

// ****************************************************************
//	CdBrushProp
// ****************************************************************
/**
* @brief
* yTvz
*  uV̑ێPf[^NXłB

*	   CConverter_WinGdi NXgpƁALOGBRUSH\̂Ƃ̊Ԃőݕϊ
*	AuVnh𐶐ł܂B
*/
class CdBrushProp
{
// ********************************
///@name	Ci[^Cv
// ********************************
///@{
 public:
	enum EStyle
	{
		/** F̃uVB 	*/
		SOLID ,

		/** Eւ 45 x̃nb` */
		HATCHED_BDIAGONAL ,
		
		/** Åiq̃nb`	*/
		HATCHED_CROSS ,

		/** 45 x̊iq̃nb`	*/
		HATCHED_DIAGCROSS ,

		/** ォEւ 45 x̃nb`	*/
		HATCHED_FDIAGONAL ,

		/** ̃nb`	*/
		HATCHED_HORIZONTAL ,

		/** ̃nb`	*/
		HATCHED_VERTICAL ,

		/** ̃uVBȂɂ`悵܂B	*/
		NULLBRUSH ,
	};
///@}
// ********************************
///@name	
// ********************************
///@{
 private:
	/**
	*	uV̐FłB
	*	ftHg͍łB
	*/
	CdColorProp m_colorrefColor;
	
	/**	
	*	`BftHǵANULLBRUSH łB
	*/
	EStyle	m_eStyle	;
	
///@}
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	*	uV̐Fƌ`w肵܂B
	* @param colorrefColor
	*	uV̐Fł
	* @param eStyle	
	*	`BftHǵASOLID łB
	*/
	CdBrushProp( CdColorProp colorrefColor , 
				EStyle	eStyle = SOLID ) 
		: m_colorrefColor( colorrefColor ) 
		, m_eStyle( eStyle ){} ;
	
	CdBrushProp() : 
		m_colorrefColor( CdColorProp( 0 , 0 , 0 ) ) ,
		m_eStyle( NULLBRUSH ) {};
	

// ********************************
//	CdBrushProp
// ********************************
 public:
	// ********************************
	///@name	
	// ********************************
	///@{
	CdColorProp getColor()const{	return m_colorrefColor ; } ;
	CdBrushProp& setColor( CdColorProp ev ){
		m_colorrefColor = ev ;	return *this ; } ;
	
	EStyle getStyle()const{	return m_eStyle ; } ;
	CdBrushProp& setStyle( EStyle ev ){
		m_eStyle = ev ;	return *this ; } ;

	/**
	 *	2̃IuWFNg̊eǂ𔻒肵܂B
	 * @param value [in]
	 *	ȓΏۂƂȂIuWFNgw肵ĂB
	 * @return 
	 *	value  *this Ƃ̊ԂŁAׂĂ̑ΐ^łB
	 */
	bool isEqualTo( const CdBrushProp& value )const{
		return ( 
			m_colorrefColor == value.m_colorrefColor && 
			m_eStyle == value.m_eStyle );
	};
	/**
	 *	isEqualTo() ƓłB
	 */
	bool operator==( const CdBrushProp& value )const{
		return ( isEqualTo( value ) ) ;
	};	
	bool operator!=( const CdBrushProp& value )const{
		return ( !isEqualTo( value ) ) ;
	};	
	///@}
	/**
	 *	this  b 
	 *	iOɂȂjȂ^łB
	 * @param b [in]
	 *	ȓΏۂƂȂIuWFNgw肵ĂB
	 * @return 
	 *	this  b 
	 *	iOɂȂjȂ^łB
	 */
	bool  less( const CdBrushProp& value )const{
		if ( m_colorrefColor != value.m_colorrefColor ){
			return ( m_colorrefColor < value.m_colorrefColor ) ; 
		}	else if ( m_eStyle != value.m_eStyle ){
			return ( m_eStyle < value.m_eStyle );
		}
		return ( false ) ;
	};
	/**
	 *	less() ƓłB
	 */
	bool operator<( const CdBrushProp& b )const{
		return less( b );
	};
	

};

} //namespace DcDrawProp
} //namespace DcdCd
} //namespace DcDrawLib

#endif /*CdBrushProp_h*/
