/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvDcdPosOnZone_PosOrgAndRate.cpp
// $Id: CconvDcdPosOnZone_PosOrgAndRate.cpp 313 2016-06-11 13:20:04Z okm $
// ****************************************************************
*/
/** @file */
#include "CconvDcdPosOnZone_PosOrgAndRate.h"


/** @page cconvdcdposonzone_posorgandrate CconvDcdPosOnZone_PosOrgAndRate ϊ

@W̕ϊɂ́AL̕ϊ2gpĂ܂B

ϊ1
  - Zone1̍W posZone1Pos
  - Zone2̍W posZone2Pos 
  ƂꍇA
  
@code
  posZone2Pos = (int)( (double)( posZone1Pos - Zone1Org ) * Zone2PerZone1 ) 
               + Zone2Org 
@endcode

  ()
  - Zone1Org=*
  - Zone2Org=0
  - Zone2PerZone1=1.5

  - Zone1Org=0
@code
  posZone1Pos  posZone2Pos
  
            0            0
            1      1.5 1
            2            3
            3      4.5 4
@endcode

  - Zone1Org=1
@code
  posZone1Pos  posZone2Pos
  
            0     -1.5-1
            1            0
            2      1.5 1
            3            3
@endcode

   @ref cconvdcdposonzone_posorgandrate_towindowscroll ɂ́A
   ̕ϊ͎g܂B
  LŎ悤ɁAposZone1Pos=1posZone1Pos=2̊Ԃ́AZone2ł̋ 
  Zone1Org ɂĕϓĂ܂܂B


ϊ2
  - Zone1̍W posZone1Pos
  - Zone2̍W posZone2Pos 
  ƂꍇA
  
@code
  posZone2Pos = (int)( (double)posZone1Pos * Zone2PerZone1 ) 
              - (int)( (double)Zone1Org  * Zone2PerZone1 )
	      + Zone2Org 
@endcode

  ()
  - Zone1Org=*
  - Zone2Org=0
  - Zone2PerZone1=1.5

  - Zone1Org=0
@code
  posZone1Pos  posZone2Pos
  
            0            0
            1      1.5 1
            2            3
            3      4.5 4
@endcode

  - Zone1Org=1
@code
  posZone1Pos                posZone2Pos
  
            0            0 -1=-1
            1      1.5 1 -1= 0
            2            3 -1= 2
            3      4.5 4 -1= 3
@endcode


   @ref cconvdcdposonzone_posorgandrate_towindowscroll ɂ́A
   ̕ϊLłB
  posZone1Pos=1posZone1Pos=2̊Ԃ́AZone2ł̋́A
  Zone1Org ̕ϓ̉e󂯂܂B
*/

namespace DcDrawLib{
namespace DcdCd{
namespace Pos{


// ****************************************************************
//	CconvDcdPosOnZone_PosOrgAndRate
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CconvDcdPosOnZone_PosOrgAndRate::CconvDcdPosOnZone_PosOrgAndRate( 
		DcdPos	posZone1Org , 
		DcdPos	posZone2Org ,
		double dZone2PerZone1 ) :
	m_posZone1Org( posZone1Org ) ,	
	m_posZone2Org( posZone2Org ) , 
	m_dZone2PerZone1( dZone2PerZone1 )
{
}

CconvDcdPosOnZone_PosOrgAndRate::CconvDcdPosOnZone_PosOrgAndRate() :
	m_posZone1Org( 0 ) ,	
	m_posZone2Org( 0 ) , 
	m_dZone2PerZone1( 1.0 )
{
}

CconvDcdPosOnZone_PosOrgAndRate::~CconvDcdPosOnZone_PosOrgAndRate() 
{
}

// ********************************
//	CconvDcdPosOnZone_PosOrgAndRate
// ********************************
	
	// ********************************
	//@name 
	// ********************************
DcdPos CconvDcdPosOnZone_PosOrgAndRate::Zone1PosToZone2( DcdPos posZone1Pos )const 
{
	DcdPos posZone2Pos = (int)( (double)posZone1Pos * m_dZone2PerZone1 ) 
          - (int)( (double)m_posZone1Org  * m_dZone2PerZone1 )
	      + m_posZone2Org ;
	return ( posZone2Pos ) ;
}

DcdPos CconvDcdPosOnZone_PosOrgAndRate::Zone1PosFromZone2( DcdPos posZone2Pos )const 
{
	double	dZone1PerZone2 = 0.0 ;
	if ( m_dZone2PerZone1 != 0.0 )
	{
		dZone1PerZone2 = (double)1 / m_dZone2PerZone1 ;
	}
	DcdPos posZone1Pos = (int)( (double)posZone2Pos * dZone1PerZone2 ) 
			- (int)( (double)m_posZone2Org * dZone1PerZone2 )
			+ m_posZone1Org ;

	return ( posZone1Pos ) ;
}


} //namespace Pos
} //namespace DcdCd
} //namespace DcDrawLib


