/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdGridYColumn.h
// ****************************************************************
*/
/** @file */
#ifndef  CDcdGridYColumn_h
#define  CDcdGridYColumn_h
#include "DcDraw/IfDcDraw.h"
#include "DcdGrid/CDcdGridYBorder.h"
#include "NsOu/Ou.h"

namespace DcDrawLib{
namespace DcdGrid{

// ****************************************************************
//	CDcdGridYColumn
// ****************************************************************
/**
 @brief
 yTvz
	DcdGrid YIuWFNgłB
	IfDcDraw IuWFNgƊ֘A  IfDcDraw IuWFNgg
	Ỷ̋E`悵܂B

	CDcdGrid ́Aʏ CDcdLine IuWFNg𐶐āA
	this Ɗ֘A IfDcDraw IuWFNgƂēo^܂
 */
class CDcdGridYColumn
{
	friend class CDcdGrid ;
private:
	// ********************************
	/// @name 	CDcdGrid Ɋ֌W鑮/֘A
	// ********************************
	///@{
	/**
		̃IuWFNgێObhIuWFNgւ̃|C^łB
		RXgN^Ō܂܂B
		j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵAthisȂĂ͂Ȃ܂B
	*/
	CDcdGrid*	m_pCDcdGrid ;

	///@}	

private:
	// ********************************
	///	@name W
	// ********************************
	///@{
	/**
		Ỷ̋EɊւ鑮ێ܂B
	*/
	CDcdGridYBorder	m_CDcdGridYBorder ;
	///@}
private:
	// ********************************
	///	@name CDcdGridYColumn ŗL̑
	// ********************************
	///@{

	/**
		_TCYŁÃTCYێ܂B
		A m_bAutoColumnSize ^ȂA̒l͖łB
		ftHgł͂PłB
	 */
	DcdSize	m_iColumnSize ;
	
	/**
		^ȂAYԍÕZ IfDcDraw IuWFNg getItemSize() Ԃ
		TCYƂɁÃTCY肵܂B
		ftHgł͐^łB
	 @attention
		A̒l^̏ꍇA`͒xȂ܂
		(ɁACDcdTextbox::getItemSize() 
		Ԃ邹łjB@n
		ƂɁA̐ꍇ͂ȂxȂ邱Ƃ
		܂̂ŁA
		̐ꍇ́A 
		CDcdGridYColumn 
		m_bAutoColumnSize UɂŁA
		m_iColumnSize ɖIɒlݒ肷邱Ƃ߂܂B
	 */
	bool	m_bAutoColumnSize ;
	
	
	///@}


// ********************************
//	RXgN^
// ********************************
public:
	/**
	 * @param [in] pCDcdGrid 
	 *	̃IuWFNgێObhIuWFNgւ̃|C^łB
	 */
	CDcdGridYColumn( CDcdGrid*	pCDcdGrid ) ;
	
 private:
	CDcdGridYColumn( const CDcdGridYColumn& ev ){} ;
	void operator=( CDcdGridYColumn& ev ) {};

// ****************************************************************
//	CDcdGridYColumn
// ****************************************************************
public:
	// ********************************
	/// @name	֘A
	// ********************************
	///@{
	///@}

	// ********************************
	/// @name	W
	// ********************************
	///@{
	CDcdGridYBorder*	getCDcdGridYBorder(){
		return &m_CDcdGridYBorder ;};
	///@}

	// ********************************
	/// @name	
	// ********************************
	///@{
	CDcdGridYColumn& setColumnSize( DcdSize ev ){
		m_bAutoColumnSize = false ;
		m_iColumnSize = ev ;	return *this ; } ;
	bool getAutoColumnSize(){
		return m_bAutoColumnSize ; } ;
	CDcdGridYColumn& setAutoColumnSize( bool ev ){
		m_bAutoColumnSize = ev ;	return *this ; } ;
	

	
	///@}
	
	// ********************************
	/// @name	
	// ********************************
	///@{
	
	/**
		_TCYŁÃTCYԂ܂B
	 @param pIfDcdTarget [in]
		`ΏۂƂȂ^[Qbgw肵ĂB
	 @return
		ỸTCYԂ܂B
	 */
	virtual DcdSize	getColumnSize( IfDcdTarget* pIfDcdTarget ) ;
	
	
	///@}

};

} //namespace DcdGrid
} //namespace DcDrawLib
#endif /*CDcdGridYColumn_h*/
