/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CBoxSelect.cpp
//	$Id: CBoxSelect.cpp 324 2016-06-12 03:03:55Z okm $
// ****************************************************************
*/
/** @file */
#include "DcdGrid\WndDcdGrid3\CBoxSelect.h"
#include "DcdGrid\WndDcdGrid3\CWndDcdGrid.h"
#include "DcdGrid\WndDcdGrid3\CPropStack.h"
#include "DcdGrid\CDcdGridCell.h"
#include "logmsg\logmsg.h"
#include "NsOu\OuNew.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


namespace DcDrawLib{
namespace DcdGrid{
namespace WndDcdGrid3{

	// --------------------------------
	///@name update_adjustProp ֐
	// --------------------------------
bool CBoxSelect::update_adjustProp_updateColumnNumberSelect() 
{
	bool bRv = false ;

	//	ύXΏۂ̒l̃LbV
	CdDcdZoneXy	zonexyColumnNumberSelectNew = m_ColumnNumberSelect ;
	//	ύXΏۂ̒l̃LbV
	CdDcdPosXy posxyColumnNumberAnchorCellNew = m_ColumnNumberAnchorCell ;
	//	lfalseB
	//	ׂẴZ̑IԂKvƔfꂽ_ true B
	bool bClearSelectRequired = false ;

	CdDcdPosXy	aColumnNumberFocus = 
		m_pCWndDcdGrid->getCFocus()->getFocusCellColumnNumber() ;
	//aColumnNumberFocus = tH[JXZ̗ԍ

	// ----------------------------------------------------------------
	//	AJ[Z̐K(AJ[ZObh͈̔͊OȂA
	//	NULL ɏC
	// ----------------------------------------------------------------
	if ( posxyColumnNumberAnchorCellNew != ColumnNumberPosXy_NULL() )
	{
		if ( !( 
			0 <= m_ColumnNumberAnchorCell.getX() && 
			m_ColumnNumberAnchorCell.getX() < m_pCWndDcdGrid->getCXDcdGrid()->getXColumnCount() &&
			0 <= m_ColumnNumberAnchorCell.getY() && 
			m_ColumnNumberAnchorCell.getY() < m_pCWndDcdGrid->getCXDcdGrid()->getYColumnCount() ) )
		{
			posxyColumnNumberAnchorCellNew = ColumnNumberPosXy_NULL() ;
		}
	}

	// ----------------------------------------------------------------
	//	tH[JXZ̈ړɏ]
	//	m_ColumnNumberSelect,m_ColumnNumberAnchorCell XV܂B
	// ----------------------------------------------------------------

	CSelect*	pCSelect = m_pCWndDcdGrid->getCSelect() ;
	CdDcdZoneXy	zonexyColumnNumberSelectLimit = 
		pCSelect->getColumnNumberSelectLimitRegularized() ;
	//zonexyColumnNumberSelectLimit = I\ȃZ̗ԍ͈̔́B


	// --------------------------------
	//ShiftꂽԂŁAhbOȊOɂtH[JXړ
	//	  BoxSelect AJ[Z͍XVɁA
	//		AJ[ZƃtH[JXZ̊ԂÏƂB
	//hbOɂtH[JXړ(MouseMove,^C}XN[)
	//	  BoxSelect@AJ[Z͍XVɁA
	//		AJ[ZƃtH[JXZ̊ԂÏƂB
	// --------------------------------
	if ( aColumnNumberFocus != CFocus::ColumnNumberPosXy_NULL() && 
		zonexyColumnNumberSelectLimit.IsInner( aColumnNumberFocus ) &&
		posxyColumnNumberAnchorCellNew != ColumnNumberPosXy_NULL() )
	{	//	tH[JXZNULLȊOőI\̈B
		//	AJ[ZNULLȊOB
		bool bBoxSelecting = false ;
		if ( m_pCWndDcdGrid->isShiftPressed() && 
			!m_pCWndDcdGrid->isDragging() && 
			m_ColumnNumberFocus_Old != aColumnNumberFocus ) 
		{	//ShiftꂽԂŁAhbOȊOɂtH[JXړ
			//	  BoxSelect AJ[Z͍XVɁA
			//		AJ[ZƃtH[JXZ̊ԂÏƂB
			bBoxSelecting = true ;
		}
		else if ( m_pCWndDcdGrid->isDragging() && 
			m_ColumnNumberFocus_Old != aColumnNumberFocus ) 
		{	//hbOɂtH[JXړ(MouseMove,^C}XN[)
			//	  BoxSelect@AJ[Z͍XVɁA
			//		AJ[ZƃtH[JXZ̊ԂÏƂB
			bBoxSelecting = true ;
		}
		if ( bBoxSelecting )
		{

			//		AJ[ZƃtH[JXZ̊ԂÏƂB
			//  @[FocusCell m_ColumnNumberSelectLimit͈͓̔]

			//X
			{
				int iPosMin = min( aColumnNumberFocus.getX() , posxyColumnNumberAnchorCellNew.getX() ) ;
				int iPosMax = max( aColumnNumberFocus.getX() , posxyColumnNumberAnchorCellNew.getX() ) ;
				zonexyColumnNumberSelectNew.setX( CdDcdZone( iPosMin , iPosMax - iPosMin + 1 ) ) ;
			}
			//Y
			{
				int iPosMin = min( aColumnNumberFocus.getY() , posxyColumnNumberAnchorCellNew.getY() ) ;
				int iPosMax = max( aColumnNumberFocus.getY() , posxyColumnNumberAnchorCellNew.getY() ) ;
				zonexyColumnNumberSelectNew.setY( CdDcdZone( iPosMin , iPosMax - iPosMin + 1 ) ) ;
			}
			//bRv̍XV́Å֐̖ōs܂B
		}
	}
	
	// --------------------------------
	//CtrlShiftȂԂŁAhbO(MouseMove,^C}XN[)ȊOɂtH[JXړ
	//@BoxSelect AJ[Z͍XVBBoxSelecẗNULLB
	//              ׂẴZ̑IԂ
	// --------------------------------
	if ( m_ColumnNumberFocus_Old != aColumnNumberFocus )
	{
		//	CRandomSelect::update_adjustProp_updateColumnNumberSelect()
		//	CBoxSelect::update_adjustProp_updateColumnNumberSelect() 
		//	l̏܂B
		if ( !m_pCWndDcdGrid->isCtrlPressed() && 
			!m_pCWndDcdGrid->isShiftPressed() && 
			!m_pCWndDcdGrid->isDragging() && 
			m_ColumnNumberFocus_Old != aColumnNumberFocus ) 
		{
			//CtrlShiftȂԂŁA
			//hbO(MouseMove,^C}XN[)ȊOɂtH[JXړ

			//AJ[Z͍XVBBoxSelecẗNULLB
			posxyColumnNumberAnchorCellNew = aColumnNumberFocus ;
			zonexyColumnNumberSelectNew =  ColumnNumberZoneXy_NULL();

			// ׂẴZ̑IԂ
			bClearSelectRequired = true ;

			//bRv̍XV́Å֐̖ōs܂B
		}
	}
	// --------------------------------
	//CtrlONAShiftOFFŁAhbOȊOɂtH[JXړ
	//@BoxSelect AJ[Z͍XVBBoxSelecẗ͂̂܂܁B
	// --------------------------------
	if ( aColumnNumberFocus != CFocus::ColumnNumberPosXy_NULL() && 
		zonexyColumnNumberSelectLimit.IsInner( aColumnNumberFocus ) )
	{	//	tH[JXZNULLȊOőI\̈B
		//	AJ[ZNULLȊOB

		if ( m_pCWndDcdGrid->isCtrlPressed() && 
			!m_pCWndDcdGrid->isShiftPressed() && 
			!m_pCWndDcdGrid->isDragging() && 
			m_ColumnNumberFocus_Old != aColumnNumberFocus ) 
		{	//CtrlShiftȂԂŁA
			//hbO(MouseMove,^C}XN[)ȊOɂtH[JXړ

			//AJ[Z͍XVBBoxSelecẗ͂̂܂܁B
			posxyColumnNumberAnchorCellNew = aColumnNumberFocus ;
		}
	}

	// ----------------------------------------------------------------
	//	posxyColumnNumberAnchorCellNewEm_ColumnNumberSelect 𐳋K܂B
	// ----------------------------------------------------------------
	// --------------------------------
	//	IZAŕ␳
	// --------------------------------


	//	IŹAI\͈͓ɂB
	//[m_ColumnNumberSelect!=NULL]
	//@m_ColumnNumberSelect ́A m_ColumnNumberSelectLimit ͈͓̔ɂB
	//@[SelectMode=SelectMode_XColumn]
	//     m_ColumnNumberSelect.Y = m_ColumnNumberSelectLimit.Y
	//@[SelectMode=SelectMode_YColumn]
	//     m_ColumnNumberSelect.X = m_ColumnNumberSelectLimit.X
	if ( zonexyColumnNumberSelectNew != ColumnNumberZoneXy_NULL() ) 
	{
		//@m_ColumnNumberSelect ́A m_ColumnNumberSelectLimit ͈͓̔ɂB
		zonexyColumnNumberSelectNew = 
			zonexyColumnNumberSelectLimit.CrossZone( zonexyColumnNumberSelectNew ) ;


		//@[SelectMode=SelectMode_XColumn]
		//     m_ColumnNumberSelect.Y = m_ColumnNumberSelectLimit.Y
		if ( pCSelect->getSelectMode() == CSelect::SelectMode_XColumn )
		{
			zonexyColumnNumberSelectNew.setY( zonexyColumnNumberSelectLimit.getY() ) ;
		}
		//@[SelectMode=SelectMode_YColumn]
		//     m_ColumnNumberSelect.X = m_ColumnNumberSelectLimit.X
		if ( pCSelect->getSelectMode() == CSelect::SelectMode_YColumn )
		{
			zonexyColumnNumberSelectNew.setX( zonexyColumnNumberSelectLimit.getX() ) ;
		}

	}
	// ----------------------------------------------------------------
	//	̍XV
	// ----------------------------------------------------------------
	if ( m_ColumnNumberSelect != zonexyColumnNumberSelectNew )
	{
		m_ColumnNumberSelect = zonexyColumnNumberSelectNew ;
		bRv = true ;
	}
	if ( m_ColumnNumberAnchorCell != posxyColumnNumberAnchorCellNew )
	{
		m_ColumnNumberAnchorCell = posxyColumnNumberAnchorCellNew ;
		bRv = true ;
	}
	if ( bClearSelectRequired ){	// ׂẴZ̑IԂ
		m_pCWndDcdGrid->getCSelect()->clearSelect() ;
		bRv = true ;
	}
	// --------------------------------
	//	Ol̍XV
	// --------------------------------
	m_ColumnNumberFocus_Old = aColumnNumberFocus ;
	// --------------------------------
	
	LogMsg( "CBoxSelect::update_adjustProp_updateColumnNumberSelect\n"
		"\tm_ColumnNumberSelect.x=(%d,%d) y=(%d,%d)\n" ,
		m_ColumnNumberSelect.getX().getPos() , 
		m_ColumnNumberSelect.getX().getSize() , 
		m_ColumnNumberSelect.getY().getPos() , 
		m_ColumnNumberSelect.getY().getSize() ) ; 

	return bRv ;	
}

bool CBoxSelect::update_adjustProp_updateCSelectCell()
{
	bool bRv = false ;
	
	CXDcdGrid* pCXDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;
	CSelect* pCSelect = m_pCWndDcdGrid->getCSelect() ;

	{
		Ou<CPropStack> pPropStack = createPropStackForSelectChange() ;

		// --------------------------------
		//	Z̑I󋵂̕ω
		//	CSelectCell ɔf܂
		// --------------------------------
		for ( int iYColumnNumber = 0 ; 
			iYColumnNumber < pCXDcdGrid->getYColumnCount() ; 
			iYColumnNumber ++ )
		{
			for ( int iXColumnNumber = 0 ; 
				iXColumnNumber < pCXDcdGrid->getXColumnCount() ; 
				iXColumnNumber ++ )
			{
				
				bool bSelected = m_ColumnNumberSelect.IsInner( 
					CdDcdPosXy( iXColumnNumber , iYColumnNumber ) ) ;
				bool bSelectedOld =  m_ColumnNumberSelect_Old.IsInner( 
					CdDcdPosXy( iXColumnNumber , iYColumnNumber ) ) ;

				if ( bSelectedOld != bSelected )
				{
					CSelectCell* pCSelectCell = pCSelect->getCell( 
						iXColumnNumber , iYColumnNumber ) ;
					pCSelectCell->setIsSelected( bSelected ) ;
					bRv = true ;
				}
			}
		}
	}
	return bRv ;
}

Ou<CPropStack> CBoxSelect::createPropStackForSelectChange() 
{
	OuNew<CPropStack> pPropStack( new CPropStack( getCWndDcdGrid() ) ) ;
	pPropStack->CSelect_setUpdateCWndDcdGrid( false ) ;
	return pPropStack ;

}



	// --------------------------------
	//@name CWndDcdGrid ̈Ϗ
	// --------------------------------
bool CBoxSelect::update_adjustProp() 
{
	bool	bRv = false ;
	if ( m_bIsEnable )
	{
		//	tH[JXZ̈ړɏ]āA
		//	m_ColumnNumberAnchorCell , m_ColumnNumberSelect XV܂B
		//	
		//	m_ColumnNumberAnchorCellEm_ColumnNumberSelect 𐳋K܂B
		bRv |= update_adjustProp_updateColumnNumberSelect() ;

		//	IZ̏ԂACSelectCell ɔf
		bRv |= update_adjustProp_updateCSelectCell() ;
	}
	else
	{
		//	ZINA
		m_ColumnNumberAnchorCell = ColumnNumberPosXy_NULL() ;
		m_ColumnNumberSelect = ColumnNumberZoneXy_NULL() ;
	}

	return bRv ;	
}
bool CBoxSelect::update_updateScreen() 
{
	//	̃NXł͏͂܂(ĕ`́ACSelect ɂčs܂)
	m_ColumnNumberSelect_Old = m_ColumnNumberSelect ;
	return false ;
}


bool CBoxSelect::OnPaint( IfDcdTarget* pIfDcdTarget ) 
{
	//	̃NXł͏͂܂(ĕ`́ACSelect ɂčs܂)
	return false ;
}

void CBoxSelect::InvalidateGrid( ) 
{
	//	̃NXł͏͂܂(ĕ`́ACSelect ɂčs܂)
}
void CBoxSelect::OnSize(UINT nType, int cx, int cy)
{
	//	̃NXł́A͂܂B
}
void CBoxSelect::OnSetFocus(CWnd* pOldWnd)
{
	//	̃NXł́A͂܂B
}

void CBoxSelect::OnKillFocus(CWnd* pNewWnd)
{
	//	̃NXł́A͂܂B
}

	// ********************************
	//	RXgN^
	// ********************************
CBoxSelect::CBoxSelect( CWndDcdGrid* pCWndDcdGrid ) 
	: m_pCWndDcdGrid( pCWndDcdGrid ) 
	, m_bIsEnable( true ) 
	, m_ColumnNumberAnchorCell( ColumnNumberPosXy_NULL()  ) 
	, m_ColumnNumberSelect( ColumnNumberZoneXy_NULL() )
	, m_ColumnNumberFocus_Old( ColumnNumberPosXy_NULL() ) 
	, m_ColumnNumberSelect_Old( ColumnNumberZoneXy_NULL() )
{
}


CBoxSelect::~CBoxSelect() 
{
}
	// ********************************
	//@name CSelect ֘A
	// ********************************
CWndDcdGrid* CBoxSelect::getCWndDcdGrid() 
{
	return m_pCWndDcdGrid ;
}

	// ********************************
	//@name CSelect 
	// ********************************
bool CBoxSelect::getIsEnable()
{
	return m_bIsEnable ;
}
void CBoxSelect::setIsEnable( bool value ) 
{
	m_bIsEnable = value ;
}
CdDcdPosXy	CBoxSelect::getColumnNumberAnchorCell()
{
	return m_ColumnNumberAnchorCell ;
}
CdDcdZoneXy	CBoxSelect::getColumnNumberSelect()const 
{
	return m_ColumnNumberSelect ;
}
void CBoxSelect::setColumnNumberSelect( const CdDcdZoneXy& value ) 
{
	m_ColumnNumberSelect = value ;
	m_pCWndDcdGrid->update() ;
}

	// ********************************
	//@name CSelect W
	// ********************************
	// ********************************
	//@name CSelect 
	// ********************************
void CBoxSelect::clearSelect() 
{
	m_ColumnNumberSelect = ColumnNumberZoneXy_NULL() ;
	m_pCWndDcdGrid->update() ;
}


} //namespace WndDcdGrid3
} //namespace DcdGrid
} //namespace DcDrawLib


