/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	WndDcdGrid_CFocus.cpp
// ****************************************************************
*/
/** @file */
#include "CWndDcdGrid.h"

#include "NsOu\OuNew.h"
#include "DcDraw\CDcdRectangle.h"
#include "DcDraw\CDcdTargetGetDC.h"
#include "DcDraw\CaDcdTargetItemPosition.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace DcDrawLib{
namespace DcdGrid{
namespace WndDcdGrid3{

// ****************************************************************
//	WndDcdGrid3::CFocus
// ****************************************************************
	// --------------------------------
	//@name	CWndDcdGrid-tH[JX
	// --------------------------------
void CFocus::CreateDcDrawFocusCell() 
{
	OuNew<CDcdRectangle>	pCDcdRectangle( new CDcdRectangle( 
				CdPenProp( 1 , CdColorProp( 0 , 0 , 0 ) , CdPenProp::DOT ) ) ) ;
	setIfDcDrawFocusCell( pCDcdRectangle ) ;
}
void CFocus::DeleteDcDrawFocusCell() 
{
	setIfDcDrawFocusCell( Ou<IfDcDraw>() ) ;
}


// --------------------------------
//@name CWndDcdGrid ̈Ϗ
// --------------------------------
bool CFocus::update_adjustProp() 
{
	bool bRv = false ;

	CXDcdGrid* m_pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;

	CDcdTargetGetDC	aCDcdTarget( m_pCWndDcdGrid->GetSafeHwnd() ) ;

	int	iFocusCellXColumnNumber = m_iFocusCellXColumnNumber ;
	int iFocusCellYColumnNumber = m_iFocusCellYColumnNumber ;
	int iXFixafterColumnNumber = m_pCDcdGrid->getXFixafterColumnNumber() ;
	int iYFixafterColumnNumber = m_pCDcdGrid->getYFixafterColumnNumber() ;

	// --------------------------------
	//	y1.̕␳z
	// --------------------------------

	//  PDFocusCell 팋ZɂȂꍇEEEFocusCell
	//	ZɈړ܂B
	{
		CDcdGridCell*	pCell = m_pCDcdGrid->getCell( 
			iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ;
		if ( pCell != NULL ){
			if ( pCell->getAttachTo() != NULL ){
				pCell = pCell->getAttachTo() ;
				iFocusCellXColumnNumber = m_pCDcdGrid->getXColumnNumberOfCell( pCell ) ;
				iFocusCellYColumnNumber = m_pCDcdGrid->getYColumnNumberOfCell( pCell ) ;

			}
		}
	}
	//LogMsg( "CWndDcdGrid::adjustProp() 0" ) ;

	//	QDFocusCellColumnNumber  EChE͈̔
	//	iIfDcdTarget::getZone()̗̈)Ɏ܂ĂȂꍇEEE
	//	[FixafterColumnNumber ύX]
	//	FocusCellColumnNumber Aʏ̈ԉE ColumnNumber ɂ܂B
	//	[FocusCellColumnNumber ύX]
	//	FocusCellColumnNumber EChE͈̔͂Ɏ܂܂ŁA
	//	FixafterColumnNumberZ܂B
	//	̌ʂƂȂ FixafterColumnNumber A
	//	 FixafterColumnNumberMaxForColumn ƌĂт܂B
	{
		int iColumnNumberMaxInDcdTarget = 
				m_pCDcdGrid->getXColumnNumberMaxInDcdTarget( &aCDcdTarget ) ;
		if ( iFocusCellXColumnNumber > iColumnNumberMaxInDcdTarget ){
			//LogMsg( "CWndDcdGrid::adjustProp() 01" ) ;
			if ( !m_bFixafterColumnNumberChange ){
				iFocusCellXColumnNumber = m_pCDcdGrid->
					getXColumnNumberMaxInDcdTarget( &aCDcdTarget )  ;
				if ( iFocusCellXColumnNumber < 0 ){
					iFocusCellXColumnNumber = 0 ;
				}
			}	else	{
				int iXFixafterColumnNumberMinForColumn = m_pCDcdGrid->
					calcXFixafterColumnNumberMinForColumn( &aCDcdTarget , 
						iFocusCellXColumnNumber ) ;

				iXFixafterColumnNumber = iXFixafterColumnNumberMinForColumn ;

				//bRv̍XV́Å֐̖ōs܂B
			}
			//LogMsg( "CWndDcdGrid::adjustProp() 02" ) ;
		}
	}
	{
		int iColumnNumberMaxInDcdTarget = 
				m_pCDcdGrid->getYColumnNumberMaxInDcdTarget( &aCDcdTarget ) ;
		if ( iFocusCellYColumnNumber > iColumnNumberMaxInDcdTarget ){
			//LogMsg( "CWndDcdGrid::adjustProp() 03" ) ;
			if ( !m_bFixafterColumnNumberChange ){
				iFocusCellYColumnNumber = m_pCDcdGrid->
					getYColumnNumberMaxInDcdTarget( &aCDcdTarget )  ;
				if ( iFocusCellYColumnNumber < 0 ){
					iFocusCellYColumnNumber = 0 ;
				}
			}	else	{
				int iYFixafterColumnNumberMinForColumn = m_pCDcdGrid->
					calcYFixafterColumnNumberMinForColumn( &aCDcdTarget , 
						iFocusCellYColumnNumber ) ;

				iYFixafterColumnNumber = iYFixafterColumnNumberMinForColumn ;

				//bRv̍XV́Å֐̖ōs܂B
			}
			//LogMsg( "CWndDcdGrid::adjustProp() 04" ) ;
		}
	}
	//LogMsg( "CWndDcdGrid::adjustProp() 1" ) ;


	//	RD FocusCellColumnNumber  ColumnScrollout ɂȂꍇEEE
	//	[FixafterColumnNumber ύX]
	//	FocusCellColumnNumber  FixafterColumnNumber Ɠɂ܂B
	//	[FocurCellColumnNumber ύX]
	//	XN[ʒu𐳋KāAtH[JXZ\悤ɂ܂B
	//	FixafterColumnNumberAFocusCellColumnNumberƓɂ܂B
	{
		if ( m_pCDcdGrid->getXFixColumnCount() <= iFocusCellXColumnNumber && 
				iFocusCellXColumnNumber < iXFixafterColumnNumber ){
			
			if ( !m_bFixafterColumnNumberChange ){
				iFocusCellXColumnNumber = iXFixafterColumnNumber ;
			}	else	{
				iXFixafterColumnNumber = iFocusCellXColumnNumber ;
				//bRv̍XV́Å֐̖ōs܂B
			}
		}
		if ( m_pCDcdGrid->getYFixColumnCount() <= iFocusCellYColumnNumber && 
				iFocusCellYColumnNumber < iYFixafterColumnNumber ){
			
			if ( !m_bFixafterColumnNumberChange ){
				iFocusCellYColumnNumber = iYFixafterColumnNumber ;
			}	else	{
				iYFixafterColumnNumber =  iFocusCellYColumnNumber ;
				//bRv̍XV́Å֐̖ōs܂B
			}
		}
	}
	//LogMsg( "CWndDcdGrid::adjustProp() 2" ) ;

	//  SDFocusCell 0ȏ ColumnCountłȂꍇEEEFocusCell
	//	̒lɂ܂B
	{
		if ( iFocusCellXColumnNumber >= m_pCDcdGrid->getXColumnCount() ){
			iFocusCellXColumnNumber = m_pCDcdGrid->getXColumnCount() - 1 ;
		}
		if ( iFocusCellXColumnNumber < 0 ){
			iFocusCellXColumnNumber = 0 ;
		}
		if ( iFocusCellYColumnNumber >= m_pCDcdGrid->getYColumnCount() ){
			iFocusCellYColumnNumber = m_pCDcdGrid->getYColumnCount() - 1 ;
		}
		if ( iFocusCellYColumnNumber < 0 ){
			iFocusCellYColumnNumber = 0 ;
		}
	}
	//LogMsg( "CWndDcdGrid::adjustProp() 3" ) ;

	//  TDFocusCell 팋ZɂȂꍇEEEFocusCell
	//	ZɈړ܂B
	{
		CDcdGridCell*	pCell = m_pCDcdGrid->getCell( 
			iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ;
		if ( pCell != NULL ){
			if ( pCell->getAttachTo() != NULL ){
				pCell = pCell->getAttachTo() ;
				iFocusCellXColumnNumber = m_pCDcdGrid->getXColumnNumberOfCell( pCell ) ;
				iFocusCellYColumnNumber = m_pCDcdGrid->getYColumnNumberOfCell( pCell ) ;
			}
		}
	}
	//LogMsg( "CWndDcdGrid::adjustProp() 4" ) ;
	//LogMsg( "CWndDcdGrid::adjustProp() =" ) ;

	// ----------------------------------------------------------------
	//	y2.̕ωCWndDcdGridɒʒmz
	// ----------------------------------------------------------------
	if ( m_iFocusCellXColumnNumber != iFocusCellXColumnNumber || 
		m_iFocusCellYColumnNumber != iFocusCellYColumnNumber )
	{
		m_iFocusCellXColumnNumber = iFocusCellXColumnNumber ; 
		m_iFocusCellYColumnNumber = iFocusCellYColumnNumber ;
		bRv = true ;
	}


	if ( m_pCDcdGrid->getXFixafterColumnNumber() != iXFixafterColumnNumber )
	{
		m_pCDcdGrid->setXFixafterColumnNumber( iXFixafterColumnNumber ) ;
		bRv = true ;
	}
	if ( m_pCDcdGrid->getYFixafterColumnNumber() != iYFixafterColumnNumber )
	{
		m_pCDcdGrid->setYFixafterColumnNumber( iYFixafterColumnNumber ) ;
		bRv = true ;
	}

	return ( bRv ) ;
}

bool CFocus::update_updateScreen() 
{
	bool	bRv = true ;
	CXDcdGrid* m_pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;

	CDcdTargetGetDC	aCDcdTarget( m_pCWndDcdGrid->GetSafeHwnd() ) ;
	
	// --------------------------------
	//	y2.̕ωCWndDcdGridɒʒmz
	// --------------------------------
	if ( m_iFocusCellXColumnNumber_Sid != m_iFocusCellXColumnNumber ||
			m_iFocusCellYColumnNumber_Sid != m_iFocusCellYColumnNumber )
	{
		// --------------------------------
		//	Cxĝ߂̉z֐
		// --------------------------------
		CDcdGridCell*	pCDcdGridCell = m_pCDcdGrid->getCell( 
				m_iFocusCellXColumnNumber , m_iFocusCellYColumnNumber ) ;
		if ( pCDcdGridCell != NULL )
		{
			m_pCWndDcdGrid->OnSetFocusCell( pCDcdGridCell ) ;
		}
	}
	// ----------------------------------------------------------------
	//	tH[JXZړ́A
	//	tH[JXZ̋ʒuƐVʒuĕ`
	// ----------------------------------------------------------------
	if ( m_iFocusCellXColumnNumber_Sid != m_iFocusCellXColumnNumber ||
			m_iFocusCellYColumnNumber_Sid != m_iFocusCellYColumnNumber )
	{
		m_pCWndDcdGrid->InvalidateCell( m_iFocusCellXColumnNumber_Sid , 
			m_iFocusCellYColumnNumber_Sid ) ;
		m_pCWndDcdGrid->InvalidateCell( m_iFocusCellXColumnNumber , 
			m_iFocusCellYColumnNumber ) ;
		
		// --------------------------------
		m_iFocusCellXColumnNumber_Sid = m_iFocusCellXColumnNumber ;
		m_iFocusCellYColumnNumber_Sid = m_iFocusCellYColumnNumber ;
		bRv = true ;
	}
	return ( bRv ) ;
}
bool CFocus::OnPaint( IfDcdTarget* pIfDcdTarget ) 
{
	bool bRv = false ;
	CXDcdGrid* m_pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;

	// --------------------------------	
	//	tH[JX}[N
	// --------------------------------	
	if ( m_pIfDcDrawFocusCell != NULL ){
		if ( m_bIsFocusmarkShowEvery || 
			CWnd::GetFocus() == m_pCWndDcdGrid ) {

			CdDcdZoneXy	zoneFocusCell = m_pCDcdGrid->getCellZone( 
				pIfDcdTarget ,
				m_iFocusCellXColumnNumber , m_iFocusCellYColumnNumber ) ;
	
			CaDcdTargetItemPosition	aCDcdTargetItemPosition( pIfDcdTarget ,
				zoneFocusCell ) ;
			if ( aCDcdTargetItemPosition.isDrawable() ){
				m_pIfDcDrawFocusCell->DcDraw( &aCDcdTargetItemPosition ) ;
				
				bRv = true ;
			}
		}
	}
	

	return bRv ;
}
	
void CFocus::OnSize(UINT nType, int cx, int cy)
{
	if ( cx == 0 || cy == 0 ){
		//	̂Q̂̂ꂩ0̏ꍇA
		//	Create() ŃTCYw肹ɃEChE
		//	̂Ǝv܂B
		//	̏ꍇ́A[U[ɂ͉Ȃ킯łA
		//	tH[JXZ̈ʒu̍œKȂǂ͂Ȃ
		//	Kv܂B
		//
		//	܂Ȃ傫̂Ƃ adjustProp() 
		//	sƁAtH[JXʒu͖ (0,0) 
		//	ړĂ܂܂B̂߁A
		//	adjustProp() ͂Ȃ
		//	悢ł傤B
		return ;
	}
	//	̏ꍇ̃tH[JXړ́A
	//	m_iXFixafterColumnNumber_Sid,m_iYFixafterColumnNumber_Sidɂ
	//	ĕ`悳邽߁ANAKv͂܂B
	//m_iFocusCellXColumnNumber_Sid = -1 ;
	//m_iFocusCellYColumnNumber_Sid = -1 ;

}

void CFocus::OnSetFocus(CWnd* pOldWnd)
{
	CDcdGridCell* pCell = getFocusCell() ;
	int iFocusCellXColumnNumber = m_pCWndDcdGrid->getCXDcdGrid()->getXColumnNumberOfCell( pCell ) ; 
	int iFocusCellYColumnNumber = m_pCWndDcdGrid->getCXDcdGrid()->getYColumnNumberOfCell( pCell ) ; 
	m_pCWndDcdGrid->InvalidateCell( iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ;
}
void CFocus::OnKillFocus(CWnd* pNewWnd)
{
	CDcdGridCell* pCell = getFocusCell() ;
	int iFocusCellXColumnNumber = m_pCWndDcdGrid->getCXDcdGrid()->getXColumnNumberOfCell( pCell ) ; 
	int iFocusCellYColumnNumber = m_pCWndDcdGrid->getCXDcdGrid()->getYColumnNumberOfCell( pCell ) ; 
	m_pCWndDcdGrid->InvalidateCell( iFocusCellXColumnNumber , iFocusCellYColumnNumber ) ;
}

void CFocus::InvalidateGrid()
{
	//	̃NX̉ʕ`ׂ͂OnPaintōs܂B
	//	InvalidateGridł́Aʂȏ͕svłB


}

	// ********************************
	//	RXgN^
	// ********************************
CFocus::CFocus( CWndDcdGrid* pCWndDcdGrid ) 
	: m_pCWndDcdGrid( pCWndDcdGrid )
	, m_iFocusCellXColumnNumber( 0 )
	, m_iFocusCellYColumnNumber( 0 )
	, m_bFixafterColumnNumberChange( true )
	, m_bIsFocusmarkShowEvery( false )
	, m_iFocusCellXColumnNumber_Sid( -1 )
	, m_iFocusCellYColumnNumber_Sid( -1 )
{

	CreateDcDrawFocusCell() ;
}

CFocus::~CFocus() 
{
	DeleteDcDrawFocusCell() ;
}
	// ********************************
	//@name ֘A
	// ********************************
Ou<IfDcDraw>	CFocus::getIfDcDrawFocusCell() 
{
	return ( m_pIfDcDrawFocusCell ) ;
}
void CFocus::setIfDcDrawFocusCell( Ou<IfDcDraw> value ) 
{
	m_pIfDcDrawFocusCell = value ;
}
	// ********************************
	///@name CWndDcdGrid-tH[JX
	// ********************************

CdDcdPosXy	CFocus::getFocusCellColumnNumber() 
{
	CdDcdPosXy	posXy( ColumnNumberPosXy_NULL() ) ;
	CXDcdGrid* pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;
	if( 0 <= m_iFocusCellXColumnNumber && 
		m_iFocusCellXColumnNumber < pCDcdGrid->getXColumnCount() && 
		0 <= m_iFocusCellYColumnNumber && 
		m_iFocusCellYColumnNumber < pCDcdGrid->getYColumnCount() )
	{
		posXy.setX( m_iFocusCellXColumnNumber ) ;
		posXy.setY( m_iFocusCellYColumnNumber ) ;
	}
	return posXy ;
}

void CFocus::setFocusCellColumnNumber( const CdDcdPosXy& value ) 
{
	if ( m_iFocusCellXColumnNumber == value.getX() &&
		m_iFocusCellYColumnNumber == value.getY() )
	{
		return ;
	}
	m_iFocusCellXColumnNumber = value.getX() ;
	m_iFocusCellYColumnNumber = value.getY() ;

	//	̕ύXƂɁAEChE\̍XVs܂B
	m_pCWndDcdGrid->update() ;
}

CDcdGridCell*	CFocus::getFocusCell() 
{
	CDcdGrid* m_pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;
	return ( m_pCDcdGrid->getCell( 
		m_iFocusCellXColumnNumber , m_iFocusCellYColumnNumber ) ) ;
}


void CFocus::setFocusCell( CDcdGridCell* value ) 
{
	if ( value == NULL ){
		return ;
	}

	CXDcdGrid* m_pCDcdGrid = m_pCWndDcdGrid->getCXDcdGrid() ;

	int iXColumnNumber = m_pCDcdGrid->getXColumnNumberOfCell( value ) ;
	int iYColumnNumber = m_pCDcdGrid->getYColumnNumberOfCell( value )  ;

	if ( m_iFocusCellXColumnNumber == iXColumnNumber &&
		m_iFocusCellYColumnNumber == iYColumnNumber )
	{
		return ;
	}
	m_iFocusCellXColumnNumber = iXColumnNumber ;
	m_iFocusCellYColumnNumber = iYColumnNumber ;

	//	̕ύXƂɁAEChE\̍XVs܂B
	m_pCWndDcdGrid->update() ;
}


bool	CFocus::getFixafterColumnNumberChange()
{
	return m_bFixafterColumnNumberChange ;
}
void CFocus::setFixafterColumnNumberChange( bool value ) 
{
	m_bFixafterColumnNumberChange = value ;
}

bool	CFocus::getIsFocusmarkShowEvery()
{
	return m_bIsFocusmarkShowEvery ;
}
void CFocus::setIsFocusmarkShowEvery( bool value ) 
{
	if ( m_bIsFocusmarkShowEvery != value ){
		m_bIsFocusmarkShowEvery = value ;
		m_pCWndDcdGrid->InvalidateCell( 
			m_iFocusCellXColumnNumber , m_iFocusCellYColumnNumber ) ;
	}
}

} //namespace WndDcdGrid3
} //namespace DcdGrid
} //namespace DcDrawLib
