/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvCDedRosenFileData.cpp
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include "Ou\OuNew.h"
#include "Ou\dynamic_castOu.h"
#include "str\CdConnectedString2.h"
#include "str\strToInt.h"
#include "str\CConnectedStringCompress.h"
#include "str\OuPropertiesText\CConvNodeContainer.h"
#include "str\OuPropertiesText\CDirectory.h"
using namespace OuPropertiesText ;
#include "str\OuPropertiesText\ErrorInfo\COuErrorInfoContainer.h"
using namespace OuPropertiesText::ErrorInfo ;
#include "logmsg\LogMsg.h"

#include "CconvCdDedDispProp.h"
#include "CconvCDedRosenFileData.h"
#include "CconvCentDed.h"


/*delete x̂ŗ}~
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
// ****************************************************************
//	CconvCDedRosenFileData
// ****************************************************************
const char nameFileType[]="FileType" ;
const char nameRosen[]="Rosen" ;
const char nameDispProp[]="DispProp" ;

int CconvCDedRosenFileData::CDedRosenFileData_to_OuPropertiesText( 
			const CDedRosenFileData* pCDedRosenFileData , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	LogMsg( "CDedRosenFileData_to_CdConnectedString()" ) ;
	int iRv = 0 ;

	//	FileType
	if ( iRv >= 0 )
	{
		pCNodeContainer->setValue( nameFileType , getFileType() ) ;

	}
	//1.Rosen
	if ( iRv >= 0 ){
		Ou<CDirectory> pCDirectory = OuNew<CDirectory>( 
			new CDirectory( nameRosen ) ) ;
		CconvCentDed aConv ;
		int iResult = aConv.CentDedRosen_To_OuPropertiesText( 
			pCDedRosenFileData->getCentDedRosen() ,
			pCDirectory->getCNodeContainer() ) ;
		//	-	-11 ;	//	Ekimei w肳Ă܂B
		//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		//	-	-32 ;	//	Ekikibo ̒lsłB
		//	-	-111 ;	//	Syubetsumei w肳Ă܂B
		//	-	-152 ;	//	DiagramSenStyle ̒lsłB
		//	-	-212 ;	//	DiagramEkiatsukai ̒lsłB
		if ( iResult < 0 )
		{
			//	-	-11 ;	//	Ekimei w肳Ă܂B
			//	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//	-	-32 ;	//	Ekikibo ̒lsłB
			//	-	-111 ;	//	Syubetsumei w肳Ă܂B
			//	-	-152 ;	//	DiagramSenStyle ̒lsłB
			//	-	-212 ;	//	DiagramEkiatsukai ̒lsłB
			iRv = iResult ;
		}
		else
		{
			pCNodeContainer->insert( pCDirectory ) ;
		}
	}
	//2.DispProp
	LogMsg( "CDedRosenFileData_to_CdConnectedString()1" ) ;
	if ( iRv >= 0 )
	{
		Ou<CDirectory> pCDirectory = OuNew<CDirectory>( 
			new CDirectory( nameDispProp ) ) ;
		CconvCdDedDispProp	aCconvCdDedDispProp ;
		int iResult = aCconvCdDedDispProp.toOuPropertiesText( 
			pCDedRosenFileData->getCdDedDispProp() ,
			pCDirectory->getCNodeContainer() ) ;
		//	݂͕̐Ԃ邱Ƃ͂܂B
		if ( iResult < 0 )
		{
			assert( false ) ;
		}
		else
		{
			pCNodeContainer->insert( pCDirectory ) ;
		}
	}


	LogMsg( "CDedRosenFileData_to_CdConnectedString()=%d" , iRv ) ;
	return ( iRv ) ;
}

int CconvCDedRosenFileData::CDedRosenFileData_from_OuPropertiesText( 
			CDedRosenFileData* pCDedRosenFileData ,
			const OuPropertiesText::CNodeContainer* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	int iRv = 0 ;

	if ( iRv >= 0 )
	{
		int iResult = isEncodeAbleFormat( pCNodeContainer ) ;
		if ( iResult < 0 )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_FileTypeIsInvalid() ) ;
			aCOuErrorInfo.getProp()->setValue( 
				ERRPROP_FileType() , pCNodeContainer->getValue( nameFileType ) ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -1 ;	//	FileType ܂B
		}
	}
	if ( iRv >= 0 )
	{
		pCDedRosenFileData->clear() ;
	}
	
	//1.Rosen

	if ( iRv >= 0 )
	{
		Ou<const CDirectory> pCDirectory = dynamic_castOu<const CDirectory>( 
			pCNodeContainer->getInName( nameRosen , 0 ) ) ;
		if ( pCDirectory == NULL )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_RosenDirectoryIsNotFound() ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -2 ;	//	Rosen Directory܂B
		}
		else
		{
			CentDedRosen	aCentDedRosen ;
			CconvCentDed aCconvCentDed ;
			int iResult = aCconvCentDed.CentDedRosen_From_OuPropertiesText( 
				&aCentDedRosen ,
				pCDirectory->getIfNodeContainerConst() ,
				pCOuErrorInfoContainer ) ;
			//-	-11 ;	//	Ekimei w肳Ă܂B
			//-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//-	-32 ;	//	Ekikibo ̒lsłB
			//-	-101 ;	//	Eki fBNgł͂܂B
			//-	-111 ;	//	Syubetsumei w肳Ă܂B
			//-	-152 ;	//	DiagramSenStyle ̒lsłB
			//-	-201 ;	//	Ressyasyubetsu fBNgł͂܂B
			//-	-211 ;	//	DiaName w肳Ă܂B
			//-	-212 ;	//	RessyaCont܂B
			//-	-352 ;	//	N_̐ݒ肪sK؂łB
			if ( iResult < 0 )
			{
				//-	-11 ;	//	Ekimei w肳Ă܂B
				//-	-22 ;	//	Ekijikokukeisiki ̒lsłB
				//-	-32 ;	//	Ekikibo ̒lsłB
				//-	-101 ;	//	Eki fBNgł͂܂B
				//-	-111 ;	//	Syubetsumei w肳Ă܂B
				//-	-152 ;	//	DiagramSenStyle ̒lsłB
				//-	-201 ;	//	Ressyasyubetsu fBNgł͂܂B
				//-	-211 ;	//	DiaName w肳Ă܂B
				//-	-212 ;	//	RessyaCont܂B
				//-	-352 ;	//	N_̐ݒ肪sK؂łB
				iRv = iResult ;
			}
			else
			{
				*pCDedRosenFileData->getCentDedRosen() = aCentDedRosen ;
			}
		}
	}
	//2.DispProp
	if ( iRv >= 0 )
	{
		Ou<const CDirectory> pCDirectory = dynamic_castOu<const CDirectory>( 
			pCNodeContainer->getInName( nameDispProp , 0 ) ) ;
		if ( pCDirectory == NULL )
		{
			COuErrorInfo aCOuErrorInfo( ERRREASON_DispPropnDirectoryIsNotFound() ) ;
			pCOuErrorInfoContainer->insert( aCOuErrorInfo ) ;
			iRv = -3 ;	//	DispProp Directory܂B
		}
		else
		{
			CconvCdDedDispProp	aCconvCdDedDispProp ;
			CdDedDispProp	aCdDedDispProp ;
			int iResult = aCconvCdDedDispProp.fromOuPropertiesText( 
				&aCdDedDispProp ,
				pCDirectory->getIfNodeContainerConst() , 
				pCOuErrorInfoContainer ) ;
			//-	-12 ;	//	JikokuhyouFont ̓esłB
			//-	-22 ;	//	DiaEkimeiFont ̓esłB
			//-	-32 ;	//	DiaJikokuFont ̓esłB
			//-	-82 ;	//	DisplayRessyabangou słB
			//-	-92 ;	//	DisplayRessyamei słB
			//-	-102 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
			//-	-112 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
			if ( iResult < 0 )
			{
				//-	-512 ;	//	JikokuhyouFont ̓esłB
				//-	-522 ;	//	DiaEkimeiFont ̓esłB
				//-	-532 ;	//	DiaJikokuFont ̓esłB
				//-	-582 ;	//	DisplayRessyabangou słB
				//-	-592 ;	//	DisplayRessyamei słB
				//-	-602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
				//-	-612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
				iRv = -500 ;	//	DispProp ̓es
			}
			else
			{
				pCDedRosenFileData->setCdDedDispProp( aCdDedDispProp ) ;
			}
		}
	}

	return ( iRv ) ;
}

int CconvCDedRosenFileData::isEncodeAbleFormat( 
			const OuPropertiesText::CNodeContainer* pCNodeContainer ) 
{
	int iRv = 0 ;
	string strFileType = pCNodeContainer->getValue( nameFileType ) ;
	if ( strFileType != getFileType() )
	{
		iRv = -1 ;	//	FileType ܂B
	}
	return iRv ;
}

int CconvCDedRosenFileData::CDedRosenFileData_to_string( 
		const CDedRosenFileData& aCDedRosenFileData , 
		string* pString ) 
{
	LogMsg( "CDedRosenFileData_to_string()" ) ;

	int iRv = 0 ;
	string	strRv ;
	CNodeContainer aCNodeContainer ;
	if ( iRv >= 0 )
	{
		int iResult = CDedRosenFileData_to_OuPropertiesText( 
			&aCDedRosenFileData , 
			&aCNodeContainer ) ;
		//iResult = 
		//-	-11 ;	//	Ekimei w肳Ă܂B
		//-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		//-	-32 ;	//	Ekikibo ̒lsłB
		//-	-111 ;	//	Syubetsumei w肳Ă܂B
		//-	-152 ;	//	DiagramSenStyle ̒lsłB
		//-	-212 ;	//	DiagramEkiatsukai ̒lsłB
		if ( iResult < 0 )
		{
			iRv = iResult ;
		}
	}
	
	LogMsg( "CDedRosenFileData_to_string()1" ) ;

	if ( iRv >= 0 )
	{
		CConvNodeContainer	aConv  ;
		strRv = aConv.encode( &aCNodeContainer ) ;
	}

	if ( iRv >= 0 )
	{
		if ( pString != NULL ){
			*pString = strRv ;
		}
	}

	LogMsg( "CDedRosenFileData_to_string()=%d" , iRv ) ;
	return ( iRv ) ;
}


int CconvCDedRosenFileData::CDedRosenFileData_from_string( 
			CDedRosenFileData* pCDedRosenFileData ,
			const string& aString ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) 
{
	LogMsg( "CDedRosenFileData_from_string()" ) ;

	int iRv = 0 ;
	string	strRv ;

	LogMsg( "CDedRosenFileData_from_string()1" ) ;

	pCDedRosenFileData->clear() ;
	CNodeContainer aCNodeContainer ;
	if ( iRv >= 0 )
	{
		string strErrorInfostring ;
		CConvNodeContainer	aConv ;
		int iResult = aConv.decode( aString , &aCNodeContainer , &strErrorInfostring ) ;
		//	-	-1 ;	//	fBNgrŕĂ܂B
		if ( iResult < 0 )
		{
			iRv = -1 ;	//	fBNgrŕĂ܂B	
		}
	}
	if ( iRv >= 0 )
	{
		int iResult = CDedRosenFileData_from_OuPropertiesText( 
			pCDedRosenFileData , 
			&aCNodeContainer , 
			pCOuErrorInfoContainer ) ;
		//iResult = 
		//-	-1 ;	//	FileType ܂B
		//-	-2 ;	//	Rosen Directory܂B
		//-	-11 ;	//	Ekimei w肳Ă܂B
		//-	-22 ;	//	Ekijikokukeisiki ̒lsłB
		//-	-32 ;	//	Ekikibo ̒lsłB
		//-	-101 ;	//	Eki fBNgł͂܂B
		//-	-111 ;	//	Syubetsumei w肳Ă܂B
		//-	-152 ;	//	DiagramSenStyle ̒lsłB
		//-	-201 ;	//	Ressyasyubetsu fBNgł͂܂B
		//-	-211 ;	//	DiaName w肳Ă܂B
		//-	-212 ;	//	RessyaCont܂B
		//-	-352 ;	//	N_̐ݒ肪sK؂łB
		//-	-3 ;	//	DispProp Directory܂B
		//-	-512 ;	//	JikokuhyouFont ̓esłB
		//-	-522 ;	//	DiaEkimeiFont ̓esłB
		//-	-532 ;	//	DiaJikokuFont ̓esłB
		//-	-582 ;	//	DisplayRessyabangou słB
		//-	-592 ;	//	DisplayRessyamei słB
		//-	-602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
		//-	-612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
		if ( iResult < 0 )
		{
			//-	-1001 ;	//	FileType ܂B
			//-	-1002 ;	//	Rosen Directory܂B
			//-	-1011 ;	//	Ekimei w肳Ă܂B
			//-	-1022 ;	//	Ekijikokukeisiki ̒lsłB
			//-	-1032 ;	//	Ekikibo ̒lsłB
			//-	-1101 ;	//	Eki fBNgł͂܂B
			//-	-1111 ;	//	Syubetsumei w肳Ă܂B
			//-	-1152 ;	//	DiagramSenStyle ̒lsłB
			//-	-1201 ;	//	Ressyasyubetsu fBNgł͂܂B
			//-	-1211 ;	//	DiaName w肳Ă܂B
			//-	-1212 ;	//	RessyaCont܂B
			//-	-1352 ;	//	N_̐ݒ肪sK؂łB
			//-	-1003 ;	//	DispProp Directory܂B
			//-	-1512 ;	//	JikokuhyouFont ̓esłB
			//-	-1522 ;	//	DiaEkimeiFont ̓esłB
			//-	-1532 ;	//	DiaJikokuFont ̓esłB
			//-	-1582 ;	//	DisplayRessyabangou słB
			//-	-1592 ;	//	DisplayRessyamei słB
			//-	-1602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
			//-	-1612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
			iRv = iResult - 1000 ;
		}
	}
	LogMsg( "CDedRosenFileData_from_string()=%d" , iRv ) ;
	return ( iRv ) ;
}

int CconvCDedRosenFileData::isEncodeAbleFormat( 
			const string& strOudFile  ) 
{
	LogMsg( "isEncodeAbleFormat()" ) ;

	int iRv = 0 ;
	string	strRv ;

	LogMsg( "CDedRosenFileData_from_string()1" ) ;

	CNodeContainer aCNodeContainer ;
	if ( iRv >= 0 )
	{
		string strErrorInfostring ;
		CConvNodeContainer	aConv ;
		int iResult = aConv.decode( strOudFile , &aCNodeContainer , &strErrorInfostring ) ;
		//	-	-1 ;	//	fBNgrŕĂ܂B
		if ( iResult < 0 )
		{
			iRv = -1 ;	//	fBNgrŕĂ܂B	
		}
	}
	if ( iRv >= 0 )
	{
		int iResult = isEncodeAbleFormat( &aCNodeContainer ) ;
		//-	-1 ;	//	FileType ܂B
		if ( iResult < 0 )
		{
			//-	-1001 ;	//	FileType ܂B
			iRv = iResult -1000 ;	//	FileType ܂B
		}
	}

	return ( iRv ) ;

}


