/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdTargetPrinter.h
// ****************************************************************
*/
/** @file */
#ifndef  CDcdTargetPrinter_h
#define  CDcdTargetPrinter_h

#include "DcDraw/IfDcdTarget.h"
#include "DcDraw/CGdiCache.h"

// ****************************************************************
//	CDcdTargetPrinter
// ****************************************************************
/**
 * @brief
 * yTvz
 *	v^́A`̈񋟂NXłB
 *	w肳ꂽv^DC̗p̗̈ Win32 GetDeviceCaps() 
 *	APIŎ擾A`̈Ƃ܂B
 *
 *	CX^X́AX^bNɐ邱Ƃz肵Ă܂B
 *
 *	̃NX́ARXgN^ŁA DC ̃}bsO[hύX܂B
 *	
 *	- MapMode  MM_ANISOTROPIC 
 *	- _͍ŁAW͉E
 *	- _ẂAEChEւ̕`Ɠl̕`悪ł悤ɒ
 *
 *	̃}bsO[hgƂɂA DC ɑ΂ẮA
 *	 MM_TEXT [h̃EChEւ̕`ASYƓl̕`悪ł悤
 *	Ȃ܂B
 *
 *	ȂÃNX́A DC ւ StartDoc()EStartPage()EEndPage()E
 *	EndDoc() ͍s܂B́A炷[U[̐ӖłB
 *
 * ygz
 *
 * PD X^bNɃCX^X𐶐ĂB
 *	RXgN^ł́AΏۂƂȂv^ DC w肵ĂB
 *
 *   v^ DC ̐́A CPrintDialog ̎gp֗łB
 *
 * QD KvɉāA DC ɑ΂ StartDoc()EStartPage() Ăяo
 *	B
 *	
 * RD StartPage() sĂA  this  IfDcDraw IuWFNgɓnāA
 *	`s킹ĂB
 * 
 * SD KvɉāA DC ɑ΂ EndPage() E EndDoc() Ăяo
 *	B
 *	
 */
class CDcdTargetPrinter : public IfDcdTarget
{
// ********************************
///@name ֘A
// ********************************
///@{
 private:
	/**
	 * 	ΏۂƂȂv^ DC B
	 *	 HDC ̔j̐Ӗ NX[U[ɂ܂B
	 * 	HWND́Athis蒷ȂĂ͂Ȃ܂B
	 */
	HDC			m_hDc ;
///@}
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 * 	`̕Kvȗ̈iv^DCj̍W͈
	 *	͓ɁA`悪LȔ͈͂ƂȂ܂B
	 * 	Pʂ́A_PʂłB
	 *
	 *	RXgN^Ō܂܂B
	 */
	CdDcdZoneXy	m_zoneLogical ;
	
	/**
	 * 	`̕Kvȗ̈iv^DCj̍W͈
	 *	͓ɁA`悪LȔ͈͂ƂȂ܂B
	 * 	Pʂ́AfoCXPʁisNZjłB
	 *
	 *	RXgN^Ō܂܂B
	 */
	CdDcdZoneXy	m_zonePixel ;
	
///@}

// ********************************
///@name	W
// ********************************
///@{
 private:
	/**
	 *	GDIIuWFNg̑ƁAnh̑Ώƕ\ێ܂B
	 */
	CGdiCache	m_CGdiCache ;
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param hDc [in]
	 * 	ΏۂƂȂv^ DC B
	 *	 HDC ̔j̐Ӗ NX[U[ɂ܂B
	 * 	HWND́Athis蒷ȂĂ͂Ȃ܂B
	 */
	CDcdTargetPrinter( HDC hDc ) ;
	
	virtual ~CDcdTargetPrinter() ;

// ********************************
///@name	IfDcdTarget
// ********************************
///@{
 public:
	/**
	* @return
	* 	`sDC擾܂B
	* 	HDC̔j̐Ӗ́Athisɂ܂B
	*/
	virtual HDC	getHdc() ;
	
	/**
	* @return
	* 	`̕Kvȗ̈̍W͈͂擾邱Ƃł܂B
	* 	Pʂ́A_PʂłB
	*/
	virtual CdDcdZoneXy getZone() ;
	
	/**
	* @return
	* 	`悪LȔ͈͂擾ł܂B
	* 	ʏ́AgetZone()Ɠ̈ƂȂ܂B
	* 
	* 	EChEWM_PAINTɂ`̏ꍇÅ֐Ԃ̂́A
	* 	ĕ`悪Kvȗ̈ƂȂ܂B
	* 	̗̈𖳎Ă܂܂BA͈̔͊Oւ̕`
	* 	Ӗ܂̂ŁA͈̔͊Oւ̕`}悤ɂ΁A
	* 	`揈̌̉P҂ł܂B
	*/
	virtual CdDcdZoneXy getDrawableZone() ;

	/**
	* 	CdFontPropIuWFNg̑ƂɁAtHg𐶐܂
	* @param aCdFontProp [in]
	* 	tHgw肵ĂB
	* @return
	*	tHg̃nhԂ܂B
	*	̃nh̔j̐Ӗ́Athisɂ܂B
	*	֐ďóAnhĂ͂܂B
	*/
	virtual HFONT	CreateFont(  const CdFontProp& aCdFontProp ) {
		return m_CGdiCache.CreateFont( aCdFontProp , getHdc() ) ;};
	
	/**
	* 	CdPenPropIuWFNg̑ƂɁAy𐶐܂
	* @param aCdPenProp [in]
	* 	yw肵ĂB
	* @return
	*	ỹnhԂ܂B
	*	̃nh̔j̐Ӗ́Athisɂ܂B
	*	֐ďóAnhĂ͂܂B
	*/
	virtual HPEN	CreatePen(  const CdPenProp& aCdPenProp )   {
		return m_CGdiCache.CreatePen( aCdPenProp ) ;};

	/**
	* 	CdBrushPropIuWFNg̑ƂɁAy𐶐܂
	* @param aCdBrushProp [in]
	* 	yw肵ĂB
	* @return
	*	ỹnhԂ܂B
	*	̃nh̔j̐Ӗ́Athisɂ܂B
	*	֐ďóAnhĂ͂܂B
	*/
	virtual HBRUSH	CreateBrush(  const CdBrushProp& aCdBrushProp ) {
		return m_CGdiCache.CreateBrush( aCdBrushProp ) ;};
///@}
// ********************************
//	CDcdTargetGetDC
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	CdDcdZoneXy	getZoneLogical(){
		return m_zoneLogical ;	};
	CdDcdZoneXy	getZonePixel(){	
		return m_zonePixel ;};
	///@}

};
#endif /*CDcdTargetPrinter_h*/

