/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CStrCharSizeMb.cpp
// ****************************************************************
*/
#include <mbstring.h>
#include "CStrCharSizeMb.h"



// ****************************************************************
//	CStrCharSizeMb
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CStrCharSizeMb::CStrCharSizeMb() 
{
	m_ariBidx.push_back( 0 ) ;
}
	
CStrCharSizeMb::CStrCharSizeMb( const std::string& ev ) 
{
	scan( ev ) ;
}
	
// ********************************
//	CStrCharSizeMb
// ********************************
CStrCharSizeMb& CStrCharSizeMb::scan( const std::string& ev ) 
{
	m_ariBidx.clear() ;

	int idx ;
	for ( idx = 0 ; idx < (int)ev.length() ; ){
		m_ariBidx.push_back( idx ) ;
		unsigned char	ch = (unsigned char)ev[idx] ;
		int iSize = _mbclen( &ch ) ;
		idx += iSize ;
	}

	m_ariBidx.push_back( idx ) ;
	return *this ;

}
	
int CStrCharSizeMb::ByteLength()const 
{
	return ( m_ariBidx.back() ) ;
}
	
int CStrCharSizeMb::CharLength()const 
{
	return ( m_ariBidx.size() - 1 ) ;
}
	
int CStrCharSizeMb::CidxOfBidx( int iBidx , int* piOffset )const 
{
	if ( piOffset != NULL ){
		*piOffset = 0 ;
	}
	
	
	if ( iBidx < 0 ){
		return ( -1 ) ;
	}	else if ( iBidx >= ByteLength() ){
		return ( CharLength() );
	}
	
	//V[PVT[`
	//{
	//	int	idx  ;
	//	for ( idx = 0 ; idx < m_ariBidx.size() ; idx ++ ){
	//		if ( m_ariBidx[idx] == iBidx ){
	//			return ( idx ) ; 
	//		}
	//	}
	//}

	//oCiT[`
	int idx = -1 ; 
	int idxBegin = 0 ; 
	int idxEnd = m_ariBidx.size() - 1 ;
	while ( idxBegin <= idxEnd ){
		idx = ( idxBegin + idxEnd ) / 2 ;
		if ( m_ariBidx[idx] == iBidx ){
			break ;
		}	else if ( iBidx < m_ariBidx[idx] ){
			idxEnd = idx - 1 ;
		}	else	{
			idxBegin = idx + 1 ;
		}
	}
	if ( !( idxBegin <= idxEnd ) ){
		//	oCiT[`ŌʂȂꍇA
		//	idxEnd́AΏۂ菬AŊ̒l̃CfNXwĂ܂B
		idx = idxEnd ;	
	}
	if ( piOffset != NULL ){
		*piOffset = iBidx - m_ariBidx[idx] ;
	}

	return ( idx ) ;
}
int CStrCharSizeMb::BidxOfCidx( int iCidx )const 
{
	if ( iCidx < 0 ){
		return ( -1 ) ;
	}	else if ( iCidx >= CharLength() ){
		return ( ByteLength() );
	}
	
	return ( m_ariBidx[ iCidx ] ) ;
}
	
int CStrCharSizeMb::CsizeOfBidx( int iBidx )const 
{
	if ( iBidx < 0 ){
		//iBidx ̐: 0Ԃ܂B
		return ( 0 ) ;	
	}	else if ( iBidx >= ByteLength() ){
		//iBidx ByteLength() ȏ : 0Ԃ܂B
		return ( 0 );
	}
	
	int iOffset = 0 ;
	int iCidx = CidxOfBidx( iBidx , &iOffset ) ;
	if ( iOffset != 0 ){
		//iBidx ̂QoCg: 0Ԃ܂B
		return ( 0 ) ;
	}
	return ( CsizeOfCidx( iCidx ) ) ;
}

int CStrCharSizeMb::CsizeOfCidx( int iCidx )const 
{
	if ( iCidx < 0 ){
		return ( 0 ) ;	//	iCidx ̐/CharLength() ȏ : 0Ԃ܂B
	}	else if ( iCidx >= CharLength() ){
		return ( 0 );	//	iCidx ̐/CharLength() ȏ : 0Ԃ܂B
	}
	
	return ( m_ariBidx[ iCidx + 1 ] - m_ariBidx[ iCidx ] ) ;
}
	
int CStrCharSizeMb::BidxNextChar( int iBidx , int iCharOffset )const 
{
	int iCidx = CidxOfBidx( iBidx ) ;
	//if ( iCidx == -2 ){
	//	return ( -2 ) ;	//	iBidx ̂QoCgڂwĂ : -2 Ԃ܂B
	//}
	
	iCidx += iCharOffset ;
	return ( BidxOfCidx( iCidx ) ) ;
	
}

int CStrCharSizeMb::CidxLast()const 
{
	return ( CharLength() - 1 ) ;
}
	
int CStrCharSizeMb::BidxLast()const 
{
	return ( BidxOfCidx( CharLength() - 1 ) ) ;
}



static const char* const hantozen_table[] = {
	"" , "K" , 
	"" , "M" ,
	"" , "O" ,
	"" , "Q" ,
	"" , "S" ,
	"" , "U" ,
	"" , "W" ,
	"" , "Y" , 
	"" , "[" ,
	"" , "]" ,
	"" , "_" ,
	"" , "a" ,
	"" , "d" ,
	"" , "f" ,
	"" , "h" ,
	"" , "o" ,
	"" , "p" ,
	"" , "s" ,
	"" , "u" ,
	"" , "v" , 
	"" , "x" ,
	"" , "y" ,
	"" , "{" ,
	"" , "|" ,
};

std::string CStrCharSizeMb::strToSingleByte( const std::string& strEv , 
						int* piResult ) 
{
	int iResult = 0 ;
	std::string	strRv ;
	bool bDakutenChange = true ;
	
	// --------------------------------
	CStrCharSizeMb	aCStrCharSizeMb( strEv ) ;
	int iBidx ;
	for ( iBidx = 0 ; iBidx < aCStrCharSizeMb.ByteLength() ; 
				iBidx = aCStrCharSizeMb.BidxNextChar( iBidx ) ){
		if ( aCStrCharSizeMb.CsizeOfBidx( iBidx ) == 1 ){
			strRv += strEv[iBidx] ;
		}	else	{
			unsigned short ch = 0 ;
			ch |= (unsigned char)strEv[iBidx] ;
			ch <<= 8 ;
			ch |= (unsigned char)strEv[iBidx+1] ;
			
			//	ϊ\ɂϊ
			int idxTbl ; 
			for ( idxTbl = 1 ; 
				idxTbl < sizeof(hantozen_table) / sizeof(hantozen_table[0]) ;
				idxTbl += 2 ){
				unsigned short chTbl = 0 ;
				chTbl |= (unsigned char)hantozen_table[idxTbl][0] ;
				chTbl <<= 8 ;
				chTbl |= (unsigned char)hantozen_table[idxTbl][1] ;

				if ( ch == chTbl ){
					strRv += hantozen_table[idxTbl - 1 ] ;
					break ;
				}
			}
			if ( idxTbl < sizeof(hantozen_table) / sizeof(hantozen_table[0]) ){
				continue ;
			}
			
			// --------------------------------
			//	֐ɂϊ
			unsigned short ch2 = _mbctombb( ch ) ;
			if ( ch == ch2 ){
				strRv += (char)( ( ch2 >> 8 ) & 0xff ) ;
				strRv += (char)( ( ch2 >> 0 ) & 0xff ) ;
				iResult = -1 ;
			}	else	{
				strRv += (char)( ( ch2 >> 0 ) & 0xff ) ;
				if ( iResult == 0 ){
					iResult = 1 ;
				}
			}
		}
	}
	
	
	// --------------------------------
	if ( piResult != NULL ){
		*piResult = iResult ;
	}
	return ( strRv ) ;
}

std::string CStrCharSizeMb::strToDoubleByte( const std::string& strEv , 
						int* piResult ) 
{
	int iResult = 0 ;
	std::string	strRv ;
	bool bDakutenChange = true ;
	
	// --------------------------------
	CStrCharSizeMb	aCStrCharSizeMb( strEv ) ;
	int iBidx ;
	for ( iBidx = 0 ; iBidx < aCStrCharSizeMb.ByteLength() ; 
				iBidx = aCStrCharSizeMb.BidxNextChar( iBidx ) ){
		if ( aCStrCharSizeMb.CsizeOfBidx( iBidx ) == 2 ){
			strRv += strEv[iBidx] ;
			strRv += strEv[iBidx+1] ;
		}	else	{
			unsigned short ch = (unsigned char)strEv[iBidx];
			
			//	ϊ\ɂϊ
			if ( bDakutenChange ){
				char b0 = strEv[iBidx] ;
				char b1 = 0 ;
				if ( iBidx < aCStrCharSizeMb.ByteLength() - 1 ){
					b1 = strEv[iBidx+1] ;
				}
				int idxTbl ; 
				for ( idxTbl = 0 ; 
					idxTbl < sizeof(hantozen_table)/sizeof(hantozen_table[0]) ;
					idxTbl += 2 ){
					if ( b0 == hantozen_table[idxTbl][0] && 
							b1 == hantozen_table[idxTbl][1] ){
						strRv += hantozen_table[idxTbl+1][0] ; 
						strRv += hantozen_table[idxTbl+1][1] ;
						if ( b1 != '\0' ){
							//	ϊQg߁A
							//	iBidx ͂QڂɈڂĂ܂B
							iBidx ++ ;
						}
						break ;
					}
				}
				if ( idxTbl<sizeof(hantozen_table)/sizeof(hantozen_table[0] )){
					if ( iResult == 0 ){
						iResult = 1 ;
					}
					continue ;
				}
			}
			// --------------------------------
			//	֐ɂϊ
			unsigned short ch2 = _mbbtombc( ch ) ;
			if ( ch == ch2 ){
				strRv += (char)( ( ch2 >> 0 ) & 0xff ) ;
				iResult = -1 ;
			}	else	{
				strRv += (char)( ( ch2 >> 8 ) & 0xff ) ;
				strRv += (char)( ( ch2 >> 0 ) & 0xff ) ;
				if ( iResult == 0 ){
					iResult = 1 ;
				}
			}
		}
	}
	
	
	// --------------------------------
	if ( piResult != NULL ){
		*piResult = iResult ;
	}
	return ( strRv ) ;
}
