/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessya.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CentDedRessya.h"
#include "CdDedJikan.h"

#ifdef _MFC_VER 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif


// ****************************************************************
//	CentDedRessya
// ****************************************************************

// --------------------------------
//@name CentDedRosenCentDedRessyaCont po֐
// --------------------------------
int CentDedRessya::onSetCentDedEki(const Mu<CentDedEkiCont::CdDedEki>* pCentDedEkiCont , int iEkiOrder) 
{
	int iRv = 0 ;
	return ( iRv ) ;
}
int CentDedRessya::insertCentDedEkiJikoku( 
		const CentDedEkiJikoku& aCentEkiJikoku , 
		int iEkiOrder ) 
{
	int iRv = 0 ;
	// --------------------------------
	if ( iRv >= 0 ){
		if ( iEkiOrder == INT_MAX ){
			iEkiOrder = (int)m_CentDedEkiJikokuCont.size()  ;
		}
		if ( !( 0 <= iEkiOrder && iEkiOrder <= (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	CfNXsłB
		}
	}
	if ( iRv >= 0 ){
		m_CentDedEkiJikokuCont.insert( 
			m_CentDedEkiJikokuCont.begin() + iEkiOrder , 
			new CentDedEkiJikoku( aCentEkiJikoku ) ) ;		
	}
	// --------------------------------
	return ( iRv ) ;
}

int CentDedRessya::eraseCentDedEkiJikoku( int iEkiOrder ) 
{
	int iRv = 0 ;
	// --------------------------------
	if ( iRv >= 0 ){
		if ( iEkiOrder == INT_MAX ){
			iEkiOrder = (int)m_CentDedEkiJikokuCont.size() - 1 ;
		}
		if ( !( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	CfNXsłB
		}
	}
	if ( iRv >= 0 ){
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrder ] ;		
		m_CentDedEkiJikokuCont.erase( 
			m_CentDedEkiJikokuCont.begin() + iEkiOrder ) ;
		delete pCentDedEkiJikoku ;
	}
	// --------------------------------
	return ( iRv ) ;
}

// ********************************
//	RXgN^
// ********************************
CentDedRessya::CentDedRessya( 
		int iEkiJikokuCount ,
		ERessyahoukou	eRessyahoukou ) :
	m_bIsNull( true ) ,
	m_eRessyahoukou( eRessyahoukou ) ,
	m_iRessyasyubetsuIndex( 0 )
{
	while ( (int)m_CentDedEkiJikokuCont.size() < iEkiJikokuCount ){
		m_CentDedEkiJikokuCont.push_back( new CentDedEkiJikoku ) ;
	}
}

CentDedRessya::CentDedRessya( const CentDedRessya& value ) :
	m_bIsNull( value.m_bIsNull ) ,
	m_eRessyahoukou( value.m_eRessyahoukou ) ,
	m_iRessyasyubetsuIndex( value.m_iRessyasyubetsuIndex ) ,
	m_strRessyabangou( value.m_strRessyabangou ),
	m_strRessyamei( value.m_strRessyamei ),
	m_strGousuu( value.m_strGousuu ),
	m_strBikou( value.m_strBikou )
{
	int iEkiOrder ;
	for ( iEkiOrder = 0 ; 
			iEkiOrder < (int)value.m_CentDedEkiJikokuCont.size() ; iEkiOrder ++ ){
		m_CentDedEkiJikokuCont.push_back( new CentDedEkiJikoku( 
			*value.m_CentDedEkiJikokuCont[iEkiOrder] ) ) ;
	} 
}
CentDedRessya& CentDedRessya::operator=( const CentDedRessya& value )
{
	m_bIsNull = value.m_bIsNull ;
	m_iRessyasyubetsuIndex = value.m_iRessyasyubetsuIndex ;
	m_strRessyabangou = value.m_strRessyabangou ;
	m_strRessyamei = value.m_strRessyamei;
	m_strGousuu = value.m_strGousuu;
	m_strBikou = value.m_strBikou;


	int iEkiOrder ;
	for ( iEkiOrder = 0 ; 
			iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ; iEkiOrder ++ ){
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[iEkiOrder] ;
		if ( iEkiOrder < (int)value.m_CentDedEkiJikokuCont.size() ){
			*pCentDedEkiJikoku = *value.m_CentDedEkiJikokuCont[iEkiOrder] ;
		}	else	{
			*pCentDedEkiJikoku = CentDedEkiJikoku() ;
		}
	} 
	return *this ;
}

CentDedRessya::~CentDedRessya() 
{
	while ( m_CentDedEkiJikokuCont.size() > 0 )
	{
		CentDedEkiJikoku*	pCentDedEkiJikoku = m_CentDedEkiJikokuCont.back() ;
		m_CentDedEkiJikokuCont.pop_back() ;
		delete pCentDedEkiJikoku ;
	}
}

// ********************************
//	CentDedRessya
// ********************************
	// ********************************
	//@name 
	// ********************************
ERessyahoukou	CentDedRessya::getRessyahoukou()const
{
		return m_eRessyahoukou ;
};
int	CentDedRessya::getRessyasyubetsuIndex()const
{
		return m_iRessyasyubetsuIndex ; 
};
CentDedRessya& CentDedRessya::setRessyasyubetsuIndex( int value )
{
		m_bIsNull = false ;
		m_iRessyasyubetsuIndex = value ; return *this ;
};
	
	// ********************************
	//@name -CentDedEkiJikoku
	// ********************************

int CentDedRessya::getCentDedEkiJikokuCount()const 
{
	return ( (int)m_CentDedEkiJikokuCont.size() ) ;
}

CentDedEkiJikoku CentDedRessya::
getCentDedEkiJikoku( int iEkiOrder )const 
{
	CentDedEkiJikoku	aCentDedEkiJikoku ;
	if ( iEkiOrder == INT_MAX ){
		iEkiOrder = (int)m_CentDedEkiJikokuCont.size() - 1 ;
	}
	if ( ( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ) ){
		aCentDedEkiJikoku = *m_CentDedEkiJikokuCont[iEkiOrder] ;
	}
	return ( aCentDedEkiJikoku ) ;
}


CentDedRessya& CentDedRessya::
setCentDedEkiJikoku( int iEkiOrder , const CentDedEkiJikoku& value ) 
{
	if ( iEkiOrder == INT_MAX ){
		iEkiOrder = (int)m_CentDedEkiJikokuCont.size() - 1 ;
	}
	if ( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ){
		m_bIsNull = false ;
		*m_CentDedEkiJikokuCont[iEkiOrder] = value ;
	}
	return *this ;
}
	// ********************************
	//@name wwOrderxPʂ̑
	// ********************************
int CentDedRessya::EkiIndexOfEkiOrder( int iEkiOrder )const  
{
	int iRv = iEkiOrder ;
	if ( m_eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = (int)m_CentDedEkiJikokuCont.size() - 1 - iEkiOrder ;
	}
	return ( iRv ) ;
}

int CentDedRessya::EkiOrderOfEkiIndex( int iEkiIndex ) const
{
	int iRv = iEkiIndex ;
	if ( m_eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = (int)m_CentDedEkiJikokuCont.size() - 1 - iEkiIndex ;
	}
	return ( iRv ) ;
}


CentDedRessya& CentDedRessya::modifyCentDedEkiJikoku( 
	int iEkiOrder , 
	const CentDedEkiJikoku& value ) 
{
	if ( iEkiOrder == INT_MAX ){
		iEkiOrder = (int)m_CentDedEkiJikokuCont.size() - 1 ;
	}
	if ( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ){
		m_bIsNull = false ;
	
		//	ύXO̎ۑ
		CdDedJikoku jikokuChakujikokuPrev = 
				m_CentDedEkiJikokuCont[iEkiOrder]->getChakujikoku() ;
		CdDedJikoku jikokuHatsujikokuPrev = 
				m_CentDedEkiJikokuCont[iEkiOrder]->getHatsujikoku() ;
		CdDedJikoku jikokuChakujikoku = value.getChakujikoku() ;
		CdDedJikoku jikokuHatsujikoku =  value.getHatsujikoku() ;
		
		//	w̕ύX
		m_CentDedEkiJikokuCont[iEkiOrder]->set( 
			value.getEkiatsukai() , value.getChakujikoku() , value.getHatsujikoku() ) ;

		//	̌̎̌JグEJ
		if ( !jikokuHatsujikoku.isNull() && !jikokuHatsujikokuPrev.isNull() )
		{
			//	ύXOEύX͂Ăꍇ́A
			//	̓͑OE͌̍߂āA
			//	̉wȍ~Js܂B
			CdDedJikan	aCdDedJikan = jikokuHatsujikoku.subJikoku( 
					jikokuHatsujikokuPrev ) ;
			modifyRessyaJikoku( 
				aCdDedJikan , 
				CdDedJikokuOrder( iEkiOrder + 1 , CdDedJikokuOrder::EkiJikokuItem_Chaku ) ) ;
		}
		else if ( !jikokuChakujikoku.isNull() && !jikokuChakujikokuPrev.isNull() )
		{
			//	ɂJグEJ͂łȂA
			//	ύXOEύX͂Ăꍇ́A
			//	̍߂āA
			//	̉w̔ȍ~Js܂B
			CdDedJikan	aCdDedJikan = jikokuChakujikoku.subJikoku( 
					jikokuChakujikokuPrev ) ;
			modifyRessyaJikoku(
				aCdDedJikan , 
				CdDedJikokuOrder( iEkiOrder , CdDedJikokuOrder::EkiJikokuItem_Hatsu ) ) ;
		}
	}
	return *this ;
}

int CentDedRessya::getSihatsuEki() const
{
	int	iRv = -1 ;
	// --------------------------------
	int iEkiOrder = 0 ;
	for ( iEkiOrder = 0 ; 
			iRv == -1 && 
			iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ; 
			iEkiOrder ++ ){
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrder ] ;
		if ( pCentDedEkiJikoku->getEkiatsukai() != 
				CentDedEkiJikoku::Ekiatsukai_None ){
			iRv = iEkiOrder ;
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

int CentDedRessya::setSihatsuEki( int iEkiOrder ) 
{
	int	iRv = 0 ;

	if ( iRv >= 0 ){
		if ( !( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	wwIndexxsłB
		}
	}

	// --------------------------------
	int iEkiOrderCurr = 0 ;
	for ( iEkiOrderCurr = 0 ; 
			iEkiOrderCurr < iEkiOrder; 
			iEkiOrderCurr ++ ){
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrderCurr ] ;
		pCentDedEkiJikoku->setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
	}
	{
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrderCurr ] ;
		if ( !pCentDedEkiJikoku->getHatsujikoku().isNull() ){
			//	ݒ肳Ăꍇ
			//	܂B
			//	iݒ肳ĂȂꍇɒ
			//	Ă܂ƁẢw̉w
			//	^sȂ Ekiatsukai_None ɂȂĂ܂߂łj
			pCentDedEkiJikoku->setChakujikoku( CdDedJikoku() ) ;
	
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

int CentDedRessya::getSyuuchakuEki() const
{
	int	iRv = -1 ;
	// --------------------------------
	int iEkiOrder = 0 ;
	for ( iEkiOrder = (int)m_CentDedEkiJikokuCont.size() - 1 ; 
			iRv == -1 && 
			iEkiOrder >= 0 ; 
			iEkiOrder -- )
	{
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrder ] ;
		if ( pCentDedEkiJikoku->getEkiatsukai() != 
				CentDedEkiJikoku::Ekiatsukai_None )
		{
			iRv = iEkiOrder ;
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

int CentDedRessya::setSyuuchakuEki( int iEkiOrder ) 
{
	int	iRv = 0 ;

	if ( iRv >= 0 ){
		if ( !( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	wwIndexxsłB
		}
	}

	// --------------------------------
	{
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrder ] ;
		if ( !pCentDedEkiJikoku->getChakujikoku().isNull() ){
			//	ݒ肳Ăꍇ
			//	܂B
			//	iݒ肳ĂȂꍇɔ
			//	Ă܂ƁẢw̉w
			//	^sȂ Ekiatsukai_None ɂȂĂ܂߂łj
			pCentDedEkiJikoku->setHatsujikoku( CdDedJikoku() ) ;

		}
	}
	int iEkiOrderCurr = 0 ;
	for ( iEkiOrderCurr = iEkiOrder + 1  ; 
			iEkiOrderCurr < (int)m_CentDedEkiJikokuCont.size() ; 
			iEkiOrderCurr ++ ){
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrderCurr ] ;
		pCentDedEkiJikoku->setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
	}
	// --------------------------------
	return ( iRv ) ;
}

bool CentDedRessya::isRunBetweenNextEki( int iEkiOrder )const 
{
	bool bRv = false ;
	if ( !( 0 <= iEkiOrder && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() - 1 ) )
	{
		bRv = false ;	//	wwIndexxsłB
	}
	else
	{
		CentDedEkiJikoku* pEkijikoku = m_CentDedEkiJikokuCont[ iEkiOrder ] ;
		CentDedEkiJikoku* pEkijikokuNext = m_CentDedEkiJikokuCont[ iEkiOrder + 1 ] ;
		if ( 
			( pEkijikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya 
				|| pEkijikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
			&& ( pEkijikokuNext->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya 
				|| pEkijikokuNext->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
		)
		{
			bRv = true ;
		}

	}
	return bRv ;
}

int CentDedRessya::getRunFirstEkiOrder()const 
{
	int iRv = -1 ;
	for ( int iEkiOrder = 0 ; 
		iRv == -1 && iEkiOrder < (int)m_CentDedEkiJikokuCont.size() - 1 ; 
		iEkiOrder ++ )
	{
		if ( isRunBetweenNextEki( iEkiOrder ) )
		{
			iRv = iEkiOrder ;
		}
	}
	return iRv ;
}
	
int CentDedRessya::getRunLastEkiOrder()const 
{
	int iRv = -1 ;
	for ( int iEkiOrder = m_CentDedEkiJikokuCont.size() - 2 ; 
		iRv == -1 && iEkiOrder >= 0 ; 
		iEkiOrder -- )
	{
		if ( isRunBetweenNextEki( iEkiOrder ) )
		{
			iRv = iEkiOrder + 1 ;
		}
	}
	return iRv ;
}

void CentDedRessya::adjustByEkijikokukeisiki(
		int iEkiOrder ,
		bool bChakujikokuHyouji , bool bHatsujikokuHyouji ) 
{
	if ( !m_bIsNull )
	{
		bool bSihatsuEki = ( getSihatsuEki() == iEkiOrder ) ;
		bool bSyuuchakuEki = ( getSyuuchakuEki() == iEkiOrder ) ;

		CentDedEkiJikoku aEkiJikoku = getCentDedEkiJikoku(iEkiOrder) ;
		aEkiJikoku.adjustByEkijikokukeisiki( 
			bChakujikokuHyouji , bHatsujikokuHyouji,
			bSihatsuEki , bSyuuchakuEki ) ;
		setCentDedEkiJikoku( iEkiOrder , aEkiJikoku ) ;
	}
}


	// ********************************
	//@name wOrderxPʂ̑
	// ********************************
CdDedJikokuOrder CentDedRessya::incJikokuOrder( 
		const CdDedJikokuOrder& aJikokuOrder )const 
{
	CdDedJikokuOrder jikokuOrderRv = aJikokuOrder ;


	//	- aJikokuOrder  EkiOrder>=this.size() (Ō̉wOrder̎) ȂA@n
	//		aJikokuOrder ̂܂ܕԂ܂B
	//	- aJikokuOrder NULL ȂAaJikokuOrder ̂܂ܕԂ܂B
	if ( !aJikokuOrder.getIsNull() && 
		aJikokuOrder.getEkiOrder() < (int)m_CentDedEkiJikokuCont.size() )
	{
		//	- aJikokuOrder ̏ꍇ́AwOrder̔
		if ( jikokuOrderRv.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Chaku )
		{
			jikokuOrderRv.setEkiOrder( jikokuOrderRv.getEkiOrder() , 
				CdDedJikokuOrder::EkiJikokuItem_Hatsu );
		}
		else if ( jikokuOrderRv.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Hatsu )
		{
			//- aJikokuOrder ̏ꍇ́ẢwOrder̒
			jikokuOrderRv.setEkiOrder( jikokuOrderRv.getEkiOrder() + 1 , 
				CdDedJikokuOrder::EkiJikokuItem_Chaku );
		}
	}
	return jikokuOrderRv ;
}

CdDedJikokuOrder CentDedRessya::decJikokuOrder( 
		const CdDedJikokuOrder& aJikokuOrder )const 
{
	CdDedJikokuOrder jikokuOrderRv = aJikokuOrder ;

	//	- aJikokuOrder NULL ȂAaJikokuOrder ̂܂ܕԂ܂B
	if ( !aJikokuOrder.getIsNull() )
	{ 
		//- aJikokuOrder  EkiOrder>=this.size() (Ō̉wOrder̎) ȂA@n
		//	Ō̉wOrder̔
		if ( aJikokuOrder.getEkiOrder() >= (int)m_CentDedEkiJikokuCont.size() )
		{
			jikokuOrderRv.setEkiOrder( m_CentDedEkiJikokuCont.size() - 1, 
				CdDedJikokuOrder::EkiJikokuItem_Hatsu ) ;
		}
		//- aJikokuOrder ̏ꍇ́AwOrder̒
		else if ( aJikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Hatsu )
		{
			jikokuOrderRv.setEkiOrder( aJikokuOrder.getEkiOrder() , 
				CdDedJikokuOrder::EkiJikokuItem_Chaku ) ; 
		}
		//- aJikokuOrder ̏ꍇ́ẢwOrder̔
		//- aJikokuOrder  EkiOrder=0 ̒ȂANULL
		else if (  aJikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Chaku )
		{
			jikokuOrderRv.setEkiOrder( aJikokuOrder.getEkiOrder() - 1 , 
				CdDedJikokuOrder::EkiJikokuItem_Hatsu ) ; 
		}
	}
	return jikokuOrderRv ;
}



CdDedJikoku CentDedRessya::getEkiJikoku( CdDedJikokuOrder aJikokuOrder )const 
{
	CdDedJikoku	aCdDedJikoku ;
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( !( 0 <= aJikokuOrder.getEkiOrder() && 
				aJikokuOrder.getEkiOrder() < (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	p[^s
		}
	}
	if ( iRv >= 0 ){
		if ( aJikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Hatsu ){
			aCdDedJikoku = 
				m_CentDedEkiJikokuCont[ aJikokuOrder.getEkiOrder() ]->getHatsujikoku() ;
		}	else	{
			aCdDedJikoku = 
				m_CentDedEkiJikokuCont[ aJikokuOrder.getEkiOrder() ]->getChakujikoku() ;
		}
	}
	return ( aCdDedJikoku ) ;
}

int CentDedRessya::setEkiJikoku( 
		const CdDedJikoku& aCdDedJikoku ,
		CdDedJikokuOrder aJikokuOrder ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( !( 0 <= aJikokuOrder.getEkiOrder() && 
				aJikokuOrder.getEkiOrder() < (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	p[^s
		}
	}
	if ( iRv >= 0 ){
		if ( aJikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Hatsu ){
			m_CentDedEkiJikokuCont[ aJikokuOrder.getEkiOrder() ]->setHatsujikoku(
				aCdDedJikoku ) ;
		}	else	{
			m_CentDedEkiJikokuCont[ aJikokuOrder.getEkiOrder() ]->setChakujikoku(
				aCdDedJikoku ) ;
		}
	}
	return ( iRv ) ;
}

int CentDedRessya::modifyRessyaJikoku( 
	const CdDedJikan& aCdDedJikan , 
	const CdDedJikokuOrder& aJikokuOrder ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( !( 0 <= aJikokuOrder.getEkiOrder() && 
				aJikokuOrder.getEkiOrder() < (int)m_CentDedEkiJikokuCont.size() ) ){
			iRv = -1 ;	//	p[^s
		}
	}
	if ( iRv >= 0 ){
		CdDedJikokuOrder iJikokuOrderCurr ;
		for ( iJikokuOrderCurr = aJikokuOrder ;
			iJikokuOrderCurr.getEkiOrder() < (int)m_CentDedEkiJikokuCont.size() ;
			iJikokuOrderCurr = incJikokuOrder( iJikokuOrderCurr ) )
		{
			CdDedJikoku aCdDedJikoku = getEkiJikoku( iJikokuOrderCurr ) ;
			if ( !aCdDedJikoku.isNull() )
			{
				aCdDedJikoku = aCdDedJikoku.addSeconds( 
					aCdDedJikan.getTotalSeconds() ) ;
				setEkiJikoku( aCdDedJikoku , iJikokuOrderCurr ) ;
			}
		}
	}
	return ( iRv ) ;
	
}

CdDedJikokuOrder CentDedRessya::findrevJikoku( 
	const CdDedJikokuOrder& jikokuOrder )const 
{
	CdDedJikokuOrder aJikokuOrder = jikokuOrder ;
	CdDedJikokuOrder iRv  ;
	
	for ( ; 
		iRv.getIsNull() && aJikokuOrder.getEkiOrder() >= 0 ; 
		aJikokuOrder = decJikokuOrder(  aJikokuOrder ) )
	{
		CdDedJikoku	aCdDedJikoku = getEkiJikoku( aJikokuOrder ) ;
		if ( !aCdDedJikoku.isNull() )
		{
			iRv = aJikokuOrder ;
		}
	}
	return ( iRv ) ;
}
	
	
	// ********************************
	//@name 
	// ********************************
bool CentDedRessya::isNull()const 
{
	return ( m_bIsNull ) ;
}

void CentDedRessya::clear() 
{
	m_bIsNull = true ;
	m_iRessyasyubetsuIndex = 0 ;
	m_strRessyabangou.erase() ;
	m_strRessyamei.erase() ;
	m_strGousuu.erase() ;
	m_strBikou.erase() ;	

	for ( int iEkiOrder = 0 ; 
			iEkiOrder < (int)m_CentDedEkiJikokuCont.size() ; 
			iEkiOrder ++ ){
		CentDedEkiJikoku*	pCentDedEkiJikoku = 
			m_CentDedEkiJikokuCont[ iEkiOrder ] ;
		pCentDedEkiJikoku->setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
	}

}

void CentDedRessya::pasteEkiJikoku( const CentDedRessya& aCentDedRessyaSrc ) 
{
	
	int iEkiOrder = 0 ;
	for ( iEkiOrder = 0 ; 
		iEkiOrder < (int)m_CentDedEkiJikokuCont.size()  ; 
			iEkiOrder ++ )
	{
		CentDedEkiJikoku aCentDedEkiJikokuSrc = 
			aCentDedRessyaSrc.getCentDedEkiJikoku( iEkiOrder ) ;
		if ( aCentDedEkiJikokuSrc.getEkiatsukai() != 
				CentDedEkiJikoku::Ekiatsukai_None  )
		{
			CentDedEkiJikoku* pCentDedEkiJikokuDst = m_CentDedEkiJikokuCont[iEkiOrder] ;
			pCentDedEkiJikokuDst->setEkiatsukai( aCentDedEkiJikokuSrc.getEkiatsukai() ) ;
			
			if ( !aCentDedEkiJikokuSrc.getChakujikoku().isNull() )
			{
				pCentDedEkiJikokuDst->setChakujikoku( aCentDedEkiJikokuSrc.getChakujikoku() ) ;
			}
			if ( !aCentDedEkiJikokuSrc.getHatsujikoku().isNull() )
			{
				pCentDedEkiJikokuDst->setHatsujikoku( aCentDedEkiJikokuSrc.getHatsujikoku() ) ;
			}
			
		}
	}
}

int CentDedRessya::direct( 
		const CentDedRessya& aRessyaSihatsu ) 
{
	int iRv = 0 ;

	int iEkiOrderSyuuchaku = -1 ;
	int iEkiOrderSihatsu = -1 ;

	//	thisԂ̏IwEnԂ̎nw̎擾
	if ( iRv >= 0 )
	{
		iEkiOrderSyuuchaku = getRunLastEkiOrder() ;
		iEkiOrderSihatsu = aRessyaSihatsu.getRunFirstEkiOrder() ;
		if ( iEkiOrderSyuuchaku == -1 )
		{
			iRv = -1 ;	//	̗Ԃɂ͉ww肳Ă܂B
		}
		else if ( iEkiOrderSihatsu == -1 )
		{
			iRv = -2 ;	//	nԂɂ͉ww肳Ă܂B
		}
		else if ( !( iEkiOrderSyuuchaku <= iEkiOrderSihatsu ) )
		{
			iRv = -3 ;	//	aRessyaSihatsu Ƃ̒ʉ͂ł܂B\n
			//aRessyaSihatsu ̎nẃA	this ̏IwƓAȍ~łȂĂ͂Ȃ܂B
		}
	}
	//iEkiOrderSyuuchaku = thisԂ̏Iw̉wOrder
	//iEkiOrderSihatsu = aRessyaSihatsu ̎nw̉wOrder

	//	Iw`nw܂ł̊Ԃ́AoRȂƂ܂B
	if ( iRv <= 0 )
	{
		for ( int iEkiOrder = iEkiOrderSyuuchaku + 1 ;
			iEkiOrder < iEkiOrderSihatsu ;
			iEkiOrder ++ )
		{
			setCentDedEkiJikoku( 
				iEkiOrder , 
				CentDedEkiJikoku( CentDedEkiJikoku::Ekiatsukai_Keiyunasi , CdDedJikoku() , CdDedJikoku() ) 
				);
		}
	}

	//	nԂ̎nw
	//
	//nw̎(ʉ)́Aȉ̂悤ɂȂ܂B
	//- wFς܂B
	//- F
	//  - thisԂɒw肳ĂꍇF̒
	//  - thisԂɒȂAw肳ĂꍇFrw~܂Ԃ̔
	//  - thisԂɒw肳ĂȂꍇF͂Ȃ
	//- 
	//  - nԂɔw肳ĂꍇF̔𒼒ʉԂ̔Ƃ܂B
	//  - nԂɔȂAw肳ĂꍇFrwnԂ̒AVԂ̔Ƃ܂B
	//  - nԂɒw肳ĂȂꍇF͂Ȃ
	if ( iRv <= 0 )
	{
		CentDedEkiJikoku	aCentDedEkiJikokuSyuuchaku = getCentDedEkiJikoku( iEkiOrderSihatsu ) ;
		CentDedEkiJikoku	aCentDedEkiJikokuSihatsu = aRessyaSihatsu.getCentDedEkiJikoku( iEkiOrderSihatsu ) ;

		CentDedEkiJikoku	aCentDedEkiJikokuNew = aCentDedEkiJikokuSyuuchaku ;
		//- F
		if ( !aCentDedEkiJikokuSyuuchaku.getChakujikoku().isNull() )
		{
			//@rw~܂̗Ԃɒw肳ĂꍇF̒
			aCentDedEkiJikokuNew.setChakujikoku( aCentDedEkiJikokuSyuuchaku.getChakujikoku() ) ;
		}
		else if ( !aCentDedEkiJikokuSyuuchaku.getHatsujikoku().isNull() )
		{
			//@rw~܂̗ԂɒȂAw肳ĂꍇFrw~܂Ԃ̔
			aCentDedEkiJikokuNew.setChakujikoku( aCentDedEkiJikokuSyuuchaku.getHatsujikoku() ) ;
		}
		else
		{
			//@rw~܂̗Ԃɒw肳ĂȂꍇF͂Ȃ
			aCentDedEkiJikokuNew.setChakujikoku( CdDedJikoku() ) ;
		}


		//- 
		if ( !( aCentDedEkiJikokuSihatsu.getHatsujikoku().isNull() ) )
		{
			//  - nԂɔw肳ĂꍇF̔𒼒ʉԂ̔Ƃ܂B
			aCentDedEkiJikokuNew.setHatsujikoku( aCentDedEkiJikokuSihatsu.getHatsujikoku() ) ;
		}
		else if ( !( aCentDedEkiJikokuSihatsu.getChakujikoku().isNull() ) )
		{
			//  - nԂɔȂAw肳ĂꍇFrwnԂ̒AVԂ̔Ƃ܂B
			aCentDedEkiJikokuNew.setHatsujikoku( aCentDedEkiJikokuSihatsu.getChakujikoku() ) ;
		}
		else
		{
			//  - nԂɒw肳ĂȂꍇF͂Ȃ
			aCentDedEkiJikokuNew.setHatsujikoku( CdDedJikoku() ) ;
		}
		setCentDedEkiJikoku( iEkiOrderSihatsu , aCentDedEkiJikokuNew ) ;
	}

	//	nw̉w
	if ( iRv <= 0 )
	{
		for ( int iEkiOrder = iEkiOrderSihatsu + 1 ; 
			iEkiOrder < (int)m_CentDedEkiJikokuCont.size()  ; 
				iEkiOrder ++ )
		{
			CentDedEkiJikoku	aCentDedEkiJikokuSihatsu = aRessyaSihatsu.getCentDedEkiJikoku( iEkiOrder ) ;
			setCentDedEkiJikoku( iEkiOrder , aCentDedEkiJikokuSihatsu ) ;
		}
	}
	return iRv ;
}

int CentDedRessya::undirect(
		int iEkiOrder , 
		CentDedRessya* pCentDedRessyaSyuuchaku ,
		CentDedRessya* pCentDedRessyaSihatsu )const 
{
	int iRv = 0 ;


	//rw~܂Ԃ̏IwOrder
	//([IwOrder̉wƏIwOrder-1̉ẘԂɗԉ^sȂ]
	//̏ŮԂ́AIwOrder--B
	//IwOrder0ȂG[)
	//[IwOrder==0]G[
	int iEkiOrderSyuuchaku = -1 ;
	if ( iRv >= 0 )
	{
		for ( iEkiOrderSyuuchaku = iEkiOrder ;
			iEkiOrderSyuuchaku > 0 && !isRunBetweenNextEki( iEkiOrderSyuuchaku - 1 ) ;
			iEkiOrderSyuuchaku -- )
		{
		}
		if ( iEkiOrderSyuuchaku == 0 )
		{
			iRv = -1 ;	//	w̉wOrderł́Af͂ł܂
		}
	}

	//rwnԂ̎nwIndex
	//([nwOrder̉wƎnwOrder+1̉ẘԂɗԉ^sȂ]
	//̏ŮԂ́AnwrOder++B)
	//[nwOrder==w-1]G[
	int iEkiOrderSihatsu = -1 ;
	if ( iRv >= 0 )
	{
		for ( iEkiOrderSihatsu = iEkiOrder ;
			iEkiOrderSihatsu < (int)m_CentDedEkiJikokuCont.size() - 1 && 
				!isRunBetweenNextEki( iEkiOrderSihatsu ) ;
			iEkiOrderSihatsu ++ )
		{
		}
		if ( iEkiOrderSihatsu == m_CentDedEkiJikokuCont.size() - 1 )
		{
			iRv = -1 ;	//	w̉wOrderł́Af͂ł܂
		}
	}
	//fԂ̃Rs[2쐬B
	//rw~܂ԁErwnԂƂB
	//rw~܂Ԃ̕AIwOrderœwǂ܂ɂ
	//rwnԂ̕AnwOrderœwnɂ
	if ( iRv >= 0 )
	{
		*pCentDedRessyaSyuuchaku = *this ;
		pCentDedRessyaSyuuchaku->setSyuuchakuEki( iEkiOrderSyuuchaku ) ;
		*pCentDedRessyaSihatsu = *this ;
		pCentDedRessyaSihatsu->setSihatsuEki( iEkiOrderSihatsu ) ;
	}	

	return iRv ;
}
