/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdFillRectangleTextV2.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include <deque>
using namespace std ;

#include "CDcdFillRectangleTextV2.h"

#include "str/CStrCharSizeMb.h"
#include "Mu/CMup_deque.h"
#include "logmsg/logmsg.h"
#include "DcDraw/CaDcdTargetItemPosition.h"
#include "DcDraw/CConverter_WinGdi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ****************************************************************
//	CDcdFillRectangleTextV2
// ****************************************************************
// --------------------------------
//@name ֐
// --------------------------------
Ou<CGdiHFontHolder> CDcdFillRectangleTextV2::CreateVFont( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& fontHorizontal ) 
{
	Ou<CGdiHFontHolder> pfontVertical ;
	{
		CdFontProp	aCdFontPropV = fontHorizontal ;
		string strFacename = aCdFontPropV.getFacename() ;
		if ( !( strFacename.size() >= 1 && strFacename.substr( 0 , 1 ) 
				== "@" ) ){
			strFacename = string( "@" ) + strFacename ;
		}
		aCdFontPropV.setFacename( strFacename ) ;
		aCdFontPropV.setIsEscapementVertical() ;
		pfontVertical = pIfDcdTarget->createGdiHFontHolder( aCdFontPropV ) ;
	}
	return ( pfontVertical ) ;
}
CdDcdSizeXy CDcdFillRectangleTextV2::calcZenkakuCharExtent(
		IfDcdTarget* pIfDcdTarget , const CdFontProp& aCdFontProp ) 
{
	CdDcdSizeXy	sizeExtent ;
	{
		Ou<CGdiHFontHolder> pFontHolder = pIfDcdTarget->createGdiHFontHolder( aCdFontProp ) ;
		// --------------------------------
		HFONT hFontOld = (HFONT)SelectObject( 
			pIfDcdTarget->getHdc() , 
			pFontHolder->getHFont() ) ;
		TEXTMETRIC	aTEXTMETRIC ;
		GetTextMetrics( pIfDcdTarget->getHdc() , &aTEXTMETRIC ) ;
		sizeExtent.setX( aTEXTMETRIC.tmHeight ) ;
		sizeExtent.setY( aTEXTMETRIC.tmMaxCharWidth ) ;

		sizeExtent.setX( max( sizeExtent.getX() , sizeExtent.getY() ) ) ;
		sizeExtent.setY( sizeExtent.getX() ) ;

		// --------------------------------
		if ( hFontOld != NULL ){
			SelectObject( pIfDcdTarget->getHdc() , hFontOld ) ;
		}
	}
	return sizeExtent ;
}


CDcdText CDcdFillRectangleTextV2::createCDcdTextH( 
		const CdFontProp&	aCdFontProp , 
		const CdColorProp& colorrefText ) 
{
	CDcdText	aCDcdText( 
		"" , 
		CdDrawTextProp( aCdFontProp , colorrefText ) , 
		"00" ) ;
	//	aCDcdText ́A㉺E񂹂ɂ܂B
	//	́ApP\ۂɁAɕ\邽߂łB
	{
		CdDrawTextProp	aCdDrawTextProp = aCDcdText.getCdDrawTextProp() ;
		aCdDrawTextProp.setCdDrawTextFormat( 
			CdDrawTextFormat(
				 CdDrawTextFormat::H_CENTER , 
				CdDrawTextFormat::V_SINGLELINT_CENTER 
			) 
		) ;
		aCDcdText.setCdDrawTextProp( aCdDrawTextProp ) ;
	}
	return aCDcdText ;
}

static bool isSpace( const string& aStr )
{
	static char* kyoukai[] = {
		" " , "@" ,
	};
	for ( int idx = 0 ; idx < sizeof(kyoukai) / sizeof(kyoukai[0]) ; idx ++ ){
		if ( aStr == kyoukai[idx] ) {
			return true ;
		}
	}
	return ( false ) ;
}

static bool isKyoukai( const string& aStr )
{
	static char* kyoukai[] = {
		"," , "C" ,
		"." , "D" ,
		      "B" , 
		      "A" , 
	};
	for ( int idx = 0 ; idx < sizeof(kyoukai) / sizeof(kyoukai[0]) ; idx ++ ){
		if ( aStr == kyoukai[idx] ) {
			return true ;
		}
	}
	return ( false ) ;
}

int CDcdFillRectangleTextV2::StringToMojiretsuyouso( 
		const string& aStr , 
		Mup<CMojiretsuyouso>* pCMojiretsuyousoCont ) 
{
	int iRv = 0 ;

	//	̃Rei܂ŕێĂvf͔j܂B
	pCMojiretsuyousoCont->erase( 0 , INT_MAX ) ;

	CStrCharSizeMb	aCStrCharSizeMb( aStr ) ;
	for ( int bidx = 0 ; 
			bidx < aCStrCharSizeMb.ByteLength() ; 
			bidx = aCStrCharSizeMb.BidxNextChar( bidx ) )
	{
		LogMsgL( 3 , "CDcdFillRectangleTextV2::StringToMojiretsuyouso"
			"bidx=%d CsizeOfBidx=%d" , bidx , aCStrCharSizeMb.CsizeOfBidx( bidx ) ) ;

		string strChar = aStr.substr( bidx , 
			aCStrCharSizeMb.CsizeOfBidx( bidx ) ) ;
		CMojiretsuyouso*	pCMojiretsuyousoPrev = NULL ;
		if ( pCMojiretsuyousoCont->size() > 0 )
		{
			pCMojiretsuyousoPrev = pCMojiretsuyousoCont->getp( INT_MAX ) ;
		}
		//strChar = ̕B
		//aCMojiretsuyousoPrev = O̕vf

		if ( aCStrCharSizeMb.CsizeOfBidx( bidx ) == 1 )
		{
			//	͂̕PoCg

			string strCharPrev ;
			if ( pCMojiretsuyousoPrev != NULL ){
				strCharPrev = pCMojiretsuyousoPrev->getBubunMojiretsu().substr( 
					pCMojiretsuyousoPrev->getBubunMojiretsu().size() - 1 , 1 ) ;
			}
			//strCharPrev = O̕vf̖̕

			if ( !isSpace( strChar ) && 
				pCMojiretsuyousoPrev != NULL && 
				pCMojiretsuyousoPrev->getType() == CMojiretsuyouso::V_HANKAKU &&
				!isKyoukai( strCharPrev ) && !isSpace( strCharPrev ) )
			{
				//	͋̕󔒈ȊÔPoCgŁA
				//	( O̕vf V_HANKAKU A
				//	AO̕vf؂蕶󔒂ŏIĂȂ
				//	) 
				//	ꍇ́AO̕vfɕǉ܂B
				//
				pCMojiretsuyousoPrev->setBubunMojiretsu( 
					pCMojiretsuyousoPrev->getBubunMojiretsu() + strChar ) ;
			}
			else
			{
				//	vfǉ܂B
				CMojiretsuyouso	aCMojiretsuyouso ;

				aCMojiretsuyouso.setBubunMojiretsu( strChar ) ;
				aCMojiretsuyouso.setType( CMojiretsuyouso::V_HANKAKU ) ;

				pCMojiretsuyousoCont->insert( aCMojiretsuyouso ) ;
			}
		}
		else if ( aCStrCharSizeMb.CsizeOfBidx( bidx ) == 2 )
		{
			//	͂̕QoCgłꍇ́Avfǉ܂B

			//	͂̕QoCg̋؂蕶ŁA
			//	( O̕vf V_ZENKAKU 
			//	) 
			//	ꍇ́AO̕vfɕǉ܂B
			//
			if ( isKyoukai( strChar ) && 
				pCMojiretsuyousoPrev != NULL && 
				pCMojiretsuyousoPrev->getType() == CMojiretsuyouso::V_ZENKAKU )
			{
				pCMojiretsuyousoPrev->setBubunMojiretsu( 
					pCMojiretsuyousoPrev->getBubunMojiretsu() + strChar ) ;
			}
			else
			{
				//	Vvfǉ܂B
				CMojiretsuyouso	aCMojiretsuyouso ;
				aCMojiretsuyouso.setBubunMojiretsu( strChar ) ;
				aCMojiretsuyouso.setType( CMojiretsuyouso::V_ZENKAKU ) ;
				pCMojiretsuyousoCont->insert( aCMojiretsuyouso ) ;

			}
		}

	}
	//pCMojiretsuyousoCont =  V_ZENKAKU  V_HANKAKU ̂Q
	//	vfɕ܂B
	//	V_ZENKAKU ́AƂđSpPłB
	//	AA[Sp][Sp؂蕶]
	//	́A[Sp+Sp؂蕶]̂P̗vfɂȂĂ܂B
	//	V_HANKAKU ́AApP̗vfƂ܂B

	// --------------------------------	
	int idxMojiretsuyouso ;
	for ( idxMojiretsuyouso = 0 ; 
			idxMojiretsuyouso < pCMojiretsuyousoCont->size() ;
			idxMojiretsuyouso ++ )
	{
		//	̕vfppPQ 
		//	AND 
		//	( 
		//		( O̕vf݂Ȃ)
		//		OR
		//		( O̕vfi󔒈ȊO̔p̗vfjłȂ)
		//	) 
		//	
		//	̏ꍇ́Aɔpp1E2ŕׂ܂B
		CMojiretsuyouso* pCMojiretsuyousoPrev = NULL ;
		if ( idxMojiretsuyouso > 0 )
		{
			pCMojiretsuyousoPrev = pCMojiretsuyousoCont->getp( idxMojiretsuyouso - 1 ) ;
		}
		CMojiretsuyouso* pCMojiretsuyouso = pCMojiretsuyousoCont->getp( idxMojiretsuyouso ) ;
		string strCurr = pCMojiretsuyouso->getBubunMojiretsu() ;
		if ( pCMojiretsuyouso->getType() == CMojiretsuyouso::V_HANKAKU )
		{
			if ( 
				( strCurr.size() == 1 && isdigit( (unsigned char)strCurr[0] ) ) || 
				( strCurr.size() == 2 && isdigit( (unsigned char)strCurr[0] ) && isdigit( (unsigned char)strCurr[1] ) ) 
			){

				if ( pCMojiretsuyousoPrev == NULL || 
					!(  
						pCMojiretsuyousoPrev->getType() == CMojiretsuyouso::V_HANKAKU && 
						!isSpace( pCMojiretsuyousoPrev->getBubunMojiretsu() ) 
					) 
				){
					pCMojiretsuyouso->setType( CMojiretsuyouso::H_HANKAKU ) ;
				}
			}
				
		}

	}
	

	// --------------------------------	
	return ( iRv ) ;
}

int CDcdFillRectangleTextV2::MojiretsuyousoToMojiretsuyousoPlace( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& fontHorizontal ,
		const Mu<CMojiretsuyouso>* pCMojiretsuyousoCont ,
		Mui<CMojiretsuyousoPlace>* pCMojiretsuyousoPlaceCont ) 
{
	int iRv = 0 ;
	
	// --------------------------------
	CdDcdZoneXy	zonexyTarget = pIfDcdTarget->getZone() ;
	pCMojiretsuyousoPlaceCont->erase( 0 , INT_MAX ) ;
	// --------------------------------
	//	tHg쐬
	// --------------------------------
	Ou<CGdiHFontHolder> pfontVertical = CreateVFont( pIfDcdTarget , fontHorizontal ) ;
	//hFontVertical = c̃tHg
	
	CDcdText aCDcdText( createCDcdTextH( 
				fontHorizontal , CdColorProp( 0 , 0 , 0 ) ) ) ;
	//aCDcdText = eLXgṕADcDrawIuWFNg
	

	// --------------------------------
	int logicalunitYOffset = 0 ;
	int iXLineNumber = 0 ;
	
	int idxMojiretsuyousoCont ;
	for ( idxMojiretsuyousoCont = 0 ; 
			idxMojiretsuyousoCont < pCMojiretsuyousoCont->size() ;){
		CMojiretsuyouso	aCMojiretsuyouso = 
			pCMojiretsuyousoCont->get( idxMojiretsuyousoCont ) ;
		if ( aCMojiretsuyouso.getType() == CMojiretsuyouso::V_ZENKAKU || 
				aCMojiretsuyouso.getType() == CMojiretsuyouso::V_HANKAKU ){
			HFONT hFontOld = (HFONT)SelectObject( pIfDcdTarget->getHdc() , 
				pfontVertical->getHFont() ) ;
			// --------------------------------
			//	ނ̘Awx
			//	I[T܂B
			//	AAsɕ\łȂꍇ́A
			//	ł؂܂B
			// --------------------------------
			string strMojiretsu ;
			int idxMojiretsuyousoEnd = idxMojiretsuyousoCont ;
			int logicalunitYSize = 0 ;
			int iXLineWidth = 0 ;
			for ( idxMojiretsuyousoEnd = idxMojiretsuyousoCont ;
				idxMojiretsuyousoEnd < pCMojiretsuyousoCont->size() ;
				idxMojiretsuyousoEnd ++ ){
				CMojiretsuyouso	aCMojiretsuyousoEnd = 
					pCMojiretsuyousoCont->get( idxMojiretsuyousoEnd ) ;

				
				if ( aCMojiretsuyousoEnd.getType() != 
						aCMojiretsuyouso.getType() ){
					//	́wx́A idxMojiretsuyousoCont ̈ʒu
					//	wxƂ͎ނقȂ܂B
					break ;
				}


				string aString = strMojiretsu + 
					aCMojiretsuyousoEnd.getBubunMojiretsu() ;
				SIZE	aSize ;
				GetTextExtentPoint32( 
					pIfDcdTarget->getHdc() , 
					aString.c_str() , 
					(int)aString.size() , 
					&aSize ) ;
				
				if ( logicalunitYOffset + aSize.cx <= 
						zonexyTarget.getY().getSize() || 
					( logicalunitYOffset == 0 && strMojiretsu.size() == 0 ) ){
					//	́̕A̍siiXLineNumber ̍sj
					//	\ł܂B
					//
					//	@s̐擪ɂ͕KPwx
					//	݂Kv܂B
					strMojiretsu = aString ;
					logicalunitYSize = aSize.cx ;
					iXLineWidth = aSize.cy ;
				}	else	{
					break ;
				}
			}
			//idxMojiretsuyousoEnd = wx̎̃CfNX
			//	wx݂̍siiXLineNumberjɈ`łȂ
			//	ꍇ́A
			//	idxMojiretsuyousoCont == idxMojiretsuyousoEnd ƂȂ܂B
			//
			//	܂Ȁ󋵂ŁAlogicalunitYOffset  0 ̏ꍇ́A
			//	݂̍sɉ`łȂƂɂȂ܂B
			//strMojiretsu = ꂽʂ̕
			//logicalunitYSize = ꂽʂ́̕AỸTCY
			//	i_Pʁj
			if ( idxMojiretsuyousoCont == idxMojiretsuyousoEnd ){
				logicalunitYOffset = 0 ;
				iXLineNumber ++ ;
				continue ;
			}
			CMojiretsuyousoPlace aCMojiretsuyousoPlace( 
				CMojiretsuyouso( strMojiretsu , aCMojiretsuyouso.getType() ) ,
				logicalunitYOffset , iXLineNumber , iXLineWidth ) ;
			pCMojiretsuyousoPlaceCont->insert( aCMojiretsuyousoPlace ) ;

			logicalunitYOffset += logicalunitYSize ;
			idxMojiretsuyousoCont = idxMojiretsuyousoEnd ;
			// --------------------------------
			SelectObject( pIfDcdTarget->getHdc() , hFontOld ) ;
			hFontOld = NULL ;
		}	else if ( aCMojiretsuyouso.getType() == 
				CMojiretsuyouso::H_HANKAKU ){
			// --------------------------------
			//	ނ̘Awx
			//	͍s܂B
			// --------------------------------
			string strMojiretsu ;
			int idxMojiretsuyousoEnd = idxMojiretsuyousoCont ;
			int logicalunitYSize = 0 ;
			int iXLineWidth = 0 ;
			{
				CMojiretsuyouso	aCMojiretsuyousoEnd = 
					pCMojiretsuyousoCont->get( idxMojiretsuyousoEnd ) ;
				
				string aString = strMojiretsu + 
					aCMojiretsuyousoEnd.getBubunMojiretsu() ;
				aCDcdText.setText( aString ) ;
				CdDcdSizeXy aCdDcdSizeXy ;
				aCDcdText.getItemSize( pIfDcdTarget , &aCdDcdSizeXy ) ;

				if ( logicalunitYOffset + aCdDcdSizeXy.getY() <= 
						zonexyTarget.getY().getSize() || 
					( logicalunitYOffset == 0 && strMojiretsu.size() == 0 ) ){
					//	́̕A̍siiXLineNumber ̍sj
					//	\ł܂B
					//
					//	@s̐擪ɂ͕KPwx
					//	݂Kv܂B
					strMojiretsu = aString ;
					logicalunitYSize = aCdDcdSizeXy.getY() ;
					iXLineWidth = aCdDcdSizeXy.getX() ;
					idxMojiretsuyousoEnd ++ ;
				}
			}
			//idxMojiretsuyousoEnd = wx̎̃CfNX
			//	wx݂̍siiXLineNumberjɈ`łȂ
			//	ꍇ́A
			//	idxMojiretsuyousoCont == idxMojiretsuyousoEnd ƂȂ܂B
			//
			//	܂Ȁ󋵂ŁAlogicalunitYOffset  0 ̏ꍇ́A
			//	݂̍sɉ`łȂƂɂȂ܂B
			//strMojiretsu = ꂽʂ̕
			//logicalunitYSize = ꂽʂ́̕AỸTCY
			//	i_Pʁj
			if ( idxMojiretsuyousoCont == idxMojiretsuyousoEnd ){
				logicalunitYOffset = 0 ;
				iXLineNumber ++ ;
				continue ;
			}
			CMojiretsuyousoPlace aCMojiretsuyousoPlace( 
				CMojiretsuyouso( strMojiretsu , aCMojiretsuyouso.getType() ) ,
				logicalunitYOffset , iXLineNumber , iXLineWidth ) ;
			pCMojiretsuyousoPlaceCont->insert( aCMojiretsuyousoPlace ) ;

			logicalunitYOffset += logicalunitYSize ;
			idxMojiretsuyousoCont = idxMojiretsuyousoEnd ;
		}
	}
	
	//debug
	{
		CdDcdZoneXy	zonexyTarget = pIfDcdTarget->getZone() ;
		LogMsgL(3, "CDcdFillRectangleTextV2::MojiretsuyousoToMojiretsuyousoPlace"
			"(X.Pos=%d X.Size=%d Y.Pos=%d Y.Size=%d)" , 
			zonexyTarget.getX().getPos() , 
			zonexyTarget.getX().getSize() , 
			zonexyTarget.getY().getPos() , 
			zonexyTarget.getY().getSize() ) ;
		int idx ;
		for ( idx = 0 ; idx < pCMojiretsuyousoPlaceCont->size() ; idx ++ ){
			CMojiretsuyousoPlace aCMojiretsuyousoPlace = 
				pCMojiretsuyousoPlaceCont->get( idx ) ;
			LogMsgL(3, "\t[%d] \"%s\" %d iY=%d iX=%d iXLineWidth=%d" ,
				idx , 
				aCMojiretsuyousoPlace.getCMojiretsuyouso().getBubunMojiretsu().c_str() ,
				aCMojiretsuyousoPlace.getCMojiretsuyouso().getType() ,
				aCMojiretsuyousoPlace.getYOffset() ,
				aCMojiretsuyousoPlace.getXLineNumber() , 
				aCMojiretsuyousoPlace.getXLineWidth() ) ;

		}
	}
	
	
	
	// --------------------------------
	return ( iRv ) ;
}

bool CDcdFillRectangleTextV2::DcDrawMojiretsuyousoPlace( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& fontHorizontal ,
		const CdColorProp&  colorTextColor , 
		const Mu<CMojiretsuyousoPlace>* pCMojiretsuyousoPlaceCont ) 
{
	bool bRv = false ;

	// --------------------------------
	CdDcdZoneXy	zonexyTarget = pIfDcdTarget->getZone() ;

	// --------------------------------
	//	tHg쐬
	// --------------------------------
	Ou<CGdiHFontHolder>  pfontVertical = CreateVFont( pIfDcdTarget , fontHorizontal ) ;
	CdDcdSizeXy	sizeExtent = calcZenkakuCharExtent( pIfDcdTarget , fontHorizontal) ;
	//hFontVertical = c̃tHg
	//sizeExtent = eLXgSp{bNXP̃TCYB
	//	ATCY͐`ɂȂ悤ɍœK܂B
	//	܂AX,ŶA傫̕ӂɍ킹܂B
	
	CDcdText aCDcdText( createCDcdTextH( 
				fontHorizontal , colorTextColor ) ) ;
	//aCDcdText = eLXgṕADcDrawIuWFNg
	// --------------------------------
	int iLines = 1 ;
	if ( pCMojiretsuyousoPlaceCont->size() > 0 ){
		iLines = pCMojiretsuyousoPlaceCont->get( INT_MAX ).getXLineNumber() 
			+ 1 ;
	}
	//iLines = X̍s

	int iXOffset = 0 ;
	{
		iXOffset = 
			( zonexyTarget.getX().getSize() - iLines * sizeExtent.getX() ) 
			/ 2 ;
	}
	//iXOffset = m_strText ̕`́A[̍WB
	//	́AzonexyTarget.X.Pos ̃ItZbgł

	// --------------------------------
	//	`
	// --------------------------------
	for ( int idxCMojiretsuyousoPlaceCont = 0 ;
			idxCMojiretsuyousoPlaceCont < pCMojiretsuyousoPlaceCont->size() ;
			idxCMojiretsuyousoPlaceCont ++ ){
		CMojiretsuyousoPlace	aCMojiretsuyousoPlace = 
			pCMojiretsuyousoPlaceCont->get( idxCMojiretsuyousoPlaceCont ) ;
		CMojiretsuyouso	aCMojiretsuyouso = 
			aCMojiretsuyousoPlace.getCMojiretsuyouso() ;
		
		int iXPos = zonexyTarget.getX().getPos() + iXOffset + 
				( iLines - 1 - aCMojiretsuyousoPlace.getXLineNumber() ) 
				* sizeExtent.getX() ;
		int iYPos = zonexyTarget.getY().getPos() + 
				aCMojiretsuyousoPlace.getYOffset() ;
		string strChar = aCMojiretsuyouso.getBubunMojiretsu() ;
		
		if ( aCMojiretsuyouso.getType() == CMojiretsuyouso::V_ZENKAKU || 
				aCMojiretsuyouso.getType() == CMojiretsuyouso::V_HANKAKU )
		{
			// --------------------------------
			//	ctHg
			// --------------------------------
			HFONT hfontOld = (HFONT)SelectObject( pIfDcdTarget->getHdc() , 
				pfontVertical->getHFont() ) ;
			int iBkModeOld = SetBkMode( pIfDcdTarget->getHdc() , 
				TRANSPARENT ) ;
			CConverter_WinGdi	aConv ;
			COLORREF colTextColorOld = SetTextColor( 
				pIfDcdTarget->getHdc() , 
				aConv.COLORREFOf( colorTextColor ) ) ;
			// --------------------------------
			TextOut( pIfDcdTarget->getHdc() , 
				//	́{ṔAۂ̉ʂŒl
				iXPos + sizeExtent.getX() + 1 
					- ( sizeExtent.getX() - aCMojiretsuyousoPlace.getXLineWidth() ) / 2 ,
				iYPos , 
				strChar.c_str() , 
				(int)strChar.size() ) ;
			// --------------------------------
			SetTextColor( pIfDcdTarget->getHdc() , colTextColorOld ) ;
			SetBkMode( pIfDcdTarget->getHdc() , iBkModeOld ) ;
			if ( hfontOld != NULL ){
				SelectObject( pIfDcdTarget->getHdc() , hfontOld ) ;
				hfontOld = NULL ;
			}
			bRv = true ;
		}	else if ( aCMojiretsuyouso.getType() == 
				CMojiretsuyouso::H_HANKAKU ){
			// --------------------------------
			//	tHg
			// --------------------------------
			CdDcdZoneXy	zoneChar( 
				CdDcdZone( iXPos, sizeExtent.getX() ) , 
				CdDcdZone( iYPos , sizeExtent.getY() ) ) ;
			aCDcdText.setText( strChar ) ;
			CaDcdTargetItemPosition	aTarget( pIfDcdTarget ,  zoneChar ) ;
			if ( aCDcdText.DcDraw( &aTarget ) ) {
				bRv = true ;
			}
		}
	}


	return ( bRv ) ;
}


// ********************************
//	RXgN^
// ********************************
CDcdFillRectangleTextV2::CDcdFillRectangleTextV2( 
		const tstring&			strText  ,
		const CdFontProp&	aCdFontProp  ,
		int						iLinesExtentX  ,
		int						iLinesExtentY  ,
		const CdColorProp&	colorrefText , 
		int						logicalunitFrameWidth   ,
		int						logicalunitFrameHeight   ,
		const CdPenProp&		aCdPenProp ,
		const CdBrushProp& 		aCdBrushProp )
	: m_CDcdFillrect( aCdBrushProp ) 
	, m_CDcdRectangle(  aCdPenProp ) 
	, m_strText( strText ) 
	, m_CdFontProp( aCdFontProp ) 
	, m_iLinesExtentX( iLinesExtentX )
	, m_iLinesExtentY( iLinesExtentY ) 
	, m_colorrefText( colorrefText ) 
	, m_logicalunitFrameWidth( logicalunitFrameWidth )
	, m_logicalunitFrameHeight( logicalunitFrameHeight )
{
}



CDcdFillRectangleTextV2::CDcdFillRectangleTextV2() 
	: m_iLinesExtentX ( 1 ) 
	, m_iLinesExtentY( 1 ) 
	, m_colorrefText( CdColorProp( 0 , 0 , 0 ) ) 
	, m_logicalunitFrameWidth( 0 )
	, m_logicalunitFrameHeight( 0 )
{
}
	
CDcdFillRectangleTextV2::~CDcdFillRectangleTextV2() 
{
}
// ********************************
//	IfDcDraw
// ********************************
bool CDcdFillRectangleTextV2::DcDraw( IfDcdTarget* pIfDcdTarget ) 
{
	bool	bRv = false ;

	// --------------------------------
	//	wiuV̕`
	// --------------------------------
	{
		if ( m_CDcdFillrect.DcDraw( pIfDcdTarget ) ) {
			bRv = true ;
		}
	}
	// --------------------------------
	//	g̕`
	// --------------------------------
	{
		if ( m_CDcdRectangle.DcDraw( pIfDcdTarget ) ) {
			bRv = true ;
		}
	}

	// ********************************
	//	eLXg̕`
	// ********************************
	CdDcdZoneXy	aCdDcdZoneXy ;
	{
		aCdDcdZoneXy = pIfDcdTarget->getZone() ;
		aCdDcdZoneXy.setX( CdDcdZone( 
			aCdDcdZoneXy.getX().getPos() + m_logicalunitFrameWidth , 
			aCdDcdZoneXy.getX().getSize() - m_logicalunitFrameWidth * 2 )
			)  ;
		aCdDcdZoneXy.setY( CdDcdZone( 
			aCdDcdZoneXy.getY().getPos() + m_logicalunitFrameHeight , 
			aCdDcdZoneXy.getY().getSize() - m_logicalunitFrameHeight * 2 )
			)  ;
	}
	//aCdDcdZoneXy = eLXg`悷̈łB
	//	IfDcdTargeẗ̗悩A㉺E̘g̈̈łB

	{
		CaDcdTargetItemPosition aCaDcdTargetItemPosition( 
			pIfDcdTarget , 
			aCdDcdZoneXy ) ;
		CMup_deque<CMojiretsuyouso> aCMojiretsuyousoCont ;
		StringToMojiretsuyouso( m_strText , &aCMojiretsuyousoCont ) ;
		CMup_deque<CMojiretsuyousoPlace> aCMojiretsuyousoPlaceCont ;
		MojiretsuyousoToMojiretsuyousoPlace( &aCaDcdTargetItemPosition , m_CdFontProp , 
			&aCMojiretsuyousoCont , &aCMojiretsuyousoPlaceCont ) ;
		bRv = DcDrawMojiretsuyousoPlace( &aCaDcdTargetItemPosition , m_CdFontProp , 
			m_colorrefText , &aCMojiretsuyousoPlaceCont ) ;
	}
	return ( bRv ) ;
}


	
bool CDcdFillRectangleTextV2::getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) 
{
	bool bRv = false ;

	CdDcdSizeXy	sizeExtent = calcZenkakuCharExtent( pIfDcdTarget , m_CdFontProp ) ;

	pCdDcdSizeXy->setX( sizeExtent.getX() * m_iLinesExtentX + m_logicalunitFrameWidth * 2 ) ;
	pCdDcdSizeXy->setY( sizeExtent.getY() * m_iLinesExtentY + m_logicalunitFrameHeight * 2 ) ;
	return ( true ) ;
}
