/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdTargetCompatibleBitmap.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CDcdTargetCompatibleBitmap.h"
#include "CConverter_WinGdi.h"

// ****************************************************************
//	CDcdTargetCompatibleBitmap
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CDcdTargetCompatibleBitmap::CDcdTargetCompatibleBitmap( 
	const CdDcdSizeXy& aCdDcdSizeXy , HDC hDc ) 
{
	m_hDc = NULL ;
	m_hBitmap = NULL ;
	m_hBitmapSid = NULL ;
	resetSize( aCdDcdSizeXy , hDc ) ;
}
CDcdTargetCompatibleBitmap::CDcdTargetCompatibleBitmap() 
{
	m_hDc = NULL ;
	m_hBitmap = NULL ;
	m_hBitmapSid = NULL ;
}

CDcdTargetCompatibleBitmap::~CDcdTargetCompatibleBitmap() 
{
	resetSize( CdDcdSizeXy( 0 , 0 )  , NULL ) ;
}
	
	
// ********************************
//	IfDcdTarget
// ********************************
HDC	CDcdTargetCompatibleBitmap::getHdc() 
{
	return ( m_hDc ) ;
}

CdDcdZoneXy CDcdTargetCompatibleBitmap::getZone() 
{
	return ( CdDcdZoneXy( CdDcdPosXy( 0 , 0 ) , m_CdDcdSizeXy ) ) ;
}
	
CdDcdZoneXy CDcdTargetCompatibleBitmap::getDrawableZone() 
{
	return ( CdDcdZoneXy( CdDcdPosXy( 0 , 0 ) , m_CdDcdSizeXy ) ) ;
}


Ou<CGdiHFontHolder>	CDcdTargetCompatibleBitmap::createGdiHFontHolder(  const CdFontProp& aCdFontProp ) 
{
	CConverter_WinGdi	aConv ;
	return aConv.createGdiHFontHolder( aCdFontProp , m_hDc ) ;
}
	
Ou<CGdiHPenHolder> CDcdTargetCompatibleBitmap::createGdiHPenHolder(  const CdPenProp& aCdPenProp )
{
	CConverter_WinGdi	aConv ;
	return aConv.createGdiHPenHolder( aCdPenProp  ) ;
}

Ou<CGdiHBrushHolder> CDcdTargetCompatibleBitmap::createGdiHBrushHolder(  const CdBrushProp& aCdBrushProp ) 
{
	CConverter_WinGdi	aConv ;
	return aConv.createGdiHBrushHolder( aCdBrushProp  ) ;
}

// ********************************
//	CDcdTargetCompatibleBitmap
// ********************************
CdDcdSizeXy CDcdTargetCompatibleBitmap::getSize() 
{
	return ( m_CdDcdSizeXy ) ;
}
	
int CDcdTargetCompatibleBitmap::resetSize( 
		const CdDcdSizeXy& aCdDcdSizeXy , HDC hDc ) 
{
	int	iRv = 0 ;
	// ********************************
	//	DCEBITMAPj
	// ********************************
	if ( iRv == 0 ){
		m_CdDcdSizeXy.setX( 0 ).setY( 0 ) ;

		if ( m_hBitmapSid != NULL ){
			SelectObject( m_hDc , m_hBitmapSid ) ;
			m_hBitmapSid = NULL ;
		}	
		if ( m_hBitmap != NULL ){
			DeleteObject( m_hBitmap ) ;
			m_hBitmap = NULL ;
		}
		if ( m_hDc != NULL ){
			DeleteDC( m_hDc ) ;
			m_hDc = NULL ;
		}
	}
	// ********************************
	//	VDCEBITMAP쐬
	// ********************************
	if ( aCdDcdSizeXy.getX() > 0 && aCdDcdSizeXy.getY() > 0 ){
		bool	bhDcDeleteObligatory = false ;
		if ( hDc == NULL ){
			hDc = GetDC( NULL ) ;
			bhDcDeleteObligatory = true ;
		}

		if ( iRv == 0 ){
			m_hDc = CreateCompatibleDC( hDc ) ;
			if ( m_hDc == NULL ){
				iRv = -1 ;	//	DC̍쐬Ɏs܂
			}
		}	
		if ( iRv == 0 ){
			m_hBitmap = CreateCompatibleBitmap( hDc , aCdDcdSizeXy.getX() , aCdDcdSizeXy.getY() ) ;
			if ( m_hBitmap == NULL ){
				iRv = -2 ;	//	BITMAP̍쐬Ɏs܂
			}
			
		}
		if ( iRv == 0 ){
			m_hBitmapSid = (HBITMAP)SelectObject( m_hDc , m_hBitmap ) ;
		}
		if ( iRv == 0 ){
			m_CdDcdSizeXy = aCdDcdSizeXy ;
		}	
		// --------------------------------
		if ( bhDcDeleteObligatory ){
			ReleaseDC( NULL , hDc ) ;
			hDc = NULL ;
		}
	}	
	
	return ( iRv ) ;
}






