/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CLineFunc.h
// ****************************************************************
*/
/** @file */
#ifndef  CLineFunc_h
#define  CLineFunc_h
#include "DcdCd\Pos\CdDcdPosXy.h"
// ****************************************************************
//	CLineFunc
// ****************************************************************
/**
 * @brief
 * yTvz
 * Q̓_ԒɂA
 *	XWɑΉYWľvZE
 *	YWɑΉXWľvZs܂B
 *
 *	<H4>
 * ygz
 *	</H4>
 *
 *	RXgN^\bhŁA\Q̓_ Pos1 , Pos2 
 *	w肵ĂB
 *
 *	Ȍ́AcalcYofX() , calcXofY() ŁAvZsƂł܂B
 *
 */
class CLineFunc
{
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	m_Pos1  m_Pos2 ́A\Q̓_ ێ܂B
	 */
	CdDcdPosXy	m_Pos1 ;
	/**
	 * @see m_Pos1 
	 */
	CdDcdPosXy	m_Pos2 ;
///@}
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param aPos1,aPos2 [in]
	 *	\Q̓_ w肵ĉB
	 */
	CLineFunc( const CdDcdPosXy& aPos1 , const CdDcdPosXy& aPos2 ) :
		m_Pos1( aPos1 ) , m_Pos2( aPos2 ){} ;
	
	CLineFunc(){} ;
	virtual ~CLineFunc(){} ;
	

// ********************************
//	CLineFunc
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	CdDcdPosXy	getPos1()const{	return m_Pos1 ;};
	CLineFunc& setPos1( const CdDcdPosXy& value ){
		m_Pos1 = value ; return *this ; } ;
	CdDcdPosXy	getPos2()const{ return 	m_Pos2 ;};
	CLineFunc& setPos2( const CdDcdPosXy& value ){
		m_Pos2 = value ; return *this ; } ;
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	 * Q̓_ԒɂAXWɑΉYWl߂܂B
	 * @param iX [in]
	 *	߂YWlɑΉXWl
	 * @return
	 *	YWlԂ܂B
	 *
	 * @attention
	 *	m_Pos1.X == m_Pos2.X ̏ꍇȉꍇj́A
	 *	߂l m_Pos1.Y ƂȂ܂B
	 */
	int calcYofX( int iX ) ;

	/**
	 * Q̓_ԒɂAXWɑΉYWl߂܂B
	 * @param posSrc , posDst [in]
	 *	\Q̓_́AXYWw肵ĂB
	 * @param iX [in]
	 *	߂YWlɑΉXWl
	 * @return
	 *	YWlԂ܂B
	 * @attention
	 *	m_Pos1.Y == m_Pos2.Y ̏ꍇȉꍇj́A
	 *	߂l m_Pos1.X ƂȂ	܂B
	 */
	int calcXofY( int iY ) ;
	///@}
};

#endif /*CLineFunc_h*/
