/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvContentPosToTargetXy.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include <stddef.h>
#include "DcdCd\Pos\CconvContentPosToTargetXy.h"

// ****************************************************************
//	CconvContentPosToTargetXy
// ****************************************************************
	// ********************************
	//	RXgN^
	// ********************************
CconvContentPosToTargetXy::CconvContentPosToTargetXy( 
		CconvContentPosToTarget::EMode	eMode ) 
	: m_convX( eMode )
	, m_convY( eMode )
{
}

CconvContentPosToTargetXy::CconvContentPosToTargetXy( 
		DcdPos	iContentPosX ,
		double dTargetPosPerContentX ,
		DcdPos	iContentPosY ,
		double dTargetPosPerContentY ) 
	: m_convX( iContentPosX , dTargetPosPerContentX )
	, m_convY( iContentPosY , dTargetPosPerContentY ) 
{
}

CconvContentPosToTargetXy::CconvContentPosToTargetXy( 
		DcdPos	iContentPosX ,
		DcdSize	iContentSizeX ,
		DcdPos	iContentPosY ,
		DcdSize	iContentSizeY ) 
	: m_convX( iContentPosX , iContentSizeX )
	, m_convY( iContentPosY , iContentSizeY ) 
{
}

CconvContentPosToTargetXy::CconvContentPosToTargetXy( 
		const CdDcdZoneXy&	zonexyContent ) 
	: m_convX( zonexyContent.getX() )
	, m_convY( zonexyContent.getY() ) 
{
}

CconvContentPosToTargetXy::CconvContentPosToTargetXy() 
{
}

CconvContentPosToTargetXy::~CconvContentPosToTargetXy() 
{
}


	// ********************************
	//@name CconvContentPosToTargetXy-
	// ********************************
CconvContentPosToTarget::EMode	
CconvContentPosToTargetXy::getMode()const 
{
	return m_convX.getMode() ;
}

void CconvContentPosToTargetXy::setMode( CconvContentPosToTarget::EMode	value ) 
{
	m_convX.setMode( value ) ;
	m_convY.setMode( value ) ;
}

void CconvContentPosToTargetXy::setContentPosAndRate( 
		const CdDcdPosXy& posContentPos , 
		double dTargetPosPerContentX , 
		double dTargetPosPerContentY , 
		const CdDcdZoneXy* pTargetZone ) 
{
	CdDcdZone* pTargetZoneX = NULL ;
	CdDcdZone* pTargetZoneY = NULL ;
	CdDcdZone aTargetZoneX ;
	CdDcdZone aTargetZoneY ;
	if ( pTargetZone != NULL )
	{
		aTargetZoneX = pTargetZone->getX() ;
		pTargetZoneX = &aTargetZoneX ;
		aTargetZoneY = pTargetZone->getY() ;
		pTargetZoneY = &aTargetZoneY ;
	}
	// --------------------------------
	m_convX.setContentPosAndRate( 
		posContentPos.getX() , dTargetPosPerContentX, pTargetZoneX );
	m_convY.setContentPosAndRate( 
		posContentPos.getY() , dTargetPosPerContentY, pTargetZoneY );
}

CdDcdZoneXy CconvContentPosToTargetXy::getContentZone( 
	const CdDcdZoneXy* pTargetZone ) 
{
	CdDcdZoneXy	zonexyRv ;
	// --------------------------------
	CdDcdZone* pTargetZoneX = NULL ;
	CdDcdZone* pTargetZoneY = NULL ;
	CdDcdZone aTargetZoneX ;
	CdDcdZone aTargetZoneY ;
	if ( pTargetZone != NULL )
	{
		aTargetZoneX = pTargetZone->getX() ;
		pTargetZoneX = &aTargetZoneX ;
		aTargetZoneY = pTargetZone->getY() ;
		pTargetZoneY = &aTargetZoneY ;
	}
	// --------------------------------
	zonexyRv.setX( m_convX.getContentZone( pTargetZoneX ) );
	zonexyRv.setY( m_convY.getContentZone( pTargetZoneY ) );
	// --------------------------------
	return zonexyRv ;
}

void CconvContentPosToTargetXy::setContentZone( 
	const CdDcdZoneXy& zoneContent , 
	const CdDcdZoneXy* pTargetZone ) 
{
	CdDcdZone* pTargetZoneX = NULL ;
	CdDcdZone* pTargetZoneY = NULL ;
	CdDcdZone aTargetZoneX ;
	CdDcdZone aTargetZoneY ;
	if ( pTargetZone != NULL )
	{
		aTargetZoneX = pTargetZone->getX() ;
		pTargetZoneX = &aTargetZoneX ;
		aTargetZoneY = pTargetZone->getY() ;
		pTargetZoneY = &aTargetZoneY ;
	}
	// --------------------------------
	m_convX.setContentZone( zoneContent.getX() , pTargetZoneX );
	m_convY.setContentZone( zoneContent.getY() , pTargetZoneY );
}
	// ********************************
	//@name CconvContentPosToTargetXy-Wϊ
	// ********************************

CdDcdPosXy CconvContentPosToTargetXy::ContentPosToTarget( 
		const CdDcdPosXy& value ,
		const CdDcdZoneXy& aTargetZone ) 
{
	return CdDcdPosXy( 
		m_convX.ContentPosToTarget( value.getX() , aTargetZone.getX() )  ,
		m_convY.ContentPosToTarget( value.getY() , aTargetZone.getY()) );
}
	
CdDcdPosXy CconvContentPosToTargetXy::ContentPosFromTarget( 
		const CdDcdPosXy& value ,
		const CdDcdZoneXy& aTargetZone ) 
{
	return CdDcdPosXy( 
		m_convX.ContentPosFromTarget( value.getX() , aTargetZone.getX() )  ,
		m_convY.ContentPosFromTarget( value.getY() , aTargetZone.getY() ) );
}

CdDcdZoneXy CconvContentPosToTargetXy::ContentZoneToTarget( 
		const CdDcdZoneXy& value ,
		const CdDcdZoneXy& aTargetZone ) 
{
	return CdDcdZoneXy( 
		m_convX.ContentZoneToTarget( value.getX() , aTargetZone.getX() )  ,
		m_convY.ContentZoneToTarget( value.getY() , aTargetZone.getY() ) );
}
	
CdDcdZoneXy CconvContentPosToTargetXy::ContentZoneFromTarget( 
		const CdDcdZoneXy& value ,
		const CdDcdZoneXy& aTargetZone ) 
{
	return CdDcdZoneXy( 
		m_convX.ContentZoneFromTarget( value.getX() , aTargetZone.getX() )  ,
		m_convY.ContentZoneFromTarget( value.getY() , aTargetZone.getY() ) );
};
