/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	./CdDcdZone.h
// ****************************************************************
*/
/** @file */
#ifndef  CdDcdZone_h
#define  CdDcdZone_h

#include "./DcdType.h"

// ****************************************************************
//	CdDcdZone.h
// ****************************************************************
/**
 @brief 
 yTvz
 	  P̍Wԏ́A͈͂\Pf[^NXłB
 	  N_ʒuWƁA͈̔͂̑傫\܂B
*/
class CdDcdZone
{
public:
	// --------------------------------
	///@name	֐
	// --------------------------------
	///@{
	/**
	 	l̕\lԂ܂B
	 @param ev [in]
	 	؂lw肵ĂB
	 @return
	 	l	@n
	 		OȂOA		@n
	 		̐ȂP	@n
	 		̐Ȃ|P	@n
	 	Ԃ܂B
	*/
	static int Sign( int ev ){
		if ( ev > 0 ){	return ( 1 ) ;}
		else if ( ev < 0 ){	return ( -1 ) ;}
		return ( 0 ) ;
	};
	///@}
private:
	// ********************************
	///@name	
	// ********************************
	///@{
	///	N_ʒułB
	DcdPos m_iPos ;
	
	///  ͈͂̑傫łB
	DcdSize m_iSize ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CdDcdZone() : m_iPos( 0 ) , m_iSize( 0 ) {} ;
	
	/**
	 	N_ʒuP͈̔͂\IuWFNg𐶐܂
	 @param iPos [in]
	 	N_ʒuw肵ĂB
	*/
	CdDcdZone( DcdPos iPos ) 
		: m_iPos( iPos ) , m_iSize( 1 ) {} ;
	
	/**
	 @param iPos [in]
	 	N_ʒuw肵ĂB
	 @param iSize ; [in]
	   ͈͂̑傫łB
	*/
	CdDcdZone( DcdPos iPos , DcdSize iSize ) 
		: m_iPos( iPos ) , m_iSize( iSize ) {} ;
	
 public:
	// ********************************
	///@name	CdDcdZone-
	// ********************************
	///@{
	DcdPos getPos()const{	return ( m_iPos ) ;	};
	CdDcdZone& setPos( DcdPos ev ){	m_iPos = ev ;	return ( *this ) ;	};
	DcdSize getSize()const{	return ( m_iSize ) ;};
	CdDcdZone& setSize( DcdSize ev ){	m_iSize = ev ;	return ( *this ) ;	};
	
	/**
	  @return
	    ͈͂̏I_ʒu̎̈ʒuԂ܂B
	  	̈ʒúA͈͂ɂ͊܂܂܂B
	*/
	DcdPos getEndPos()const{	return m_iPos + m_iSize ; } ;
	
	/**
	    ͈͂̏I_ʒu̎̈ʒuw肵܂B
	  	 ̈ʒúA͈͂ɂ͊܂܂܂B
	 	
	 	̊֐́A value ƂɁAm_iSize 肵܂B
	 	m_iPos ɂ́Ae^܂B
	*/
	CdDcdZone& setEndPos( DcdPos value ){
		m_iSize = value - m_iPos ; return *this ; } ;
	
	/**
	    ͈͂̋N_ʒuƏI_ʒuݒ肵܂B
	  @param posBegin [in]
	 	N_ʒuw肵ĂB
	  @param posEnd [in]
	  	 I_ʒuw肵ĂB
	 	̈ʒúA͈͂ɂ͊܂܂܂B
	*/
	CdDcdZone& setBeginEndPos( DcdPos posBegin , DcdPos posEnd ){
		m_iPos = posBegin ;
		m_iSize = posEnd - posBegin ; 
		return *this ;
	};
		
	
	///@}
	
	// ********************************
	///@name	CdDcdZone-
	// ********************************
	///@{
	
	/**
	 @return
	 	  ͈͂̑傫̕킷Ԃ܂B
	 		͈͂OȂOA
	 		̐ȂP
	 		̐Ȃ|P
	 	Ԃ܂B
	*/
	int getSizeSign()const{	return ( Sign( getSize() ) ) ;	};
	
	/**
	 	  ͈͂̑傫\l̕A̐E܂͕̐ɕύX܂B
	 	  ̏ꍇłAW͈͕͂ς܂B
	 	() Pos = 1,Size=5̃IuWFNgɁA ev=-1 ł̃\bhĂяo
	 	Pos = 5 ,Size=-5 ɂȂ܂B
	 @param ev [in]
	 	𐳂̐ɂȂPE̐ɂȂ|Pw肵ĂB
	*/
	CdDcdZone& setSizeSign( int ev = 1 ){
		if ( getSizeSign() == -Sign( ev ) ){
			//	𔽓]܂B
			m_iPos = m_iPos + m_iSize - getSizeSign() ;
			m_iSize = -m_iSize ;
		}
		return ( *this ) ;
	};
	
	
	/**
	 	CdDcdZoneƂ̔rs܂B
	 @param ev [in]
	 	rΏۂw肵ĂB
	 @return
	 	ׂĂ̑łΐ^łB
	*/
	bool IsEqualTo( const CdDcdZone& ev )const{	
		return ( m_iPos == ev.m_iPos && m_iSize == ev.m_iSize );
	};
	
	/**
	  	͈̔͂ƁAw肳ꂽʂ͈̔͂Ƃ̊ԂŁAĂ͈͂
	  	߂܂B
	  @param ev [in]
	  	߂ΏۂɂȂ CdDcdZone IuWFNgw肵ĂB
	  @return
	  	͈̔͂ƁAev ƂĂ̈Ԃ܂B
	    - this  ev ̂ꂩ Size Oł΁AN_thisƓA
	  	TCYÕIuWFNgԂ܂B
	    - thisev̕قȂꍇ́Aev̕̕𔽓]āA
	  	͈͂߂܂B̏ꍇA߂l̕
	  	thisƓɂȂ܂B
	    - this  ev ɌĂ̈悪Ȃꍇ́AN_thisƓA
	  	TCYÕIuWFNgԂ܂B
	 */
	CdDcdZone CrossZone( const CdDcdZone& ev )const{
		//	this  ev ̂ꂩ Size Oł΁AN_thisƓA
		//	TCYÕIuWFNgԂ܂B
		if ( getSizeSign() == 0 || ev.getSizeSign() == 0 ){
			return ( CdDcdZone( m_iPos , 0 ) ) ;
		}	
		
		//	TCY̕قȂꍇ́A̕̕𔽓]܂B
		CdDcdZone	aZone( ev ) ;
		if ( getSizeSign() == -aZone.getSizeSign() ){
			aZone.setSizeSign( -aZone.getSizeSign() ) ;
		}
		
		//	̏ꍇ
		if ( getSizeSign() == 1 )
		{
			DcdPos	aPos = m_iPos ;
			if ( m_iPos < aZone.m_iPos ){
				aPos = aZone.m_iPos ;
			}
			DcdPos	aEndPos = getEndPos() ;
			if ( getEndPos() > aZone.getEndPos() ){
				aEndPos = aZone.getEndPos() ;
			}
			if ( aPos <= aEndPos ){
				return ( CdDcdZone( aPos , aEndPos - aPos ) ) ;
			}
			return ( CdDcdZone( m_iPos , 0 ) ) ;
		}
		
		//	̏ꍇ
			DcdPos	aPos = m_iPos ;
			if ( m_iPos > aZone.m_iPos ){
				aPos = aZone.m_iPos ;
			}
			DcdPos	aEndPos = getEndPos() ;
			if ( getEndPos() < aZone.getEndPos() ){
				aEndPos = aZone.getEndPos() ;
			}
			if ( aPos >= aEndPos ){
				return ( CdDcdZone( aPos , aEndPos - aPos ) ) ;
			}
			return ( CdDcdZone( m_iPos , 0 ) ) ;
	};
	
	/**
	  	͈̔͂ƁAw肳ꂽʂ͈̔͂܂ށA
		ł͈͂߂܂B
	  @param ev [in]
	  	܂߂ΏۂɂȂ CdDcdZone IuWFNgw肵ĂB
	  @return
	  	͈̔͂ƁAev ܂̈Ԃ܂B
	    - thisev̕قȂꍇ́Aev̕̕𔽓]āA
	  	͈͂߂܂B̏ꍇA߂l̕
	  	thisƓɂȂ܂B
	 */
	CdDcdZone ZoneOr( const CdDcdZone& ev )const{
		CdDcdZone	zoneRv ;

		//	TCY̕قȂꍇ́A̕̕𔽓]܂B
		CdDcdZone	aZone( ev ) ;
		if ( getSizeSign() == -aZone.getSizeSign() ){
			aZone.setSizeSign( -aZone.getSizeSign() ) ;
		}


		//	0̏ꍇ
		if ( getSizeSign() >= 0 )
		{
			//	aPos ́Am_iPos0ɋ߂قƂ܂B
			DcdPos	aPos = m_iPos ;
			if ( m_iPos > aZone.m_iPos ){
				aPos = aZone.m_iPos ;
			}
			//	aEndPos ́AgetEndPos() 0牓B
			DcdPos	aEndPos = getEndPos() ;
			if ( getEndPos() < aZone.getEndPos() ){
				aEndPos = aZone.getEndPos() ;
			}

			zoneRv.setBeginEndPos( aPos , aEndPos ) ;
		}
		//	̏ꍇ
		else
		{
			//	aPos ́Am_iPos0ɋ߂قƂ܂B
			DcdPos	aPos = m_iPos ;
			if ( m_iPos < aZone.m_iPos ){
				aPos = aZone.m_iPos ;
			}
			//	aEndPos ́AgetEndPos() 0牓B
			DcdPos	aEndPos = getEndPos() ;
			if ( getEndPos() > aZone.getEndPos() ){
				aEndPos = aZone.getEndPos() ;
			}

			zoneRv.setBeginEndPos( aPos , aEndPos ) ;
		}
		return ( zoneRv ) ;
	};



	/**
	 	ẅʒu͈̔͂Ɋ܂܂Ă邩ǂ𔻒f܂B
	 @param ev [in]
	 	肷ʒuw肵ĂB
	 @return
	 	ʒu͈̔͂Ɋ܂܂Ăΐ^łB
	*/
	bool IsInner( DcdPos ev )const{	
		if ( getSizeSign() == -1 ){
			return ( m_iPos >= ev && ev > getEndPos() ) ;
		}
		return ( m_iPos <= ev && ev < getEndPos() ) ;
	};
	
	/**
	 	w͈͈̔͂̔͂Ɋ܂܂Ă邩ǂ𔻒f܂B
	 @param ev [in]
	 	肷ʒuw肵ĂB
	 @return
	 	ʒu͈̔͂Ɋ܂܂Ăΐ^łB
	*/
	bool IsInner( CdDcdZone& ev )const{	
		CdDcdZone	aZone( ev ) ;
		aZone.setSizeSign( getSizeSign() ) ;
		if ( CrossZone( aZone ).IsEqualTo( aZone ) ){
			return ( true ) ;
		}
		return ( false ) ;
	};
	///@}
	// ********************************
	///@name	Zq	
	// ********************************
	///@{
	/// IsEqualTo() Ƃē삵܂B
	bool operator ==( const CdDcdZone& ev )const{	
		return (  IsEqualTo( ev ) ) ; 
	};
	/// IsEqualTo() Ƃē삵܂B
	bool operator !=( const CdDcdZone& ev )const{
		return ( !IsEqualTo( ev ) ) ; 
	};
	///@}
	
};


#endif /*CdDcdZone_h*/
