/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaMup.h
// ****************************************************************
*/
/** @file */
#ifndef  CaMup_h
#define  CaMup_h

#include "./Mup.h"
// ****************************************************************
//	CaMup
// ****************************************************************
/**
 @brief
   A_v^NXłBlێRei 
	"Mup< ElementType >" 𑀍ΏۂƂARei
	vfւ̃|C^EQƂԂ "Mu" C^[tF[Xɕϊ܂B
 
 (  |C^ێReiɂ́ÃA_v^͎g܂)
 
   ̃A_v^NXgƁAȉ̃C^[tF[X擾
	Ƃł܂BΉ郁\bhĂяoĂB

 	- "Mu< ElementType* >" EEE getMuPtr()
 	- "Mu< const ElementType* >" EEE getMuConstPtr() 
 	- "Mu< ElementType& >" EEE getMuConstRef()
 	- "Mu< const ElementType& >" EEE getMuConstRef() 
 
 @param ElementType
	ΏۃIuWFNgi[Ăf[^̌^w肵ĂB
	ΏۃIuWFNǵA "Mup<ElementType>" C^[tF[X
	T|[g܂B
	̃f[^^́Al^z肵Ă܂
	i|C^EQƂi[Rei𑀍ΏۂɂӖ͂܂jB
 */
template < class ElementType > class CaMup 
{
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	/**
		ΏۃIuWFNgƂȂAReiłB
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵAthisƂ̊֘AۂĂԂ́A
		ȂĂ͂Ȃ܂B
	 */
	Mup<ElementType>*	m_pAdaptee ;
	///@}

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	// ********************************
	//	"Mu< ElementType* >" EEE getMuPtr()
	// ********************************
	/**
	 @brief
		CaMup::getMuPtr() \bhԂC^[tF[X
		NXłB
	 */
	class XMuPtr : public Mu< ElementType* >
	{
	public:
		virtual int	size()const
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuPtr) ) ;
			return pOuter->m_pAdaptee->size() ; 
		} ;
		virtual ElementType* get( int idx )const 
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuPtr) ) ;
			ElementType*	pRv = pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xMuPtr ;
	friend class XMuPtr ;
	//*******************************
	// 	"Mu< const ElementType* >" EEE getMuConstPtr() 
	//*******************************
	/**
	 @brief
		CaMup::getMuConstPtr() \bhԂC^[tF[X
		NXłB
	 */
	class XMuConstPtr : public Mu< const ElementType* >
	{
	public:
		virtual int	size()const
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuConstPtr) ) ;
			return pOuter->m_pAdaptee->size() ; 
		} ;
		virtual const ElementType* get( int idx )const 
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuConstPtr) ) ;
			ElementType*	pRv = pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xMuConstPtr ;
	friend class XMuConstPtr ;

	// ********************************
	// 	"Mu< ElementType& >" EEE getMuRef()
	// ********************************
	/**
	 @brief
		CaMup::getMuRef() \bhԂC^[tF[X
		NXłB
	 */
	class XMuRef : public Mu< ElementType& >
	{
	 public:
		virtual int	size()const
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuRef) ) ;
			return pOuter->m_pAdaptee->size() ; 
		} ;
		virtual ElementType& get( int idx )const 
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuRef) ) ;
			ElementType&	pRv = *pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xMuRef ;
	friend class XMuRef ;
	// ********************************
	// 	"Mu< const ElementType& >" EEE getMuConstRef() 
	// ********************************
	/**
	 @brief
		CaMup::getMuConstRef() \bhԂC^[tF[X
		NXłB
	 */
	class XMuConstRef : public Mu< const ElementType& >
	{
	 public:
		virtual int	size()const
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuConstRef) ) ;
			return pOuter->m_pAdaptee->size() ; 
		} ;
		virtual const ElementType& get( int idx )const 
		{
			CaMup* pOuter = (CaMup*)((char*)this - offsetof(CaMup,m_xMuConstRef) ) ;
			ElementType&	pRv = *pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xMuConstRef ;
	friend class XMuConstRef ;

	///@}
// ********************************
//	RXgN^
// ********************************
public:
	CaMup() : 
		m_pAdaptee( NULL ) {};
	CaMup( Mup<ElementType>* pAdaptee ) : 
		m_pAdaptee( pAdaptee ) {};
private:
	CaMup( const CaMup<ElementType>& ){};
	CaMup& operator=( const CaMup<ElementType>& ){ return *this ;};

public:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	Mup<ElementType>*	getAdaptee(){	return m_pAdaptee ;};
	const Mup<ElementType>*	getAdaptee()const{	return m_pAdaptee ;};
	CaMup& setAdaptee( Mup<ElementType>*	value )
	{	m_pAdaptee = value ; 	return *this ;	};
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	Mu< ElementType* >* getMuPtr()
	{	return &m_xMuPtr ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	const Mu< ElementType* >* getMuPtr()const 
	{	return &m_xMuPtr ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	Mu< const ElementType* >*  getMuConstPtr()
	{	return &m_xMuConstPtr ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	const Mu< const ElementType* >*  getMuConstPtr()const 
	{	return &m_xMuConstPtr ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	Mu< ElementType& >* getMuRef()
	{	return m_xMuRef ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	const Mu< ElementType& >* getMuRef()const 
	{	return m_xMuRef ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	Mu< const ElementType& >* getMuConstRef()
	{	return &m_xMuConstRef ;};
	/**
	@return 
		ElementType ɃANZX邽߂ MuC^[tF[XB
	*/
	const Mu< const ElementType& >* getMuConstRef()const 
	{	return &m_xMuConstRef ;};
	///@}
};

#endif /*CaMup_h*/
