/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: IfNodeContainerConst.h 10 2012-08-26 09:48:47Z okm $
#pragma once
#include <deque>
#include "Mu\Mui.h"
#include "str\OuPropertiesText\CNode.h"
#include "str\OuPropertiesText\CPropertyString.h"
#include "str\OuPropertiesText\CInNameIndexContainer.h"

namespace OuPropertiesText{

/**
@brief
	Node IuWFNgێReiQƂC^[tF[XłB
	
	̃C^[tF[X́ACNodeContainer ̑SẴm[hɑ΂
	Ou<const CNode> 擾邱Ƃł܂A
	m[h̒ǉEύXE폜͂ł܂B
*/
class IfNodeContainerConst : public Mu< Ou<const CNode> >
{
public:
	// ********************************
	///@name	IfNodeContainerConst-Property̎擾
	// ********************************
	///@{
	/**
		Property  Name ɑΉ Value 擾܂B
	@param strName [in]
		Property  Name w肵ĂB
	@return
		ΉValueԂ܂B

		NameɑΉ Property Ȃꍇ́A
		󕶎Ԃ܂B

		Name ɑΉ 2ȏCPropertyString CX^X
		ꍇ́AInNameIndex ł CPropertyString  Value 
		Ԃ܂B
	*/
	virtual std::string getValue( const std::string& strName )const = 0 ;
	///@}

public:
	// ********************************
	///@name	Mu
	// ********************************
	///@{
	
	/**
	 * @return
	 * 	ReiɊi[Ăvf̌Ԃ܂B
	 */
	virtual int	size()const = 0 ;
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 * 	vfԂ܂B
	 *
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	CfNXŎw肳ꂽvfԂ܂B
	 */
	virtual Ou<const CNode> get( int iIndex )const = 0 ;
	
	///@}
	
public:
	// ********************************
	///@name	CNodeContainer-InNameIndexł̃ANZX
	// ********************************
	///@{
	
	/**
	 	w Name vf̌Ԃ܂B
	 @param strName [in]
		Name w肵ĂB
	 @return
	 	vf̌Ԃ܂B
	*/
	virtual int	sizeInName( const std::string& strName )const = 0 ;
	/**
	 	ReíAw Name vfԂ܂B
	 @param strName [in]
		Name w肵ĂB
	 @param iInNameIndex [in]
	 	InNameIndex w肵ĂB
		InNameIndex ́ÃRei̓ Name  Node ł́A
		On܂CfNXłB
		͈͂͂Oȏ sizeInName() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	CfNXŎw肳ꂽvfԂ܂B
	*/
	virtual Ou<const CNode> getInName( const std::string& strName , int iInNameIndex )const = 0 ;
	
	

	/**
		InNameIndex ReĩCfNXɕϊ܂B
	@param strName [in]
		Name w肵ĂB
	@param iInNameIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ sizeInName() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@return
		CfNX Ԃ܂B
		-	-1 ;	//	CfNXsłB
	*/
	virtual int indexOfInNameIndex( 
		const std::string& strName ,
		int iInNameIndex )const = 0 ;
	/**
		ReĩCfNXAInNameIndex ɕϊ܂B
	@param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@return
		InNameIndex Ԃ܂B
	*/
	virtual int indexToInNameIndex( 
		int iIndex )const = 0 ;

	///@}



	virtual ~IfNodeContainerConst(){};

};


} //namespace OuPropertiesText
