/*
	OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDiagramEditDoc.cpp : CDiagramEditDoc NX̓̒`s܂B
// $Id: CDiagramEditDoc.cpp 295 2016-06-11 05:14:13Z okm $
/** @file */
#include "stdafx.h"

#include "logmsg/LogMsg.h"
#include "str/vectorToFile.h"
#include "str/CdFilenameStr.h"
#include "str/OuPropertiesText\CConvNodeContainer.h"
#include "str/OuPropertiesText\ErrorInfo\COuErrorInfoContainer.h"
#include "str/strprintf.h"
#include "str/strToVector.h"
#include "str/strToWstr.h"
#include "str/tstring.h"
#include "str/strLf.h"
#include "NsOu/dynamic_castOu.h"
#include "NsOu/OuNew.h"
#include "MfcUtil/MfcUtil.h"

#include "DiagramEdit.h"
#include "CDiagramEditDoc.h"
#include "DedRosenFileData\CconvCDedRosenFileData.h"
#include "DedRosenFileData\CconvCDedRosenFileDataOud.h"
#include "entDed\CconvCentDed.h"
#include "WinDia\CconvWinDia.h"
#include "CRfEditCmdHolder.h"
#include "WinDia\CDlgDiaSaveSelect.h"
#include "ConvFile\CConvFileDll.h"
#include "ConvFile\CaByteBuffer_vector.h"
#include "ConvFile\CaByteBuffer_string.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std ;
using namespace OuLib::Str ;
using namespace OuLib::Str::OuPropertiesText ;
using namespace OuLib::Str::OuPropertiesText::ErrorInfo ;
using namespace WinDia;
using namespace ConvFile;
using namespace OuMfc;

/////////////////////////////////////////////////////////////////////////////
// CDiagramEditDoc

/**	Undo ̍ő񐔂łB */
const int iUndoLevel = 8 ;
// --------------------------------
//@name	֐-WinDia`
// --------------------------------
BOOL CDiagramEditDoc::OnOpenDocument_WinDia( LPCTSTR lpszPathName ) 
{
	LogMsg( "CDiagramEditDoc::OnOpenDocument_WinDia(%s)" , lpszPathName ) ;
	int iRv = 0 ;

	// --------------------------------
	//	t@C̓eAstringɕۑ
	// --------------------------------
	string	aString ;
	CString	strError ;
	if ( iRv >= 0 ){
		int iResult = stringFromFile( &aString , lpszPathName ) ;
		//iResult = 
		//	-1: t@CI[vł܂B
		//	-2 ; ǂݍ݂Ɏs܂B
		//	-3 ; t@Cɂ "\0" ܂܂܂(oCit@Cł 
		//	v܂)B
		//	 ̏ꍇApString ɂ́A "\0" ̒O܂ł̃f[^i[ 
		//	܂B 
		if ( iResult < 0 ){
			iRv = iResult ;
			switch( iResult ){
			 case -1 :	// t@CI[vł܂B
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILENOTFOUND ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			 case -2 :	//; ǂݍ݂Ɏs܂B
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILEREAD ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			 case -3 :	// t@Cɂ "\0" ܂܂܂
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILEFORMAT ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			}
			//iRv = 
			//	-1: t@CI[vł܂B
			//	-2 ; ǂݍ݂Ɏs܂B
			//	-3 ; t@Cɂ "\0" ܂܂܂(oCit@Cł 
			//	v܂)B
			//	 ̏ꍇApString ɂ́A "\0" ̒O܂ł̃f[^i[ 
			//	܂B 
		}
	}
	//aString = t@C̓eێ܂B

	LogMsg( "CDiagramEditDoc::OnOpenDocument_WinDia()1" ) ;

	// --------------------------------
	//	t@C̓e̕
	// --------------------------------
	if ( iRv >= 0 ){
		CDedRosenFileData	aCDedRosenFileData ;
		CconvWinDia aCconvWinDia ;
		int iResult = aCconvWinDia.CDedRosenFileData_From_WinDiaFileString( 
			&aCDedRosenFileData , aString ) ;
		if ( iResult < 0 ){
			iRv = iResult ;
		}	else	{
			m_CDedRosenFileData = aCDedRosenFileData ;
		}
	}	

	// --------------------------------
	//	Hr[XV
	// --------------------------------
	getCDiagramEditApp()->getCDlgRosenView()->OnUpdate( NULL , 0 , NULL ) ;

	// --------------------------------
	LogMsg( "CDiagramEditDoc::OnOpenDocument_WinDia()=%d" , iRv ) ;
	if ( iRv < 0 ){
		if ( strError.IsEmpty() ){
			CString	strFmt ;
			strFmt.LoadString( IDS_ERR_ERRORCODE ) ;
			strError.Format( strFmt , iRv ) ;
		}
		AfxMessageBox( strError , MB_ICONSTOP ) ; 
		return ( FALSE ) ;
	}
	//	hLg̃t@ĆA
	//	CDiagramEditDoc::SetPathName()Ń`FbN܂B
	//	gq .dia ́AhLg̗Lȃt@CƂ
	//	܂(.dia ւ̏㏑ۑ͂܂)
	return TRUE;

}

	
BOOL CDiagramEditDoc::OnSaveDocument_WinDia(  LPCTSTR lpszPathName ) 
{
	/*
	 *	OnSaveDocument() ̉֐łB
	 *	hLg̓eAWinDia `̃t@Cɕۑ܂B
	 * @param lpszPathName [in]
	 * 	ۑt@Cw肵ĉB
	 * @return
	 *	 TRUE E G[Ȃ FALSE łB
	 *
	 *	̊֐́AG[̏ꍇ̓bZ[W{bNX\܂B
	 */
	// --------------------------------
	int iRv = 0 ;

	CString	strError ;
	string	aString ;

	// --------------------------------
	//	ۑ_CI
	// --------------------------------
	int idxDia = -1 ;
	if ( iRv >= 0 ){
		CentDedRosen* pCentDedRosen = m_CDedRosenFileData.getCentDedRosen();
		if ( pCentDedRosen->getCentDedDiaCont()->getMuPtr()->size() == 0 )
		{
			iRv = -101 ;	//	_C݂܂B
			CString strFmt ;
			strFmt.LoadString( IDS_ERR_NoDia ) ;
			strError.Format( strFmt , lpszPathName ) ;
		}
		else if ( pCentDedRosen->getCentDedDiaCont()->getMuPtr()->size() == 1 )
		{
			idxDia = 0 ;
		}	else	{
			Mu<CentDedDia*>* pCentDedDiaContGet = 
				pCentDedRosen->getCentDedDiaCont()->getMuPtr() ;

			CMup_deque< string > contstrDiaName ;
			for ( int idxDiaName = 0 ; 
				idxDiaName < pCentDedDiaContGet->size() ; 
				idxDiaName ++ ){
				contstrDiaName.insert( pCentDedDiaContGet->get( idxDiaName )->getName() ) ;
			}
			CDlgDiaSaveSelect	aDlg( contstrDiaName , NULL ) ;
			if ( aDlg.DoModal() == IDOK ){
				idxDia = aDlg.getDiaIndex() ;
			}	else	{
				return FALSE ;
			}
		}
	}
	//idxDia = Iꂽ_C̃CfNX
	// --------------------------------
	//	WinDIA`̃t@C̕쐬
	// --------------------------------
	if ( iRv >= 0 ){
		CconvWinDia aCconvWinDia ;
		int iResult = aCconvWinDia.CDedRosenFileData_To_WinDiaFileString( &m_CDedRosenFileData ,idxDia , &aString ) ;
		//iResult = 
		//	-21 ;	//	WinDIA `ł́AԎʂ24ނ܂łɐĂ܂B
		//	-22 ;	//	̂̒pT𒴂Ԏʂ܂B
		//			//	WinDIA `ɕۑ邽߂ɂ́AׂĂ̗Ԏʗ̂
		//			//	SpQȓłȂĂ͂Ȃ܂B
		//	-1 ;	//	idxDia ̎w肪słB
		if ( iResult < 0 ){
			iRv = iResult ;
			switch( iResult ){
			 case -21 : //	WinDIA `ł́AԎʂ24ނ܂łɐĂ܂B
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_RessyasyubetsuTooMany ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			 case -22 :	//	̂̒pT𒴂Ԏʂ܂B
				 {
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_RyakusyouTooLong ) ;
					strError.Format( strFmt , lpszPathName ) ;
				 }
			}
			//iRv = 
			//	-	-21 ;	//	WinDIA `ł́AԎʂ24ނ܂łɐĂ܂B
			//	-	-22 :	//	̂̒pT𒴂Ԏʂ܂B
			//	-	-1 ;	//	idxDia ̎w肪słB
		}
	}	
	//aString = t@CɏށwHt@Cx`̕ێ܂B

	// --------------------------------
	//	t@C̕ۑ
	// --------------------------------
	LogMsg( "CDiagramEditDoc::OnSaveDocument()1" ) ;
	if ( iRv >= 0 ){
		int iResult = stringToFile( aString , lpszPathName ) ;
		//iResult = 
		//	-1: t@CI[vł܂B
		//	-2 ; // ݂Ɏs܂B 
		if ( iResult < 0 ){
			switch( iResult ){
			 case -1 :	// t@CI[vł܂B
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILECREATE ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			 case -2 :	//;݂Ɏs܂
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILEWRITE ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			}
			//iRv = 
			//	-1: t@CI[vł܂B
			//	-2 ; ݂Ɏs܂
			iRv = iResult - 100 ;
		}
	}

	// --------------------------------
	LogMsg( "CDiagramEditDoc::OnSaveDocument()=%d" , iRv ) ;

	if ( iRv < 0 ){
		if ( strError.IsEmpty() ){
			CString	strFmt ;
			strFmt.LoadString( IDS_ERR_ERRORCODE ) ;
			strError.Format( strFmt , iRv ) ;
		}
		AfxMessageBox( strError , MB_ICONSTOP ) ; 
		return ( FALSE ) ;
	}

	//	WinDIA `̕ۑ́AȃhLg̕ۑƂ͂܂B
	//	WinDIA `̕ۑɐĂAhLgt@C
	//	WinDIA t@C̃t@Cɂ͂܂B
	//	hLg̕ύXtOANA܂B
	//	iWinDIAt@ĆAhLgŜێ邱Ƃ
	//	łȂ߂łBj
	//	̂߁Aȉ͍̏s܂
	// --------------------------------
	//	SetModifiedFlag( FALSE ) ;
	//	return TRUE;
	// --------------------------------
	
	//iRv = 
	//	-	-101 ;	//	_C݂܂B
	//	-	-21 ;	//	WinDIA `ł́AԎʂ24ނ܂łɐĂ܂B
	//	-	-22 :	//	̂̒pT𒴂Ԏʂ܂B
	//	-	-1 ;	//	idxDia ̎w肪słB
	//	-	-201: t@CI[vł܂B
	//	-	-202 ; ݂Ɏs܂
	return FALSE ;
}
	

// ********************************
//	CHidemdiRootDoc
// ********************************
void CDiagramEditDoc::UpdateAllSubDocviews( CView* pSender
							, LPARAM lHint , CObject* pHint )
{
	// --------------------------------
	//	\E_COr[ɑΉ
	//	_C폜ĂA
	//	ΉTuView܂B
	// --------------------------------
	POSITION	LPosition = AfxGetApp()->GetFirstDocTemplatePosition() ;
	while( LPosition != NULL ){
		CDocTemplate*	pLDocTemplate = AfxGetApp()
						->GetNextDocTemplate( LPosition ) ;
		{
			POSITION	LPosition = pLDocTemplate->GetFirstDocPosition() ;
			while( LPosition != NULL ){
				CDocument*	pLDocument = 
					pLDocTemplate->GetNextDoc( LPosition ) ;
				
				if ( pLDocument != NULL && 
						pLDocument->IsKindOf( RUNTIME_CLASS( CJikokuhyouDoc ) ) ){
					CJikokuhyouDoc*	pCJikokuhyouDoc = 
						(CJikokuhyouDoc*)pLDocument ;
					
					const CentDedRosen*	pCentDedRosen = 
						getCDiagramEditDoc()->getCDedRosenFileData()->
						getCentDedRosen() ;
					CentDedDia*	pCentDedDia = NULL ;
					int idxDia = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName( 
						pCJikokuhyouDoc->getDiaName() ) ;
					if ( idxDia < 0 ){
						//	̃hLgɑΉ_C͍폜܂
						pCJikokuhyouDoc->OnCloseDocument() ;
						pLDocument = NULL ;
					}
				}
				if (  pLDocument != NULL && 
						pLDocument->IsKindOf( RUNTIME_CLASS( CDedDiagramDoc ) ) ){
					CDedDiagramDoc*	pCDedDiagramDoc = 
						(CDedDiagramDoc*)pLDocument ;
					
					const CentDedRosen*	pCentDedRosen = 
						getCDiagramEditDoc()->getCDedRosenFileData()->
						getCentDedRosen() ;
					CentDedDia*	pCentDedDia = NULL ;
					int idxDia = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName( 
						pCDedDiagramDoc->getDiaName() ) ;
					if ( idxDia < 0 ){
						//	̃hLgɑΉ_C͍폜܂
						pCDedDiagramDoc->OnCloseDocument() ;
						pLDocument = NULL ;
					}
				}
			}
		}
	}
	// --------------------------------
	//	ׂẴTuViewXV
	// --------------------------------
	super::UpdateAllSubDocviews( pSender , lHint , pHint );
	// --------------------------------
	//	HViewXV
	// --------------------------------
	getCDiagramEditApp()->getCDlgRosenView()->OnUpdate(  pSender , lHint , pHint ) ;

}

// ********************************
//	CDiagramEditDoc
// ********************************
	// ********************************
	//@name 
	// ********************************
const CDedRosenFileData*	CDiagramEditDoc::getCDedRosenFileData()const 
{
	return &m_CDedRosenFileData ;
}



	// ********************************
	//@name Nbv{[h
	// ********************************

UINT CDiagramEditDoc::getCF_CentDedEki()
{
	return RegisterClipboardFormat( "CF_CentDedEki" ) ;
} ;

/**
	string ANbv{[hɃRs[܂B
@param aHwnd [in]
	Nbv{[h̃I[i[ƂȂEChEw肵ĂB
@param uiClipboardFormat [in]
	Nbv{[htH[}bgw肵ĂB
@param strData [in]
	Nbv{[hɃRs[镶w肵ĂB
@return
	 0 ȏAG[Ȃ畉̐łB
	-	-2 ;	//	̊mۂɎs܂B
	-	-11 ;	//	Nbv{[hI[vł܂B
	-	-12 ;	//	Nbv{[hւ̃f[^ݒ肪s
*/
static int stringToClipboard( 
		HWND aHwnd , 
		UINT uiClipboardFormat , 
		const string& strData ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	Nbv{[hւ̓]
	// --------------------------------
	HGLOBAL	hGlobal = NULL ;
	if ( iRv >= 0 )
	{	
		hGlobal = GlobalAlloc( GMEM_MOVEABLE, strData.length() + 1);
		if ( hGlobal == NULL )
		{
			iRv = -2 ;	//	̊mۂɎs܂B
		}
		else
		{
			void*	pGlobal = GlobalLock( hGlobal ) ;
			memcpy( pGlobal , strData.c_str() , strData.length() + 1 ) ;
			GlobalUnlock( hGlobal ) ;
		}
	}
	//hGlobal = CentDedEki ̓eێĂ܂B
	
	bool	bIsOpen = false ;
	if ( iRv >= 0 )
	{	
		if ( !OpenClipboard( aHwnd ) )
		{
			iRv = -11 ;	//	Nbv{[hI[vł܂B
		}
		else
		{
			bIsOpen = true ;
		}
	}
	if ( iRv >= 0 ){	
		EmptyClipboard();
		HANDLE hResult = SetClipboardData( uiClipboardFormat , hGlobal);
		if ( hResult == NULL )
		{
			iRv = -12 ;	//	Nbv{[hւ̃f[^ݒ肪s
		}
		else
		{
			//	Nbv{[hւ̓]܂̂ŁA
			//	̃AvP[V hGlobal ɕ܂B
			hGlobal = NULL ;
		}
	}
	if ( bIsOpen )
	{
		CloseClipboard();
	}
	if ( hGlobal != NULL )
	{
		GlobalFree( hGlobal ) ;
		hGlobal = NULL ;
	}
	return iRv ;
}



/**
	string ANbv{[hɃRs[܂B
@param aHwnd [in]
	Nbv{[h̃I[i[ƂȂEChEw肵ĂB
@param uiClipboardFormat [in]
	Nbv{[htH[}bgw肵ĂB
@param pstrData [out]
	̊֐͂̕ɁANbv{[h̕Rs[܂B
	svȂ NULL w肵Ă܂܂B
@return
	 0 ȏAG[Ȃ畉̐łB
	-	-1 ;	//	Nbv{[hɂ͗Lȃf[^͂܂B
	-	-11 ;	//	Nbv{[hI[vł܂B
*/
static int stringFromClipboard( 
		HWND aHwnd , 
		UINT uiClipboardFormat , 
		string* pstrData )
{
	int iRv = 0 ;
	// --------------------------------
	//	Nbv{[hf[^擾
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 )
	{	
		if ( !IsClipboardFormatAvailable(uiClipboardFormat) ) 
		{
			iRv = -1 ;	//	Nbv{[hɂ͗Lȃf[^͂܂B
		}
	}
	bool	bIsOpen = false ;
	if ( iRv >= 0 )
	{ 
		if ( !OpenClipboard( aHwnd ) )
		{
			iRv = -11 ;	//	Nbv{[hI[vł܂B
		}
		else
		{
			bIsOpen = true ;
		}
	}
	if ( iRv >= 0 )
	{
		HGLOBAL	hGlobal = NULL ;
        hGlobal = GetClipboardData(uiClipboardFormat);
		if ( hGlobal != NULL )
		{
			const char* lpszData = (const char*)GlobalLock( hGlobal ) ;
			strData = lpszData ;
			GlobalUnlock( hGlobal ) ;
		}
	}
	if ( bIsOpen )
	{
        CloseClipboard();
	} 
	// --------------------------------
	if ( pstrData != NULL )
	{
		*pstrData = strData ;
	}
	// --------------------------------
	return iRv ;
}


int CDiagramEditDoc::CentDedEki_To_Cliboard( 
	const Mu<CentDedEki>* pMuCentDedEki ) 
{
	int iRv = 0 ;

	// --------------------------------
	//	Mu  EkiCont ɕϊ
	// --------------------------------
	CentDedEkiCont	aEkiCont ;
	if ( iRv >= 0 )
	{
		CaMui<CentDedEki> aCaMui( &aEkiCont ) ;
		aCaMui.insert( pMuCentDedEki ) ;
	}

	// --------------------------------
	//	f[^𕶎
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 )
	{
		CNodeContainer aCNodeContainer ;
		CconvCentDed aCconvCentDed ;
		int iResult = aCconvCentDed.CentDedEkiCont_To_OuPropertiesText( 
			aEkiCont , 
			&aCNodeContainer ) ;
		if ( iRv < 0 )
		{
			iRv = -1 ;	//	CentDedEki ̓esłB
		}
		else
		{
			CConvNodeContainer	aCConvNodeContainer ;
			strData = aCConvNodeContainer.encode( &aCNodeContainer ) ;
			if ( strData.length() == 0 )
			{
				iRv = -1 ;	//	CentDedEki ̓esłB
			}
		}
	}
	//strData = CentDedEki ̓e

	// --------------------------------
	//	Nbv{[hւ̓]
	// --------------------------------
	if ( iRv >= 0 )
	{
		int iResult = stringToClipboard(  
			AfxGetMainWnd()->GetSafeHwnd() ,
			getCF_CentDedEki() , 
			strData ) ;
		if ( iResult < 0 )
		{
			iRv = -11 ;	//	Nbv{[hւ̃f[^ݒ肪s
		}
	}
	return iRv ;
}

int CDiagramEditDoc::CentDedEki_From_Cliboard( 
		Mui<CentDedEki>* pCentDedEki ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	Nbv{[hf[^擾
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 )
	{	
		if (!IsClipboardFormatAvailable(getCF_CentDedEki())) 
		{
			iRv = -1 ;	//	Nbv{[hɂ͗Lȃf[^͂܂B
		}
	}
	if ( iRv >= 0 )
	{
		int iResult = stringFromClipboard( 
			AfxGetMainWnd()->GetSafeHwnd() , 
			getCF_CentDedEki() , 
			&strData ) ;
		if ( iResult < 0 )
		{
			iRv = -2 ;	//	Nbv{[h̓ǂݍ݂Ɏs܂B	
		}
	}
	//strData = CentDedEki ̓e
	// --------------------------------
	//	񂩂wf[^쐬
	// --------------------------------
	CNodeContainer aCNodeContainer ;
	if ( iRv >= 0 )
	{
		CConvNodeContainer aCConvNodeContainer ;
		int iResult = aCConvNodeContainer.decode( 
			strData , 
			&aCNodeContainer ) ;
		if ( iResult < 0 )
		{
			iRv = -3 ;	//	Nbv{[h̓esłB
		}
	}
	CentDedEkiCont	aCentDedEkiCont ;
	if ( iRv >= 0 )
	{
		CconvCentDed aCconvCentDed ;
		COuErrorInfoContainer aCOuErrorInfoContainer ;
		int iResult = aCconvCentDed.CentDedEkiCont_From_OuPropertiesText( 
			&aCentDedEkiCont , 
			aCNodeContainer.getIfNodeContainerConst() , 
			&aCOuErrorInfoContainer ) ;
		//iResult = 
		//	-22 ; // Ekijikokukeisiki ̒lsłB
		//	-32 ; // Ekikibo ̒lsłB 
		if ( iRv < 0 )
		{
			iRv = -4 ;	//	CentDedEki ̓esłB
		}
	}

	// --------------------------------
	//	Mu  EkiCont ɕϊ
	// --------------------------------
	if ( iRv >= 0 )
	{
		CaMui<CentDedEki> aCaMui( pCentDedEki ) ;
		aCaMui.insert( &aCentDedEkiCont ) ;
	}
	// --------------------------------
	return ( iRv ) ;
}



bool CDiagramEditDoc::CentDedEki_IsClipboardFormatAvailable() 
{
	return ( IsClipboardFormatAvailable( getCF_CentDedEki() ) != 0 );
}

UINT CDiagramEditDoc::getCF_CentDedRessyasyubetsu()
{
	return RegisterClipboardFormat( "CF_CentDedRessyasyubetsu" ) ;
} ;

int CDiagramEditDoc::CentDedRessyasyubetsu_To_Cliboard( 
		const Mu<CentDedRessyasyubetsu>* pMuCentDedRessyasyubetsu ) 
{
	int iRv = 0 ;

	// --------------------------------
	//	Mu  CentDedRessyasyubetsuCont ɕϊ
	// --------------------------------
	CentDedRessyasyubetsuCont	aRessyasyubetsuCont ;
	if ( iRv >= 0 )
	{
		CaMui<CentDedRessyasyubetsu> aCaMui( &aRessyasyubetsuCont ) ;
		aCaMui.insert( pMuCentDedRessyasyubetsu ) ;
	}
	// --------------------------------
	//	f[^𕶎
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 )
	{
		CNodeContainer aCNodeContainer ;
		CconvCentDed aCconvCentDed ;
		int iResult = aCconvCentDed.CentDedRessyasyubetsuCont_To_OuPropertiesText( 
			aRessyasyubetsuCont , 
			&aCNodeContainer ) ;
		//iResult = 
		//	-	-11 ;	//	Syubetsumei w肳Ă܂B
		//	-	-52 ;	//	DiagramSenStyle ̒lsłB
		if ( iRv < 0 )
		{
			iRv = -1 ;	//	CentDedRessyasyubetsuCont ̓esłB
		}
		else
		{
			CConvNodeContainer	aCConvNodeContainer ;
			strData = aCConvNodeContainer.encode( &aCNodeContainer ) ;
			if ( strData.length() == 0 )
			{
				iRv = -1 ;	//	CentDedRessyasyubetsu ̓esłB
			}
		}
	}
	//strData = CentDedRessyasyubetsu ̓e	return iRv ;
	// --------------------------------
	//	Nbv{[hւ̓]
	// --------------------------------
	if ( iRv >= 0 )
	{
		int iResult = stringToClipboard(  
			AfxGetMainWnd()->GetSafeHwnd() ,
			getCF_CentDedRessyasyubetsu() , 
			strData ) ;
		if ( iResult < 0 )
		{
			iRv = -11 ;	//	Nbv{[hւ̃f[^ݒ肪s
		}
	}
	return iRv ;
}

int CDiagramEditDoc::CentDedRessyasyubetsu_From_Cliboard( 
	Mui<CentDedRessyasyubetsu>* pMuCentDedRessyasyubetsu ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	Nbv{[hf[^擾
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 )
	{	
		if (!IsClipboardFormatAvailable(getCF_CentDedRessyasyubetsu())) 
		{
			iRv = -1 ;	//	Nbv{[hɂ͗Lȃf[^͂܂B
		}
	}
	if ( iRv >= 0 )
	{
		int iResult = stringFromClipboard( 
			AfxGetMainWnd()->GetSafeHwnd() , 
			getCF_CentDedRessyasyubetsu() , 
			&strData ) ;
		if ( iResult < 0 )
		{
			iRv = -2 ;	//	Nbv{[h̓ǂݍ݂Ɏs܂B	
		}
	}
	//strData = CentDedEki ̓e
	// --------------------------------
	//	񂩂Ԏʃf[^쐬
	// --------------------------------
	CNodeContainer aCNodeContainer ;
	if ( iRv >= 0 )
	{
		CConvNodeContainer aCConvNodeContainer ;
		int iResult = aCConvNodeContainer.decode( 
			strData , 
			&aCNodeContainer ) ;
		if ( iResult < 0 )
		{
			iRv = -3 ;	//	Nbv{[h̓esłB
		}
	}
	CentDedRessyasyubetsuCont	aCentDedRessyasyubetsuCont ;
	if ( iRv >= 0 )
	{
		CconvCentDed aCconvCentDed ;
		COuErrorInfoContainer aCOuErrorInfoContainer ;
		int iResult = aCconvCentDed.CentDedRessyasyubetsuCont_From_OuPropertiesText( 
			&aCentDedRessyasyubetsuCont , 
			aCNodeContainer.getIfNodeContainerConst() , 
			&aCOuErrorInfoContainer ) ;
		//iResult = 
		//-	-11 ;	//	Syubetsumei w肳Ă܂B
		//-	-52 ;	//	DiagramSenStyle ̒lsłB
		//-	-101 ;	//	ľ`܂B
		if ( iRv < 0 )
		{
			iRv = -4 ;	//	CentDedEki ̓esłB
		}
	}
	// --------------------------------
	//	Mu  EkiCont ɕϊ
	// --------------------------------
	if ( iRv >= 0 )
	{
		CaMui<CentDedRessyasyubetsu> aCaMui( pMuCentDedRessyasyubetsu ) ;
		aCaMui.insert( &aCentDedRessyasyubetsuCont ) ;
	}
	// --------------------------------

	return iRv ;
}


bool CDiagramEditDoc::CentDedRessyasyubetsu_IsClipboardFormatAvailable() 
{
	return ( IsClipboardFormatAvailable( getCF_CentDedRessyasyubetsu() ) != 0 );
}

UINT CDiagramEditDoc::getCF_CentDedRessyaCont() 
{
	return RegisterClipboardFormat( "CF_CentDedRessyaCont" ) ;
}

int CDiagramEditDoc::CentDedRessyaCont_To_Cliboard( 
		const CentDedRessyaCont& aCentDedRessyaCont ) 
{
	int iRv = 0 ;

	// --------------------------------
	//	f[^𕶎
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 )
	{
		CNodeContainer aCNodeContainer ;
		CconvCentDed aCconvCentDed ;
		int iResult = aCconvCentDed.CentDedRessyaCont_To_OuPropertiesText( 
			&aCentDedRessyaCont , 
			&aCNodeContainer ) ;
		if ( iRv < 0 )
		{
			iRv = -1 ;	//	aCentDedRessyaCont ̓esłB
		}
		else
		{
			CConvNodeContainer	aCConvNodeContainer ;
			strData = aCConvNodeContainer.encode( &aCNodeContainer ) ;
			if ( strData.length() == 0 )
			{
				iRv = -1 ;	//	aCentDedRessyaCont ̓esłB
			}
		}
	}
	//string = aCentDedRessyaCont ̓e

	// --------------------------------
	//	Nbv{[hւ̓]
	// --------------------------------
	if ( iRv >= 0 )
	{
		int iResult = stringToClipboard(  
			AfxGetMainWnd()->GetSafeHwnd() ,
			getCF_CentDedRessyaCont() , 
			strData ) ;
		if ( iResult < 0 )
		{
			iRv = -11 ;	//	Nbv{[hւ̃f[^ݒ肪s
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

int CDiagramEditDoc::CentDedRessyaCont_From_Cliboard( 
		CentDedRessyaCont* pCentDedRessyaCont ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	Nbv{[hf[^擾
	// --------------------------------
	string	strData ;
	if ( iRv >= 0 ){	
		if (!IsClipboardFormatAvailable(getCF_CentDedRessyaCont())) {
			iRv = -1 ;	//	Nbv{[hɂ͗Lȃf[^͂܂B
		}
	}
	if ( iRv >= 0 )
	{
		int iResult = stringFromClipboard( 
			AfxGetMainWnd()->GetSafeHwnd() , 
			getCF_CentDedRessyaCont() , 
			&strData ) ;
		if ( iResult < 0 )
		{
			iRv = -2 ;	//	Nbv{[h̓ǂݍ݂Ɏs܂B	
		}
	}
	//strData = CentDedRessyaCont ̓e
	// --------------------------------
	//	񂩂ԃf[^쐬
	// --------------------------------
	CNodeContainer aCNodeContainer ;
	if ( iRv >= 0 )
	{
		CConvNodeContainer aCConvNodeContainer ;
		int iResult = aCConvNodeContainer.decode( 
			strData , 
			&aCNodeContainer ) ;
		if ( iResult < 0 )
		{
			iRv = -3 ;	//	Nbv{[h̓esłB
		}
	}

	if ( iRv >= 0 )
	{
		CconvCentDed aCconvCentDed ;
		COuErrorInfoContainer aCOuErrorInfoContainer ;
		int iResult = aCconvCentDed.CentDedRessyaCont_From_OuPropertiesText( 
			pCentDedRessyaCont , 
			aCNodeContainer.getIfNodeContainerConst() , 
			&aCOuErrorInfoContainer ) ;
		if ( iResult < 0 )
		{
			iRv = -4 ;	//	CentDedRessyaCont ̓esłB
		}
	}
	//pCentDedRessyaCont = CentDedRessyaCont ̓e

	// --------------------------------
	return ( iRv ) ;
}

bool CDiagramEditDoc::CentDedRessyaCont_IsClipboardFormatAvailable() 
{
	return ( IsClipboardFormatAvailable( getCF_CentDedRessyaCont() ) != 0 );
}
	// ********************************
	//@name 
	// ********************************
int CDiagramEditDoc::executeEditCmd( Ou< CRfEditCmd > pCmd ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	R}hs
	// --------------------------------
	if ( iRv >= 0 )
	{
		iRv = pCmd->execute( &m_CDedRosenFileData ) ;
	}
	// --------------------------------
	//	r[̍XV
	// --------------------------------
	if ( iRv >= 0 )
	{
		UpdateAllSubDocviews( NULL , 0 , 
			&CRfEditCmdHolder( pCmd ) ) ;
	}
	// --------------------------------
	//	Undo,Redo֌Wf[^ XV
	//	Undo̕ۑ/Redo̓NA
	// --------------------------------
	if ( iRv >= 0 )
	{
		m_contUndo.insert( pCmd ) ;
		while ( m_contUndo.size() > iUndoLevel )
		{
			m_contUndo.erase( 0 ) ;
		}

		m_contRedo.erase( 0 , INT_MAX ) ;
		
		if ( m_iModifyCountFromDoc != INT_MAX )
		{
			if ( m_iModifyCountFromDoc < 0 )
			{
				m_iModifyCountFromDoc = INT_MAX ;
			}
			else
			{
				m_iModifyCountFromDoc ++ ;
			}
		}
	}
	// --------------------------------
	//	ModifiedFlag XV
	// --------------------------------
	SetModifiedFlag( m_iModifyCountFromDoc != 0 ) ;

	return ( iRv ) ;
}


bool CDiagramEditDoc::canUndo() 
{
	return ( m_contUndo.size() > 0 ) ; 
}
int CDiagramEditDoc::undo() 
{
	LogMsg( "CDiagramEditDoc::undo()" ) ;
	int iRv = 0 ;

	Ou< CRfEditCmd >	pCmd ;
	// --------------------------------
	//	R}hL[擾
	// --------------------------------
	if ( iRv >= 0 ){
		if ( m_contUndo.size() >= 1 ){
			pCmd = m_contUndo.get( INT_MAX ) ;
		}	else	{
			iRv = -1 ;	//	undo 񂪂܂B
		}
	}
	//pcmdUndo = undo ̂߂̃R}h
	// --------------------------------
	//	R}hs
	// --------------------------------
	Ou< CRfEditCmd >	pUndoCmd ;
	if ( iRv >= 0 ){
		pUndoCmd = pCmd->createUndoCmd() ;
		if ( pUndoCmd == NULL ){
			iRv = -2 ;	//	undo ̎sɎs
		}
	}
	if ( iRv >= 0 ){
		int iResult  = pUndoCmd->execute( &m_CDedRosenFileData ) ;
		if ( iResult < 0 ){
			iRv = -2 ;	//	undo ̎sɎs
		}
	}
	// --------------------------------
	//	r[̍XV
	// --------------------------------
	if ( iRv >= 0 ){
		UpdateAllSubDocviews( NULL , 0 , 
			&CRfEditCmdHolder( pUndoCmd ) ) ;
	}
	// --------------------------------
	//	Undo,Redo֌Wf[^ XV
	//	UndoRedoɈړ
	// --------------------------------
	if ( iRv >= 0 )
	{
		m_contUndo.erase( INT_MAX ) ;
		m_contRedo.insert( pCmd ) ;

		if ( m_iModifyCountFromDoc != INT_MAX )
		{
				m_iModifyCountFromDoc -- ;
		}
	}

	// --------------------------------
	//	ModifiedFlag XV
	// --------------------------------
	SetModifiedFlag( m_iModifyCountFromDoc != 0 ) ;
	LogMsg( "CDiagramEditDoc::undo()=" ) ;


	return ( iRv ) ;
}

bool CDiagramEditDoc::canRedo() 
{
	return ( m_contRedo.size() > 0 ) ; 
}

int CDiagramEditDoc::redo() 
{
	LogMsg( "CDiagramEditDoc::redo()" ) ;
	int iRv = 0 ;

	Ou< CRfEditCmd >	pCmd ;
	// --------------------------------
	//	R}hL[擾
	// --------------------------------
	if ( iRv >= 0 ){
		if ( m_contRedo.size() >= 1 ){
			pCmd = m_contRedo.get( INT_MAX ) ;
		}	else	{
			iRv = -1 ;	//	redo 񂪂܂B
		}
	}
	//pcmdUndo = undo ̂߂̃R}h
	// --------------------------------
	//	R}hs
	// --------------------------------
	if ( iRv >= 0 )
	{
		int iResult  = pCmd->execute( &m_CDedRosenFileData ) ;
		if ( iResult < 0 ){
			iRv = -2 ;	//	redo ̎sɎs
		}
	}
	// --------------------------------
	//	r[̍XV
	// --------------------------------
	if ( iRv >= 0 ){
		UpdateAllSubDocviews( NULL , 0 , 
			&CRfEditCmdHolder( pCmd ) ) ;
	}
	// --------------------------------
	//	Undo,Redo֌Wf[^ XV
	//	RedoUndoɈړ
	// --------------------------------
	if ( iRv >= 0 ){
		m_contRedo.erase( INT_MAX ) ;
		m_contUndo.insert( pCmd ) ;

		if ( m_iModifyCountFromDoc != INT_MAX )
		{
				m_iModifyCountFromDoc ++ ;
		}
	}

	// --------------------------------
	//	ModifiedFlag XV
	// --------------------------------
	SetModifiedFlag( m_iModifyCountFromDoc != 0 ) ;

	LogMsg( "CDiagramEditDoc::redo()=" ) ;
	return ( iRv ) ;
}


// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------

IMPLEMENT_DYNCREATE(CDiagramEditDoc, CHidemdiRootDoc)

BEGIN_MESSAGE_MAP(CDiagramEditDoc, CHidemdiRootDoc)
	//{{AFX_MSG_MAP(CDiagramEditDoc)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, &CDiagramEditDoc::OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_UNDO, &CDiagramEditDoc::OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, &CDiagramEditDoc::OnUpdateEditRedo)
	ON_COMMAND(ID_EDIT_REDO, &CDiagramEditDoc::OnEditRedo)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, &CDiagramEditDoc::OnUpdateFileSaveAs)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiagramEditDoc NX̍\z/

CDiagramEditDoc::CDiagramEditDoc()
	: m_iModifyCountFromDoc( 0 ) 
{

}

CDiagramEditDoc::~CDiagramEditDoc()
{
}

BOOL CDiagramEditDoc::OnNewDocument()
{
	if (!CHidemdiRootDoc::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	return TRUE;
}




/////////////////////////////////////////////////////////////////////////////
// CDiagramEditDoc NX̐ff

#ifdef _DEBUG
void CDiagramEditDoc::AssertValid() const
{
	CHidemdiRootDoc::AssertValid();
}

void CDiagramEditDoc::Dump(CDumpContext& dc) const
{
	CHidemdiRootDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDiagramEditDoc R}h

void CDiagramEditDoc::DeleteContents() 
{
	m_CDedRosenFileData.clear() ;
	// --------------------------------
	//	Undo,Redo֌Wf[^ XV
	// --------------------------------
	m_contUndo.erase( 0 , INT_MAX ) ;
	m_contRedo.erase( 0 , INT_MAX ) ;
	m_iModifyCountFromDoc = 0 ;

	// --------------------------------
	//	Hr[XV
	// --------------------------------
	getCDiagramEditApp()->getCDlgRosenView()->OnUpdate( NULL , 0 , NULL ) ;
	// --------------------------------

	CHidemdiRootDoc::DeleteContents();
}

int CDiagramEditDoc::OnOpenDocument_ConvFile( 
	LPCTSTR lpszDllFilename , 
	std::vector< char >* pbinFileContent , 
	CString* pstrError ) 
{
	int iRv = 0 ;
	CString	strError ;

		if ( iRv >= 0 )
		{
			IfConvFile* pIfConvFile = NULL ;
			CConvFileDll	aCConvFileDll( lpszDllFilename ) ;
			if ( iRv >= 0 )
			{
				int iResult = aCConvFileDll.validate() ;
				if ( iResult < 0 )
				{
					strError = MfcUtil::LoadCString( IDS_ERR_DLLNOTFOUND ) ;
					strError += "\n" ;
					strError += aCConvFileDll.getDllFilename().c_str()  ;
					iRv = -101 ;
				}
				else
				{
					pIfConvFile = aCConvFileDll.getIfConvFile() ;
				}
			}
			//aCConvFileDll = DLL[h܂B
	
			LogMsg( "CDiagramEditDoc::OnOpenDocument()31" ) ;
			if ( iRv >= 0 )
			{
				std::vector<char>	binFileContentNew ;
				int iResult = pIfConvFile->isLeftFormat( 
					&CaByteBuffer_vector< std::vector< char > >( pbinFileContent ) ) ;
				LogMsg( "CDiagramEditDoc::OnOpenDocument()32" ) ;
				if ( iResult >= 0 )
				{
					//	FileFormat ADLLł邱ƂmFł܂B
					string strErrorInfoString ;
					int iResult = pIfConvFile->LeftToRight( 
						&CaByteBuffer_vector< std::vector< char > >( pbinFileContent ) , 
						&CaByteBuffer_vector< std::vector< char > >( &binFileContentNew ) , 
						&CaByteBuffer_string( &strErrorInfoString )  ) ;
					if ( iResult >= 0 )
					{
						*pbinFileContent = binFileContentNew ;
					}
					else
					{
						
						strError = MfcUtil::LoadCString( IDS_ERR_FILECONVERT_FAILED ) ;
						strError += "\n" ;
						//strError += aCConvFileDll.getDllFilename().c_str()  ;
						if ( strErrorInfoString.size() > 0 )
						{
							strError += strErrorInfoString.c_str() ;
							strError += "\n" ;
						}
						iRv = -102 ;	//	t@C̕ϊɎs܂B
					}
				}
				else	
				{
					iRv = -1 ;	//DLLT|[gt@C`ł͂܂łB
				}
			}
			LogMsg( "CDiagramEditDoc::OnOpenDocument()33" ) ;
		}
	// --------------------------------
	if ( pstrError != NULL )
	{
		*pstrError = strError ;
	}
	return iRv ;
}


BOOL CDiagramEditDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	CWaitCursor	aCWaitCursor ;

	LogMsg( "CDiagramEditDoc::OnOpenDocument(%s)" , lpszPathName ) ;
	//	Serialize ͎g܂B
	//
	//if (!CHidemdiRootDoc::OnOpenDocument(lpszPathName))
	//	return FALSE;

	// --------------------------------
	//	gq .dia ȂA
	//	WinDIA ̏
	// --------------------------------
	CdFilenameStr	aCdFilenameStr( lpszPathName ) ;
	if ( _stricmp( "dia" , aCdFilenameStr.Extension().c_str() ) == 0 )
	{
		return OnOpenDocument_WinDia( lpszPathName ) ;
	}
	// --------------------------------
	int iRv = 0 ;
	CString	strError ;

	// --------------------------------
	//	t@C̓eAstringɕۑ
	// --------------------------------
	string	strFile ;
	if ( iRv >= 0 )
	{
		int iResult = stringFromFile( &strFile , lpszPathName ) ;
		//iResult = 
		//	-1: t@CI[vł܂B
		//	-2 ; ǂݍ݂Ɏs܂B
		//	-3 ; t@Cɂ "\0" ܂܂܂(oCit@Cł 
		//	v܂)B
		//	 ̏ꍇApString ɂ́A "\0" ̒O܂ł̃f[^i[ 
		//	܂B 
		if ( iResult < 0 ){
			iRv = iResult ;
			switch( iResult ){
			 case -1 :	// t@CI[vł܂B
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILENOTFOUND ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			 case -2 :	//; ǂݍ݂Ɏs܂B
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILEREAD ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			 case -3 :	// t@Cɂ "\0" ܂܂܂
				{
					CString	strFmt ;
					strFmt.LoadString( IDS_ERR_FILEFORMAT ) ;
					strError.Format( strFmt , lpszPathName ) ;
				}
				break ;
			}
			//iRv = 
			//	-1: t@CI[vł܂B
			//	-2 ; ǂݍ݂Ɏs܂B
			//	-3 ; t@Cɂ "\0" ܂܂܂(oCit@Cł 
			//	v܂)B
			//	 ̏ꍇApString ɂ́A "\0" ̒O܂ł̃f[^i[ 
			//	܂B 
		}
	}
	//strFile = t@C̓e

	string strOudFile = strFile ;
	//strOudFile = t@C̓eێ܂B
	//	AÃt@C̃tH[}bgÂꍇ́A
	//	̏œe܂B


	LogMsg( "CDiagramEditDoc::OnOpenDocument()1" ) ;



	// --------------------------------
	//	t@Cߕs\̏ꍇ
	//	ϊ݂܂B
	// --------------------------------
	CconvCDedRosenFileData	aConv ;

	if ( iRv >= 0 && aConv.isEncodeAbleFormat( strOudFile ) < 0 )
	{
		LogMsg( "CDiagramEditDoc::OnOpenDocument()2" ) ;
		
		bool	bFileTypeDetected = false ;
		std::vector<char>	binFileContent ;
		binFileContent = vectorCharOf( strCrlfOf( strOudFile ) ) ;

		LogMsg( "CDiagramEditDoc::OnOpenDocument()3" ) ;

		// --------------------------------
		//	t@Cϊs
		// --------------------------------
		const TCHAR* const arstrConvFileDllFilename[] = 
		{
			_T("ConvFileOudia02To03.dll" ),		//	Ver01,Ver02  Ver03 ɕϊ
			_T(  "ConvFileOudia03To05.dll"  ) , //	Ver03  Ver05 ɕϊ
			_T( "ConvFileOudia05To06.dll"  ) ,	//	Ver05  Ver06 ɕϊ
			_T( "ConvFileOudia06To101.dll" ) ,	//	Ver06  Ver1.01 ɕϊ
			_T( "ConvFileOudia101To102.dll" ) ,	//	Ver1.01  Ver1.02 ɕϊ
 		};
		for ( int idx = 0 ;
			iRv >= 0 && idx < sizeof(arstrConvFileDllFilename)/sizeof(arstrConvFileDllFilename[0]);
			idx ++ )
		{
			iRv = OnOpenDocument_ConvFile( 
				arstrConvFileDllFilename[idx], 
				&binFileContent , 
				&strError ) ;
			if ( iRv == -1 )
			{
				//	tH[}bgFłȂꍇ́A
				//	̃tH[}bgϊs邽߁A
				//	G[ɂ͂܂B
				iRv = 0 ;	
			}
			else
			{
				bFileTypeDetected = true ;
			}
		}

		// --------------------------------
		if ( iRv >= 0 && !bFileTypeDetected )
		{
			strError.Format( MfcUtil::LoadCString( IDS_ERR_FILEFORMAT ) , 
					lpszPathName ) ;
			iRv = -31 ;	// FileTypeFł܂B
				//iRv = 
				//	-31 ; // FileTypeFł܂B
		}
		if ( iRv >= 0 )
		{
			strOudFile = strLfOf( stringOf( binFileContent ) ) ;
		}
		LogMsg( "CDiagramEditDoc::OnOpenDocument()101" ) ;
	}
	//strOudFile = o[Wt@Cϊ̓eɕς܂B

	// --------------------------------
	//	CDedRosenFileData
	//	Jgo[Wt@C
	//	aString t@C̓e߂܂B
	// --------------------------------
	if ( iRv >= 0 )
	{
		CDedRosenFileData	aCDedRosenFileData ;
		CconvCDedRosenFileData aConv ;
		COuErrorInfoContainer aCOuErrorInfoContainer ;
		int iResult = aConv.CDedRosenFileData_from_string( 
			&aCDedRosenFileData , 
			strOudFile , 
			&aCOuErrorInfoContainer ) ;
		//iResult = 
		//	-	-1 ;	//	fBNgrŕĂ܂B	
		//	-	-1001 ;	//	FileType ܂B
		//	-	-1002 ;	//	Rosen Directory܂B
		//	-	-1022 ;	//	Ekijikokukeisiki ̒lsłB
		//	-	-1032 ;	//	Ekikibo ̒lsłB
		//	-	-1101 ;	//	Eki fBNgł͂܂B
		//	-	-1111 ;	//	Syubetsumei w肳Ă܂B
		//	-	-1152 ;	//	DiagramSenStyle ̒lsłB
		//	-	-1201 ;	//	Ressyasyubetsu fBNgł͂܂B
		//	-	-1211 ;	//	DiaName w肳Ă܂B
		//	-	-1212 ;	//	RessyaCont܂B
		//	-	-1352 ;	//	N_̐ݒ肪sK؂łB
		//	-	-1003 ;	//	DispProp Directory܂B
		//	-	-1512 ;	//	JikokuhyouFont ̓esłB
		//	-	-1522 ;	//	DiaEkimeiFont ̓esłB
		//	-	-1532 ;	//	DiaJikokuFont ̓esłB
		//	-	-1582 ;	//	DisplayRessyabangou słB
		//	-	-1592 ;	//	DisplayRessyamei słB
		//	-	-1602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
		//	-	-1612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB
		if ( iResult < 0 )
		{
			iRv = iResult ;
			//iRv = 
			//	-	-1 ;	//	fBNgrŕĂ܂B	
			//	-	-1001 ;	//	FileType ܂B
			//	-	-1002 ;	//	Rosen Directory܂B
			//	-	-1022 ;	//	Ekijikokukeisiki ̒lsłB
			//	-	-1032 ;	//	Ekikibo ̒lsłB
			//	-	-1101 ;	//	Eki fBNgł͂܂B
			//	-	-1111 ;	//	Syubetsumei w肳Ă܂B
			//	-	-1152 ;	//	DiagramSenStyle ̒lsłB
			//	-	-1201 ;	//	Ressyasyubetsu fBNgł͂܂B
			//	-	-1211 ;	//	DiaName w肳Ă܂B
			//	-	-1212 ;	//	RessyaCont܂B
			//	-	-1352 ;	//	N_̐ݒ肪sK؂łB
			//	-	-1003 ;	//	DispProp Directory܂B
			//	-	-1512 ;	//	JikokuhyouFont ̓esłB
			//	-	-1522 ;	//	DiaEkimeiFont ̓esłB
			//	-	-1532 ;	//	DiaJikokuFont ̓esłB
			//	-	-1582 ;	//	DisplayRessyabangou słB
			//	-	-1592 ;	//	DisplayRessyamei słB
			//	-	-1602 ;	//	DiaRessyajouhouHyoujiEkiOrderKudari słB
			//	-	-1612 ;	//	DiaRessyajouhouHyoujiEkiOrderNobori słB

			{
				CString	strFmt ;
				strFmt.LoadString( IDS_ERR_FILEFORMAT_ERRORCODE ) ;
				strError.Format( strFmt , lpszPathName , iRv ) ;
			}

			string strOuErrorInfoText = aCOuErrorInfoContainer.toOuErrorInfoText() ;
			if ( !strOuErrorInfoText.empty() )
			{
				strError += "\n\n" ;
				strError += "(" ;
				strError += strOuErrorInfoText.c_str() ;
				strError += ")" ;
			}

		}
		else
		{
			m_CDedRosenFileData = aCDedRosenFileData ;
		}
	}


	// --------------------------------
	//	Hr[XV
	// --------------------------------
	getCDiagramEditApp()->getCDlgRosenView()->OnUpdate( NULL , 0 , NULL ) ;
	// --------------------------------
	//	G[bZ[W̕\
	// --------------------------------
	LogMsg( "CDiagramEditDoc::OnOpenDocument()=%d" , iRv ) ;
	if ( iRv < 0 )
	{
		string strFileTypeAppComment ;
		//	strFileTypeAppComment 擾
		CNodeContainer aCNodeContainer ;
		CConvNodeContainer aCConvNodeContainer ;
		int iResult = aCConvNodeContainer.decode( 
			strFile , 
			&aCNodeContainer ) ;
		if ( iResult >= 0 )
		{
			strFileTypeAppComment = aCNodeContainer.getValue( nameFileTypeAppComment );
		}
		//strFileTypeAppComment = ږ FileTypeAppComment ̓e

		
		if ( strError.IsEmpty() )
		{
			CString	strFmt ;
			strFmt.LoadString( IDS_ERR_ERRORCODE ) ;
			strError.Format( strFmt , iRv ) ;
		}
		if ( !strFileTypeAppComment.empty() )
		{
			CString strFmt ;
			strFmt.LoadString( IDS_ERR_FileTypeAppComment ) ;
			CString strLs ;
			strLs.Format( strFmt , strFileTypeAppComment.c_str() ) ;
			strError += "\n\n(" ;
			strError += strLs ;
			strError += ")" ;

		}
		AfxMessageBox( strError , MB_ICONSTOP ) ; 
	}
	return ( iRv >= 0 ) ;
}
BOOL CDiagramEditDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CWaitCursor	aCWaitCursor ;

	
	LogMsg( "CDiagramEditDoc::OnSaveDocument(%s)" , lpszPathName ) ;
	//Serialize() ͎g܂B
	//
	//return CHidemdiRootDoc::OnSaveDocument(lpszPathName);


	// --------------------------------
	//	gq .dia ȂA
	//	WinDIA ̏
	// --------------------------------
	CdFilenameStr	aCdFilenameStr( lpszPathName ) ;
	if ( _stricmp( "dia" , aCdFilenameStr.Extension().c_str() ) == 0 )
	{
		return OnSaveDocument_WinDia( lpszPathName ) ;
	}
	// --------------------------------
	int iRv = 0 ;

	CString strError ;

	// --------------------------------
	//	t@C̓eCdConnectedString2쐬
	// --------------------------------
	CNodeContainer aCNodeContainer ;
	//CdFilenameStr	aCdFilenameStr( lpszPathName ) ;
	//gq.oud̏ꍇAOudiaver1.02ɕϊďo͂
	if ( _stricmp( "oud" , aCdFilenameStr.Extension().c_str() ) == 0 )
	{
		if ( iRv >= 0 )
		{
			CconvCDedRosenFileDataOud aConv ;
			int iResult = aConv.CDedRosenFileData_to_OuPropertiesText( 
				&m_CDedRosenFileData , 
				&aCNodeContainer ) ;
			//iResult = 
			//		-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//		-	-32 ;	//	Ekikibo ̒lsłB
			//		-	-111 ;	//	Syubetsumei w肳Ă܂B
			//		-	-152 ;	//	DiagramSenStyle ̒lsłB
			//		-	-212 ;	//	DiagramEkiatsukai ̒lsłB
			if ( iResult < 0 )
			{
				iRv = iResult ;
				strError.Format( IDS_ERR_FILEFORMAT , lpszPathName ) ;
				//iRv = 
				//		-	-22 ;	//	Ekijikokukeisiki ̒lsłB
				//		-	-32 ;	//	Ekikibo ̒lsłB
				//		-	-111 ;	//	Syubetsumei w肳Ă܂B
				//		-	-152 ;	//	DiagramSenStyle ̒lsłB
				//		-	-212 ;	//	DiagramEkiatsukai ̒lsłB
			}
		}	
	}
	else
	{
		if ( iRv >= 0 )
		{
			CconvCDedRosenFileData aConv ;
			int iResult = aConv.CDedRosenFileData_to_OuPropertiesText( 
				&m_CDedRosenFileData , 
				&aCNodeContainer ) ;
			//iResult = 
			//		-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			//		-	-32 ;	//	Ekikibo ̒lsłB
			//		-	-111 ;	//	Syubetsumei w肳Ă܂B
			//		-	-152 ;	//	DiagramSenStyle ̒lsłB
			//		-	-212 ;	//	DiagramEkiatsukai ̒lsłB
			if ( iResult < 0 )
			{
				iRv = iResult ;
				strError.Format( IDS_ERR_FILEFORMAT , lpszPathName ) ;
				//iRv = 
				//		-	-22 ;	//	Ekijikokukeisiki ̒lsłB
				//		-	-32 ;	//	Ekikibo ̒lsłB
				//		-	-111 ;	//	Syubetsumei w肳Ă܂B
				//		-	-152 ;	//	DiagramSenStyle ̒lsłB
				//		-	-212 ;	//	DiagramEkiatsukai ̒lsłB
			}
		}	
	}
		//aString = t@CɏށwHt@Cx`̕ێ܂B

	LogMsg( "CDiagramEditDoc::OnSaveDocument()1" ) ;

	// --------------------------------
	//	FileTypeAppComment t^
	// --------------------------------
	if ( iRv >= 0 )
	{
		string strFileTypeAppComment ;
		strFileTypeAppComment += AfxGetAppName() ;
		strFileTypeAppComment += " Ver. " ;
		strFileTypeAppComment += getCDiagramEditApp()->getProgramVer() ;
		aCNodeContainer.setValue( nameFileTypeAppComment , strFileTypeAppComment );
	}
	
	// --------------------------------
	//	aCNodeContainer ̓e
	//	Ɋi[
	// --------------------------------
	string aString ;
	if ( iRv >= 0 ){
		//	CConnectedStringCompress ɂ鈳k
		CConvNodeContainer aCConvNodeContainer ;
		aString = aCConvNodeContainer.encode( &aCNodeContainer ) ;
	}
	//	aString = t@Cɏo͂镶

	// --------------------------------
	//	string̓eAt@Cɏ
	// --------------------------------
	if ( iRv >= 0 ){
		int iResult = stringToFile( aString , lpszPathName ) ;
		//iResult = 
		//	-1: t@CI[vł܂B
		//	-2 ; // ݂Ɏs܂B 
		if ( iResult < 0 ){
			iRv = iResult ;
			switch( iResult ){
			 case -1 :	// t@CI[vł܂B
				{
					CString	strFmt ;
					strError.Format( IDS_ERR_FILECREATE , lpszPathName ) ;
				}
				break ;
			 case -2 :	//;݂Ɏs܂
				{
					CString	strFmt ;
					strError.Format( IDS_ERR_FILEWRITE , lpszPathName ) ;
				}
				break ;
			}
			//iRv = 
			//	-1: t@CI[vł܂B
			//	-2 ; ݂Ɏs܂B
		}
	}

	// --------------------------------
	LogMsg( "CDiagramEditDoc::OnSaveDocument()=%d" , iRv ) ;

	if ( iRv < 0 )
	{
		if ( strError.IsEmpty() )
		{
			CString	strFmt ;
			strFmt.LoadString( IDS_ERR_ERRORCODE ) ;
			strError.Format( strFmt , iRv ) ;
		}
		AfxMessageBox( strError , MB_ICONSTOP ) ; 
		return ( FALSE ) ;
	}
	//	ۑɐAI
	//	ύXtOȂĂ͂Ȃ܂B

	// --------------------------------
	//	Undo,Redo֌Wf[^ XV
	//	UndoRedoɈړ
	// --------------------------------
	if ( iRv >= 0 )
	{
		m_iModifyCountFromDoc = 0 ;
	}

	// --------------------------------
	//	ModifiedFlag XV
	// --------------------------------
	SetModifiedFlag( m_iModifyCountFromDoc != 0 ) ;
	return TRUE;
}

void CDiagramEditDoc::OnFileSaveAs() 
{
	CString	strExt ;
	getCDiagramEditApp()->pRootDoctmpl()->GetDocString( strExt , CDocTemplate::filterExt ) ;
	//CString strBuf = GetPathName() ;
	if ( _strnicmp( _strrev( _strdup( GetPathName() ) ) , "duo" , 3 ) == 0 )
	{
	CFileDialog	aDlg( FALSE , strExt , GetPathName()  , 
	  OFN_HIDEREADONLY | OFN_PATHMUSTEXIST
	  | OFN_OVERWRITEPROMPT , 
		getCDiagramEditApp()->getCFileDialogOud2Filter() , NULL ) ;//edit_by_d_mania
		if ( aDlg.DoModal() != IDOK )
		{
			return ;
		}	
		// --------------------------------
		DoSave(aDlg.GetPathName(), TRUE ) ;
	}
	else
	{
	CFileDialog	aDlg( FALSE , strExt , GetPathName()  , 
	  OFN_HIDEREADONLY | OFN_PATHMUSTEXIST
	  | OFN_OVERWRITEPROMPT , 
		getCDiagramEditApp()->getCFileDialogFilter() , NULL ) ;//reedit_by_d_mania
		if ( aDlg.DoModal() != IDOK )
		{
			return ;
		}	
		// --------------------------------
		DoSave(aDlg.GetPathName(), TRUE ) ;
	}
}



void CDiagramEditDoc::OnUpdateFileSaveAs(CCmdUI *pCmdUI)
{
	//	Otĕۑ ́A펞Lɂ܂B
	pCmdUI->Enable( TRUE ) ;
}

void CDiagramEditDoc::SetPathName(LPCTSTR lpszPathName, BOOL bAddToMRU) 
{
	CdFilenameStr	aCdFilenameStr( lpszPathName ) ;
	if ( _stricmp( "dia" , aCdFilenameStr.Extension().c_str() ) == 0 )
	{
		//	gq .dia ́AhLg̗Lȃt@CƂ
		//	F߂܂B
		//	AhLg̃^CgƂāA
		//	gq菜t@Cݒ肵܂B

		if ( GetTitle().IsEmpty() )
		{
			SetTitle(aCdFilenameStr.BaseFilename().c_str() );
		}
		return ;
	}	
	
	CHidemdiRootDoc::SetPathName(aCdFilenameStr.FullpathFilename().c_str() , bAddToMRU);
}

void CDiagramEditDoc::OnUpdateEditUndo(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE ;
	{
		bEnable = this->canUndo() ;
	}
	pCmdUI->Enable( bEnable ) ;	
}

void CDiagramEditDoc::OnEditUndo()
{
	this->undo() ;
}

void CDiagramEditDoc::OnUpdateEditRedo(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE ;
	{
		bEnable = this->canRedo() ;
	}
	pCmdUI->Enable( bEnable ) ;	
}

void CDiagramEditDoc::OnEditRedo()
{
	this->redo() ;
}
