/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	CaByteBuffer_vector.h
// ****************************************************************
/** @file */
#ifndef  CaByteBuffer_vector_h
#define  CaByteBuffer_vector_h

#include "..\..\ConvDedFile\interface\IfByteBuffer.h"

namespace ConvFile{

// ****************************************************************
//	CaByteBuffer_vector
// ****************************************************************
/**
@brief
  std::vector<char> ܂ std::vector<unsigned char> 
   IfByteBuffer C^[tF[Xő삷邽߂̃A_v^NXłB

@param vectorT 
  std::vector<char> ܂ std::vector<unsigned char> 
  w肵ĂB
	
*/
template< class vectorT > class CaByteBuffer_vector : public IfByteBuffer 
{
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	vectorT*	m_pVector ;
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	CaByteBuffer_vector( vectorT* pVector )
		: m_pVector( pVector )
	{
	};


public:
	// ********************************
	///@name IfByteBuffer	
	// ********************************
	///@{
	/**
		obt@̃TCYύX܂B
		̊֐ĂяoƁAobt@ɂ܂ŕێĂ
		f[^͔j܂B
	@param iBytes [in] 
		obt@̃oCgw肵ĂB
	@return 
		 0 ȏAG[Ȃ畉̐łB
		-	-1;	//	mۂł܂B
	*/
	virtual int size_reset( int iBytes ) 
	{
		m_pVector->resize( iBytes ) ;
		return 0 ;
	};

	/**
	@return 
		obt@̃oCgԂ܂B
	*/
	virtual int size()const 
	{
		return m_pVector->size() ;
	};

	/**
		obt@̎ẅʒuɃf[^݂܂B
	@param pData [in]
		f[^̐擪AhXw肵ĂB
	@param iPos [in]
		obt@́Af[^ވʒuAoCgCfNXŎw肵ĂB
	@param iBytes [in]
		ރoCgw肵ĂB
	@return 
		񂾃oCgԂ܂B
		̐̓G[łB
	*/
	virtual int write( const char* pData , int iPos , int iBytes ) 
	{
		if ( iBytes > (int)m_pVector->size() - iPos ) 
		{
			iBytes = m_pVector->size() - iPos ; 
		}
		if ( iBytes < 0 )
		{
			iBytes = 0 ;
		}
		if ( iBytes > 0 )
		{
			memcpy( &(*m_pVector)[iPos] , pData , iBytes ) ;
		}
		return iBytes ;
	};


	/**
		obt@̎ẅʒuf[^ǂݍ݂܂B
	@param pData [out]
		̊֐͂̃AhXɁAǂݍ񂾃f[^݂܂B
	@param iPos [in]
		obt@́Af[^ǂݏoʒuA
		oCgCfNXŎw肵ĂB
	@param iBytes [in]
		ǂݍރoCgw肵ĂB
	@return 
		ǂݍނ񂾃oCgԂ܂B
		̐̓G[łB
	*/
	virtual int read( char* pData , int iPos , int iBytes )const
	{
		if ( iBytes > (int)m_pVector->size() - iPos ) 
		{
			iBytes = m_pVector->size() - iPos ; 
		}
		if ( iBytes < 0 )
		{
			iBytes = 0 ;
		}
		if ( iBytes > 0 )
		{
			memcpy( pData , &(*m_pVector)[iPos] , iBytes ) ;
		}
		return iBytes ;
	};

	///@}
};

} //namespace ConvFile

#endif //CaByteBuffer_vector_h
