/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	$Id: CPropEditUi_Ressyasyubetsu.cpp 399 2016-11-26 08:45:03Z okm $
// ****************************************************************

/** @file */
#include "stdafx.h"
#include "CPropEditUi_Ressyasyubetsu.h"

namespace ViewRessyasyubetsu {

// ****************************************************************
//	CPropEditUi_Ressyasyubetsu
// ****************************************************************
	// ʖw肳Ă܂
const char* const CPropEditUi_Ressyasyubetsu::ERRMSG_SYUBETUSMEI_EMPTY = "Ressyasyubetsumei is empty." ;

	// ̂܂
const char* const CPropEditUi_Ressyasyubetsu::ERRMSG_RYAKUSYOULENGTH = "Ryakusyou is too long(Limit is 6 characters)." ;


	// ================================
	//  I[o[Cg̕Kvȃ\bh1-TargetɈˑ鏈
	// ================================
void CPropEditUi_Ressyasyubetsu::UiDataFromTarget( UIDATA* pUiData ) 
{
	for ( int i = 0 ; i < m_pTarget->size() ; i ++ )
	{
		const CentDedRessyasyubetsu* pTarget = m_pTarget->get( i ) ; 

		/* Ԏʖ */
		if ( i == 0 )
		{
			pUiData->strSyubetsumei = pTarget->getSyubetsumei() ;
		}
		else if ( pUiData->strSyubetsumei != pTarget->getSyubetsumei() )
		{
			pUiData->strSyubetsumei = "" ;
		}
	
		/* Ԏʖ̗LE ́AΏۊO */
	
		/** ́iʖ̗́j */
		if ( i == 0 )
		{
			pUiData->strRyakusyou = pTarget->getRyakusyou();
		}
		else if ( pUiData->strRyakusyou != pTarget->getRyakusyou() )
		{
			pUiData->strRyakusyou = "" ;
		}
	
		/*	\F(_CO̗ԏ̕F˂܂)	*/
		if ( i == 0 )
		{
			pUiData->colorJikokuhyouMojiColor = pTarget->getJikokuhyouMojiColor() ;
		}
		else if ( pUiData->colorJikokuhyouMojiColor != pTarget->getJikokuhyouMojiColor() )
		{
			pUiData->colorJikokuhyouMojiColor.setIsNull( true ) ; 
		}
		/* \r[ŁA̗Ԏʂ̎\邽߂̎\tHg */
		if ( i == 0 )
		{
			pUiData->iJikokuhyouFontIndex= pTarget->getJikokuhyouFontIndex() ;
		}
		else if ( pUiData->iJikokuhyouFontIndex != pTarget->getJikokuhyouFontIndex() )
		{
			pUiData->iJikokuhyouFontIndex = -1 ;
		}

		/* _CO̐F */
		if ( i == 0 )
		{
			pUiData->colorDiagramSenColor = pTarget->getDiagramSenColor() ;
		}
		else if ( pUiData->colorDiagramSenColor != pTarget->getDiagramSenColor()  )
		{
			pUiData->colorDiagramSenColor.setIsNull( true )  ;
		}
	
		/* _CO̐X^C	*/
		if ( i == 0 )
		{
			pUiData->iDiagramSenStyle = (int)pTarget->getDiagramSenStyle() ;
		}
		else if ( pUiData->iDiagramSenStyle = (int)pTarget->getDiagramSenStyle() )
		{
			pUiData->iDiagramSenStyle = -1 ;	// s
		}
		/* _CO̐X^Cۂw肵܂B*/
		if( i == 0 )
		{
			pUiData->iDiagramSenIsBold = (int)pTarget->getDiagramSenIsBold() ;
		} 
		else if ( pUiData->iDiagramSenIsBold != (int)pTarget->getDiagramSenIsBold() )
		{
			pUiData->iDiagramSenIsBold = -1 ;	// s	
		}

		/*  ԉw̕@ */
		if ( i == 0 )
		{
			pUiData->iStopMarkDrawType = (int)pTarget->getStopMarkDrawType() ;
		}
		else if ( pUiData->iStopMarkDrawType != (int)pTarget->getStopMarkDrawType() )
		{
			pUiData->iStopMarkDrawType = -1 ;
		}
	}
}



void CPropEditUi_Ressyasyubetsu::AdjustUiData( 
		UIDATA* pUiData , 
		const UIDATA* pUiDataPrev , 
		bool bStartEdit )
{
	/* Ԏʖ */
	if ( bStartEdit || pUiDataPrev->strSyubetsumei != pUiData->strSyubetsumei)
	{
		// pUiData->o[ ̐KsR[hB
	}
	
	/* Ԏʖ̗LE */
	if ( bStartEdit || pUiDataPrev->bSyubetsumeiIsEnable != pUiData->bSyubetsumeiIsEnable)
	{
		// pUiData->o[ ̐KsR[hB
	}
	
	/* ́iʖ̗́j */
	if ( bStartEdit || pUiDataPrev->strRyakusyou != pUiData->strRyakusyou)
	{
		// pUiData->o[ ̐KsR[hB
	}
	/* \F(_CO̗ԏ̕F˂܂)	*/
	if ( bStartEdit || pUiDataPrev->colorJikokuhyouMojiColor != pUiData->colorJikokuhyouMojiColor)
	{
		// pUiData->o[ ̐KsR[hB
	}

	/* \r[ŁA̗Ԏʂ̎\邽߂̎\tHg */
	if ( bStartEdit || pUiDataPrev->iJikokuhyouFontIndex != pUiData->iJikokuhyouFontIndex)
	{
		// pUiData->o[ ̐KsR[hB
	}

	/* _CO̐F */
	if ( bStartEdit || pUiDataPrev->colorDiagramSenColor != pUiData->colorDiagramSenColor)
	{
		// pUiData->o[ ̐KsR[hB
	}
	
	/* _CO̐X^C*/	
	if ( bStartEdit || pUiDataPrev->iDiagramSenStyle != pUiData->iDiagramSenStyle)
	{
		// pUiData->o[ ̐KsR[hB
	}

	/* _CO̐X^Cۂw肵܂B*/
	if ( bStartEdit || pUiDataPrev->iDiagramSenIsBold != pUiData->iDiagramSenIsBold)
	{
		// pUiData->o[ ̐KsR[hB
	}
	
	/*	 ԉw̕@ */
	if ( bStartEdit || pUiDataPrev->iStopMarkDrawType != pUiData->iStopMarkDrawType)
	{
		// pUiData->o[ ̐KsR[hB
	}
}


int CPropEditUi_Ressyasyubetsu::CheckUiData( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ;


	/* Ԏʖ */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->strSyubetsumei != pUiData->strSyubetsumei)
		{
			if ( pUiData->strSyubetsumei.length() == 0 )
			{
				iRv = -1 ;      //  ʖw肳Ă܂
				ShowError( ERRMSG_SYUBETUSMEI_EMPTY ) ;
				SetFocus( offsetof( UIDATA , strSyubetsumei )) ;
			}
		}
	}
		
	/* Ԏʖ̗LE */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->bSyubetsumeiIsEnable != pUiData->bSyubetsumeiIsEnable)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}
		
	/* ́iʖ̗́j */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->strRyakusyou != pUiData->strRyakusyou)
		{
			if ( pUiData->strRyakusyou.length() > 6 )
			{
				iRv = -2 ;      //  ̂܂(̂6܂(p)ł)
				ShowError( ERRMSG_RYAKUSYOULENGTH ) ;
				SetFocus( offsetof( UIDATA , strRyakusyou )) ;
			}
		}
	}
	/* \F(_CO̗ԏ̕F˂܂)	*/
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->colorJikokuhyouMojiColor != pUiData->colorJikokuhyouMojiColor)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}

	/* \r[ŁA̗Ԏʂ̎\邽߂̎\tHg */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iJikokuhyouFontIndex != pUiData->iJikokuhyouFontIndex)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}

	/* _CO̐F */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->colorDiagramSenColor != pUiData->colorDiagramSenColor)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}
		
	/* _CO̐X^C*/	
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iDiagramSenStyle != pUiData->iDiagramSenStyle)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}

	/* _CO̐X^Cۂw肵܂B*/
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iDiagramSenIsBold != pUiData->iDiagramSenIsBold)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}
		
	/*	 ԉw̕@ */
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iStopMarkDrawType != pUiData->iStopMarkDrawType)
		{
			// pUiData->o[ ̐KsR[hB
		}
	}


	return iRv ;
}
int CPropEditUi_Ressyasyubetsu::UiDataToTarget( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ; 
	for ( int i = 0 ; iRv >= 0 && i < m_pTarget->size() ; i ++ )
	{
		CentDedRessyasyubetsu* pTarget = m_pTarget->get( i ) ; 

		/* Ԏʖ */
		if ( bNewItem || pUiDataStartEdit->strSyubetsumei != pUiData->strSyubetsumei)
		{
			pTarget->setSyubetsumei( pUiData->strSyubetsumei ) ;
		}
		
		/* ́iʖ̗́j */
		if ( bNewItem || pUiDataStartEdit->strRyakusyou != pUiData->strRyakusyou)
		{
			pTarget->setRyakusyou( pUiData->strRyakusyou ) ;
		}
		/* \F(_CO̗ԏ̕F˂܂)	*/
		if ( bNewItem || pUiDataStartEdit->colorJikokuhyouMojiColor != pUiData->colorJikokuhyouMojiColor)
		{
			pTarget->setJikokuhyouMojiColor( pUiData->colorJikokuhyouMojiColor ) ;
		}

		/* \r[ŁA̗Ԏʂ̎\邽߂̎\tHg */
		if ( bNewItem || pUiDataStartEdit->iJikokuhyouFontIndex != pUiData->iJikokuhyouFontIndex)
		{
			pTarget->setJikokuhyouFontIndex( pUiData->iJikokuhyouFontIndex ) ;
		}

		/* _CO̐F */
		if ( bNewItem || pUiDataStartEdit->colorDiagramSenColor != pUiData->colorDiagramSenColor)
		{
			pTarget->setDiagramSenColor( pUiData->colorDiagramSenColor ) ;
		}
		
		/* _CO̐X^C*/	
		if ( bNewItem || pUiDataStartEdit->iDiagramSenStyle != pUiData->iDiagramSenStyle)
		{
			pTarget->setDiagramSenStyle( (CentDedRessyasyubetsu::ESenStyle)pUiData->iDiagramSenStyle ) ;
		}

		/* _CO̐X^Cۂw肵܂B*/
		if ( bNewItem || pUiDataStartEdit->iDiagramSenIsBold != pUiData->iDiagramSenIsBold)
		{
			pTarget->setDiagramSenIsBold( pUiData->iDiagramSenIsBold == 1 ) ;
		}
		
		/*	 ԉw̕@ */
		if ( bNewItem || pUiDataStartEdit->iStopMarkDrawType != pUiData->iStopMarkDrawType)
		{
			pTarget->setStopMarkDrawType( (CentDedRessyasyubetsu::EStopMarkDrawType)pUiData->iStopMarkDrawType ) ;
		}
	}
	return iRv ;
}



	// ********************************
	//	RXgN^
	// ********************************
CPropEditUi_Ressyasyubetsu::CPropEditUi_Ressyasyubetsu(
	bool bNewItem , 
	Mu<CentDedRessyasyubetsu*>* pTarget )
	: CPropEditUi2( bNewItem )
	, m_pTarget( pTarget ) 
{
	
}

} //namespace ViewRessyasyubetsu 



