/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
//$Id: CentDedEkiJikokuTrackCont.cpp 378 2016-11-16 21:10:54Z okm $
/** @file */

#include "stdafx.h"
#include "CentDedEkiJikokuCont.h"
#include "CentDedEkiJikokuTrackCont.h"
#include "CentDedRosen.h"


namespace entDed{
	
// ****************************************************************
//	CentDedEkiJikokuTrackCont
// ****************************************************************

	// ********************************
	//	RXgN^
	// ********************************
CentDedEkiJikokuTrackCont::CentDedEkiJikokuTrackCont() 
{
	//Rei̐(RXgN^):Ԑwq́w{x ԕɉwNULLvf2ݒ肷B
	super::insert( CentDedEkiJikokuTrack() ) ; 
	super::insert( CentDedEkiJikokuTrack() ) ; 
}
CentDedEkiJikokuTrackCont::CentDedEkiJikokuTrackCont(const CentDedEkiJikokuTrackCont& value ) 
: super( value ) 
{
}
CentDedEkiJikokuTrackCont& CentDedEkiJikokuTrackCont::operator=(const CentDedEkiJikokuTrackCont& value ) 
{
	super::operator=( value ) ;
	return *this ;
}
	// ********************************
	//@name Mui
	// ********************************
int CentDedEkiJikokuTrackCont::insert( const CentDedEkiJikokuTrack& element , int iIndex )
{
	//insert,erase ́AG[(vfŒ̂)
	return -1 ;
}
int CentDedEkiJikokuTrackCont::erase( int iIndex  , int iSize ) 
{
	//insert,erase ́AG[(vfŒ̂)
	return -1 ;
}
int CentDedEkiJikokuTrackCont::set( const CentDedEkiJikokuTrack& element , int iIndex ) 
{
	int iResult = setable( element , iIndex ) ;
	if ( iResult < 0 ){	
		return  iResult ;
	}
	return super::set(element , iIndex )  ;
}

	// ********************************
	//@name CentDedEkiJikokuTrackCont-֘A
	// ********************************
CentDedRosen* CentDedEkiJikokuTrackCont::getRosen() 
{
	CentDedRosen* pRosen = NULL ;
	CentDedEkiJikoku* pEkiJikoku = getEkiJikoku() ;
	if ( pEkiJikoku == NULL ){	return NULL ;}
	CentDedEkiJikokuCont* pEkiJikokuCont = dynamic_cast<CentDedEkiJikokuCont*>( pEkiJikoku->getParent() ) ;
	if ( pEkiJikokuCont == NULL ){	return NULL ;}
	pRosen = pEkiJikokuCont->getRosen() ;
	return pRosen ;
}
const CentDedRosen* CentDedEkiJikokuTrackCont::getRosen()const
{
	const CentDedRosen* pRosen = NULL ;
	const CentDedEkiJikoku* pEkiJikoku = getEkiJikoku() ;
	if ( pEkiJikoku == NULL ){	return NULL ;}
	const CentDedEkiJikokuCont* pEkiJikokuCont = dynamic_cast<const CentDedEkiJikokuCont*>( pEkiJikoku->getParent() ) ;
	if ( pEkiJikokuCont == NULL ){	return NULL ;}
	pRosen=  pEkiJikokuCont->getRosen() ;
	return pRosen ;
}

const CentDedEki* CentDedEkiJikokuTrackCont::getEki()const 
{
	const CentDedRosen* pRosen = getRosen() ;
	if ( pRosen == NULL ){ return NULL ;}

	//	wIuWFNg擾܂B
	//	̔z̃CfNX́wwOrderxȂ̂ŁAwwIndexxɕϊ܂B
	//	(̂߂ɁAwOrderƗԕKvł)
	const CentDedEki* pEki = NULL ;
	{
		//	̓̉wOrderƗԕ擾܂B
		ERessyahoukou eRessyahoukou ;
		int iEkiOrder ;
		{
			const CentDedEkiJikokuCont* pEkiJikokuCont = static_cast<const CentDedEkiJikokuCont*>( this->getEkiJikoku()->getParent() );
			iEkiOrder = pEkiJikokuCont->getIndex( this->getEkiJikoku() ) ;
			eRessyahoukou = pEkiJikokuCont->getRessya()->getRessyahoukou() ;
		}

		pEki = pRosen->getCentDedEkiCont()->getMuPtr()->get( 
				pRosen->getCentDedEkiCont()->EkiIndexOfEkiOrder( eRessyahoukou , iEkiOrder ) ) ;
	}
	return pEki ;
}


	// ********************************
	//@name CentDedEkiJikokuTrackCont-
	// ********************************
int  CentDedEkiJikokuTrackCont::setable(  const CentDedEkiJikokuTrack& element , int iIndex )const 
{

	//set  CentDedEkiJikokuTrack H(CentDedRosen)̈ꕔłꍇŁA
	//ԐwqwԐReixCentDedEkiTrackCont ̗vfɑΉĂȂꍇ́AG[ƂB
	const CentDedEki* pEki = getEki() ;
	if ( pEki != NULL )
	{
		const CentDedEkiTrackCont* pEkTrackCont = pEki->getEkiTrackCont() ;

		if ( !element.getTrack().isNull() && element.getTrack().getiIndex() >= pEkTrackCont->size() )
		{
			return -11 ;	//	ԐIndexACentDedEkiTrackCont̗vfɑΉĂ܂
		}
	}

	//set  CentDedEkiJikokuTrackCont ẅꕔłꍇŁA
	//w^sȂEoRȂ̏ꍇA
	//NULLȊO̔ԐENULLȊO̓̐ݒ̓G[ƂB
	const CentDedEkiJikoku* pEkiJikoku = getEkiJikoku() ;
	if (pEkiJikoku  != NULL )
	{
		if ( pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None
			|| pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
		{
			if ( !element.getTrack().isNull() )
			{
				return -12 ;	//	w^sȂEoRȂ̏ꍇANULLȊO̔Ԑ̐ݒ͂ł܂
			}
			if ( !element.getNyusenJikoku().isNull() )
			{
				return -13 ;	//	w^sȂEoRȂ̏ꍇANULLȊO̓̐ݒ͂ł܂
			}
		}

	}

	return 0 ; 
}

int  CentDedEkiJikokuTrackCont::getIndex( const CentDedEkiJikokuTrack* element )const 
{
	const Mu<const CentDedEkiJikokuTrack*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		if ( pMu->get( idx ) == element ){	return idx ;}
	}
	return -1 ;
}
void CentDedEkiJikokuTrackCont::adjust() 
{
	Mu<CentDedEkiJikokuTrack*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		pMu->get( idx )->adjust() ;
	}
}

	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
void CentDedEkiJikokuTrackCont::onEkiTrackInsert(  int iEkiTrackIndex )
{
	Mu<CentDedEkiJikokuTrack*>* muEkiJikokuTrack = getMuPtr() ;
	for ( int i = 0 ; i < muEkiJikokuTrack->size() ; i ++ )
	{
		muEkiJikokuTrack->get( i )->onEkiTrackInsert( iEkiTrackIndex ) ;
	}
}
void CentDedEkiJikokuTrackCont::onEkiTrackErase( int iEkiTrackIndex )
{
	Mu<CentDedEkiJikokuTrack*>* muEkiJikokuTrack = getMuPtr() ;
	for ( int i = 0 ; i < muEkiJikokuTrack->size() ; i ++ )
	{
		muEkiJikokuTrack->get( i )->onEkiTrackErase( iEkiTrackIndex ) ;
	}
}


}//namespace entDed


