/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CentDedEkiTrackCont.cpp 378 2016-11-16 21:10:54Z okm $


#include "stdafx.h"

#include "CentDedEkiTrackCont.h"
#include "CentDedRosen.h"
#include "CentDedEki.h"

namespace entDed{

	// ********************************
	//	RXgN^
	// ********************************
CentDedEkiTrackCont::CentDedEkiTrackCont() 
{
	super::insert( CentDedEkiTrack( CentDedEkiTrack::ETrackType_NoboriMain ) ) ;
	super::insert( CentDedEkiTrack( CentDedEkiTrack::ETrackType_KudariMain ) ) ;
}


CentDedEkiTrackCont& CentDedEkiTrackCont::operator=( const CentDedEkiTrackCont& value )
{
	const Mu<const CentDedEkiTrack*>* muSrc = value.getMuPtr() ;
	
	int idxSrc ;
	//	]A{̑OB
	//	]悪 Named Ȃ㏑B]悪 {Ȃ烋[vI 
	for ( idxSrc = 0  
		; muSrc->get( idxSrc )->getTrackType() 
			==  CentDedEkiTrack::ETrackType_Named 
		; idxSrc ++ )
	{
		if ( this->get( idxSrc ).getTrackType() ==  CentDedEkiTrack::ETrackType_Named )
		{
			this->set( *muSrc->get( idxSrc ) , idxSrc ) ;
		}
		else
		{
			this->insert( *muSrc->get( idxSrc ) , idxSrc ) ;
		}
	}
	
	//	]A{
	//	]悪 Named Ȃ폜B]悪 {Ȃ 
	while( this->get( idxSrc ).getTrackType() != CentDedEkiTrack::ETrackType_NoboriMain )
	{
		this->erase( idxSrc ) ;
	}
	
	//	]A{Ɖ{̊ԁB
	//	]悪 Named Ȃ㏑B]悪 {Ȃ烋[vI 
	for ( idxSrc ++  
		; muSrc->get( idxSrc )->getTrackType() 
			==  CentDedEkiTrack::ETrackType_Named 
		; idxSrc ++ )
	{
		if ( this->get( idxSrc ).getTrackType() ==  CentDedEkiTrack::ETrackType_Named )
		{
			this->set( *muSrc->get( idxSrc ) , idxSrc ) ;
		}
		else
		{
			this->insert( *muSrc->get( idxSrc ) , idxSrc ) ;
		}
	}
	
	//	]A{
	//	]悪 Named Ȃ폜B]悪 {Ȃ 
	while( this->get( idxSrc ).getTrackType() != CentDedEkiTrack::ETrackType_KudariMain )
	{
		this->erase( idxSrc ) ;
	}
	
	//	]A{̌
	//	]悪 Named Ȃ㏑B]悪 {Ȃ烋[vI 
	for ( idxSrc ++  
		; idxSrc < muSrc->size()
		; idxSrc ++ )
	{
		if ( this->get( idxSrc ).getTrackType() ==  CentDedEkiTrack::ETrackType_Named )
		{
			this->set( *muSrc->get( idxSrc ) , idxSrc ) ;
		}
		else
		{
			this->insert( *muSrc->get( idxSrc ) , idxSrc ) ;
		}
	}
	
	//	]̗]폜
	this->erase( idxSrc , INT_MAX ) ; 
	
	
	return *this ;
}

// ********************************
//@name Mui
// ********************************
int CentDedEkiTrackCont::insert( const CentDedEkiTrack& element ,  int iIndex) 
{
	int iRv = 0; 
	if ( iIndex == INT_MAX )
	{
		iIndex = size() ;
	}
	
	if ( element.getTrackType() != CentDedEkiTrack::ETrackType_Named )
	{
		iRv = -11 ;	//	{ǉ邱Ƃ͏o܂B
	}
	if ( iRv >= 0 )
	{
		iRv = super::insert( element ,  iIndex ) ;
	}
	//	  ̃Rei CentDedEki ̎qIuWFNgŁA
	//	 CentDedEki  CentDedRosen ɕ܂ĂꍇA insert() 
	//	\bh́ACentDedRosen::onEkiTrackInsert( iEkiIndex , iEkiTrackIndex ) 
	//	ɏϏ܂B
	if ( iRv >= 0 )
	{
		CentDedRosen* pRosen = getRosen() ;
		CentDedEki* pEki = getEki() ;
		if ( pRosen != NULL && pEki != NULL )
		{
			int iEkiIndex = pRosen->getCentDedEkiCont()->getIndex( pEki ) ;
			pRosen->onEkiTrackInsert( iEkiIndex , iIndex ) ; 
		}
	}

	return iRv ;
}
int CentDedEkiTrackCont::erase( int iIndex  , int iSize ) 
{
	int iRv = 0 ;
	if ( iIndex == INT_MAX && iSize != INT_MAX )
	{
		iIndex = (int)size() - iSize ;
	}
	else if ( iIndex != INT_MAX && iSize == INT_MAX )
	{
		iSize = (int)size() - iIndex ;
	}
	if ( !( 0 <= iIndex && iIndex + iSize <= (int)size() ) )
	{
		iRv = -1 ;	//	CfNX͈͊OłB
	}
	// --------------------------------	
	if ( iRv >= 0 )
	{
		for ( int i = 0 ; i < iSize ; i ++ )
		{
			if ( getMuPtr()->get( iIndex + i )->getTrackType() != CentDedEkiTrack::ETrackType_Named )
			{
				iRv = -11 ;	//	{폜邱Ƃ͏o܂B
			}
		}
	}
	// --------------------------------	
	if ( iRv >= 0 )
	{
		iRv = super::erase( iIndex , iSize ) ; 
	}
	// --------------------------------	
	//	  ̃Rei CentDedEki ̎qIuWFNgŁA
	//	 CentDedEki  CentDedRosen ɕ܂ĂꍇA erase() 
	//	\bh́ACentDedRosen::onEkiTrackInsert( iEkiIndex , iEkiTrackIndex )
	//	ɏϏ܂B
	if ( iRv >= 0 )
	{
		CentDedRosen* pRosen = getRosen() ;
		CentDedEki* pEki = getEki() ;
		if ( pRosen != NULL && pEki != NULL )
		{
			int iEkiIndex = pRosen->getCentDedEkiCont()->getIndex( pEki ) ;
			for ( int idx = iIndex + iSize - 1 ; idx >= iIndex ; idx-- )
			{
				pRosen->onEkiTrackErase( iEkiIndex , idx ) ; 
			}
		}
	}
	// --------------------------------	
	return iRv ;
}
int CentDedEkiTrackCont::set( const CentDedEkiTrack& element , int iIndex ) 
{
	int iRv = 0 ; 
	if ( iIndex == INT_MAX )
	{
		iIndex = size() - 1 ;
	}

	if ( iRv >= 0 )
	{
		iRv = setable( element , iIndex ) ;
	}
	if ( iRv >= 0 )
	{
		iRv = super::set( element ,  iIndex ) ;
	}
	return iRv ; 
}
	// ********************************
	//@name CentDedEkiTrackCont-֘A
	// ********************************

CentDedRosen* CentDedEkiTrackCont::getRosen() 
{
	if ( getEki() == NULL ){	return NULL ;}
	CentDedEkiCont* pEkiCont = dynamic_cast<CentDedEkiCont*>( getEki()->getParent() ) ;
	if ( pEkiCont == NULL ){	return NULL ;}
	return pEkiCont->getRosen() ;
}
const CentDedRosen* CentDedEkiTrackCont::getRosen()const 
{
	if ( getEki() == NULL ){	return NULL ;}
	const CentDedEkiCont* pEkiCont = dynamic_cast<const CentDedEkiCont*>( getEki()->getParent() ) ;
	if ( pEkiCont == NULL ){	return NULL ;}
	return pEkiCont->getRosen() ;
}


	// ********************************
	///@name CentDedEkiTrackCont-
	// ********************************
int  CentDedEkiTrackCont::setable(  const CentDedEkiTrack& element , int iIndex ) const
{
	int iRv = 0 ;
	if ( iIndex == INT_MAX )
	{
		iIndex = size() - 1 ;
	}
	if ( iRv >= 0 )
	{
		if ( getMuPtr()->get( iIndex )->getTrackType() != element.getTrackType() )
		{
			iRv = -11 ;	//	Ԑʂ̈قȂIuWFNg㏑邱Ƃ͂ł܂B
		}
	}

	return iRv ;
}

int  CentDedEkiTrackCont::getIndex( const CentDedEkiTrack* element ) const
{
	const Mu<const CentDedEkiTrack*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		if ( pMu->get( idx ) == element ){	return idx ;}
	}
	return -1 ;
}

void CentDedEkiTrackCont::adjust() 
{
	Mu<CentDedEkiTrack*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		pMu->get( idx )->adjust() ;
	}
}


int CentDedEkiTrackCont::findRessyaOfEkiTrack( 
		int index , 
		int* piDiaIndex , 
		ERessyahoukou* pRessyahoukou , int* piRessyaIndex ) const
{
	const CentDedRosen* pRosen = getRosen() ;
	const CentDedEki* pEki = getEki() ;
	if ( pRosen != NULL )
	{
		int iEkiIndex = pRosen->getCentDedEkiCont()->getIndex( pEki ) ;
		for ( int iDiaIndex = 0 ; iDiaIndex < pRosen->getCentDedDiaCont()->size() ; iDiaIndex++ )
		{
			const CentDedDia* pDia = pRosen->getCentDedDiaCont()->getMuPtr()->get( iDiaIndex ) ; 
			for ( int iRessyahoukou = Ressyahoukou_Kudari ; 
					iRessyahoukou <= Ressyahoukou_Nobori ; 
					iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				int iEkiOrder = pRosen->getCentDedEkiCont()->EkiOrderOfEkiIndex( eRessyahoukou , iEkiIndex ) ; 
				const CentDedRessyaCont* pRessyaCont = pDia->getCentDedRessyaCont( eRessyahoukou ) ;
				for ( int iRessyaIndex = 0  ; iRessyaIndex < pRessyaCont->size() ; iRessyaIndex++ )
				{
					const CentDedRessya* pRessya = pRessyaCont->getMuPtr()->get( iRessyaIndex ) ;
					const CentDedEkiJikokuTrackCont* pEkiJikokuTrackCont = pRessya->getCentDedEkiJikokuCont()->getMuPtr()->get( iEkiOrder )->getEkiJikokuTrackCont() ;
					for ( int iEkiJikokuTrackIndex = 0 ; iEkiJikokuTrackIndex < pEkiJikokuTrackCont->size() ; iEkiJikokuTrackIndex++ )
					{
						const CentDedEkiJikokuTrack* pEkiJikokuTrack = pEkiJikokuTrackCont->getMuPtr()->get( iEkiJikokuTrackIndex ) ;
						CentDedEkiTrackSelector aTrackSelector = pEkiJikokuTrack->getTrack() ;
						if ( !aTrackSelector.isNull() && aTrackSelector.getiIndex() == index )
						{
							*piDiaIndex = iDiaIndex ;
							*pRessyahoukou = eRessyahoukou ;
							*piRessyaIndex = iRessyaIndex ;
							return 1 ;
						}
					}
				}
			}
		}


	}
	return 0 ;
}



} //namespace entDed


