/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedRessyaSoater_Transfer.cpp
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include <algorithm>
#include "CDedRessyaSoater_Transfer.h"
#include "NsMu\CaMui.h"
#include "NsMu\CMup_vector.h"
#include "NsMu\CaMup_vector.h"
#include "CentDedDgrRessya.h"



namespace entDgr{
using namespace std ;

// ****************************************************************
//	CDedRessyaSoater_Transfer
// ****************************************************************
	// --------------------------------
	//@name ֐
	// --------------------------------
bool CDedRessyaSoater_Transfer::sortRessyaIndex_TransferFromSortedRessyaAtEki( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		int iEkiOrder , 
		int iMaxTransferSec ,
		IfProgress* pIfProgress )
{
	bool bAbort = false ;
	const CentDedRessyaCont* pRessyaCont = pEstimateRessyaCont ;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont() ;

	//@@@@@@S\[gOԂ̃[v(̒xقق)
	//@@@@@@@@S\[gԂ̃[v(̒xقق)
	//@@@@@@@@@@[抷wIndexŁA\[gԁ\[gOԂ
	//@@@@@@@@@@@@p10ȓŉ\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒ɁA
	//@@@@@@@@@@@@@}
	for ( int idxRessyaIndexBeforeSort = (int)pcontRessyaIndexBeforeSort->size() - 1 ; 
		!bAbort && idxRessyaIndexBeforeSort >= 0 ;
		idxRessyaIndexBeforeSort -- )
	{
		int iRessyaIndexBeforeSort = pcontRessyaIndexBeforeSort->at( idxRessyaIndexBeforeSort ) ;
		const CentDedRessya*	pRessyaBeforeSort = pRessyaCont->getMuPtr()->get( iRessyaIndexBeforeSort ) ;

		CentDedEkiJikoku	aEkiJikokuBeforeSort = pRessyaBeforeSort->getCentDedEkiJikoku( iEkiOrder ) ;

		int idxRessyaIndexAfterSort = -1 ;
		for ( idxRessyaIndexAfterSort = (int)pcontRessyaIndexAfterSort->size() - 1 ;
			idxRessyaIndexAfterSort >= 0 ; 
			idxRessyaIndexAfterSort -- )
		{
			int iRessyaIndexAfterSort = pcontRessyaIndexAfterSort->at( idxRessyaIndexAfterSort ) ;
			const CentDedRessya*	pRessyaAfterSort = pRessyaCont->getMuPtr()->get( iRessyaIndexAfterSort ) ;
			CentDedEkiJikoku	aEkiJikokuAfterSort = pRessyaAfterSort->getCentDedEkiJikoku( iEkiOrder ) ;

			//	p\̔
			int iNorikaeSec = calcNorikaeSec( 
				aEkiJikokuAfterSort , 
				aEkiJikokuBeforeSort ,
				m_pDedRosen->getKitenJikoku() ) ;
			//iNorikaeSec = 芷(b)
			//	芷s\ȂA-1 ;

			if ( iNorikaeSec >= 0 && iNorikaeSec <= iMaxTransferSec )
			{
				//	芷\
				break ;
			}
		}
		//idxRessyaIndexAfterSort =
		//	芷ƂȂA\[g
		//	Ȃꍇ́AidxRessyaIndexAfterSort=-1 ; 

		if ( 0 <= idxRessyaIndexAfterSort )
		{
			//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
			//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒ɁA
			//@@@@@@@@@@@@@}
			pcontRessyaIndexBeforeSort->erase( 
					pcontRessyaIndexBeforeSort->begin() + idxRessyaIndexBeforeSort ) ;

			//	\[gԂ̒ȍ~ŁA}
			for ( idxRessyaIndexAfterSort ++ ;
				idxRessyaIndexAfterSort < (int)pcontRessyaIndexAfterSort->size() ;
				idxRessyaIndexAfterSort ++ )
			{
				int iRessyaIndexAfterSort = pcontRessyaIndexAfterSort->at( idxRessyaIndexAfterSort ) ;
				const CentDedRessya*	pRessyaAfterSort = pRessyaCont->getMuPtr()->get( iRessyaIndexAfterSort ) ;
				CentDedEkiJikoku	aEkiJikokuAfterSort = pRessyaAfterSort->getCentDedEkiJikoku( iEkiOrder ) ;

				if ( aEkiJikokuAfterSort.getHatsujikoku().isNull() || 
					aEkiJikokuBeforeSort.getHatsujikoku( true ).compare(
						aEkiJikokuAfterSort.getHatsujikoku( true ) ,
						m_pDedRosen->getKitenJikoku() ) <= 0 )
				{
					break ;
				}
			}
			//idxRessyaIndexAfterSort = Ԃ̑}

			pcontRessyaIndexAfterSort->insert( 
				pcontRessyaIndexAfterSort->begin() + idxRessyaIndexAfterSort ,
				iRessyaIndexBeforeSort ) ;
		}

		// --------------------------------
		if ( pIfProgress != NULL )
		{
			int iResult = pIfProgress->onNotifyProgress( 
				pcontRessyaIndexAfterSort->size() ,
				pRessyaCont->size() ) ;
			if ( iResult != 0 )
			{
				bAbort = true ;
			}

		}

	}

	return bAbort ;
}


bool CDedRessyaSoater_Transfer::sortRessyaIndex_TransferToSortedRessyaAtEki( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		int iEkiOrder , 
		int iMaxTransferSec ,
		IfProgress* pIfProgress )
{
	bool bAbort = false ;
	const CentDedRessyaCont* pRessyaCont = pEstimateRessyaCont ;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont() ;

	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̑قxق)
	//@@@@@@@@@@[抷wIndexŁA\[gOԁ\[gԂ
	//@@@@@@@@@@@@pw蕪ȓŉ\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒OɁA
	//@@@@@@@@@@@@@}
	for ( int idxRessyaIndexBeforeSort = 0 ; 
		!bAbort && idxRessyaIndexBeforeSort < (int)pcontRessyaIndexBeforeSort->size() ;
		idxRessyaIndexBeforeSort ++ )
	{
		const CentDedRessya*	pRessyaBeforeSort = pRessyaCont->getMuPtr()->get( 
			pcontRessyaIndexBeforeSort->at( idxRessyaIndexBeforeSort ) ) ;
		CentDedEkiJikoku	aEkiJikokuBeforeSort = pRessyaBeforeSort->getCentDedEkiJikoku( iEkiOrder ) ;

		int idxRessyaIndexAfterSort = -1 ;
		for ( idxRessyaIndexAfterSort = 0 ;
			idxRessyaIndexAfterSort < (int)pcontRessyaIndexAfterSort->size()  ; 
			idxRessyaIndexAfterSort ++ )
		{
			const CentDedRessya*	pRessyaAfterSort = pRessyaCont->getMuPtr()->get( 
				pcontRessyaIndexAfterSort->at( idxRessyaIndexAfterSort ) ) ;
			CentDedEkiJikoku	aEkiJikokuAfterSort = pRessyaAfterSort->getCentDedEkiJikoku( iEkiOrder ) ;

			//	p\̔
			int iNorikaeSec = calcNorikaeSec( 
				aEkiJikokuBeforeSort , 
				aEkiJikokuAfterSort ,
				m_pDedRosen->getKitenJikoku() ) ;
			//iNorikaeSec = 芷(b)
			//	芷s\ȂA-1 ;

			if ( iNorikaeSec >= 0 && iNorikaeSec <= iMaxTransferSec )
			{
				//	芷\
				break ;
			}
		}
		//idxRessyaIndexAfterSort =
		//	芷ƂȂA\[g
		//	Ȃꍇ́AidxRessyaIndexAfterSort=pcontRessyaIndexAfterSort->size() ; 

		if ( idxRessyaIndexAfterSort < (int)pcontRessyaIndexAfterSort->size() )
		{
			//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
			//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒ɁA
			//@@@@@@@@@@@@@}
			int iRessyaIndexBeforeSort = pcontRessyaIndexBeforeSort->at( idxRessyaIndexBeforeSort ) ;
			pcontRessyaIndexBeforeSort->erase( 
					pcontRessyaIndexBeforeSort->begin() + idxRessyaIndexBeforeSort ) ;
			idxRessyaIndexBeforeSort -- ;



			//	\[gԂ̒OȑOŁA}
			for ( idxRessyaIndexAfterSort -- ;
				idxRessyaIndexAfterSort >= 0 ;
				idxRessyaIndexAfterSort -- )
			{
				int iRessyaIndexAfterSort = pcontRessyaIndexAfterSort->at( idxRessyaIndexAfterSort ) ;
				const CentDedRessya*	pRessyaAfterSort = pRessyaCont->getMuPtr()->get( iRessyaIndexAfterSort ) ;
				CentDedEkiJikoku	aEkiJikokuAfterSort = pRessyaAfterSort->getCentDedEkiJikoku( iEkiOrder ) ;

				if ( aEkiJikokuAfterSort.getChakujikoku().isNull() || 
					aEkiJikokuAfterSort.getChakujikoku( true ).compare(
						aEkiJikokuBeforeSort.getChakujikoku( true ) ,
						m_pDedRosen->getKitenJikoku() ) <= 0 )
				{
					break ;
				}
			}
			idxRessyaIndexAfterSort ++ ;
			//idxRessyaIndexAfterSort = Ԃ̑}

			pcontRessyaIndexAfterSort->insert( 
				pcontRessyaIndexAfterSort->begin() + idxRessyaIndexAfterSort ,
				iRessyaIndexBeforeSort ) ;
		}

		// --------------------------------
		if ( pIfProgress != NULL )
		{
			int iResult = pIfProgress->onNotifyProgress( 
				pcontRessyaIndexAfterSort->size() ,
				pRessyaCont->size() ) ;
			if ( iResult != 0 )
			{
				bAbort = true ;
			}

		}

	}

	return bAbort ;
}

bool CDedRessyaSoater_Transfer::sortRessyaIndex_TransferFromSortedRessya( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		CdDedJikokuOrder aEkijikokuOrder  , 
		IfProgress* pIfProgress ) 
{
	bool bAbort = false ;
	ERessyahoukou	eRessyahoukou = pEstimateRessyaCont->getRessyahoukou() ;
	const CentDedRessyaCont* pRessyaCont = pEstimateRessyaCont ;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont() ;

	//\[gOԂA\[gΏۉw(F)肠Ƃ̒ԉw10ȓɏ芷̂ł\[gԂ̌ɔzu
	//@@芷wOrder̃[v(\[gΏۉw+1`Iw)
	//@@@@[̉wvw]
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̒xقق)
	//@@@@@@@@@@[抷wIndexŁA\[gԁ\[gOԂ
	//@@@@@@@@@@@@p10ȓŉ\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒ɁA
	//@@@@@@@@@@@@@}
	//@@\[gOԂ1{łÃ[vĎs
	int iRessyaIndexBeforSortCount ;
	do{
		iRessyaIndexBeforSortCount = pcontRessyaIndexBeforeSort->size() ;

		for ( int iEkiOrder = aEkijikokuOrder.getEkiOrder() ; 
			!bAbort && iEkiOrder <= pEkiCont->size() - 1 ;
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki	aEki = pEkiCont->getMuPtr(eRessyahoukou)->get( iEkiOrder ) ;
			if ( aEki.getEkikibo() == CentDedEki::Ekikibo_Syuyou )
			{
				//\[gOԂA\[gΏۉw(F)肠Ƃ̒ԉw
				//	10ȓɏ芷̂ł\[gԂ̌ɔzu
				bAbort = sortRessyaIndex_TransferFromSortedRessyaAtEki( 
					pEstimateRessyaCont ,
					pcontRessyaIndexBeforeSort , 
					pcontRessyaIndexAfterSort , 
					iEkiOrder , 
					10 * 60 , 
					pIfProgress ) ; 
			}
		}

	} while( !bAbort && iRessyaIndexBeforSortCount > (int)pcontRessyaIndexBeforeSort->size() ) ;
	



	//
	//@@芷wOrder̃[v(\[gΏۉw+1`Iw)
	//@@@@[̉wNOT(vw)]
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̒xقق)
	//@@@@@@@@@@[抷wIndexŁA\[gԁ\[gOԂ
	//@@@@@@@@@@@@p10ȓŉ\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒ɁA
	//@@@@@@@@@@@@@}
	//@@\[gOԂ1{łÃ[vĎs

	do{
		iRessyaIndexBeforSortCount = pcontRessyaIndexBeforeSort->size() ;

		for ( int iEkiOrder = aEkijikokuOrder.getEkiOrder() ; 
			!bAbort && iEkiOrder <= pEkiCont->size() - 1 ;
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki	aEki = pEkiCont->getMuPtr(eRessyahoukou)->get( iEkiOrder ) ;
			if ( aEki.getEkikibo() != CentDedEki::Ekikibo_Syuyou )
			{
				//\[gOԂA\[gΏۉw(F)肠Ƃ̒ԉw
				//	10ȓɏ芷̂ł\[gԂ̌ɔzu
				bAbort = sortRessyaIndex_TransferFromSortedRessyaAtEki( 
					pEstimateRessyaCont ,
					pcontRessyaIndexBeforeSort , 
					pcontRessyaIndexAfterSort , 
					iEkiOrder , 
					10 * 60 , 
					pIfProgress ) ; 
			}
		}

	} while( !bAbort && iRessyaIndexBeforSortCount > (int)pcontRessyaIndexBeforeSort->size() ) ;




	//\[gOԂA\[gΏۉw(F)肠Ƃ̒ԉwŏ芷̂ł\[gԂTB
	//@@芷wOrder̃[v(\[gΏۉw+1`Iw)
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̒xقق)
	//@@@@@@@@@@[抷wIndexŁA\[gԁ\[gOԂ̏p\]
	//@@@@@@@@@@@@\[gOԂ́uבւpwvɁA
	//@@@@@@@@@@@@@\[gԂ́uבւpwv̉wERs[B
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒ɁA
	//@@@@@@@@@@@@@}
	//@@\[gOԂ1{łÃ[vĎs

	do{
		iRessyaIndexBeforSortCount = pcontRessyaIndexBeforeSort->size() ;

		for ( int iEkiOrder = aEkijikokuOrder.getEkiOrder()  ; 
			!bAbort && iEkiOrder <= pEkiCont->size() - 1 ;
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki	aEki = pEkiCont->getMuPtr(eRessyahoukou)->get( iEkiOrder ) ;
			{
				//\[gOԂA\[gΏۉw(F)肠Ƃ̒ԉw
				//	芷̂ł\[gԂ̌ɔzu
				bAbort = sortRessyaIndex_TransferFromSortedRessyaAtEki( 
					pEstimateRessyaCont ,
					pcontRessyaIndexBeforeSort , 
					pcontRessyaIndexAfterSort , 
					iEkiOrder , 
					INT_MAX , 
					pIfProgress ) ; 
			}
		}

	} while( !bAbort && iRessyaIndexBeforSortCount > (int)pcontRessyaIndexBeforeSort->size() ) ;

	return bAbort ;
}


bool CDedRessyaSoater_Transfer::sortRessyaIndex_TransferToSortedRessya( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		CdDedJikokuOrder aEkijikokuOrder  , 
		IfProgress* pIfProgress ) 
{
	bool bAbort = false ;
	ERessyahoukou	eRessyahoukou = pEstimateRessyaCont->getRessyahoukou() ;
	const CentDedRessyaCont* pRessyaCont = pEstimateRessyaCont ;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont() ;
	//\[gOԂA\[gΏۉw(F)O̒ԉw10ȓɏ芷̂ł\[gԂ̑Oɔzu
	//@@芷wOrder̃[v(\[gΏۉw-1`N_w)
	//@@@@[̉wIworvw]
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̑قxق)
	//@@@@@@@@@@[抷wIndexŁA\[gOԁ\[gԂ
	//@@@@@@@@@@@@p10ȓŉ\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒OɁA
	//@@@@@@@@@@@@@}
	//@@\[gOԂ1{łÃ[vĎs

	int iRessyaIndexBeforSortCount ;
	do{
		iRessyaIndexBeforSortCount = pcontRessyaIndexBeforeSort->size() ;

		for ( int iEkiOrder = aEkijikokuOrder.getEkiOrder()  ; 
			!bAbort && iEkiOrder >= 0 ;
			iEkiOrder -- )
		{
			CentDedEkiCont::CdDedEki	aEki = pEkiCont->getMuPtr(eRessyahoukou)->get( iEkiOrder ) ;
			if ( aEki.getEkikibo() == CentDedEki::Ekikibo_Syuyou )
			{
				bAbort = sortRessyaIndex_TransferToSortedRessyaAtEki( 
					pEstimateRessyaCont ,
					pcontRessyaIndexBeforeSort , 
					pcontRessyaIndexAfterSort , 
					iEkiOrder , 
					10 * 60 , 
					pIfProgress ) ; 
			}
		}

	} while( !bAbort && iRessyaIndexBeforSortCount > (int)pcontRessyaIndexBeforeSort->size() ) ;


	//
	//@@芷wOrder̃[v(\[gΏۉw-1`N_w)
	//@@@@[̉wNOT(Iworvw)]
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̑قxق)
	//@@@@@@@@@@[抷wIndexŁA\[gOԁ\[gԂ
	//@@@@@@@@@@@@p10ȓŉ\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒OɁA
	//@@@@@@@@@@@@@}
	//@@\[gOԂ1{łÃ[vĎs
	do{
		iRessyaIndexBeforSortCount = pcontRessyaIndexBeforeSort->size() ;

		for ( int iEkiOrder = aEkijikokuOrder.getEkiOrder()  ; 
			!bAbort && iEkiOrder >= 0 ;
			iEkiOrder -- )
		{
			CentDedEkiCont::CdDedEki	aEki = pEkiCont->getMuPtr(eRessyahoukou)->get( iEkiOrder ) ;
			if ( aEki.getEkikibo() != CentDedEki::Ekikibo_Syuyou )
			{
				bAbort = sortRessyaIndex_TransferToSortedRessyaAtEki( 
					pEstimateRessyaCont ,
					pcontRessyaIndexBeforeSort , 
					pcontRessyaIndexAfterSort , 
					iEkiOrder , 
					10 * 60 , 
					pIfProgress ) ; 
			}
		}

	} while( !bAbort && iRessyaIndexBeforSortCount > (int)pcontRessyaIndexBeforeSort->size() ) ;

	//\[gOԂA\[gΏۉw(F)O̒ԉwŏ芷̂ł\[gԂTB
	//@@芷wOrder̃[v(\[gΏۉw-1`N_w)
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@S\[gԂ̃[v(̒xقق)
	//@@@@@@@@@@[抷wIndexŁA\[gOԁ\[gԂ̏p\]
	//@@@@@@@@@@@@\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃReíAΏۂƂȂ\[gԂ̒OɁA
	//@@@@@@@@@@@@@}
	//@@\[gOԂ1{łÃ[vĎs
	//
	do{
		iRessyaIndexBeforSortCount = pcontRessyaIndexBeforeSort->size() ;

		for ( int iEkiOrder = aEkijikokuOrder.getEkiOrder() ; 
			!bAbort && iEkiOrder >= 0 ;
			iEkiOrder -- )
		{
			CentDedEkiCont::CdDedEki	aEki = pEkiCont->getMuPtr(eRessyahoukou)->get( iEkiOrder ) ;
			{
				bAbort = sortRessyaIndex_TransferToSortedRessyaAtEki( 
					pEstimateRessyaCont ,
					pcontRessyaIndexBeforeSort , 
					pcontRessyaIndexAfterSort , 
					iEkiOrder , 
					INT_MAX , 
					pIfProgress ) ; 
			}
		}

	} while( !bAbort && iRessyaIndexBeforSortCount > (int)pcontRessyaIndexBeforeSort->size() ) ;

	return bAbort ;
}


	// ********************************
	//	RXgN^
	// ********************************
CDedRessyaSoater_Transfer::CDedRessyaSoater_Transfer(
	const CentDedRosen* pDedRosen , 
	const CentDedDia* pDedDia ,
	CdDedJikokuOrder  aCdDedJikokuOrder ) :  
	m_bIsValid( false ) ,
	m_pDedRosen( pDedRosen ) ,
	m_pDedDia( pDedDia ) ,
	m_JikokuOrder( aCdDedJikokuOrder ) 
{
}

CDedRessyaSoater_Transfer::~CDedRessyaSoater_Transfer() 
{
	invalidate() ;
}
	


int CDedRessyaSoater_Transfer::validate()  
{
	if ( isValid() )
	{
		return 0 ;
	}
	// --------------------------------
	int iRv = 1 ;
	//\[gΏۂ̗ԃReiA莞ԂێԂ𐶐
	//@\[gΏۂ̗ԃRei܂ CentDedDia ACentDedDgrDia 𐶐
	//@\[gΏۂ̗Ԃ̐莞CentDedRessyaCont𐶐
	//@@	\[gΏۂ̑SԂ̃[v
	//@@@@	CentDedDgrRessyaA莞CentDedRessya𐶐AReiɒǉ
	if ( iRv >= 1 )
	{
		m_CentDedDgrDia.readCentDedRosen(
			m_pDedRosen , 
			m_pDedDia );

	}


	// --------------------------------
	if ( iRv >= 1 )
	{
		m_bIsValid = true ;
	}
	else
	{
		invalidate() ;
	}
	return iRv ;
}
	
void CDedRessyaSoater_Transfer::invalidate() 
{
	m_bIsValid = false ;
}
	
bool CDedRessyaSoater_Transfer::isValid() 
{
	return m_bIsValid ;
}
	// ********************************
	//@name 
	// ********************************


/**
	IndexAw肳ꂽwOrder̎Ŕr֐IuWFNgłB
*/
class CCompareRessyaIndex_Ekijikoku
{
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	/**
		ԃReiB
	*/
	const CentDedRessyaCont* m_pRessyaCont ;

	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		wOrderxw肵ĂB
	*/
	CdDedJikokuOrder m_JikokuOrder ;

	/**
		_CON_w肵ĂB
		̊֐́A\[gɁA̒lł
		݂Ȃ܂B
		(F̎5:00w肳ꂽꍇ́A5:00<23:59<0:00<4:59 ƂĔrs܂)
	*/
	CdDedJikoku m_jikokuKitenJikoku ;
	///@}
public:
	/**
	@param pRessyaCont [in]
		ԃReiB
	@param iJikokuOrder [in]
		wOrderxw肵ĂB
	@param jikokuKitenJikoku [in]
		_CON_w肵ĂB
		̊֐́A\[gɁA̒lł
		݂Ȃ܂B
		(F̎5:00w肳ꂽꍇ́A5:00<23:59<0:00<4:59 ƂĔrs܂)
	*/
	CCompareRessyaIndex_Ekijikoku( 
		const CentDedRessyaCont* pRessyaCont ,
		const CdDedJikokuOrder& aJikokuOrder ,
		CdDedJikoku jikokuKitenJikoku )
		: 
		m_pRessyaCont( pRessyaCont ) ,
		m_JikokuOrder( aJikokuOrder ) ,
		m_jikokuKitenJikoku( jikokuKitenJikoku )
	{
	};
	/**
	@return
		left < right Ȃ^łB

	@note
	  r́A
			- wNULLłȂ̂NULL̂̂Ƃł́ANULLłȂ̂B
			- EkijikokȕقB
			- EkijikokuȂAB
			- Ekijikoku/ȂRessyaIdx̏قB
	*/
	bool operator()( int left , int right )
	{
		const CentDedRessya*	pRessyaLeft = m_pRessyaCont->getMuPtr()->get( left ) ;
		const CentDedRessya*	pRessyaRight = m_pRessyaCont->getMuPtr()->get( right ) ;
		CentDedEkiJikoku	aEkiJikokuLeft = pRessyaLeft->getCentDedEkiJikoku( m_JikokuOrder.getEkiOrder()  ) ;
		CentDedEkiJikoku	aEkiJikokuRight = pRessyaRight->getCentDedEkiJikoku( m_JikokuOrder.getEkiOrder() ) ;
		CdDedJikoku aJikokuLeft ;
		bool bLeftIsHatsu = false ;
		CdDedJikoku aJikokuRight ;
		bool bRightIsHatsu = false ;

		if ( m_JikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Chaku )
		{
			//	ŗD悵Ĕr
			aJikokuLeft = aEkiJikokuLeft.getChakujikoku() ;	
			bLeftIsHatsu = false ;
			if ( aEkiJikokuLeft.getChakujikoku().isNull() &&
				!aEkiJikokuLeft.getHatsujikoku().isNull() )
			{
				aJikokuLeft = aEkiJikokuLeft.getHatsujikoku() ;
				bLeftIsHatsu = true ;
			}
			aJikokuRight = aEkiJikokuRight.getChakujikoku() ;
			bRightIsHatsu = false ;
			if ( aEkiJikokuRight.getChakujikoku().isNull() &&
				!aEkiJikokuRight.getHatsujikoku().isNull() )
			{
				aJikokuRight = aEkiJikokuRight.getHatsujikoku() ;
				bLeftIsHatsu = true ;
			}
		}
		else
		{
			//	ŗD悵Ĕr

			aJikokuLeft = aEkiJikokuLeft.getHatsujikoku() ;	
			bLeftIsHatsu = true ;
			if ( !aEkiJikokuLeft.getChakujikoku().isNull() &&
				  aEkiJikokuLeft.getHatsujikoku().isNull() )
			{
				aJikokuLeft = aEkiJikokuLeft.getChakujikoku() ;
				bLeftIsHatsu = false ;
			}
			aJikokuRight = aEkiJikokuRight.getHatsujikoku() ;
			bRightIsHatsu = true ;
			if ( !aEkiJikokuRight.getChakujikoku().isNull() &&
				  aEkiJikokuRight.getHatsujikoku().isNull() )
			{
				aJikokuRight = aEkiJikokuRight.getChakujikoku() ;
				bLeftIsHatsu = false ;
			}

		}
		// --------------------------------
		//	ЕNULL̏ꍇ̔r
		// --------------------------------
		if ( !aJikokuLeft.isNull() && aJikokuRight.isNull() )
		{
			//	leftNULLŁAright͔NULL
			return true ;
		}
		else if ( aJikokuLeft.isNull() && !aJikokuRight.isNull() )
		{
			//	left͔NULLŁArightNULL
			return false ;
		}
		// --------------------------------
		//	m_Jikoku ͂ǂNULLł͂ȂE͂ǂNULL
		//	̔r
		// --------------------------------
		int iResult = aJikokuLeft.compare( aJikokuRight , m_jikokuKitenJikoku ) ;
		if ( iResult == -1 )
		{
			return true ;
		}
		else if ( iResult == 1 )
		{
			return false ;
		}
		// --------------------------------
		// 	EkijikokuȂAB
		// --------------------------------
		if ( !bLeftIsHatsu && bRightIsHatsu )
		{
			return true ;
		}
		else if ( bLeftIsHatsu && !bRightIsHatsu )
		{
			return false ;
		}

		// --------------------------------
		// EƂɓꍇ́AIndexق
		// --------------------------------
		if ( left < right )
		{
			return true ;
		}
		return false ;
	}

};


void CDedRessyaSoater_Transfer::sortRessyaIndex( 
		const CentDedRessyaCont* pRessyaCont , 
		Mui<int>* muRessyaIndexOrder , 
		IfProgress* pIfProgress ) 
{
	bool bAbort = false ;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont() ;
	CdDedJikokuOrder aEkijikokuOrder = m_JikokuOrder ;
	ERessyahoukou eRessyahoukou = pRessyaCont->getRessyahoukou() ;

	//pRessyaContA莞ԃRei쐬
	//	validate() ŁAm_pDedRosen m_pDedDia Ɋ܂܂SԂ
	//	莞 CentDedRessya 𐶐A̓eێ܂B

	CentDedRessyaCont aEstimateRessyaCont = pRessyaCont->createEmptyCont() ;
	for ( int idxRessya = 0 ; idxRessya < pRessyaCont->size() ; idxRessya ++ )
	{
		const CentDedRessya* pCentDedRessya = pRessyaCont->getMuPtr()->get( idxRessya ) ;
		CentDedDgrRessya	aCentDedDgrRessya( 
			m_pDedRosen , 
			&m_CentDedDgrDia , 
			pCentDedRessya ) ;

		CentDedRessya aEstimateRessya( aEstimateRessyaCont.createNullRessya() ) ; 
		m_CentDedDgrDia.createEstimateRessya2( 
			&aCentDedDgrRessya ,
			&aEstimateRessya ) ;
		aEstimateRessyaCont.insert( aEstimateRessya ) ;
	}
	//aEstimateRessyaCont = pRessyaCont ɐ莞ǉ܂B
	CentDedRessyaCont*	pEstimateRessyaCont = &aEstimateRessyaCont ;

	//\[gOwCfNXRei𐶐
	vector<int>	contRessyaIndexBeforSort ;
	vector<int>	contRessyaIndexAfterSort ;
	{
		contRessyaIndexBeforSort.reserve( muRessyaIndexOrder->size() ) ;
		contRessyaIndexAfterSort.reserve( muRessyaIndexOrder->size() ) ; 
		CaMui<int>( &CaMup_vector<vector<int>>( &contRessyaIndexBeforSort ) ).insert( muRessyaIndexOrder ) ; ;
	}

	//ŵ()̂A\[gReiɈڂ
	if ( !bAbort )
	{
		for ( int idx = 0 ; idx < (int)contRessyaIndexBeforSort.size() ; idx++ )
		{
			int iRessyaIndex = contRessyaIndexBeforSort[idx] ;

			const CentDedRessya* pRessya = pEstimateRessyaCont->getMuPtr()->get( iRessyaIndex ) ;
			CentDedEkiJikoku aEkiJikoku = pRessya->getCentDedEkiJikoku( aEkijikokuOrder.getEkiOrder() ) ;
			CdDedJikoku	aJikoku = pRessya->getEkiJikoku( aEkijikokuOrder ) ;

			if ( aEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya )
			{
				contRessyaIndexAfterSort.push_back( iRessyaIndex ) ;
				contRessyaIndexBeforSort.erase(	contRessyaIndexBeforSort.begin() + idx ) ;
				idx -- ;
			}
		}
	}

	if ( !bAbort )
	{
		if ( pIfProgress != NULL )
		{
			int iResult = pIfProgress->onNotifyProgress( 
				contRessyaIndexAfterSort.size() ,
				pEstimateRessyaCont->size() ) ;
			if ( iResult != 0 )
			{
				bAbort = true ;
			}
		}
	}	

	//\[gReiAwŃ\[gB
	//
	//@code
	//\[g
	//RessyaIdx 2   5   
	//G         00120020
	/// @@@  
	//@endcode	        
	//
	//@code
	//\[gO
	//RessyaIdx 0   1   3   4   6   
	//G         NULLNULLNULLNULLNULL
	/// @@          
	//@endcode	        
	if ( !bAbort )
	{
		std::sort( 
			contRessyaIndexAfterSort.begin() , 
			contRessyaIndexAfterSort.end() ,
			CCompareRessyaIndex_Ekijikoku( 
				pEstimateRessyaCont , 
				aEkijikokuOrder , 
				m_pDedRosen->getKitenJikoku() ) 
			) ;
	}



	if ( aEkijikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Chaku)
	{
		//	Ń\[g̏ꍇ

		//\[gOԂA\[gΏۉwO̒ԉwŏ芷̂ł\[gԂ̑Oɔzu
		if ( !bAbort )
		{
			bAbort = sortRessyaIndex_TransferToSortedRessya( 
				pEstimateRessyaCont ,
				&contRessyaIndexBeforSort , 
				&contRessyaIndexAfterSort , 
				aEkijikokuOrder , 
				pIfProgress ) ; 
		}

		//\[gOԂA\[gΏۉw肠Ƃ̒ԉwŏ芷̂ł\[gԂ̌ɔzu
		if ( !bAbort )
		{
			bAbort = sortRessyaIndex_TransferFromSortedRessya( 
				pEstimateRessyaCont ,
				&contRessyaIndexBeforSort , 
				&contRessyaIndexAfterSort , 
				aEkijikokuOrder , 
				pIfProgress ) ; 
		}

		//\[gOԂAׂĂ̒ԉwŏ芷̂ł\[gԂ̌ɔzu
		if ( !bAbort )
		{
			bAbort = sortRessyaIndex_TransferFromSortedRessya( 
				pEstimateRessyaCont ,
				&contRessyaIndexBeforSort , 
				&contRessyaIndexAfterSort , 
				CdDedJikokuOrder( 0 , CdDedJikokuOrder::EkiJikokuItem_Chaku )  , 
				pIfProgress ) ; 
		}
	}
	else
	{
		//	Ń\[g

		//\[gOԂA\[gΏۉw肠Ƃ̒ԉwŏ芷̂ł\[gԂ̌ɔzu
		if ( !bAbort )
		{
			bAbort = sortRessyaIndex_TransferFromSortedRessya( 
				pEstimateRessyaCont ,
				&contRessyaIndexBeforSort , 
				&contRessyaIndexAfterSort , 
				aEkijikokuOrder , 
				pIfProgress ) ; 
		}

		//\[gOԂA\[gΏۉwO̒ԉwŏ芷̂ł\[gԂ̑Oɔzu
		if ( !bAbort )
		{
			bAbort = sortRessyaIndex_TransferToSortedRessya( 
				pEstimateRessyaCont ,
				&contRessyaIndexBeforSort , 
				&contRessyaIndexAfterSort , 
				aEkijikokuOrder , 
				pIfProgress ) ; 
		}
		//\[gOԂAׂĂ̒ԉwŏ芷̂ł\[gԂ̑Oɔzu
		if ( !bAbort )
		{
			bAbort = sortRessyaIndex_TransferToSortedRessya( 
				pEstimateRessyaCont ,
				&contRessyaIndexBeforSort , 
				&contRessyaIndexAfterSort , 
				CdDedJikokuOrder( pEkiCont->size() - 1 , CdDedJikokuOrder::EkiJikokuItem_Hatsu) , 
				pIfProgress ) ; 
		}

	}


	//c\[gO(\[gΏۉw(F)̗ps\ȗ)\[gԂɈړ
	//@@@@@@S\[gOԂ̃[v
	//@@@@@@@@[Iw\[gΏۉw]\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃRei̐擪ɑ}
	//@@@@@@@@[else]\[gOԂ\[gOԃRei폜A
	//@@@@@@@@@@@@@\[gԃRei̖ɑ}
	if ( !bAbort )
	{
		int idxTo = 0 ;
		for ( int idx = 0 ; idx < (int)contRessyaIndexBeforSort.size() ; idx ++ )
		{
			int iRessyaIndex = contRessyaIndexBeforSort[idx] ;

			const CentDedRessya* pRessya = pRessyaCont->getMuPtr()->get( iRessyaIndex ) ;
			if ( !pRessya->isNull() && pRessya->getSyuuchakuEki() > aEkijikokuOrder.getEkiOrder() )
			{
				contRessyaIndexBeforSort.erase(
					contRessyaIndexBeforSort.begin() + idx ) ;
				idx -- ;

				contRessyaIndexAfterSort.insert( 
					contRessyaIndexAfterSort.begin() + idxTo , 
					iRessyaIndex ) ;
				idxTo ++ ;

			}
		}
	}
	


	//ŏIIɃ\[głȂIndex́Aɒǉ
	{
		contRessyaIndexAfterSort.insert( 
			contRessyaIndexAfterSort.end() ,
			contRessyaIndexBeforSort.begin() ,
			contRessyaIndexBeforSort.end() ) ;
		contRessyaIndexBeforSort.clear() ;
	}

	//\[gʂ muRessyaIndexOrder Ɋi[
	{
		muRessyaIndexOrder->erase( 0 , INT_MAX ) ;
		CaMui<int>( muRessyaIndexOrder ).insert( &CaMup_vector<vector<int>>( &contRessyaIndexAfterSort ) ) ; ;
	}
};


int CDedRessyaSoater_Transfer::calcNorikaeSec( 
	const CentDedEkiJikoku& aEkiJikokuFrom , 
	const CentDedEkiJikoku& aEkiJikokuTo ,
	const CdDedJikoku& jikokuKitenJikoku ) 
{
	int iNorikaeSec = -1 ;
	if ( aEkiJikokuFrom.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya &&
		aEkiJikokuTo.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya )
	{

		//	芷Ԓ芷Ԕ
		CdDedJikoku	jikokuFrom = aEkiJikokuFrom.getChakujikoku() ;
		CdDedJikoku	jikokuTo = aEkiJikokuTo.getHatsujikoku() ;
		// --------------------------------
		if ( !jikokuFrom.isNull() && !jikokuTo.isNull() )
		{
			int iComp = jikokuTo.compare( jikokuFrom , jikokuKitenJikoku ) ;
			if ( iComp >= 0 )
			{
				//	͒肠(_CON_܂łȂ)

				iNorikaeSec = jikokuTo.subJikoku( jikokuFrom ) ;
				if ( iNorikaeSec < 0 )
				{
					iNorikaeSec = -1 ;
				}
			}
		}
	}
		//iNorikaeSec = 芷(b)
		//	芷s\ȂA-1 ;

	return iNorikaeSec ;
}

} //namespace entDgr
