/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDgrRessya.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CentDedDgrRessya.h"
#include "logmsg/LogMsg.h"
#include "CentDedDgrDia.h"

using namespace std ;

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif //_CONSOLE

namespace entDgr{

/** ̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true ,		//	NoColon 
	//  00  09 ̏ꍇA10̈ʂ "0" 폜܂B
	CdDedJikoku::CConv::EHour_ZeroToNone ,	
	CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B 
	) ;
// ****************************************************************
//	CentDedDgrRessya
// ****************************************************************
	// --------------------------------
	//@name readCentDedRessya() ̉֐
	// --------------------------------
	/*
		readCentDedRessya() ̉֐
		(01)CentDedDgrRessyȃ̂ACentDedRessya ݂̂Ō肷鑮ݒ
	*/
void CentDedDgrRessya::readCentDedRessya_01_readProp( const CentDedRessya* pCentDedRessya ) 
{
	m_bIsNull = pCentDedRessya->isNull() ;
	m_eRessyahoukou = pCentDedRessya->getRessyahoukou() ;
	m_iRessyasyubetsuIndex = pCentDedRessya->getRessyasyubetsuIndex() ;
	m_strRessyabangou = pCentDedRessya->getRessyabangou() ;
	m_strRessyamei = pCentDedRessya->getRessyamei() ;
	m_strGousuu = pCentDedRessya->getGousuu() ;

	m_DgrXZone = CdDcdZone() ;
}
	/*
		readCentDedRessya() ̉֐
		(02)CentDedDgrEkiJikoku 𐶐A CentDedEkiJikoku Ō܂鑮B
	*/
void CentDedDgrRessya::readCentDedRessya_02_CreateCentDedEkiJikoku( 
		const CentDedRessya* pCentDedRessya ) 
{
	//	Ỏw̉wB
	CdDedJikoku	aCdDedJikokuLastStation ;


	//	Ỏw̉włXWBaCdDedJikokuLastStation NULL̏ꍇ
	//	łB
	//	ŏ́uNULLłȂwvꍇ́Ảw瓱oꂽ
	//	XWɂȂ܂B
	//	2ӏڈȍ~́uNULLłȂwvȍ~́A
	//	Ỏw̌oߎԂZ܂B
	//
	//	iXZahyouLastStation = iXZahyouLastStation 
	//		+ ( ̉w̉w - aCdDedJikokuLastStation ) 
	//
	//	ɂA24:00܂đԂł́A
	//	24:00ȍ~̉wɑΉ XW 24:00 (24*60*60=86400) ȏ
	//	ɂȂ܂B
	int	iXZahyouLastStation = 0 ;

	for ( int iEkiOrder = 0 ; 
		iEkiOrder < pCentDedRessya->getCentDedEkiJikokuCount() ; 
		iEkiOrder ++ )
	{
		CentDedEkiJikoku aCentDedEkiJikoku 
			= pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;

		//	wAXWvZ	
		int iDgrXZahyou[2] = { INT_MIN , INT_MIN } ;
		for ( int iChakuHatsu = 0 ; iChakuHatsu < 2 ; iChakuHatsu ++ )
		{
			int iX = INT_MIN ;
			CdDedJikokuOrder::EEkiJikokuItem eEkiJikokuItem = CdDedJikokuOrder::EkiJikokuItem_Chaku ;
			if ( iChakuHatsu == 1 )
			{
				eEkiJikokuItem = CdDedJikokuOrder::EkiJikokuItem_Hatsu ; 
			}


			CdDedJikokuOrder	aCdDedJikokuOrder ;
			aCdDedJikokuOrder.setEkiOrder( iEkiOrder , 
				eEkiJikokuItem ) ;
			CdDedJikoku	aCdDedJikoku 
				= pCentDedRessya->getEkiJikoku( aCdDedJikokuOrder ) ;

			if ( aCdDedJikoku.isNull() )
			{
				//	NULL ȂAȂ
			}
			else if ( aCdDedJikokuLastStation.isNull() )
			{
				//	1ڈȍ~́ANULL
				iX = aCdDedJikoku.getTotalSeconds() ;	//	ŏ́ANULL
			}
			else
			{
				//	2ڈȍ~́ANULL
				CdDedJikan	aCdDedJikan 
					= aCdDedJikoku.subJikoku( aCdDedJikokuLastStation ) ;
				iX = iXZahyouLastStation + aCdDedJikan.getTotalSeconds() ;
			}
			// --------------------------------
			if ( iX != INT_MIN )
			{
				aCdDedJikokuLastStation = aCdDedJikoku ;
				iXZahyouLastStation = iX ;
			}
			iDgrXZahyou[iChakuHatsu] = iX ;
		}

		CentDedDgrEkiJikoku	aCentDedDgrEkiJikoku( 
			aCentDedEkiJikoku.getEkiatsukai() ,
			iDgrXZahyou[0] ,
			iDgrXZahyou[1] ) ;
		
		m_MuCentDedDgrEkiJikoku.insert( aCentDedDgrEkiJikoku ) ;
	}
}

void CentDedDgrRessya::readCentDedRessya_03_updateDgrXZone() 
{
	int iDgrXMin = INT_MIN ;
	int iDgrXMax = INT_MIN ;
	for ( int idx = 0 ; idx < m_MuCentDedDgrEkiJikoku.size() ; idx ++ )
	{
		CentDedDgrEkiJikoku	aCentDedDgrEkiJikoku 
			= m_MuCentDedDgrEkiJikoku.get( idx ) ;
		if ( aCentDedDgrEkiJikoku.getDgrXPosChaku() != INT_MIN )
		{
			if ( iDgrXMin == INT_MIN || 
				iDgrXMin > aCentDedDgrEkiJikoku.getDgrXPosChaku() )
			{
				iDgrXMin = aCentDedDgrEkiJikoku.getDgrXPosChaku() ;
			}
			if ( iDgrXMax == INT_MIN || 
				iDgrXMax < aCentDedDgrEkiJikoku.getDgrXPosChaku() )
			{
				iDgrXMax = aCentDedDgrEkiJikoku.getDgrXPosChaku() ;
			}
		}

		if ( aCentDedDgrEkiJikoku.getDgrXPosHatsu() != INT_MIN )
		{
			if ( iDgrXMin == INT_MIN || 
				iDgrXMin > aCentDedDgrEkiJikoku.getDgrXPosHatsu() )
			{
				iDgrXMin = aCentDedDgrEkiJikoku.getDgrXPosHatsu() ;
			}
			if ( iDgrXMax == INT_MIN || 
				iDgrXMax < aCentDedDgrEkiJikoku.getDgrXPosHatsu() )
			{
				iDgrXMax = aCentDedDgrEkiJikoku.getDgrXPosHatsu() ;
			}
		}
	}
	if ( iDgrXMin != INT_MIN && iDgrXMax != INT_MIN )
	{
		m_DgrXZone.setBeginEndPos( iDgrXMin , iDgrXMax ) ;

		//	iDgrXMiniDgrXMax̏ꍇ́AOIɃTCY1Ƃ܂
		if ( m_DgrXZone.getSize() == 0 )
		{
			m_DgrXZone.setSize( 1 ) ;
		}
	}
}

void CentDedDgrRessya::readCentDedRessya_04_updateShouldRessyajouhouDraw(
	const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ) 
{
	bool	bFirstRessyajouhouHyoujiIsSet = false ;
	for ( int iEkiOrder = 0 ;
		iEkiOrder < m_MuCentDedDgrEkiJikoku.size() ; 
		iEkiOrder ++ )
	{
		bool	bShouldRessyajouhouDraw = false ;

		CentDedDgrEkiJikoku*	pCentDedDgrEkiJikoku = 
			m_MuCentDedDgrEkiJikoku.getMuPtr()->get( iEkiOrder ) ;

		CentDedDgrEkiCont::CdDedDgrEki	aCdDedDgrEki = 
			pMuCdDedDgrEki->get( iEkiOrder ) ;

		if ( isRunBetweenNextEki( iEkiOrder ) )
		{
			//	Ԑ݂̑wԁA
			CentDedDgrEki::EDiagramRessyajouhouHyouji	
				eDiagramRessyajouhouHyouji = 
					aCdDedDgrEki.getDiagramRessyajouhouHyouji() ;

			//	(1)  [̗Ԃ̗ԏ񂪂܂1ӏ`悳ĂȂ]
			//		ԏ`悪u\ȂvȊỎwԁB
			if ( !bFirstRessyajouhouHyoujiIsSet && 
				eDiagramRessyajouhouHyouji !=
				CentDedDgrEki::DiagramRessyajouhouHyouji_Not ) 
			{
				bShouldRessyajouhouDraw = true ;
			}

			//	(2)  ԏ`悪uɕ\v̉w
			if ( eDiagramRessyajouhouHyouji ==
				CentDedDgrEki::DiagramRessyajouhouHyouji_Anytime )
			{
				bShouldRessyajouhouDraw = true ;

			}

		}

		pCentDedDgrEkiJikoku->setShouldRessyajouhouDraw( 
			bShouldRessyajouhouDraw ) ;
		if ( bShouldRessyajouhouDraw )
		{
			bFirstRessyajouhouHyoujiIsSet = true ;
		}

	}

	//	1ӏԏ`ʒuȂꍇ́A
	//	ŏ̗Ԑʒuɕ`悵܂B
	for ( int iEkiOrder = 0 ;
		!bFirstRessyajouhouHyoujiIsSet 
			&& iEkiOrder < m_MuCentDedDgrEkiJikoku.size() ; 
		iEkiOrder ++ )
	{
		bool	bShouldRessyajouhouDraw = false ;

		CentDedDgrEkiJikoku*	pCentDedDgrEkiJikoku = 
			m_MuCentDedDgrEkiJikoku.getMuPtr()->get( iEkiOrder ) ;

		CentDedDgrEkiCont::CdDedDgrEki	aCdDedDgrEki = 
			pMuCdDedDgrEki->get( iEkiOrder ) ;

		if ( isRunBetweenNextEki( iEkiOrder ) )
		{
			//	Ԑ݂̑wԁA
				bShouldRessyajouhouDraw = true ;
		}

		pCentDedDgrEkiJikoku->setShouldRessyajouhouDraw( 
			bShouldRessyajouhouDraw ) ;
		if ( bShouldRessyajouhouDraw )
		{
			bFirstRessyajouhouHyoujiIsSet = true ;
		}

	}

}


//	(05)oRȂ̑O̒₤
void CentDedDgrRessya::readCentDedRessya_05_complementKeiyunasiSide() 
{
	for ( int iEkiOrderBefore = 0 ; 
		iEkiOrderBefore < m_MuCentDedDgrEkiJikoku.size() ; 
		iEkiOrderBefore ++ )
	{
		// --------------------------------
		//	iEkiOrderBefore ȍ~ŁAȉ̉w̕тT܂B
		//	(1)w={,ʉ}̂ꂩ
		//	(2)uw={oRȂ}v1ȏ̕
		//	(3)w={,ʉ}̂ꂩ
		// --------------------------------
		//	(1)w={,ʉ}̂ꂩ ̉wT
		CentDedDgrEkiJikoku	ekijikokuBefore = 
			m_MuCentDedDgrEkiJikoku.get( iEkiOrderBefore ) ;
		if ( !(  
			( ekijikokuBefore.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Teisya || 
			  ekijikokuBefore.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
		) )
		{
			continue ;
		}
		//iEkiOrderBefore,ekijikokuBefore = (1)w={,ʉ}̂ꂩ

		int iEkiOrderAfter = INT_MIN ;
		CentDedDgrEkiJikoku	ekijikokuAfter ;
		for ( iEkiOrderAfter = iEkiOrderBefore + 1  ;
				iEkiOrderAfter < m_MuCentDedDgrEkiJikoku.size() ;
				iEkiOrderAfter ++ )
		{
			ekijikokuAfter = 
				m_MuCentDedDgrEkiJikoku.get( iEkiOrderAfter ) ;
			if ( ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
			{
				//	(2)uw={oRȂ}v
				//		̕
				continue ;
			}
			else if ( ekijikokuBefore.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Teisya || 
			  ekijikokuBefore.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
			{
				//	(3)w={,ʉ}̂ꂩ
				break ;
			}
			else
			{
				//	ɂĂ͂܂Ȃw
				//(F̉wE^sȂ̉w)
				iEkiOrderAfter = INT_MIN ;
				break ;
			}
		}
		if ( iEkiOrderAfter == INT_MIN 
			|| iEkiOrderAfter == m_MuCentDedDgrEkiJikoku.size() )
		{
			//	𖞂w܂
			continue ;
		}
		//iEkiOrderAfter,ekijikokuAfter = (3)w={,ʉ}̂ꂩ
		if ( iEkiOrderBefore + 1 == iEkiOrderAfter )
		{
			//	(2)uw={oRȂ}v܂܂Ă܂B
			continue ;
		}

		//- AoRȂ̒OɒȂ 
		//		AND oRȂ̒ɒꍇ
		//	O̒₢܂B
		if ( ekijikokuBefore.getDgrXPosChaku() == INT_MIN && 
			ekijikokuAfter.getDgrXPosChaku() != INT_MIN )
		{
			ekijikokuBefore.setDgrXPosChaku( ekijikokuAfter.getDgrXPosChaku());
		}
		
		//- AoRȂ̒OɔȂ 
		//		AND oRȂ̒ɔꍇ
		//	O̔₢܂B
		if ( ekijikokuBefore.getDgrXPosHatsu() == INT_MIN && 
			ekijikokuAfter.getDgrXPosHatsu() != INT_MIN )
		{
			ekijikokuBefore.setDgrXPosHatsu( ekijikokuAfter.getDgrXPosHatsu() ) ;
		}

		//- AoRȂ̒Oɒ 
		//		AND oRȂ̒ɒȂꍇ́A
		//	̒₢܂B
		if ( ekijikokuBefore.getDgrXPosChaku() != INT_MIN && 
			ekijikokuAfter.getDgrXPosChaku() == INT_MIN )
		{
			ekijikokuAfter.setDgrXPosChaku(ekijikokuBefore.getDgrXPosChaku() );
		}
		//- AoRȂ̒Oɔ 
		//		AND oRȂ̒ɔȂꍇ́A
		//	̔₢܂B
		if ( ekijikokuBefore.getDgrXPosHatsu() != INT_MIN && 
			ekijikokuAfter.getDgrXPosHatsu() == INT_MIN )
		{
			ekijikokuAfter.setDgrXPosHatsu(ekijikokuBefore.getDgrXPosHatsu());
		}


		m_MuCentDedDgrEkiJikoku.set( 
			ekijikokuBefore ,
			iEkiOrderBefore ) ;
		m_MuCentDedDgrEkiJikoku.set( 
			ekijikokuAfter ,
			iEkiOrderAfter ) ;
		// --------------------------------
		//	̌Jnʒu߂
		// --------------------------------
		{
			//	(1)w={,ʉ}̂ꂩ
			//	(3)w={,ʉ}̂ꂩ
			//	̗ꍇ́A
			//	̌ (3)w={,ʉ}̂ꂩ
			//	n߂܂B
			iEkiOrderBefore = iEkiOrderAfter - 1;
		}
	}
}

void CentDedDgrRessya::readCentDedRessya_06_complementLongStop_01(
	const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ) 
{
	// --------------------------------
	//	ԒԂ̒₤
	// --------------------------------
	for ( int iEkiOrderBefore = 0 ; 
		iEkiOrderBefore < m_MuCentDedDgrEkiJikoku.size() ; 
		iEkiOrderBefore ++ )
	{
		// --------------------------------
		//	iEkiOrderBefore ȍ~ŁAȉ̉w̕тT܂B
		//	(1)(= or =) AND w={,ʉ}̂ꂩ
		//	(2)u=ȂA=ȂAw={ʉ,oRȂ}̂ꂩv
		//		0ȏ̕
		//	(3)=ȂA= AND Ԃ̏IwłȂ
		// --------------------------------
		//	(1)(= or =) AND w={,ʉ}̂ꂩ
		//	̉wT
		CentDedDgrEkiJikoku	ekijikokuBefore = 
			m_MuCentDedDgrEkiJikoku.get( iEkiOrderBefore ) ;
		if ( !( 
			( ekijikokuBefore.getDgrXPosChaku() != INT_MIN || 
			  ekijikokuBefore.getDgrXPosHatsu() != INT_MIN ) && 
			( ekijikokuBefore.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Teisya || 
			  ekijikokuBefore.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
		) )
		{
			continue ;
		}
		//iEkiOrderBefore,ekijikokuBefore = 
		//	(1)(= or =) AND w={,ʉ}̂ꂩ

		int iEkiOrderAfter = INT_MIN ;
		CentDedDgrEkiJikoku	ekijikokuAfter ;
		for ( iEkiOrderAfter = iEkiOrderBefore + 1  ;
				iEkiOrderAfter < m_MuCentDedDgrEkiJikoku.size() ;
				iEkiOrderAfter ++ )
		{

			ekijikokuAfter = 
				m_MuCentDedDgrEkiJikoku.get( iEkiOrderAfter ) ;
			if ( ekijikokuAfter.getDgrXPosChaku() == INT_MIN && 
				ekijikokuAfter.getDgrXPosHatsu() == INT_MIN && 
				( ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Teisya || 
				  ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Tsuuka || 
				  ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Keiyunasi ) )
			{
				//	(2)u=ȂA=ȂAw={,ʉ,oRȂ}
				//		ꂩv0ȏ̕
				continue ;
			}
			else if ( ekijikokuAfter.getDgrXPosChaku() == INT_MIN && 
				ekijikokuAfter.getDgrXPosHatsu() != INT_MIN &&
				iEkiOrderAfter < getSyuuchakuEki() )
			{
				//	(3)=ȂA= AND Ԃ̏IwłȂ
				break ;
			}
			else
			{
				//	ɂĂ͂܂Ȃw
				//(F̉wE^sȂ̉w)
				iEkiOrderAfter = INT_MIN ;
				break ;
			}
		}
		if ( iEkiOrderAfter == INT_MIN 
			|| iEkiOrderAfter == m_MuCentDedDgrEkiJikoku.size() )
		{
			//	𖞂w܂
			continue ;
		}
		//iEkiOrderAfter,ekijikokuAfter = 
		//	(3)=ȂA= AND Ԃ̏IwłȂ

		// --------------------------------
		//	(1)̔{ȂΒ}+(1)`(3)Ԃ̉wԍŏvb
		//		(3)̔-60bȂA
		//	(3)̒=(1)̔+(1)`(3)Ԃ̉wԍŏvb
		//	Ƃ܂B
		// --------------------------------

		int iDgrXPos = ekijikokuBefore.getDgrXPosHatsu() ;
		if ( iDgrXPos == INT_MIN )
		{
			iDgrXPos = ekijikokuBefore.getDgrXPosChaku() ;
		}
		iDgrXPos += calcEkikanSaisyouSec( 
			pMuCdDedDgrEki ,
			iEkiOrderBefore ,
			iEkiOrderAfter ) ; 
		//iDgrXPos = (1)̔(ȂΒ)+(1)`(3)Ԃ̉wԍŏvb

		if ( iDgrXPos < ekijikokuAfter.getDgrXPosHatsu() - 60 )
		{
			//	(1)̔(ȂΒ)+(1)`(3)Ԃ̉wԍŏvb
			//		(3)̔-60bȂA
			//	(3)̒=(1)̔+(1)`(3)Ԃ̉wԍŏvb
			//	Ƃ܂B
			ekijikokuAfter.setDgrXPosChaku( iDgrXPos ) ;
			m_MuCentDedDgrEkiJikoku.set( ekijikokuAfter ,iEkiOrderAfter ) ;
		}
		// --------------------------------
		//	̌Jnʒu߂
		// --------------------------------
		{
			//	(1)(= or =) AND w={,ʉ}̂ꂩ
			//	(3)=ȂA=
			//	̗ꍇ́A
			//	̌ (3)=ȂA=
			//	n߂܂B
			iEkiOrderBefore = iEkiOrderAfter - 1;
		}
	}
}

	//	(06_02)ԒԂ
	//		(ԒԂ̒=E=Ȃ ̉wɁA₤)
void CentDedDgrRessya::readCentDedRessya_06_complementLongStop_02( 
		const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ) 
{
	// --------------------------------
	//	ԒԂ̒₤
	// --------------------------------
	for ( int iEkiOrderBefore = 0 ; 
		iEkiOrderBefore < m_MuCentDedDgrEkiJikoku.size() ; 
		iEkiOrderBefore ++ )
	{
		// --------------------------------
		//	iEkiOrderBefore ȍ~ŁAȉ̉w̕тT܂B
		//	(1)=A=Ȃ
		//	(2)u=ȂA=ȂAw={ʉ,oRȂ}̂ꂩv
		//		0ȏ̕
		//	(3)=Aw={,ʉ}̂ꂩ
		// --------------------------------
		//	(1)=A=Ȃ
		//	̉wT
		CentDedDgrEkiJikoku	ekijikokuBefore = 
			m_MuCentDedDgrEkiJikoku.get( iEkiOrderBefore ) ;
		if ( !( 
			ekijikokuBefore.getDgrXPosChaku() != INT_MIN && 
			ekijikokuBefore.getDgrXPosHatsu() == INT_MIN 
		) )
		{
			continue ;
		}
		//iEkiOrderBefore,ekijikokuBefore = (1)=A=Ȃ

		int iEkiOrderAfter = INT_MIN ;
		CentDedDgrEkiJikoku	ekijikokuAfter ;
		for ( iEkiOrderAfter = iEkiOrderBefore + 1  ;
				iEkiOrderAfter < m_MuCentDedDgrEkiJikoku.size() ;
				iEkiOrderAfter ++ )
		{
			ekijikokuAfter = 
				m_MuCentDedDgrEkiJikoku.get( iEkiOrderAfter ) ;
			if ( ekijikokuAfter.getDgrXPosChaku() == INT_MIN && 
				ekijikokuAfter.getDgrXPosHatsu() == INT_MIN && 
				( ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Teisya || 
				  ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Tsuuka || 
				  ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Keiyunasi ) )
			{
				//	(2)u=ȂA=ȂA
				//		w={,ʉ,oRȂ}̂ꂩv
				//		0ȏ̕
				continue ;
			}
			else if ( ekijikokuAfter.getDgrXPosChaku() != INT_MIN && 
				( ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Teisya || 
				  ekijikokuAfter.getEkiatsukai() == 
					CentDedEkiJikoku::Ekiatsukai_Tsuuka ) )
			{
				//	(3)=Aw={,ʉ}̂ꂩ
				break ;
			}
			else
			{
				//	ɂĂ͂܂Ȃw
				//(F̉wE^sȂ̉w)
				iEkiOrderAfter = INT_MIN ;
				break ;
			}
		}
		if ( iEkiOrderAfter == INT_MIN 
			|| iEkiOrderAfter == m_MuCentDedDgrEkiJikoku.size() )
		{
			//	𖞂w܂
			continue ;
		}
		//iEkiOrderAfter,ekijikokuAfter = (3)=A
		//		w={,ʉ}̂ꂩ

		// --------------------------------
		//	(1)̒(3)̒-(1)`(3)Ԃ̉wԍŏvb-60bȂA
		//	(1)̔=(3)̒-(1)`(3)Ԃ̉wԍŏvb
		//	Ƃ܂B
		// --------------------------------
		int iDgrXPos = ekijikokuAfter.getDgrXPosChaku() ;
		iDgrXPos -= calcEkikanSaisyouSec( 
			pMuCdDedDgrEki ,
			iEkiOrderBefore ,
			iEkiOrderAfter ) ; 
		//iDgrXPos = (3)̒-(1)`(3)Ԃ̉wԍŏvb

		if ( ekijikokuBefore.getDgrXPosChaku() < iDgrXPos - 60 )
		{
			//	(1)̒(3)̒-(1)`(3)Ԃ̉wԍŏvb-60bȂA
			//	(1)̔=(3)̒-(1)`(3)Ԃ̉wԍŏvb
			//	Ƃ܂B
			ekijikokuBefore.setDgrXPosHatsu( iDgrXPos ) ;
			m_MuCentDedDgrEkiJikoku.set( ekijikokuBefore ,iEkiOrderBefore ) ;
		}
		// --------------------------------
		//	̌Jnʒu߂
		// --------------------------------
		{
			//	(1)=Aw={,ʉ}̂ꂩ
			//	(3)=ȂA=
			//	̗ꍇ́A
			//	̌ (3)=ȂA=
			//	n߂܂B
			iEkiOrderBefore = iEkiOrderAfter - 1;
		}
	}
}

	//(08)CentDedDgrRessyaseñRei𐶐A
	//  CentDedDgrEkijikoku::m_iDgrXPosOnRessyasen
	//C
void CentDedDgrRessya::readCentDedRessya_08_updateRessyasenCont(
	const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ) 
{
	m_pCentDedDgrRessyasenCont->erase( 0 , INT_MAX ) ;

	Mu<CentDedDgrEkiJikoku*>*	pMuCentDedDgrEkiJikoku 
		= this->getMuCentDedDgrEkiJikoku() ;

	int iRessyasenKitenEkiOrder = 0 ;
	int iResult = 0 ;
	//(01)
	//wԐN_wOrderxT܂B
	while ( ( iResult = updateRessyasenCont_01_calcRessyasenKiten( 
			iRessyasenKitenEkiOrder , 
			&iRessyasenKitenEkiOrder ) ) >= 0 )
	{
		//iRessyasenKitenEkiOrder = wԐN_wOrderx


		// --------------------------------
		int iRessyasenSyuutenEkiOrder = INT_MIN ;

		//(02)wԐN_wOrderxɑΉwԐI_wOrderx܂B
		//	
		//	  (1)@wԐI_wOrderx̏́A
		//uE̗w肳Ăv OR
		//u ̉w̉ww^sȂx v OR
		//uuwwOrderxA̗Ԃɂ̏Iwv 
		//	  Ώۉw݂Ȃ΁AԐI_wOrdeř͎sƂȂ܂
		//  (oRȂ̒ÓAԐ̏I_ɂ͂Ȃ܂
		//  @(̎_ł̗ԐN_ƏI_́AoRȂ܂Ƃ܂B)
		//
		//	  (2)@̎_ŁAwԐI_wOrderxɒ
		//ݒ肳ĂȂꍇ́A
		//nwɌāAÊꂩw肳Ă
		//w܂B
		//	  ̌ʁwԐI_wOrderxɑwȂꍇ́A
		//ԐI_wOrdeř͎sƂȂ܂B
		{
			int iResult = updateRessyasenCont_02_calcRessyasenSyuuten(
				iRessyasenKitenEkiOrder , 
				&iRessyasenSyuutenEkiOrder ) ;

			//iResult = 
			//	-	0 ;	//	wԐI_wOrderx݂܂B
			//	-	-1 ;	//	ԐI_w܂B
			//				//	̋ԂɊւẮAԐ쐬ł܂B
			if ( iResult == -1 )
			{
				iRessyasenKitenEkiOrder ++ ;
				continue ;
			}
			//iRessyasenSyuutenEkiOrder = wԐI_wOrderxi␳Oj
		}
		//(04)
		//	w_COԐxIuWFNg
		//	wԐN_wOrderxƁwԐI_wOrderx̊Ԃ
		//	rwŁAÊꂩw肳Ăvw΁A
		//	
		//	wԐI_wOrderxƁwԐI_xɂ܂B
		updateRessyasenCont_04_adjustRessyasenSyuuten4( 
			pMuCdDedDgrEki ,
			iRessyasenKitenEkiOrder ,
			&iRessyasenSyuutenEkiOrder ) ;
		LogMsgL(3, "updateRessyasenCont_adjustRessyasenSyuuten4()4"
			" Kiten=%d Syuuten=%d" ,
			iRessyasenKitenEkiOrder ,iRessyasenSyuutenEkiOrder ) ;

		// --------------------------------
		{
			bool	bRetryRequested = false ;
			do{
				bRetryRequested = false ;

				//	wԐN_xƁwԐI_x̊ԂɁAԐ𐶐
				CentDedDgrRessyasen	aRessyasen(
					iRessyasenKitenEkiOrder ,iRessyasenSyuutenEkiOrder ) ;
				m_pCentDedDgrRessyasenCont->insert( aRessyasen ) ;

				//(05)
				//wԐRei CentDedDgrRessyasenCont x̖
				//wԐ CentDedDgrRessyasenx̓rw̒ŁA
				//Ԑ̈ʒu(CentDedDgrEkiJikoku::m_iDgrXPosRessyasen)
				//E
				//(CentDedDgrEkiJikoku::m_iDgrXPosChaku,m_iDgrXPosHatsu)
				//60 bȏ゠ꍇ́ẢwwԐI_wOrderx
				//	܂B
				{
					int iResult=updateRessyasenCont_05_adjustRessyasenSyuuten5(
						&iRessyasenSyuutenEkiOrder ) ;
					//iResult = 
					//-	0 ;	//	wԐI_wOrderx̕␳̕Kv͂܂
					//		//	łB
					//-	1 ;	//	wԐI_wOrderx̕␳s܂B
					if ( iResult == 1 )
					{
						//iRessyasenSyuutenEkiOrder = 
						//	wԐI_wOrderx͏C܂B

						//	̗Ԑ폜
						m_pCentDedDgrRessyasenCont->erase( INT_MAX ) ;

						bRetryRequested = true ;
					}
				}
			}	while ( bRetryRequested ) ;
		}


		//(06)	Rei̗ԐrɁuoRȂv܂ޏꍇA
		//	̗ԐuoRȂv܂łɒZk܂B
		//	(1)uoRȂvỎwẺw̒EuԐwv
		//	u܂B
		//	(2)Ԑ́uoRȂvO܂łɒZk܂B
		//	(3)ԐI_uoRȂv̒OƂ܂B
		{
			int iResult = updateRessyasenCont_06_reduceToKeiyunasi( 
						&iRessyasenSyuutenEkiOrder ) ;
		}
		//	ԐN_ẃAȌI_wƂ܂B
		iRessyasenKitenEkiOrder = iRessyasenSyuutenEkiOrder ;

	}
}

int CentDedDgrRessya::updateRessyasenCont_01_calcRessyasenKiten( 
		int iEkiOrder ,
		int* piRessyasenKitenEkiOrder ) 
{
	//	wԐN_wOrderx̏́A
	//	uÊꂩw肳Ă AND 
	//	́wwOrderx̉wwԁxwʉ߁xv
	Mu<CentDedDgrEkiJikoku*>*	pMuCentDedDgrEkiJikoku 
		= this->getMuCentDedDgrEkiJikoku() ;

	for ( ; iEkiOrder < pMuCentDedDgrEkiJikoku->size() - 1 ; 
			iEkiOrder ++ )
	{
		CentDedDgrEkiJikoku*	pEkiJikokuCurr = 
			pMuCentDedDgrEkiJikoku->get( iEkiOrder ) ;
		CentDedDgrEkiJikoku*	pEkiJikokuNext = 
			pMuCentDedDgrEkiJikoku->get( iEkiOrder + 1 ) ;
 
		int iDgrXPosHatsu = pEkiJikokuCurr->getDgrXPosHatsu( true ) ;
		if ( iDgrXPosHatsu != INT_MIN && 
			( pEkiJikokuNext->getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Teisya ||
			  pEkiJikokuNext->getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Tsuuka ) ){
			*piRessyasenKitenEkiOrder = iEkiOrder ;
			return ( 0 ) ;
		} 
	}	
	return -1 ;	//	iEkiOrder ȍ~ŁAԐN_w܂B
}

int CentDedDgrRessya::updateRessyasenCont_02_calcRessyasenSyuuten( 
		int iRessyasenKitenEkiOrder ,
		int* piRessyasenSyuutenEkiOrder ) 
{
	int iRv = 0 ;
	Mu<CentDedDgrEkiJikoku*>*	pMuCentDedDgrEkiJikoku 
		= this->getMuCentDedDgrEkiJikoku() ;

	int iSyuuchakuEki = getSyuuchakuEki()  ;
	int iRessyasenSyuutenEkiOrder = -1 ;

	//	  (1)@wԐI_wOrderx̏́A
	//uE̗w肳Ăv OR
	//u ̉w̉ww^sȂx v OR
	//uuwwOrderxA̗Ԃɂ̏Iwv 
	//	  Ώۉw݂Ȃ΁AԐI_wOrdeř͎sƂȂ܂
	//  (oRȂ̒ÓAԐ̏I_ɂ͂Ȃ܂
	//  @(̎_ł̗ԐN_ƏI_́AoRȂ܂Ƃ܂B)

	if ( iRv >= 0 )
	{
		for ( int iEkiOrder = iRessyasenKitenEkiOrder + 1 ; 
			iRessyasenSyuutenEkiOrder < 0 && 
				iEkiOrder <= iSyuuchakuEki ;
			iEkiOrder ++ )
		{
			CentDedDgrEkiJikoku	aEkiJikokuCurr = 
				*pMuCentDedDgrEkiJikoku->get( iEkiOrder ) ;
			CentDedDgrEkiJikoku	aEkiJikokuNext ;
			if ( iEkiOrder + 1 < pMuCentDedDgrEkiJikoku->size() )
			{
				aEkiJikokuNext = 
					*pMuCentDedDgrEkiJikoku->get( iEkiOrder + 1 ) ;
			}
			//aEkijikokuCurr = iEkiOrder ̉w
			//aEkiJikokuNext = iEkiOder ̎̉w̉wB
			//	iEkiOrderIw̏ꍇ́ANULLƂȂ܂B


			int jikokuChaku = aEkiJikokuCurr.getDgrXPosChaku( false ) ;
			int	jikokuHatsu = aEkiJikokuCurr.getDgrXPosHatsu( false ) ;
			if ( jikokuChaku != INT_MIN && jikokuHatsu != INT_MIN )
			{
				//uE̗w肳Ăv 
				iRessyasenSyuutenEkiOrder = iEkiOrder ;
			}
			else if ( aEkiJikokuNext.getEkiatsukai() == 
						CentDedEkiJikoku::Ekiatsukai_None ) 
			{
				//	ủw̉ww^sȂxv  
				iRessyasenSyuutenEkiOrder = iEkiOrder ;
			}
			else if ( iEkiOrder == iSyuuchakuEki )
			{
				//	uuwwOrderxA̗Ԃɂ̏Iwv 
				iRessyasenSyuutenEkiOrder = iEkiOrder ;
			}
		}
		if ( iRessyasenSyuutenEkiOrder < 0 )
		{
			iRv = -1 ;	//	ԐI_ł܂B(ʏ͔܂)
		}
	}
	// iRessyasenSyuutenEkiOrder = 肵ԐI_wOrder

	//	(2)@̎_ŁAwԐI_wOrderxɒ
	//	ݒ肳ĂȂꍇ́A
	//	nwɌāAÊꂩw肳Ă
	//	w܂B
	//	  ̌ʁwԐI_wOrderxɑwȂꍇ́A
	//	ԐI_wOrdeř͎sƂȂ܂B
	if ( iRv >= 0 )
	{
		for ( ; iRessyasenSyuutenEkiOrder > iRessyasenKitenEkiOrder ; 
			iRessyasenSyuutenEkiOrder -- )
		{
			CentDedDgrEkiJikoku	aEkiJikokuCurr = 
				*pMuCentDedDgrEkiJikoku->get( iRessyasenSyuutenEkiOrder ) ;
			int jikokuChaku = aEkiJikokuCurr.getDgrXPosChaku( false ) ;
			int	jikokuHatsu = aEkiJikokuCurr.getDgrXPosHatsu( false ) ;
			if ( jikokuChaku != INT_MIN || jikokuHatsu != INT_MIN )
			{
				//uÊǂ炩w肳Ăv 
				break ;
			}
		}
		if ( iRessyasenSyuutenEkiOrder == iRessyasenKitenEkiOrder )
		{
			iRv = -1 ;	//	ԐI_ł܂B
		}
		//iRessyasenSyuutenEkiOrder = 
		//	Êꂩw肳ꂽAwԐI_wOrderx
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		*piRessyasenSyuutenEkiOrder = iRessyasenSyuutenEkiOrder ;
	}
	return ( iRv ) ;
}

int CentDedDgrRessya::updateRessyasenCont_04_adjustRessyasenSyuuten4( 
		const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ,
		int iRessyasenKitenEkiOrder ,
		int* piRessyasenSyuutenEkiOrder ) 
{
	int iRessyasenSyuutenEkiOrder = *piRessyasenSyuutenEkiOrder ;
	// --------------------------------
	//	wvwxT܂B
	// --------------------------------
	Mu<CentDedDgrEkiJikoku*>*	pMuCentDedDgrEkiJikoku 
		= this->getMuCentDedDgrEkiJikoku() ;
	for ( int iEkiOrder = iRessyasenKitenEkiOrder + 1 ;
		iEkiOrder < iRessyasenSyuutenEkiOrder ; 
		iEkiOrder ++ )
	{
		CentDedDgrEkiCont::CdDedDgrEki aCdDedDgrEki = 
			pMuCdDedDgrEki->get( iEkiOrder ) ;
		CentDedDgrEkiJikoku aCentDedDgrEkiJikoku = 
			*pMuCentDedDgrEkiJikoku->get( iEkiOrder ) ;
		int jikokuToueki = aCentDedDgrEkiJikoku.getDgrXPosChaku( true ) ;

		if ( jikokuToueki != INT_MIN && 
			aCdDedDgrEki.getIsSyuyoueki() )
		{
			//	wԐN_wOrderxƁwԐI_wOrderx̊Ԃ
			//	rwŁAÊꂩw肳Ăvw
			//	΁A
			//	wԐI_wOrderxƂ܂B
			*piRessyasenSyuutenEkiOrder = iEkiOrder ;
			return 	1 ;	//	wԐI_wOrderx̕␳s܂B
		}
		if ( aCentDedDgrEkiJikoku.getEkiatsukai() == 
				CentDedEkiJikoku::Ekiatsukai_Tsuuka && 
			( jikokuToueki != INT_MIN  ) )
		{
			//uʉ߉wŁA
			//̂ꂩw肳Ăv 
			*piRessyasenSyuutenEkiOrder = iEkiOrder ;
			return 	1 ;	//	wԐI_wOrderx̕␳s܂B
		}


	}
	return 0 ;
}


int CentDedDgrRessya::updateRessyasenCont_05_adjustRessyasenSyuuten5( 
		int* piRessyasenSyuutenEkiOrder ) 
{
	int iRv = 0 ;
	CentDedDgrRessyasen aCentDedDgrRessyasen 
		= m_pCentDedDgrRessyasenCont->get( INT_MAX ) ;

	for ( int iEkiOrder = *piRessyasenSyuutenEkiOrder - 1 ;
		iRv==0 && iEkiOrder > aCentDedDgrRessyasen.getRessyasenKitenEkiOrder();
		iEkiOrder -- )
	{
		CentDedDgrEkiJikoku	aEkiJikoku = m_MuCentDedDgrEkiJikoku.get( 
			iEkiOrder ) ;

		//Ԑ̈ʒu(CentDedDgrEkiJikoku::m_iDgrXPosRessyasen)
		//E(CentDedDgrEkiJikoku::m_iDgrXPosChaku,m_iDgrXPosHatsu)
		//60 bȏ゠
		//ꍇ́ẢwwԐI_wOrderxƂ܂B
		int iDgrXPosChakuHatsu = aEkiJikoku.getDgrXPosHatsu( true ) ;
		int iDgrXPosRessyasen = aEkiJikoku.getDgrXPosRessyasen() ;
		if ( iDgrXPosChakuHatsu != INT_MIN && 
			abs( iDgrXPosChakuHatsu - iDgrXPosRessyasen ) >= 60 )
		{
			*piRessyasenSyuutenEkiOrder = iEkiOrder ;
			iRv = 1 ;	//	wԐI_wOrderx̕␳s܂B
		}
	}
	return iRv ;
}



int CentDedDgrRessya::updateRessyasenCont_06_reduceToKeiyunasi( 
		int* piRessyasenSyuutenEkiOrder ) 
{
	int iRv = 0 ;
	CentDedDgrRessyasen aCentDedDgrRessyasen = m_pCentDedDgrRessyasenCont->get(
		INT_MAX ) ;
	// --------------------------------
	//	ԐɊ܂܂A
	//	oRȂ̎n_ƏI_
	// --------------------------------
	int iEkiOrderBeforeKeiyunasi = INT_MIN ;
	int iEkiOrderAfterKeiyunasi = INT_MIN ;
	for ( int iEkiOrder = aCentDedDgrRessyasen.getRessyasenKitenEkiOrder()+1 ;
		iEkiOrderBeforeKeiyunasi == INT_MIN 
			&& iEkiOrder < *piRessyasenSyuutenEkiOrder ;
		iEkiOrder ++ )
	{
		CentDedDgrEkiJikoku	aEkiJikokuNext = m_MuCentDedDgrEkiJikoku.get( 
			iEkiOrder + 1 ) ;

		if ( aEkiJikokuNext.getEkiatsukai() 
			== CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
		{
			iEkiOrderBeforeKeiyunasi = iEkiOrder ;
		}
	}
	if ( iEkiOrderBeforeKeiyunasi != INT_MIN )
	{
		int iEkiOrder = 0 ;
		for ( iEkiOrder = iEkiOrderBeforeKeiyunasi + 1 ;
			iEkiOrderAfterKeiyunasi == INT_MIN 
				&& iEkiOrder < *piRessyasenSyuutenEkiOrder ;
			iEkiOrder ++ )
		{
			CentDedDgrEkiJikoku	aEkiJikoku = m_MuCentDedDgrEkiJikoku.get( 
				iEkiOrder ) ;

			//wwoRȂx̏I[n_T܂B
			if ( aEkiJikoku.getEkiatsukai() 
				!= CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
			{
				iEkiOrderAfterKeiyunasi = iEkiOrder ;
			}
		}
		//iEkiOrderAfterKeiyunasi = iEkiOrderBeforeKeiyunasi Ȍōŏ
		//	uwwoRȂxȊỎwv̉wOrderB
		//	AAꂪuԐI_wOrdeȑꍇv́AINT_MINƂȂ܂B
	}

	//iEkiOrderBeforeKeiyunasi = woRȂxỎwOrder
	//iEkiOrderAfterKeiyunasi = woRȂx̉wOrder
	//	AAuwoRȂx̉wOrderv
	//	uԐI_wOrdeȑꍇv́AINT_MINƂȂ܂B

	if ( iEkiOrderBeforeKeiyunasi != INT_MIN ) 
	{
		//	woRȂxỎwOrder
		//	AԐ̎ɕύX܂
		CentDedDgrEkiJikoku aCentDedDgrEkiJikoku = 
			m_MuCentDedDgrEkiJikoku.get( iEkiOrderBeforeKeiyunasi ) ;
		aCentDedDgrEkiJikoku.setDgrXPosChaku( 
			aCentDedDgrEkiJikoku.getDgrXPosRessyasen() ) ;
		aCentDedDgrEkiJikoku.setDgrXPosHatsu( 
			aCentDedDgrEkiJikoku.getDgrXPosRessyasen() ) ;
		m_MuCentDedDgrEkiJikoku.set( 
			aCentDedDgrEkiJikoku , iEkiOrderBeforeKeiyunasi ) ;

		if ( iEkiOrderAfterKeiyunasi != INT_MIN )
		{
			//	woRȂx̉wOrder
			//	AԐ̎ɕύX܂
			CentDedDgrEkiJikoku aCentDedDgrEkiJikoku = 
				m_MuCentDedDgrEkiJikoku.get( iEkiOrderAfterKeiyunasi ) ;
			aCentDedDgrEkiJikoku.setDgrXPosChaku( 
				aCentDedDgrEkiJikoku.getDgrXPosRessyasen() ) ;
			aCentDedDgrEkiJikoku.setDgrXPosHatsu( 
				aCentDedDgrEkiJikoku.getDgrXPosRessyasen() ) ;
			m_MuCentDedDgrEkiJikoku.set( 
				aCentDedDgrEkiJikoku , iEkiOrderAfterKeiyunasi ) ;
		}

		//	̗Ԑu܂B
		m_pCentDedDgrRessyasenCont->erase( INT_MAX ) ;
		aCentDedDgrRessyasen.setSyuuten( iEkiOrderBeforeKeiyunasi ) ;
		m_pCentDedDgrRessyasenCont->insert( aCentDedDgrRessyasen ) ;

		//wwoRȂx̉wꍇ́A
		//̒OwԐI_wOrderxƂ܂B
		*piRessyasenSyuutenEkiOrder = iEkiOrderBeforeKeiyunasi ;

		iRv = 1 ;
	}
	return iRv ;
}

// --------------------------------
//@name ֐
// --------------------------------



// ********************************
//	RXgN^
// ********************************
CentDedDgrRessya::CentDedDgrRessya( 
		const CentDedRosen* pCentDedRosen ,
		const CentDedDgrDia* pCentDedDgrDia ,
		const CentDedRessya* pCentDedRessya ) 
	: m_bIsNull( true ) 
	, m_eRessyahoukou( pCentDedRessya->getRessyahoukou() ) 
	, m_iRessyasyubetsuIndex( 0 )
	, m_pCentDedDgrDia( pCentDedDgrDia ) 
	, m_pCentDedDgrRessyasenCont( NULL ) 
{
	m_pCentDedDgrRessyasenCont = new CentDedDgrRessyasenCont(
		this ) ;

	readCentDedRessya( pCentDedRosen ,
		pCentDedDgrDia ,
		pCentDedRessya ) ; 

}
	
CentDedDgrRessya::CentDedDgrRessya( 
	const CentDedDgrDia* pCentDedDgrDia )
	: m_bIsNull( true ) 
	, m_eRessyahoukou( Ressyahoukou_Kudari ) 
	, m_iRessyasyubetsuIndex( 0 )
	, m_pCentDedDgrDia( pCentDedDgrDia ) 
	, m_pCentDedDgrRessyasenCont( NULL ) 
{
	m_pCentDedDgrRessyasenCont = new CentDedDgrRessyasenCont(
		this ) ;
}

CentDedDgrRessya::CentDedDgrRessya( const CentDedDgrRessya& value )
	: m_bIsNull( value.m_bIsNull ) 
	, m_eRessyahoukou( value.m_eRessyahoukou ) 
	, m_iRessyasyubetsuIndex( value.m_iRessyasyubetsuIndex )
	, m_strRessyabangou( value.m_strRessyabangou ) 
	, m_strRessyamei( value.m_strRessyamei ) 
	, m_strGousuu( value.m_strGousuu ) 
	, m_DgrXZone( value.m_DgrXZone ) 
	, m_pCentDedDgrDia( value.m_pCentDedDgrDia ) 
	, m_MuCentDedDgrEkiJikoku( value.m_MuCentDedDgrEkiJikoku )
	, m_pCentDedDgrRessyasenCont( NULL ) 
{
	m_pCentDedDgrRessyasenCont = new CentDedDgrRessyasenCont(
		this ) ;

	*m_pCentDedDgrRessyasenCont = *value.m_pCentDedDgrRessyasenCont ;
}


CentDedDgrRessya& CentDedDgrRessya::operator=( const CentDedDgrRessya& value )
{
	m_bIsNull = value.m_bIsNull ;
	m_eRessyahoukou = value.m_eRessyahoukou ;
	m_iRessyasyubetsuIndex = value.m_iRessyasyubetsuIndex ;
	m_strRessyabangou = value.m_strRessyabangou ;
	m_strRessyamei = value.m_strRessyamei ;
	m_strGousuu = value.m_strGousuu ;
	m_DgrXZone = value.m_DgrXZone ;
	m_MuCentDedDgrEkiJikoku = value.m_MuCentDedDgrEkiJikoku ;
	*m_pCentDedDgrRessyasenCont = *value.m_pCentDedDgrRessyasenCont ;

	return *this ;
}

CentDedDgrRessya::~CentDedDgrRessya() 
{
	delete m_pCentDedDgrRessyasenCont ;	m_pCentDedDgrRessyasenCont = NULL ;
}
	
// ********************************
//	CentDedDgrRessya
// ********************************
	// ********************************
	//@name 
	// ********************************
bool CentDedDgrRessya::getIsNull()const
{
	return m_bIsNull ;
}
ERessyahoukou	CentDedDgrRessya::getRessyahoukou()const 
{
	return m_eRessyahoukou ;
}
CentDedDgrRessya& CentDedDgrRessya::setRessyahoukou( ERessyahoukou value ) 
{
	m_eRessyahoukou = value ;
	return *this ;
}

int	CentDedDgrRessya::getRessyasyubetsuIndex()const
{
	return m_iRessyasyubetsuIndex ;
};
void CentDedDgrRessya::setRessyasyubetsuIndex( int value )
{
	m_iRessyasyubetsuIndex = value ; 
};


string CentDedDgrRessya::getRessyabangou()const
{
		return m_strRessyabangou ;
};
CentDedDgrRessya& CentDedDgrRessya::setRessyabangou( const string& value )
{
		m_bIsNull = false ;
		m_strRessyabangou = value ; 
		return *this ; 
} ;
string CentDedDgrRessya::getRessyamei()const
{
		return m_strRessyamei ;
};
CentDedDgrRessya& CentDedDgrRessya::setRessyamei( const string& value )
{
		m_bIsNull = false ;
		 m_strRessyamei = value ; 
		return *this ; 
} ;
string CentDedDgrRessya::getGousuu()const
{
		return m_strGousuu ;
};
CentDedDgrRessya& CentDedDgrRessya::setGousuu( const string& value )
{
		m_bIsNull = false ;
		 m_strGousuu = value ; 
		return *this ; 
} ;
CdDcdZone	CentDedDgrRessya::getDgrXZone()const
{
	return m_DgrXZone ;
};

	// ********************************
	//@name 
	// ********************************
Mu< CentDedDgrEkiJikoku* >* 
CentDedDgrRessya::getMuCentDedDgrEkiJikoku() 
{
	return m_MuCentDedDgrEkiJikoku.getMuPtr() ;
}
const Mu< const CentDedDgrEkiJikoku* >* 
CentDedDgrRessya::getMuCentDedDgrEkiJikoku()const 
{
	return m_MuCentDedDgrEkiJikoku.getMuPtr() ;
}

Mu< CentDedDgrRessyasen* >* CentDedDgrRessya::
	getCentDedDgrRessyasenCont()
{
	return m_pCentDedDgrRessyasenCont->getMuPtr() ;
}
const Mu< const CentDedDgrRessyasen* >* CentDedDgrRessya::
	getCentDedDgrRessyasenCont()const 
{
	return ((const CentDedDgrRessyasenCont*)m_pCentDedDgrRessyasenCont)->getMuPtr() ;
}


	// ********************************
	//@name 
	// ********************************
void CentDedDgrRessya::clear()
{
	m_bIsNull = NULL ;
	m_eRessyahoukou = Ressyahoukou_Kudari ;
	m_iRessyasyubetsuIndex = 0 ;
	m_strRessyabangou.erase() ;
	m_strRessyamei.erase() ;
	m_strGousuu.erase() ;
	m_DgrXZone.setPos( 0 ).setSize( 0 ) ;
	m_MuCentDedDgrEkiJikoku.erase( 0 , INT_MAX ) ;
	m_pCentDedDgrRessyasenCont->erase( 0 , INT_MAX ) ;
}
int CentDedDgrRessya::readCentDedRessya(
		const CentDedRosen* pCentDedRosen ,
		const CentDedDgrDia* pCentDedDgrDia ,
		const CentDedRessya* pCentDedRessya ) 
{
	int iRv = 0 ;
	//	܂IuWFNgSăNAANULLԂɂ܂
	clear() ;

	//(01)CentDedDgrRessyȃ̂ACentDedRessya ݂̂Ō肷鑮ݒ
	readCentDedRessya_01_readProp( pCentDedRessya ) ;

	//(02)CentDedDgrEkiJikoku 𐶐A CentDedEkiJikoku Ō܂鑮B
	readCentDedRessya_02_CreateCentDedEkiJikoku( pCentDedRessya ) ;

	//(03)CentDedDgrRessyäȉ̑ACentDedDgrEkiJikokȗ
	//	ƂɐB
	//	CdDcdZone	m_zoneDgrXZahyou
	readCentDedRessya_03_updateDgrXZone() ;

	//(04)CentDedDgrEkijikoküȉ̑ACentDedDgrEki ̑ƂɌB
	//	m_bShouldRessyajouhouDraw //ԏ̉w̏ꏊɕ`悷Ȃ^łB
	readCentDedRessya_04_updateShouldRessyajouhouDraw(
		pCentDedDgrDia->getCentDedDgrEkiCont()->getMuPtr( m_eRessyahoukou ) ) ;

	//	(05)oRȂ̑O̒₤
	readCentDedRessya_05_complementKeiyunasiSide() ; 

	//	(06_01)ԒԂ
	//		(ԒԂ̒=ȂE= ̉wɁA₤)
	readCentDedRessya_06_complementLongStop_01( 
		pCentDedDgrDia->getCentDedDgrEkiCont()->getMuPtr( m_eRessyahoukou ) ) ;

	//	(06_02)ԒԂ
	//		(ԒԂ̒=E=Ȃ ̉wɁA₤)
	readCentDedRessya_06_complementLongStop_02( 
		pCentDedDgrDia->getCentDedDgrEkiCont()->getMuPtr( m_eRessyahoukou ) ) ;

	//(08)CentDedDgrRessyaseñRei𐶐A
	//  CentDedDgrEkijikoku::m_iDgrXPosOnRessyasen
	//C
	readCentDedRessya_08_updateRessyasenCont( 
		pCentDedDgrDia->getCentDedDgrEkiCont()->getMuPtr( m_eRessyahoukou ) ) ;
	
	return ( iRv ) ;
}

int CentDedDgrRessya::getSihatsuEki()const 
{
	int	iRv = -1 ;
	// --------------------------------
	int iEkiOrder = 0 ;
	for ( iEkiOrder = 0 ; 
			iRv == -1 && 
			iEkiOrder < (int)m_MuCentDedDgrEkiJikoku.size() ; 
			iEkiOrder ++ )
	{
		const CentDedDgrEkiJikoku*	pCentDedDgrEkiJikoku = 
			m_MuCentDedDgrEkiJikoku.getMuPtr()->get( iEkiOrder ) ;
		if ( pCentDedDgrEkiJikoku->getEkiatsukai() != 
				CentDedEkiJikoku::Ekiatsukai_None )
		{
			iRv = iEkiOrder ;
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

int CentDedDgrRessya::getSyuuchakuEki()const 
{
	int	iRv = -1 ;
	// --------------------------------
	int iEkiOrder = 0 ;
	for ( iEkiOrder = (int)m_MuCentDedDgrEkiJikoku.size() - 1 ; 
			iRv == -1 && 
			iEkiOrder >= 0 ; 
			iEkiOrder -- )
	{
		const CentDedDgrEkiJikoku*	pCentDedDgrEkiJikoku = 
			m_MuCentDedDgrEkiJikoku.getMuPtr()->get( iEkiOrder ) ;
		if ( pCentDedDgrEkiJikoku->getEkiatsukai() != 
				CentDedEkiJikoku::Ekiatsukai_None )
		{
			iRv = iEkiOrder ;
		}
	}
	// --------------------------------
	return ( iRv ) ;
}

bool CentDedDgrRessya::isRunBetweenNextEki( int iEkiOrder )const 
{
	bool bRv = false ;
	if ( !( 0 <= iEkiOrder && iEkiOrder < (int)m_MuCentDedDgrEkiJikoku.size() - 1 ) )
	{
		bRv = false ;	//	wwIndexxsłB
	}
	else
	{
		const CentDedDgrEkiJikoku* pEkijikoku 
			= m_MuCentDedDgrEkiJikoku.getMuPtr()->get( iEkiOrder ) ;
		const CentDedDgrEkiJikoku* pEkijikokuNext 
			= m_MuCentDedDgrEkiJikoku.getMuPtr()->get( iEkiOrder + 1 ) ;
		if ( 
			( pEkijikoku->getEkiatsukai()
					==CentDedEkiJikoku::Ekiatsukai_Teisya
				|| pEkijikoku->getEkiatsukai() 
					== CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
			&& ( pEkijikokuNext->getEkiatsukai() 
					== CentDedEkiJikoku::Ekiatsukai_Teisya 
				|| pEkijikokuNext->getEkiatsukai() 
					== CentDedEkiJikoku::Ekiatsukai_Tsuuka ) 
		)
		{
			bRv = true ;
		}

	}
	return bRv ;
}

int CentDedDgrRessya::calcEkikanSaisyouSec(
		const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ,
		int iEkiOrderBefore ,
		int iEkiOrderAfter )const 
{
	int iRv = 0 ;
	for ( int iEkiOrder = iEkiOrderBefore ;
		iEkiOrder < iEkiOrderAfter ;
		iEkiOrder ++ )
	{
		if ( isRunBetweenNextEki( iEkiOrder ) )
		{
			CentDedDgrEkiCont::CdDedDgrEki	aCdDedDgrEki = 
				pMuCdDedDgrEki->get( iEkiOrder ) ;
			iRv += aCdDedDgrEki.getEkikanSaisyouSec() ;
		}
	}
	return iRv ;
}

int CentDedDgrRessya::calcDgrYEkikanSize(
		const Mu<CentDedDgrEkiCont::CdDedDgrEki>* pMuCdDedDgrEki ,
		int iEkiOrderBefore ,
		int iEkiOrderAfter )const 
{
	int iRv = 0 ;
	for ( int iEkiOrder = iEkiOrderBefore ;
		iEkiOrder < iEkiOrderAfter ;
		iEkiOrder ++ )
	{
		if ( isRunBetweenNextEki( iEkiOrder ) )
		{
			CentDedDgrEkiCont::CdDedDgrEki	aCdDedDgrEki = 
				pMuCdDedDgrEki->get( iEkiOrder ) ;
			iRv += aCdDedDgrEki.getDgrYSizeEkikan() ;
		}
	}
	return iRv ;
}


void CentDedDgrRessya::modifyDgrXPos( int iSeconds ) 
{
	int idx ;
	for ( idx = 0 ; idx < m_MuCentDedDgrEkiJikoku.size() ; idx ++ )
	{
		CentDedDgrEkiJikoku	aCentDedDgrEkiJikoku 
			= m_MuCentDedDgrEkiJikoku.get( idx ) ;
		aCentDedDgrEkiJikoku.modifyDgrXPos( iSeconds ) ;
		m_MuCentDedDgrEkiJikoku.set( aCentDedDgrEkiJikoku , idx ) ;
	}
	{
		m_DgrXZone.setPos( m_DgrXZone.getPos() + iSeconds ) ;
	}
}

int CentDedDgrRessya::getDgrXPosOfJikokuOrder(
		CdDedJikokuOrder aCdDedJikokuOrder , 
		int* piDgrXPos )const 
{
	int iRv = 0 ;
	int iDgrXPos = INT_MIN ;

	const Mu<const CentDedDgrEkiJikoku*>* muCentDedDgrEkiJikoku = this->getMuCentDedDgrEkiJikoku() ;

	const CentDedDgrEkiJikoku*	pCentDedDgrEkiJikoku = muCentDedDgrEkiJikoku->get( aCdDedJikokuOrder.getEkiOrder() ) ;
	if ( !( pCentDedDgrEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya || 
		pCentDedDgrEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka ) )
	{
		iRv = -1 ;	//	̉w̍W擾ł܂B
	}
	else if ( pCentDedDgrEkiJikoku->getDgrXPosRessyasen() != INT_MIN )
	{
		//	̉wɗԐXW(Ԑ̓r)ȂA
		//	XW̗p
		iDgrXPos = pCentDedDgrEkiJikoku->getDgrXPosRessyasen() ;
	}
	else if ( aCdDedJikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Chaku)
	{
		//	w̉wOrder
		//	̍W擾(ȂΔ)
		iDgrXPos = pCentDedDgrEkiJikoku->getDgrXPosChaku( true ) ;
		if ( iDgrXPos == INT_MIN )
		{
			iRv = -1 ;	//	̉w̍W擾ł܂B
		}
	}
	else
	{
		//	w̉wOrder
		//	̍W擾(ȂΒ)
		iDgrXPos = pCentDedDgrEkiJikoku->getDgrXPosHatsu( true ) ;
		if ( iDgrXPos == INT_MIN )
		{
			iRv = -1 ;	//	̉w̍W擾ł܂B
		}
	}
	// --------------------------------
	if ( piDgrXPos != NULL )
	{
		*piDgrXPos = iDgrXPos ;
	}
	return iRv ;
}


int CentDedDgrRessya::getDgrXPosOfEkiOrder(
		int iEkiOrder , 
		int* piDgrXPos )const 
{
	int iDgrXPos = 0 ;
	int iRv = -1 ;
	if ( iRv == -1 )
	{
		iRv = this->getDgrXPosOfJikokuOrder( 
			CdDedJikokuOrder( iEkiOrder , CdDedJikokuOrder::EkiJikokuItem_Hatsu )  , 
			&iDgrXPos ) ;

	}
	if ( iRv == -1 )
	{
		//	wOrder̒̍W擾
		iRv = this->getDgrXPosOfJikokuOrder( 
			CdDedJikokuOrder( iEkiOrder , CdDedJikokuOrder::EkiJikokuItem_Chaku ) , 
			&iDgrXPos ) ;

	}
	// --------------------------------
	if ( piDgrXPos != NULL ){
		*piDgrXPos = iDgrXPos ;
	}
	return ( iRv ) ;

	// ----------------------------------------------------------------
}

} //namespace entDgr
