/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
//****************************************************************
//	CdWinGdi_DrawText_Format.h
//****************************************************************
*/
/** @file */
#ifndef  CdWinGdi_DrawText_Format_h
#define  CdWinGdi_DrawText_Format_h

#include <windows.h>

namespace DcDrawLib{
namespace DcDraw{

// ****************************************************************
//	CdWinGdi_DrawText_Format
// ****************************************************************
/**
 @brief
 yTvz
 	Win32  DrawText() API  uFormat ɕt^鑮łB
	
	̃NX̃IuWFNǵA UINT ɃLXg邱ƂɂA
	 DrawText() ɓnƂł܂B
*/
class CdWinGdi_DrawText_Format
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**	̃eLXgzuw肷񋓂ł	*/
	enum EHolizontal
	{
		/**	 (l)	*/
		H_LEFT ,				//	DT_LEFT , 
		/**		*/
		H_CENTER ,				//	DT_CENTER , 
		/**	E	*/
		H_RIGHT ,				//	DT_RIGHT
	};
	
	/**	c̃eLXgzuw肷񋓂łB	*/
	enum EVertical
	{
		/**	PsŁA	*/
		V_SINGLELINE_TOP ,		//	DT_SINGLELINE | DT_TOP
		
		/**	PsŁA (l)	*/
		V_SINGLELINE_CENTER ,	//	DT_SINGLELINE | DT_VCENTER
		
		/**	PsŁA	*/
		V_SINGLELINE_BOTTOM ,	//	DT_SINGLELINE | DT_BOTTOM
		
		/**	s				*/
		V_MULTILINE ,			//	0

		/**	sŁA܂Ԃ͒P̓rłs܂	*/
		V_MULTILINE_WORDBREAK ,	//	DT_WORDBREAK
		
		/**	
			sŁA܂Ԃ͒P̓rłs܂
			 DBCSi_uoCgZbg̕jŉŝ
			܂B̂߁AsK SBCS ƓɂȂ܂B
		*/
		V_NOFULLWIDTHCHARBREAK,	//	DT_WORDBREAK | DT_NOFULLWIDTHCHARBREAK
		
	};
	
	/**	NbsO̗L	*/
	enum EClipping
	{
		/**	NbsOs܂B (l)	*/
		C_CLIP , 				//	0
		/**	NbsO܂B`悪Ȃ܂B	*/
		C_NOCLIP ,				//	DT_NOCLIP
	};
	
	/**	GfBbgRg[	*/
	enum EEditControl
	{
		/**	GfBbgRg[Ȃ (l)	*/
		NOEDITCONTROL ,			//	0
		/**
		  	GfBbgRg[
		  	sGfBbgRg[Ɠŕ`悵܂B
		  	ɁAϕGfBbgRg[Ɠ@ŌvZA
		  	IɌĂŌ̍s͕\܂B
		 */
		EDITCONTROL ,			//	DT_EDITCONTROL
	};
	
	/**	ȗ	*/
	enum EEllipses
	{
		/**	ȗȂ (l)	*/
		NOELLIPSIS ,			//	0
		/**
		  	̍Ō̕`̈ɔ[܂؂ȂꍇA
		  	͂ݏo؂Aɏȗi...jǉ܂B
		  	̍Ōł͂ȂꏊɂPꂪ`̈悩͂ݏoꍇ́A
		  	ȗLȂŐ؂܂B 
		 */
		END_ELLIPSIS ,			//	DT_END_ELLIPSIS
		/**
		  	w肵`̈Ɏ܂悤ɁAKvɉăeLXg̓r
		  	ȗ (...) ɒu܂B~Li\j܂܂Ă
		  	eLXg̏ꍇAŌ̉~Ľ̃eLXg\Ȍێ
		  	܂B 
		 */
		PATH_ELLIPSIS ,			//	DT_PATH_ELLIPSIS
		/**
		  	`̈ɔ[܂ȂꍇA؂ŁA
		  	KȗLi...jǉ܂B 
		 */
		WORD_ELLIPSIS ,			//	DT_WORD_ELLIPSIS
	};
	
	
	/**	OfBOƂĊ܂߂	*/
	enum EExternalLeading
	{
		/**	ݒȂ (l) */
		NOEXTERNALLEADING ,		//	0
		/**
	  	s̍ɁAOfBO̍ieLXg̍sԂƂēK؂ȍj
	  	Z܂BʏAOfBO̓eLXgs̍
	  	܂B
		 */
		EXTERNALLEADING ,		//	DT_EXTERNALLEADING
	};
	
	/**	/E	*/
	enum EReading
	{
		/**	 (l)	*/
		R_LEFT			 ,		//	0
		/**	E	*/
		R_RIGHT ,					//	DT_RTLREADING
	};
	
	/**	L	*/
	enum EPrefix
	{
		/**	ʏ폈	*/
		NORMAL_PREFIX ,			//	0
		/**
	  	vtBbNX̏sȂ悤ɂ܂B (l)
		
		ʏ́A
	  	j[jbNvtBNX́u&v́A̎ɂ镶ɉi_j
	  	tĕ\Ƃ̖߂łƉ߂Aj[jbN
	  	vtBbNX́u&&v́A1 ́u&v\Ƃ̖߂
	  	Ɖ߂܂BDT_NOPREFIX w肷ƁȀsȂ
	  	Ȃ܂B
		 */
		NOPREFIX ,				//	DT_NOPREFIX 
		/**
	  	eLXgɖߍ܂ĂvtBbNXƂẴApThi&j
	  	𖳎܂Bɑɉ{ȂȂ܂BA
	  	̑̃j[jbNvtBbNX́Aʏǂ菈܂B
		 */
		HIDEPREFIX , 			//	DT_HIDEPREFIX 
		/**
	  	ApThvtBbNXi&ǰ̕ʒu
	  	`悵܂B͈̂̑ؕ̕`悵܂B
		 */
		PREFIXONLY , 			//	DT_PREFIXONLY 
	};

	/**	eLXg̃TCYvZ(`ɂ͊֌W܂)	*/
	enum ECalcrect
	{
		/**	
		 	ۂ̕`s܂B (l)	
		 */
		NOCALCRECT , 			//	0
		/**	
		 	eLXgTCYvZ܂B`͍s܂B	
		 */
		CALCRECT ,				//	DT_CALCRECT
		/**
		  	eLXgTCYvZ܂B`͍s܂B	
		  	eLXg̕\TCYvZۂɃVXetHggp܂B
		 */
		CALCRECT_INTERNAL ,		//	DT_CALCRECT | DT_INTERNAL
	};
	/**	ȗeLXgɂĎۂɕ`悳ꂽ擾(`ɂ͊֌W܂)	*/
	enum EModifystring
	{
		/**	
		ۂɕ`悳ꂽ̎擾s܂B(l)
		 */
		NOMODIFYSTEING ,		//	0
		/**	
	 	lpString p[^wobt@ɁA
		ۂɕ\ꂽi[܂B
		DT_END_ELLIPSIS tO܂ 
		DT_PATH_ELLIPSIS tOw肵ƂɂӖ܂B
		 */
		MODIFYSTRING ,			//	DT_MODIFYSTRING
	};
	

// ********************************
///@name	
// ********************************
///@{
 private:
	/**
		Win32  DrawText() API uFormat ɕt^鑮łB
	 */
	UINT	m_uiDrawTextFormat ;
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	  @param uiForamt [in]
	  	Win32  DrawText() API uFormat ɕt^鑮łB
	 */
	CdWinGdi_DrawText_Format( UINT uiFormat ) ;
	/**
	 	eݒ肷RXgN^łB
	  @param iTabstop [in]
	  	TabStopĺAȉ̂悤ɉ߂܂B
	  	-	0: ^u̓WJs܂B	
	  	-	1ȏ:^uw肵܂B	
	  	-	-1:ftHg̃^uŃ^uWJ܂B	
	 */
	CdWinGdi_DrawText_Format( 
		EHolizontal eHolizontal = H_LEFT ,
		EVertical eVertical = V_SINGLELINE_CENTER,
		EClipping eClipping = C_CLIP ,
		EEditControl eEditControl = NOEDITCONTROL ,
		EEllipses eEllipse = NOELLIPSIS ,
		int iTabstop = 0 ,
		EExternalLeading eExternalLeading = NOEXTERNALLEADING ,
		EReading eReading = R_LEFT ,
		EPrefix ePrefix = NOPREFIX ,
		ECalcrect eCalcrect = NOCALCRECT ,
		EModifystring eModifystring = NOMODIFYSTEING );

// ********************************
//	CdWinGdi_DrawText_Format
// ********************************
 public:
	EHolizontal getHorizontal()const ;
	CdWinGdi_DrawText_Format& setHorizontal( EHolizontal ev ) ;
	EVertical getVertical()const ;
	CdWinGdi_DrawText_Format& setVertical( EVertical ev ) ;
	EClipping getClipping()const ;
	CdWinGdi_DrawText_Format& setClipping( EClipping ev ) ;
	EEditControl getEditControl()const ;
	CdWinGdi_DrawText_Format& setEditControl( EEditControl ev ) ;
	EEllipses getEllipses()const ;
	CdWinGdi_DrawText_Format& setEllipses( EEllipses ev ) ;
	
	/**
	 @return 
	 	TabStoplԂ܂B
	
	 	TabStopĺAȉ̂悤ɉ߂܂B
	 	-	0: ^u̓WJs܂B	
	 	-	1ȏ:^uw肵܂B	
	 	-	-1:ftHg̃^uŃ^uWJ܂B	
	*/
	int getTabStop()const ;
	/**
	 	TabStoplݒ肵܂B
	 @param ev [in]
	 	TabStopĺAȉ̂悤ɉ߂܂B
	 	-	0: ^u̓WJs܂B	
	 	-	1ȏ:^uw肵܂B	
	 	-	-1:ftHg̃^uŃ^uWJ܂B	
	*/
	CdWinGdi_DrawText_Format& setTabStop( int ev );
	
	EExternalLeading getExternalLeading()const ;
	CdWinGdi_DrawText_Format& setExternalLeading( EExternalLeading ev ) ;
	EReading getReading()const ;
	CdWinGdi_DrawText_Format& setReading( EReading ev ) ;
	EPrefix getPrefix()const ;
	CdWinGdi_DrawText_Format& setPrefix( EPrefix ev ) ;

	ECalcrect getCalcrect()const ;
	CdWinGdi_DrawText_Format& setCalcrect( ECalcrect ev );
	EModifystring getModifystring()const ;
	CdWinGdi_DrawText_Format& setModifystring( EModifystring ev ) ;
	
	/**
	@return
	 	Win32  DrawText() API  uFormat ɕt^l
	 	Ԃ܂B
	*/
	UINT getFormat()const ;

	CdWinGdi_DrawText_Format& setFormat( UINT uiFormat ) ;
	
	/**
	 	getDrawTextFormat() ƓłB
	 */
	operator UINT()const{	return getFormat() ; } ;
	/**
	 	setDrawTextFormat() ƓłB
	 */
	CdWinGdi_DrawText_Format& operator=( UINT uiFormat ){
		return ( setFormat( uiFormat ) ) ; } ;
};

} //namespace DcDraw
} //namespace DcDrawLib

#endif /*CdWinGdi_DrawText_Format_h*/

