/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaDcdTargetZoomDisplay.cpp
// ****************************************************************
*/
#include "CaDcdTargetZoomDisplay.h"
#include "DcDraw/CConverter_WinGdi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace DcDrawLib{
namespace DcDraw{
namespace Print{


// ****************************************************************
//	CaDcdTargetZoomDisplay
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CaDcdTargetZoomDisplay::CaDcdTargetZoomDisplay( 
		IfDcdTarget* pTarget ,
		HDC	hPrinterHdc ) :
	m_pTarget( pTarget ),
	m_hPrinterHdc( hPrinterHdc ) ,
	m_iSaveDcId( 0 ) 
{
	CConverter_WinGdi	aConverter ;

	// --------------------------------
	//	DC̏ԂҔ
	// --------------------------------
	m_iSaveDcId = SaveDC( m_pTarget->getHdc() ) ;

	// --------------------------------
	HDC	hDcTarget = m_pTarget->getHdc() ;
	HDC	hDcPrinter = m_hPrinterHdc ;

	//hDcTarget = v^/vr[EChEDC
	//hDcPrinter = v^DCłB
	//	́AXP[l߂̂Ɏg܂B

	// --------------------------------
	//	`DC
	//	`悪ł̈擾
	// --------------------------------
	CdDcdZoneXy	zoneLogical ;
	CdDcdZoneXy	zoneDevice ;
	{
		zoneLogical = m_pTarget->getZone() ;
		zoneDevice = aConverter.LPtoDP( zoneLogical , hDcTarget ) ;
	}		
	//zoneLogical = `DCł́A`̈(_W)
	//zoneDevice = `DCł́A`̈(foCXW)
	
	// --------------------------------
	//	^[QbgDC̍WnύX
	// --------------------------------
	{
		CdDcdZoneXy	zoneZoomLogical ;
		CdDcdZoneXy	zoneZoomDevice ;

	
		int iMapMode = GetMapMode( hDcTarget ) ;
		if ( iMapMode == MM_TEXT ){
			zoneZoomDevice.setX( CdDcdZone( 0 , GetDeviceCaps( hDcTarget , HORZRES ) ) )
				.setY( CdDcdZone( 0 , GetDeviceCaps( hDcTarget , VERTRES ) ) ) ;
			zoneZoomLogical = zoneZoomDevice ;
			
		}	else	{

			{
				POINT	aPOINT ;
				SIZE	aSIZE ;
				GetWindowExtEx( hDcTarget , &aSIZE ) ;
				GetWindowOrgEx( hDcTarget , &aPOINT ) ;
				zoneZoomLogical.setX( CdDcdZone( aPOINT.x , aSIZE.cx ) ) 
					.setY( CdDcdZone( aPOINT.y , aSIZE.cy ) ) ;
			}
			{
				POINT	aPOINT ;
				SIZE	aSIZE ;
				GetViewportExtEx( hDcTarget , &aSIZE ) ;
				GetViewportOrgEx( hDcTarget , &aPOINT ) ;
				zoneZoomDevice.setX( CdDcdZone( aPOINT.x , aSIZE.cx ) )
					.setY( CdDcdZone( aPOINT.y , aSIZE.cy ) ) ;
			}
			//zoneZoomLogical = `DC̘_WɂA
			//	_lƑ傫B
			//zoneZoomDevice =  `DC̃foCXWɂA
			//	_lƑ傫B
			//
			//	foCXWɂA
			//	(zoneZoomDeveice.X.Pos,zoneZoomDeveice.Y.Pos) 
			//	̈ʒuɁA_W
			//	(zoneLogical.X.Pos,zoneLogical.Y.Pos)
			//	蓖ĂĂ܂B
			//
			//	foCXWɂA
			//	(zoneZoomDeveice.X.Size,zoneZoomDeveice.Y.Size) 
			//	̑傫A_W
			//	(zoneLogical.X.Pos,zoneLogical.Y.Pos)
			//	̑傫ɑ܂B
			//	
			//	̒iKł́A
			//
			//	Logical.Size : Device.Size ́A
			//
			//	v^̂Py[W̃sNZF 
			//		`DC̃sNZ
			//
			//	ƂȂ܂B
		}

		// --------------------------------
		//	Y[vZ
		//	zoneZoomDevice  zoneZoomLogical ̂A
		//	傫̒lύX܂B
		// --------------------------------
		if ( zoneZoomDevice.getX().getSize() < zoneZoomLogical.getX().getSize() ){
			//	_W̑ύX
			//	́A_WĒ܂B
			//
			//	v^vr[̏ꍇ́A
			//	foCXWł̕  < _Wiv^̂PhbgƂWjł̕
			//	ƂȂ܂B

			HDC	hdcDisplay = GetDC( NULL ) ;

			int iX = zoneZoomLogical.getX().getSize() ;
			iX *= GetDeviceCaps( hdcDisplay , LOGPIXELSX ) ; 
			iX /= GetDeviceCaps( hDcPrinter , LOGPIXELSX ) ; 

			int iY = zoneZoomLogical.getY().getSize() ;
			iY *= GetDeviceCaps( hdcDisplay , LOGPIXELSY ) ; 
			iY /= GetDeviceCaps( hDcPrinter , LOGPIXELSY ) ; 

			zoneZoomLogical.setSize( CdDcdSizeXy( iX , iY ) ) ;

			ReleaseDC( NULL , hdcDisplay ) ;
		}	else	{
			//	_W̑ύX
			//	́AfoCXW傫Ē܂B
			//
			//	v^ւ̈̏ꍇ́A
			//	foCXWł̕  > _W
			//	ƂȂ܂B
			
			HDC	hdcDisplay = GetDC( NULL ) ;

			int iX = zoneZoomDevice.getX().getSize() ;
			iX *= GetDeviceCaps( hDcPrinter , LOGPIXELSX ) ; 
			iX /= GetDeviceCaps( hdcDisplay , LOGPIXELSX ) ; 

			int iY = zoneZoomDevice.getY().getSize() ;
			iY *= GetDeviceCaps( hDcPrinter , LOGPIXELSY ) ; 
			iY /= GetDeviceCaps( hdcDisplay , LOGPIXELSY ) ; 

			zoneZoomDevice.setSize( CdDcdSizeXy( iX , iY ) ) ;

			ReleaseDC( NULL , hdcDisplay ) ;

			
		}
		//zoneLogical = 
		//	_W̑傫A CdDcdTargetPrinter ł̌vZ
		//	킹ĊZ܂B
		//	
		//	́A
		//
		//	v^̘_C`̃sNZ:
		//		fBXvC̘_C`̃sNZ
		//
		//	ɏvZƂȂ܂B

		// --------------------------------
		{
			//	^[QbgDC̃}bv[hiWnjύX
			SetMapMode( hDcTarget , MM_ANISOTROPIC);
		    SetWindowExtEx( hDcTarget , 
				zoneZoomLogical.getX().getSize() , 
				zoneZoomLogical.getY().getSize() , 
				NULL );  
		    SetViewportExtEx( hDcTarget , 
				zoneZoomDevice.getX().getSize() , 
				zoneZoomDevice.getY().getSize() , 
				NULL );  
		}

	}
	// --------------------------------
	//	vr[EChE
	//	`悪ł̈A
	//	DCɐݒ肵XP[ɏ]čČvZ
	// --------------------------------
	{
		zoneLogical = aConverter.DPtoLP( zoneDevice  , hDcTarget ) ;
	}		
	//zoneLogical = vr[EChEŕ`̂ł̈(_W)
	//zoneDevice = vr[EChEŕ`̂ł̈(foCXW)

	// --------------------------------
	m_zonexyZone = zoneLogical ;

	
}

CaDcdTargetZoomDisplay::~CaDcdTargetZoomDisplay() 
{
	if ( m_iSaveDcId != 0 ){
		RestoreDC( m_pTarget->getHdc() , m_iSaveDcId ) ;
		m_iSaveDcId = 0 ;
	}
}

// ********************************
//@name	IfDcdTarget
// ********************************
HDC	CaDcdTargetZoomDisplay::getHdc() 
{
	return ( m_pTarget->getHdc() ) ;
}

CdDcdZoneXy CaDcdTargetZoomDisplay::getZone() 
{
	return ( m_zonexyZone ) ;
}

CdDcdZoneXy CaDcdTargetZoomDisplay::getDrawableZone() 
{
	return ( m_zonexyZone ) ;
}

// ********************************
//	CaDcdTargetZoomDisplay_h
// ********************************
	// ********************************
	//@name ֘A
	// ********************************

} //namespace Print
} //namespace DcDraw
} //namespace DcDrawLib
