/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	CdDcdFreeLineProp
//	$Id: CdDcdFreeLineProp.h 314 2016-06-11 13:48:18Z okm $
// ****************************************************************
#ifndef  CdDcdFreeLineProp_h
#define  CdDcdFreeLineProp_h

#include <string>
#include "DcdCd\DcDrawProp\CdColorProp.h"

namespace DcDrawLib{
namespace DcdCd{
namespace DcDrawProp{

// ****************************************************************
//	CdDcdFreeLineProp
// ****************************************************************
/**
 @brief 
 yTvz
   Pf[^NXłB
   CDcdFreeLine NXɂ̕`́Aێ܂B
 
   Ƃ
 
 - 
 - `(EjȂ)
 - F
 
 ێ܂B
 */
class CdDcdFreeLineProp
{

// ********************************
///@name 
// ********************************
///@{
 private:
	/** 
		_Pʂő\ł B
		
		ftHgł1łB
	
		0 ȂA`悵܂B
	 */
	int			m_iLogicalunitWidth ;

	/**
		y̐FłB
	
		ftHg͍ł
	 */
	CdColorProp	m_colorrefColor ;

	/**
	   ̌`i_EjȂǁjw肵܂B
	
		̃NXł́A_Ej̎ẃAŕ\܂B
		́̕A "1" ` "9" ܂ł̔pō\܂B
		͂̕PӖA珇
		uPԖڂ̔j̒vEuPԖڂ̋󔒂̒vE
		uQԖڂ̔j̒vEuQԖڂ̋󔒂̒v̏ŁAj
		\vfw肵Ă܂B
		
		󕶎̏ꍇ́A\܂B
		
		ftHgł͎ƂȂ܂B
	 */
	std::string	m_strLinestyle ;

///@}
// ********************************
//	RXgN^
// ********************************
 public:
	/** 
	 @param iLogicalunitWidth [in]
		_Pʂő\ł B
	 @param colorrefColor [in]
		y̐FłB
		ftHg͍ł
	 @param aLinestyle [in]
		`B
	 */
	CdDcdFreeLineProp( 
		int			iLogicalunitWidth ,
		CdColorProp	colorrefColor ,
		const std::string& aLinestyle ) :
		m_iLogicalunitWidth( iLogicalunitWidth ) ,
		m_colorrefColor( colorrefColor ) ,
		m_strLinestyle( aLinestyle ){};

	/** 
	 @param iLogicalunitWidth [in]
		_Pʂő\ł B
	 @param colorrefColor [in]
		y̐FłB
		ftHg͍ł
	 */
	CdDcdFreeLineProp( 
		int			iLogicalunitWidth ,
		CdColorProp	colorrefColor = CdColorProp( 0 ,0 , 0) ) :
		m_iLogicalunitWidth( iLogicalunitWidth ) ,
		m_colorrefColor( colorrefColor )
	{
	};

	CdDcdFreeLineProp() :
		m_iLogicalunitWidth( 1 ) ,
		m_colorrefColor( CdColorProp( 0 ,0 , 0 ) )
	{
	};


// ********************************
//	CdDcdFreeLineProp
// ********************************
 public:
	// ********************************
	///@name CdDcdFreeLineProp::
	// ********************************
	///@{
	int	getLogicalunitWidth()const
	{	return m_iLogicalunitWidth ;};
	CdDcdFreeLineProp& setLogicalunitWidth( int value )
	{	m_iLogicalunitWidth = value ; return *this ;};

	CdColorProp	getColor()const{	return m_colorrefColor ;};
	CdDcdFreeLineProp& setColor( CdColorProp value )
	{	m_colorrefColor = value ; return *this ; } ;
	
	std::string getLinestyle()const{	return m_strLinestyle ;};
	CdDcdFreeLineProp& setLinestyle( const std::string& value )
	{	m_strLinestyle = value ; return *this ; };
	
	
	/**
		m_Linestyle Auv̌`ɐݒ肵܂B
	 */
	CdDcdFreeLineProp& setSolidLineStyle()
	{	m_strLinestyle.erase() ;	return *this ;	} ;

	bool isSolidLineStyle()
	{	return ( m_strLinestyle.empty() ) ;} ;
	
	/**
		ׂĂ̑Ԃɂ܂B
	 */
	void clear(){	*this = CdDcdFreeLineProp() ; } ;
	///@}

	/**
		2̃IuWFNg̊eǂ𔻒肵܂B
	 @param value [in]
		ȓΏۂƂȂIuWFNgw肵ĂB
	 @return 
		value  *this Ƃ̊ԂŁAׂĂ̑ΐ^łB
	 */
	bool isEqualTo( const CdDcdFreeLineProp& value )const
	{
		return ( 
			m_iLogicalunitWidth == value.m_iLogicalunitWidth &&  
			m_colorrefColor == value.m_colorrefColor &&  
			m_strLinestyle == value.m_strLinestyle );
	};
	/**
		isEqualTo() ƓłB
	 */
	bool operator==( const CdDcdFreeLineProp& value )const
	{	return ( isEqualTo( value ) ) ;	};	
	bool operator!=( const CdDcdFreeLineProp& value )const
	{	return ( !isEqualTo( value ) ) ;};	
};
const char LINESTYLE_SOLID[] = "" ;
const char LINESTYLE_DOT[] = "11" ;
const char LINESTYLE_DOT2[]= "22" ;
const char LINESTYLE_DASH[]= "31" ;
const char LINESTYLE_DASH_DOT[]= "3111" ;
const char LINESTYLE_DASH_DOT_DOT[]= "311111" ;

} //namespace DcDrawProp
} //namespace DcdCd
} //namespace DcDrawLib

#endif //CdDcdFreeLineProp_h
