/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CMuiOu.h 352 2016-08-16 20:22:40Z okm $

#ifndef  OuLib_NsMu_CMuiOu_h
#define  OuLib_NsMu_CMuiOu_h

#include "NsOu/Ou.h"

namespace OuLib{
namespace NsMu{

using namespace NsOu ;

/**
@brief
@ElementType^̃IuWFNgw NsOu::Ou (QƃJE^gpX}[g|C^)ێReiłB

  Reiɂ́AElementType ̔hNX̃IuWFNgw NsOu::Ou i[邱Ƃł܂B

   getMuOu() \bhgƂɂA Mu< NsOu::Ou< const ElementType > > C^[tF[X擾邱Ƃł܂B
  
  ܂AgetMuPtr() \bhgƂɂA Mu< ElementType* > , Mu< const ElementType* > C^[tF[X擾邱Ƃł܂B

@param ElementType
  i[IuWFNǧ^w肵ĂB̃p[^[ɂ́AOu ͊܂߂ȂłB
 
@param ContType
  Ou< ElementType > ێSTLReiw肵ĂB
  ł́Astd::deque łA std::vector gƂł܂B
*/
template <
	class ElementType,
	class ContType =std::deque< Ou< ElementType > > >
class CMuiOu : public Mui< Ou< ElementType > > 
{
private:
	// ********************************
	///@name W
	// ********************************
	///@{
	/**
		Ou<ElementType>  new ŐCX^XێReiłB
	*/
	ContType	m_Cont ;
	///@}
	
private:
	// ********************************
	///@name 
	// ********************************
	///@{

	/**
	 @brief
		CMuiCopied::getMuOu() \bhԂ
		Mu< Ou<const ElementType> > C^[tF[X
		NXłB
	 */
	class XMuOuConst : public Mu< Ou< const ElementType > >
	{
	public:
		virtual int	size()const
		{
			CMuiOu* pOuter 
				= (CMuiOu*)((char*)this - offsetof(CMuiOu,m_xMuOuConst) ) ;
			return (int)( pOuter->m_Cont.size() ); 
		} ;
		virtual Ou<const ElementType> get( int idx )const 
		{
			CMuiOu* pOuter 
				= (CMuiOu*)((char*)this - offsetof(CMuiOu,m_xMuOuConst) ) ;
			if ( idx == INT_MAX )
			{
				idx = (int)( pOuter->m_Cont.size() ) - 1 ;
			}
			Ou<const ElementType>pRv = pOuter->m_Cont[idx] ;
			return ( pRv ) ;
		};
	}	m_xMuOuConst ;
	friend class XMuOuConst ;

	/**
	 @brief
		CMuiCopied::getMuPtr() \bhԂ
		Mu< ElementType* > C^[tF[X
		NXłB
	 */
	class XMuPtr : public Mu< ElementType* >
	{
	public:
		virtual int	size()const
		{
			CMuiOu* pOuter 
				= (CMuiOu*)((char*)this - offsetof(CMuiOu,m_xMuPtr) ) ;
			return (int)( pOuter->m_Cont.size() ); 
		} ;
		virtual ElementType* get( int idx )const 
		{
			CMuiOu* pOuter 
				= (CMuiOu*)((char*)this - offsetof(CMuiOu,m_xMuPtr) ) ;
			if ( idx == INT_MAX )
			{
				idx = (int)( pOuter->m_Cont.size() - 1 );
			}
			ElementType*	pRv = pOuter->m_Cont[idx].getTarget ()  ;
			return ( pRv ) ;
		};
	}	m_xMuPtr ;
	friend class XMuPtr ;

	/**
	 @brief
		CMuiCopied::getMuPtr()const \bhԂ
		Mu< const ElementType* > C^[tF[X
		NXłB
	 */
	class XMuConstPtr : public Mu< const ElementType* >
	{
	public:
		virtual int	size()const
		{
			CMuiOu* pOuter 
				= (CMuiOu*)((char*)this - offsetof(CMuiOu,m_xMuConstPtr) ) ;
			return (int)( pOuter->m_Cont.size() ); 
		} ;
		virtual const ElementType* get( int idx )const 
		{
			CMuiOu* pOuter 
				= (CMuiOu*)((char*)this - offsetof(CMuiOu,m_xMuConstPtr) ) ;
			if ( idx == INT_MAX )
			{
				idx = (int)( pOuter->m_Cont.size() ) - 1 ;
			}
			ElementType*	pRv = pOuter->m_Cont[idx].getTarget ()   ;
			return ( pRv ) ;
		};
	}	m_xMuConstPtr ;
	friend class XMuConstPtr ;

	///@}


public:
	// ********************************
	// RXgN^
	// ********************************
	/**
	  Rei𐶐܂B
	*/
	CMuiOu(){} ; 
	/**  Rs[RXgN^ */
	CMuiOu( const CMuiOu<ElementType,ContType>& value ) 
		: m_Cont( value.m_Cont ) 
	{
	}
	/**  Zq */
	CMuiOu& operator=( const CMuiOu<ElementType,ContType>& value ) 
	{
		m_Cont = value.m_Cont ;
		return *this ;
	}

public:
	// ********************************
	///@name Mu
	// ********************************
	/**
	 @return
	 	ReiɊi[Ăvf̌Ԃ܂B
	*/
	virtual int size() const{ return (int)m_Cont.size() ;};

	/**
	 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 	vf̃Rs[Ԃ܂B
	 @param iIndex [in]
	 	0 n܂CfNXw肵ĂB
	 	͈͂ 0 ȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	CfNXŎw肳ꂽvfԂ܂B
	*/
	virtual Ou<ElementType> get(int iIndex)const
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Cont.size() - 1 ;
		}
		return m_Cont[iIndex] ;
	}
public:
	// ********************************
	///@name Mui 
	// ********************************
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vf̃Rs[ǉ܂B
	 @param element [in]
	 	vfw肵ĂB
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() ȉłB
	 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int insert( const Ou<ElementType> & element ,  int iIndex=INT_MAX) 
	{
		int iRv = 0 ;
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Cont.size() ;
		}
		// --------------------------------	
		if ( !( 0 <= iIndex && iIndex <= (int)m_Cont.size() ) )
		{
			iRv = -1 ;	//	CfNX͈͊OłB
		}
		else
		{
			m_Cont.insert( 
				m_Cont.begin() + iIndex , 
				element ) ;
		}
		// --------------------------------	
		return iRv ;
	}
	
	/**
	 	ReíACfNXŎw肳ꂽꏊ
	 	vf폜܂B
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @param iSize [in]
	 	폜vf̐w肵ĂB
	 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 @attention
		iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 @return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int erase( int iIndex , int iSize = 1 )
	{
		int iRv = 0 ;
		if ( iIndex == INT_MAX && iSize != INT_MAX )
		{
			iIndex = (int)m_Cont.size() - iSize ;
		}
		else if ( iIndex != INT_MAX && iSize == INT_MAX )
		{
			iSize = (int)m_Cont.size() - iIndex ;
		}
		// --------------------------------	
		if ( !( 0 <= iIndex && iIndex + iSize <= (int)m_Cont.size() ) )
		{
			iRv = -1 ;	//	CfNX͈͊OłB
		}
		else
		{
			while ( iSize > 0 )
			{
				iSize -- ;
				m_Cont.erase( m_Cont.begin() + iIndex + iSize );
			}
		}
		// --------------------------------	
		return iRv ;
	}
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vf㏑܂B
	 @param element [in]
	 	vfw肵ĂB
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int set( const Ou<ElementType>& element , int iIndex ) 
	{
		int iRv = 0 ;
		if ( iIndex == INT_MAX )
		{
			iIndex = (int)m_Cont.size() - 1 ;
		}
		// --------------------------------	
		if ( !( 0 <= iIndex && iIndex < (int)m_Cont.size() ) )
		{
			iRv = -1 ;	//	CfNX͈͊OłB
		}
		else
		{
			m_Cont[iIndex] = element ;
		}
		// --------------------------------	
		return iRv ;
	}
public:
	// ********************************
	///@name CMuiOu-
	// ********************************
	///@{
	
	/**
		ReiOuwCX^XɃANZXł
		 const Mu< Ou< const ElementType > >
		C^[tF[XԂ܂B
	*/
	virtual const Mu< Ou< const ElementType > >* getMuOu()const 
	{	return &m_xMuOuConst ;};

	/**
		ReiOuwCX^XɃANZXł
		 Mu<ElementType*>
		C^[tF[XԂ܂B
	*/
	virtual Mu<ElementType*>* getMuPtr(){ return &m_xMuPtr ;}
	
	/**
		ReiOuwCX^XɃANZXł
		 const Mu<const ElementType*>
		C^[tF[XԂ܂B
	*/
	virtual const Mu<const ElementType*>* getMuPtr()const{ return &m_xMuConstPtr ;}
	
	///@}
};

} //namespace NsMu
} //namespace OuLib


#endif //OuLib_NsMu_CMuiOu_h

